About This File

Universal Routing 7.6 Interaction Routing Designer Help

Copyright © 2000–2009 Genesys Telecommunications Laboratories, Inc. All rights reserved.
r_designer-help_05-2009_v7.6.201.00

The information contained herein is proprietary and confidential and cannot be disclosed or duplicated without the prior written consent of Genesys Telecommunications Laboratories, Inc.

About Genesys

Genesys Telecommunications Laboratories, Inc., a subsidiary of Alcatel-Lucent, is 100% focused on software for contact centers. Genesys recognizes that better interactions drive better business and build company reputations. Customer service solutions from Genesys deliver on this promise for Global 2000 enterprises, government organizations, and telecommunications service providers across 80 countries, directing more than 100 million customer interactions every day. Sophisticated routing and reporting across voice, e-mail, and Web channels ensure that customers are quickly connected to the best available resource—the first time. Genesys offers solutions for customer service, help desks, order desks, collections, outbound telesales and service, and workforce management. Visit www.genesyslab.com for more information.

Each product has its own documentation for online viewing on the Genesys Technical Support website. You can also find product documentation on the Genesys Documentation Library DVD (all documentation for releases 6.1 and 6.5 and all non-developer documentation for releases 7.0 through 8.0), or the Genesys Developer Documentation CD (developer documentation for releases 7.0 through 7.6). The Documentation Library DVD and Developer Documentation CD are available from Genesys upon request. For more information, contact your sales representative.

Notice

Although reasonable effort is made to ensure that the information in this document is complete and accurate at the time of release, Genesys Telecommunications Laboratories, Inc., cannot assume responsibility for any existing errors. Changes and/or corrections to the information contained in this document may be incorporated in future versions.

Your Responsibility for Your System’s Security

You are responsible for the security of your system. Product administration to prevent unauthorized use is your responsibility. Your system administrator should read all documents provided with this product to fully understand the features available that reduce your risk of incurring charges for unlicensed use of Genesys products.

Trademarks

Genesys and the Genesys logo are registered trademarks of Genesys Telecommunications Laboratories, Inc., in the USA and/or other countries. All other trademarks and trade names referred to in this document are the property of other companies.

Technical Support from VARs

If you have purchased this software from a value-added reseller (VAR), please contact the VAR for technical support.

Technical Support from Genesys

If you have purchased support directly from Genesys, please contact Genesys Technical Support at the following regional numbers:

North and Latin America | +888-369-5555 or +506-674-6767 | support@genesyslab.com
Europe, Middle East, and Africa | +44-(0)-1276-45-7002 | support@genesyslab.co.uk
Asia Pacific | +61-7-3368-6868 | support@genesyslab.com.au
Japan | +81-3-6361-8950 | support@genesyslab.co.jp
India | 1-800-407-436379 (toll-free) +91-(022)-3918-0537 | support@genesyslab.com.au

Before contacting technical support, please refer to the Genesys Technical Support Guide for complete contact information and procedures.

Ordering Information

For complete information on ordering Genesys products, please see the Genesys Licensing Guide.

Released by

Genesys Telecommunications Laboratories, Inc.
www.genesyslab.com


Overview

Interaction Routing Designer (IRD) is the graphical user interface (GUI) that you can use to create, edit, load, release,and monitor routing strategies, and also create business processes.

  • Routing strategies enable you to direct how voice or nonvoice interactions are handled. You create strategies in the Routing Design window.

  • Business processes enable you to direct how multimedia interactions are handled. They incorporate routing strategies that use strategy-building objects appropriate to nonvoice interactions. You create Business Processes in the Interaction Design window.

This document discusses:

  • How to use the IRD interface, including tools used to build strategies.

  • How to configure IRD options and settings.

  • How to plan strategies, create reusable objects and data, and plan Business Processes.

  • How to create strategies.

  • How to save strategies.

  • How to create strategies to route non-voice interactions.

  • How to use the Interaction Design window to create, edit, and activate Business Processes.

  • How to route outbound interactions.

  • How to compile and debug strategies.

  • How to load, schedule the loading of, and monitor strategies.

  • How to edit and manage strategies.

  • How to export and import business processes, strategies, subroutines, various objects used in strategies (such as routing rules, macros, statistics, and strategy objects), and variables.

This Help file also includes sample strategies, which demonstrate how you can create voice or non-voice routing strategies to performs various tasks.

See also:

  • Universal Routing Strategy Samples

  • Universal Routing Business Process User's Guide.


Printing This Help File

You can print a single topic (page) or all the topics (pages) within a single book. You cannot, however, print the entire Help file at once.

On the Table of Contents, select a topic or book and then do the following:

  1. Select the Print button.

  2. In the Print Topics dialog box, select either:

    • Print the selected topic

    • Print the selected heading and all subtopics

  3. Select OK.


Interaction Routing Designer Interface Overview

Interaction Routing Designer Interface

Interaction Routing Designer Interface: Overview

Interaction Routing Designer (IRD) is a user interface that enables you to create and manager routing strategies and Business Processes.

Note: It is possible for administrators to set a timeout period in the IRD Application object. If so, if you do not perform any actions for the specified inactivity period, IRD becomes inactive and you must log in again to continue.

The Interaction Routing Designer (IRD) Interface consists of the following components:

  • The main window, which is the user's primary access to IRD. The main window contains these sections:

  • A Shortcut bar, which provides quick access to IRD objects and functions.

  • The List pane, which displays lists of various objects, depending on your selection in the Shortcut bar. By default, lists appear in descending order. Click the header of the Name column to switch to ascending sort order.

  • The Output pane (also known as the Output Window), which displays messages that inform you about the status of the selected object. You can also open an Output pane in the Routing Design window.

  • Browse Arrows, located on the top-left side of the Main window, are used to move back and forth between views.

  • A Tenant drop-down list. In multi-tenant environments, you can select the tenant to display. In a single-tenant environment, the list contains only the one tenant.

  • Menus and toolbars, which provide access to the commands and objects in IRD. The main window, the Routing Design window, and the Interaction Design window all contain toolbars and menus.

  • The Routing Design window, which displays a graphical view of a strategy or subroutine. Using this window, you can build and edit a strategy or subroutine by placing objects in sequence, creating the appropriate connections, and defining the properties for each object.

  • The Interaction Design window, which enables you to create business processes that route non-voice interactions. For more information, see Designing Business Processes.

  • The Trace View window, which enables you to monitor the flow of interactions through a strategy. You can use the Trace View window to monitor the interactions handled by all route points on which the strategy is loaded, or to monitor the interactions on a single route point.

The following figure shows the main window of the Interaction Routing Designer. Click any active spot in the figure (where the cursor turns into a pointing hand) for detailed information.


Interaction Routing Designer Interface

Browse Arrows

Browse arrows are located on the top-left side of the Main window and are used to move back and forth between views; for example between Strategies and Subroutines.

  • To return to the previous view, click the Back arrow [image] .

  • To return to the view you were using before you clicked the Back arrow, click the Forward arrow [image] .

You can click these buttons multiple times to continue moving backwards or forwards through the sequence of views you have visited during your current IRD session.


Tenant

Interaction Routing Designer Interface

Tenant Selector

In a multi-tenant environment, use the Tenant drop-down list, located at the top of the main window, to select which tenant to display in IRD. All the objects displayed in IRD (strategies, subroutines, routing rules, DN Groups, and so on) are those configured for the selected tenant.

Note: In a single-tenant environment, the drop-down list contains only the name of that tenant.


Interaction Routing Designer Interface > Menus

Menus: Overview

The following menus appear in Interaction Routing Designer:

  • File Menu

  • Edit Menu

  • View Menu

  • Tools Menu

  • Help Menu


Interaction Routing Designer Interface > Menus

File Menu

The commands active in the File menu change depending on the object you have selected and whether you are in the main window, the Routing Design window, or the Interaction Design window.

Commands available from the Routing Design window are described below. For a description of the File menu in the Interaction Design window, the File Menu topic for the Interaction Design window.

This menu includes the following commands:

New
(CTRL+N)

Creates a new object based on the type of item currently selected in the Shortcut bar.

Open
(CTRL+O)

Opens the selected object. If you select Open when a strategy or subroutine is selected, the Routing Design window opens. When other types of objects are selected (Routing Rule, Business Rule, Attribute, Interaction Data, Statistic, Schedule, List Object, or Macro), the appropriate dialog box opens.

Close
(CTRL+D)

Closes only the Routing Design window, if it is open. Does not close IRD. To close IRD, select Exit from the File menu.

Save
(CTRL+S)

If you are creating a new strategy, selecting Save from the File menu opens the Save dialog box. Here you can specify the .rbn file save location and the script object save location in the Scripts folder of Configuration Manager.

If you are editing an existing strategy and select Save from the File menu, the Save action occurs, but the Save dialog does not appear.

See also: Default Storage Location by Tenant

Save As

Opens the Save As dialog box, where you have the option of changing the name and/or storage location for the .rbn file and Script object in the Scripts folder of Configuration Manager.

Describe

Opens the Describe dialog box, where you can add to or change the description of a strategy or subroutine, or the input/output parameters of a subroutine. Only available from the Routing Design window.

Backup

Backs up the current strategy by creating a version.
For more information, see Backing Up a Strategy.

Restore

Restores one of the backup versions of a strategy. You can select which version to restore.
For more information, see Restoring a Previous Version.

Restore from temp

Restores a strategy saved by Interaction Routing Designer when the Autosave Timer feature is activated.
For more information, see Restoring from a Temporary File.

Export to File

(CTRL+E)

Exports a strategy that you have selected from the Strategy List.
For more information see Exporting a Strategy.

Import From File
(CTRL+I)

Imports a strategy file and creates a Script object for a strategy and its subroutines (if any), business rules, routing rules, attributes, interaction data, statistics, list objects, and macros in the Configuration Layer for the strategy.

For more information, see Importing a Strategy.

Print
(CTRL+P)

Prints a strategy.
For more information, see Printing a Strategy.

Print Preview

Displays a strategy as it looks when printed.
For more information, see Previewing a Strategy.

Page Setup

Specifies paper type and orientation for printed strategies.
For more information, see Printing a Strategy.

Change Password

Brings up a dialog box that enables you to change your Configuration Layer password.

Exit

Exits Interaction Routing Designer if used in the Main window and closes the opened strategy or subroutine if used in Routing Design window. If there are any unsaved changes in the current strategy or subroutine, a confirmation message prompts you to save those changes.


Interaction Routing Designer Interface > Menus

Edit Menu

This menu includes the following commands:

Undo
(CTRL+Z)

Undoes the last action. This command is not available for all actions.

Note: Selecting Undo does not reverse changes made in object properties dialog boxes.

Redo
(CTRL+Y)

Repeats the last action. This command is not available for all actions.

Cut
(CTRL+X)

Removes selected objects from the Strategy Design window and moves the objects to the clipboard.

Copy
(CTRL+C)

In the Routing Design window, copies selected objects to the clipboard. This action cannot be undone. You can also copy an object using a shortcut menu.

Note: Copying in the Strategies List and Subroutines list cannot be done from the Edit menu. You must right-click the strategy or subroutine you want to copy and select Copy from the shortcut menu.

Paste
(CTRL+V)

Moves copies of selected objects from the clipboard to the Routing Design window.

Note: There is also an Edit menu in the Interaction Design window.


Interaction Routing Designer Interface > Menus

View Menu

Note: Settings on the View tab of the Routing Design Options dialog box affect the contents of the View menu.

This menu includes the following commands:

Normal | When this command is selected, the Check Integrity tool is de-activated. This is the default setting. Toggle between the Normal command and the Check Integrity command to de-activate/activate the Check Integrity tool.
Check Integrity | When this command is selected, the Check Integrity tool is activated. When activated, all strategies and objects in IRD are checked. As IRD performs the check, no other operation can be performed. The progress bar indicates the progress of the integrity check.
Toolbar | Displays/hides the Toolbar. To save changes, see the note at the bottom of this help topic.
Status Bar | Displays/hides the Status Bar. To save changes, see the note at the bottom of this help topic.
Split | Splits the active window.
Output Window | When a strategy or subroutine is open in the Routing Design window, displays the Output pane below the; contains the Find in Strategy and Errors in Strategy tabs.
Shortcut Bar | Displays/hides the Shortcut Bar.
Business Processes | Displays the Business Processes view. You can also display the Business Processes view by selecting the Business Processes icon on the Shortcut Bar.
Strategies | Displays the Strategies view. You can also display the Strategies view by selecting the Strategies icon on the Shortcut Bar.
Subroutines | Displays the Subroutines view. You can also display the Subroutines view by selecting the Subroutines icon on the Shortcut Bar.
Routing Rules | Displays the Routing Rules view. You can also display the Routing Rules view by selecting the Routing Rules icon on the Shortcut Bar.
Business Rules | Displays the Business Rules view. You can also display the Business Rules view by selecting the Business Rules icon on the Shortcut Bar.
Attributes | Displays the Attributes view. You can also display the Attributes view by selecting the Attributes icon on the Shortcut Bar.
Interaction Data | Displays the Interaction Data view. You can also display the Interaction Data view by selecting the Interaction Data icon on the Shortcut Bar.
Statistic Data | Displays the Statistics view. You can also display the Statistics view by selecting the Statistics icon on the Shortcut Bar.
Schedules | Displays the Schedules view. You can also display the Schedules view by selecting the Schedules icon on the Shortcut Bar.
List Objects | Displays the List Objects view. You can also display the List Objects view by selecting the List Objects icon on the Shortcut Bar.
Macros | Displays the Macros view. You can also display the Macros view by selecting the Macro icon on the Shortcut Bar.
Loading | Displays the Loading view. You can also display the Loading view by selecting the Loading icon on the Shortcut Bar.
Group Loading | Displays the Group Loading view. You can also display the Group Loading view by selecting the Group Loading icon on the Shortcut Bar.
View Log | Displays the Event Viewer, which provides a way to see the content of the Event Log file.
Solution export | Displays the Solution export view, which enables you to export solutions as well as other objects, such as routing rules, interaction data, attributes, business rules, statistics, macros, and so on.
Solution import | Displays the Solution import view, which enables you to import solutions as well as other objects, such as routing rules, interaction data, attributes, business rules, statistics, macros, and so on.
The following View menu items are only active in the Routing Design window:
Page Bounds | Shows the page boundaries.
Grid | Displays a grid in the Routing Design window. To save changes, see the note at the bottom of this help topic.
Snap to Grid | Snaps objects to the grid.
Angle Snap | Snaps objects on an angle.
Zoom Normal | Displays the window at 100% zoom. To permanently save changes, see the note at the bottom of this help topic.
Zoom Percent | Zooms the window to a predefined percentage. To permanently save changes, see the note at the bottom of this help topic.
Zoom Custom | Zooms the window to a custom percentage. The allowable range of integers for entry into the Magnification % field is 5 to 1500. However, if you need to bring magnification down to 5%, Genesys recommends you turn off the Grid menu item. This prevents a negative impact on IRD performance. To permanently save changes, see the note at the bottom of this help topic.
Zoom to Fit | Zooms the Design view to fit in the window. To permanently save changes, see the note at the bottom of this help topic.

Notes:

  • Select Save from the File menu to have any changes made to the Toolbar or Status Bar saved so that IRD opens with those settings.

  • Select Save from the File menu to permanently apply any changes made to the Grid and/or various Zoom commands to the current strategy or subroutine. The saved settings are applied the next time you open that strategy or subroutine.

  • The Interaction Design window also has a View menu.


Interaction Routing Designer Interface > Menus

Tools Menu

This menu includes the following commands:

Change Tenant
(CTRL+T)

Opens the Tenant menu. The tenant can be changed from any main window view. It cannot be changed from the Routing Design window.

Customize

Opens the Customize Toolbars dialog box.

When you select Tools > Customize from the Main window, you can change the settings for the Menu bar by clearing or selecting the Show Tooltips, Cool Look, and Large Buttons options. You cannot clear Menu bar check box.

If you clear the Default check box, the main window's toolbar is hidden.

Routing Design Window Toolbars

Toolbars are enabled or disabled only temporarily while working in the Routing Design window. Changes made to the toolbars for a particular strategy or subroutine do not appear the next time you open the strategy.

The only exception is the Default Toolbar, shown above. To make Default Toolbar changes permanent for a particular strategy or subroutine, select Save from the File menu after closing the Customize dialog box.

Routing Design Options

Opens the Routing Design Options dialog box. Enables you to customize the Routing Design window by changing the Graph Settings, specifying Storage Settings, and setting default fonts. Also enables you to control the objects that are accessible in the Routing Design window, the Interaction Design window, Monitoring view, and the Event Log Viewer.

The Routing Design Options command is accessible from both the Main window and the Routing Design window Tools menus.

See also: Setting Options

Compile

Compiles the strategy, displaying progress in the Status Bar and error messages in message boxes.

This command is only active when you have a strategy open in the Routing Design window.

See also: Compiling a Strategy

Load Strategy
(CTRL+L)

Opens the Select Strategy dialog box. Enables you to load a strategy to the selected route points.

This command is only active in the Loading view.

See also: Loading a Strategy

Release Strategy
(CTRL+R)

Releases a strategy from the selected route points.

This command is only active in the Loading view.

See also: Releasing a Strategy

Note: There is also a Tools menu in the Interaction Design window.


Interaction Routing Designer Interface > Menus

Help Menu

This menu includes the following commands:

Help Topics | Opens this help file.
About Routing Designer | Displays the version and copyright information for Interaction Routing Designer.


Toolbar Overview

Interaction Routing Designer Interface > Toolbars

Toolbars Overview

IRD has a number of toolbars for various purposes. To see a Tooltip containing the name of a toolbar button, hover the cursor over the button.

Note: To customize toolbars, select Tools > Customize.

The Main Window Toolbar

The top of the IRD Main window contains a toolbar. If this toolbar is not visible, display it by selecting View > Toolbar. For information about the Main window toolbar, see the Interaction Routing Designer Interface Overview topic.

The Routing Design Window Toolbars

The Routing Design window, used to create or edit a strategy or subroutine, contains these toolbars:

  • Strategy/subroutine building objects

  • Debugging

  • Positioning tools

  • Strategy/subroutine management

  • Variables

  • Compile and Check Integrity

See also:

Creating a New Strategy

Creating a Subroutine

The Routing Design Window

Using Variables: Overview

Compiling, Checking, and Debugging: Overview


Routing Design Window Toolbars

Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Routing Design Window Toolbars Overview

Located below the menu bar across the top of the Routing Design window, each toolbar contain icons that enable you to access objects and functionality that are used to create and work with strategies and subroutines. You can arrange the toolbars within the toolbar area by dragging and dropping them as desired.

Strategy/Subroutine Building Objects

The toolbar opens subtoolbars that contain the strategy and subroutine building objects, grouped according to their function. Click any icon in the preceding figure to jump to a description of the subtoolbar that it opens. These subtoolbars can be arranged within the toolbar area as desired by dragging and dropping them.

  • Click an icon in the Strategy/Subroutine Building Objects toolbar to drop down a subtoolbar, such as the Voice Treatments toolbar, shown below. The subtoolbars contain icons for the objects that are used to create strategies and subroutines.

  • To place an object in a strategy or subroutine, click the object button and then click the location in the Routing Design window where the object should appear.

  • The subtoolbars automatically close once you place an object. To close a subtoolbar without placing an object, click anywhere outside it.

Strategy Debugging

The tools shown in the following table are used for strategy debugging.

Step Into | Step Over
Step Out | Stop Debug

Positioning

The tools shown in the following table enable you to fine-tune the placement of objects in the Routing Design window workspace.

Align Tools

Nudge Tools

Arrange Tools

Strategy/Subroutine Management.

Display the strategy/subroutine management features toolbar, the icons for which are shown in the following table, by selecting the command View > Toolbar.

Close | Save | Backup | Restore
Editing Tools | Print | Find and Replace | Search

Variables

The Variables icon [image] opens the Variable list, enabling you to work with variables.

Compile

The Compile [image] and Check Integrity [image] functions enable you to do various forms of error checking.

Strategy/Subroutine Building Objects

Voice Treatments

Voice Treatment objects are located under the Voice Treatments toolbar. Use these objects to identify mandatory treatments, such as music on hold or a recorded announcement, that you would like to apply to the interaction.

Data and Services

The Data and Services toolbar contains the Database Wizard, External Services, and Web Service buttons.

The Database Wizard enables you to get information from a database by SQL SELECT statement, stored procedure, or query. The Database Wizard also enables you to access a non-SQL database through Custom Server.

The External Services object enables you to exchange data with third-party (non-Genesys) process servers that use the Genesys Interaction SDK or any other server/application that complies with the Interaction Server communication protocol.

The Web Service object enables you to interact with Web-based applications (Web services) outside of Genesys applications. You specify request parameters, what type of data you expect to be returned, and what to do with the returned data.

See also:

Defining Database Queries
Defining a Database Object
Sample E: Attributes, Business Rules, and Database Lookup

Defining a Database Object for a Custom Server

Requesting External Services

Requesting Web Services

Segmentation

Segmentation objects enable you to direct interactions along different paths based on their characteristics. For example, you can segment by the customer's choice of language or service, classification or screening rules, or various other parameters.

Routing

Routing objects are located under the Routing toolbar. Use these objects to define the targets set for a strategy or subroutine.

Miscellaneous

Miscellaneous objects are located under the Miscellaneous toolbar. Use these objects to control the flow of the interaction and to create routing information.

Multimedia

Multimedia objects are located under the Multimedia toolbar. Use these objects to define how a non-voice interaction should be routed.

Outbound

Outbound objects are used to route calls initiated by the Genesys Outbound Contact Solution.

Resource Management

Resource Management objects are used to manage resources, particularly strategies, Places, and Agents, and therefore control workflow.

SMS

SMS objects enable you to create SMS interactions and send SMS messages.

See also: Sample Strategies


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Voice Treatment Objects

Voice Treatment objects are located in the Voice Treatments toolbar. Each object is identified in the following table.

Use these objects to identify any mandatory treatment that should be applied to interactions.

For information about the properties of these objects, see the Universal Routing 7.6 Reference Manual.

Collect digits
The Collect digits object is used to collect digits that a caller enters. For example, you might collect an account number.

Play announcement
The Play announcement object is used to play an announcement for the caller.

Play announcement and collect digits
The Play announcement and collect digits object is used to play an announcement for the caller and to request that the caller provide information by inputting digits.

Play application
The Play application object is used to execute an application or script on the IP device. It is possible to pass parameters to the application and get return values.

Record User announcement
The Record User announcement object is used to record an announcement.

Verify digits
The Verify digits object is used to prompt a caller to enter digits that will be compared to a desired response.

Busy
The Busy object is used to connect the interaction to the source of a busy tone. The caller hears a busy signal.

Fast busy
The Fast busy object is used to connect the interaction to the source of a different busy tone. The caller hears a fast busy signal. This treatment is supported on a limited number of switches.

Note: On a DMS-100 switch, this treatment terminates the interaction. The caller hears a busy signal, but the interaction can no longer be transferred anywhere.

Cancel call
The Cancel call object is used to disconnect a call in progress. This treatment ends the strategy and deletes the call from the memory of URS.

Delete user announcement
The Delete user announcement object is used to remove a user-specified announcement from a strategy.

IVR
The IVR (Interactive Voice Response) object is used to connect the interaction to an IVR. The treatment is specified in a format similar to that of a target because URS transfers the interaction in the same way it would route to a target.
For examples, see Sample B and Sample E.

Music
The Music object is used to connect the interaction to a music source.

Ringback
The Ringback object is used to connect the interaction to a ringback tone source.

Set default destination
The Set default destination object is used to set the default destination.

Silence
The Silence object is used to specify an interval without sound.

Text to speech
The Text to speech object generates speech from text. No recorded announcements can be used.

Text to speech and collect digits
The Text to speech and collect digits object generates speech from text and then requests input from the caller in the form of digits.

Pause
The Pause object is used to apply a mandatory Pause treatment for an interaction.

RAN
The RAN object is similar to the Music object. The source must be a RAN port on the switch. This treatment is supported by a limited number of switches.


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Data and Services Objects

The Database Wizard, External Service, and Web Service objects are located in the Data and Services toolbar.

Database Wizard

The Database Wizard object enables you to get information from a database by a SQL SELECT statement, stored procedure, or query. The Database Wizard also enables you to access a non-SQL database through Custom Server.

External Service

The External Service object enables you to exchange data with third-party (non-Genesys) process servers that use the Genesys Interaction SDK or any other server/application that complies with Interaction Server communication protocol.

Web Service

The Web Service object enables you to interact with Web-based applications (Web services) outside of Genesys applications. You specify request parameters, what type of data you expect to be returned, and what to do with the returned data.

See also:

Using the Database Wizard Object

Sample E: Attributes, Business Rules, and Database Lookup

Querying a Custom Server

Requesting an External Service

Requesting Web Services


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Segmentation Objects

Segmentation objects are located in the Segmentation toolbar. Each object is identified in the following table.

Use these objects to cause interactions to take different paths in a strategy or subroutine based on factors such as operation condition (Time of Day, Day of Week), telephony information (ANI, DNIS), the business value of customers, classification codes returned by the Classify object, categories attached with the Attach Categories object, or Screening rules returned by the Screen object.

Each segment is represented by a green output port. The red port represents the default condition (when no other conditions are met).

Summary information on each Segmentation object is presented below. For detailed information, see the Universal Routing 7.6 Reference Manual.

Generic
The Generic Segmentation object causes interactions to take different paths in the strategy based on logical expressions created in the Expression Builder. For an example, see Sample D.

Date
The Date object segments interaction flow by the date the interaction arrives.

For an example, see Sample C.

For information on supported date formats, see the Universal Routing 7.6 Reference Manual.

Note: In the Date Segmentation object, the value of the Up To date parameter is excluded from the time interval. For example, if you segment interactions with a Date From of 10/21/07 and an Up To Date of 10/25/07, URS includes interactions arriving between 12:00:00 AM on 10/21/07 and 11:59:59 PM on 10/24/07.

Time
The Time object segments interaction flow by the time of day the interaction arrives.
For examples, see Sample B and Sample C.

For information on supported time formats, see the Universal Routing 7.6 Reference Manual.

Note: In the Time Segmentation object, the value of the Up Until parameter is excluded from the time interval. For example, if you segment interactions with a From time of 9:00:00 AM and an Up Until time of 5:00:00 PM, URS includes interactions arriving between 9:00:00 AM and 4:59:59 PM.

Day of the week
The Day of the week object segments interaction flow by the day of the week the interaction arrives.
For examples, see Sample B and Sample C.

ANI
The ANI object segments interaction flow by the originating ANI number.

DNIS
The DNIS object segments interaction flow by the destination DNIS number.
For an example, see Sample A.

Business
The Business object segments interaction flow by Business Rules.
For an example, see Sample E.

Classify

The Classify Segmentation object causes incoming interactions to take different paths in the strategy or subroutine based upon the classification codes returned by the Classify object or attached with the Attach Categories object.

Screen

The Screen Segmentation object causes incoming interactions to take different paths in the strategy based upon screening rule data returned by the Screen or Multi-Screen object. The screening rule data can be contained in variables or found in interaction data.


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Routing Objects

Routing objects, used to select a target, are located in the Routing toolbar.

Many of these objects are used to select or create routing rules for a strategy or subroutine.

For detailed information about the parameters of these objects, see the Universal Routing 7.6 Reference Manual.

Warning! Variables cannot be used in routing rules. If you manually enter the name of a variable in a routing rule and use the routing rule in another strategy or subroutine, the variable will be interpreted as a string constant.

Service level

The Service level object routes interactions based on a specified service level for a category of interaction or customer segment. For example, 80 percent of calls should be routed in 20 seconds. For an example, see Sample E.

Load balancing

The Load balancing object distributes interactions evenly to targets according to estimated wait time.

Percentage

The Percentage object uses a percentage for distributing interactions among several targets. For an example, see Sample A.

Statistics

URS obtains the values of defined statistics for targets from Stat Server. According to whether select min or select max is specified, the available target with the minimum or maximum value of the statistic will receive the interaction. For an example, see Sample D.

Switch to strategy

The Switch-to-Strategy object uses a routing rule to tell URS to direct the interaction into another strategy. You can select the Tenant name associated with the switch-to strategy. Interactions sent to another strategy by this object do not return to the original strategy, unlike those sent using the Call Subroutine object.

Notes:

  • When a call is routed to a Resource under a different Tenant using the Switch-to-Strategy routing rule, the Check Integrity function always returns an error.

  • To have Monitoring view include interactions from the Switch to strategy object, monitor at the strategy/subroutine level.

Default

The Default object routes the interaction to the default destination.

Force

The Force routing object forces the interaction to the target specified in the selected Force routing rule, without any other operations.

Selection

Used for voice interactions, the Selection object enables you to select of one or more of the following targets: ACD Queue, Agent, Agent Group, Destination Label, Place, Place Group, Queue Group, Routing Point, Skill, or Variable. Parameters can also include one or more busy treatments.

Use the Selection object for voice interactions only in a Universal Routing 7.0.1 and later environment. Use the Route Interaction object for multimedia interactions in a Universal Routing 7.0.1 and later environment.

Note: The Selection object was used for e-mail interactions in 6.5.x environments. Now, however, the Route Interaction object provides this functionality in all releases after 7.0.x. Its functionality has been extended to cover all non-voice media.

For an example, see Sample D.

Workforce

The Workforce object routes an interaction based on an activity created in Workforce Management (WFM) and stored in the WFM database. See the Workforce Management 7.6 Configuration Utility Help for information on creating activities.

Route Interaction

The Route Interaction object enables you to route non-voice interactions to one or more of the following targets: Agent, Agent Group, Place, Place Group, Skill, or Variable. Optional parameters include input and output interaction queues.

For detailed information about the Route Interaction parameters, see the Universal Routing 7.6 Reference Manual

Workbin

The Workbin object routes an interaction to a storage area associated with an Agent, Agent Group, Place, or Place Group. For example, an Agent Workbin may hold draft e-mail responses. Workbins are created in the Interaction Design window. Once created in the Interaction Design window, Workbins appear for selection in the Workbin object in the Routing Design window.

Queue Interaction

Generates a message from Universal Routing Server to Interaction Server to place the interaction into a queue. Queues defined in the Interaction Design window are listed for selection in the object properties dialog box.

See also:

Creating a Routing Rule

Universal Routing 7.6 Reference Manual


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Miscellaneous Objects

Miscellaneous objects are located in the Miscellaneous toolbar.

Use these objects to control the flow of the interaction and to create routing information for a strategy or subroutine.

Summary information on each Miscellaneous object is presented below. For detailed information, see the Universal Routing 7.6 Reference Manual.

Entry
The Entry object is placed by default at the entry point of a strategy.

Exit
The Exit object is used to terminate the strategy or to return from a subroutine to the strategy. Connect the Exit object to any output ports that represent ending points.

If
The If object is used to create logical interaction flows.

Assign
The Assign object is used to assign a value to a variable. For examples, see Sample D and Sample E. There is also a MultiAssign object.

Function
The Function object contains a list of functions that can be used to handle interactions during a strategy. These include CallInfo (such as ANI and DNIS), Statistics (such as CallsEntered or PositionInQueue), Date and Time, and many others.

The function object uses a dialog box that contains the same controls as those used to build expressions in some other objects. See Expression Building for more information.

Macro

A macro works like a user-defined function: you do not have to repeatedly enter the same set of objects and/or parameters in a strategy.

Error segmentation
The Error segmentation object can be connected to the red port of another object to provide additional error-processing information. It prevents an interaction from being routed to the default destination in the event of an error. For more information, see Error Processing.

Call Subroutine

The Call Subroutine object is used to suspend execution of the current strategy while the interaction is processed by the subroutine. After the subroutine has completed all its interaction-handling steps, control of the interaction returns to the original strategy, which resumes interaction processing.

Note: This differs from the Switch-to-Strategy object, which sends interactions to a different strategy to be fully routed. The Switch-to-Strategy object does not return interactions to the original strategy.

MultiAssign

The MultiAssign object is used to assign values to multiple variables.

MultiAttach

The MultiAttach object is used to:

  • Update or attach one or more pieces of data (either predefined interaction data or the contents of a variable) to the interaction, such as account or menu selection data that the customer entered via an IVR.

  • Attach Business or other attributes to the interaction.

Multi Function

The Multi Function object is used to perform multiple functions in a single processing step.


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Multimedia Objects

Objects used in handling non-voice interactions are located in the Multimedia toolbar.

Note: Certain objects from other toolbars can also be used when routing non-voice interactions.

Use these objects to create non-voice routing strategies. Summary information on each object is presented below. For usage examples, see Universal Routing Strategy Samples. Also see Universal Routing Business Process User's Guide.

Stop Interaction

Sends a stop interaction request to Interaction Server. Optionally, notifies Universal Contact Server that interaction processing in this particular routing strategy is finished.

Acknowledgement

Generates (but does not send) an acknowledgement message using text from your standard response library explaining that the customer's interaction has been received and will be answered by an Agent. You can send an Acknowledgement in response to an incoming interaction in any medium.

The response can be based on the results of the Classify object or you can preset the same standard response to be used in all cases.

When the strategy is used in a business process, server and queue strategy-linked nodes appear (see Autoresponse below for an example).

Autoresponse

Generates (but does not send) an automatic response message using text from your standard response library. You can send an Autoresponse in reply to an incoming interaction in any medium.

The response can be based on the results of the Classify object or you can preset a standard response. When the strategy is used in a business process, strategy-linked server and queue nodes appear.

In the preceding figure, the Classify strategy uses the Autoresponse object so strategy-linked server (Auto Response) and queue (Outbound e-mails) nodes appear.

Chat Transcript

Generates (but does not send) an e-mail, using text from your standard response library, with the customer's chat transcript attached. (Use the Send E-Mail object to send it.) Does not generate any strategy-linked nodes in a Business Process.

Send E-Mail

Sends an e-mail waiting in a queue to a customer. This can be the final e-mail response created by an Agent, or an e-mail generated with the Acknowledgement, Autoresponse, Chat Transcript, Forward E-Mail, or Redirect E-Mail object. When a strategy containing the Send E-Mail object is used in a business process, server strategy-linked nodes appear.

Redirect E-Mail

Use this when sending an incoming message to an external address without expecting a response or the need for any further processing. The Redirect E-Mail object is a request to the E-mail Server for the Redirect method to create the redirected e-mail. Use the Send E-Mail object to send the redirected e-mail that is waiting in a queue.

Server and queue strategy-linked nodes appear when a strategy containing the Redirect E-Mail object is used in a Business Process.

Forward E-Mail

Use when sending an incoming message to an external address with the expectation of getting a response back. Supports Agent collaboration. The Forward E-Mail object is a request to the E-mail Server for the Forward method to create the forwarded e-mail. Use the Send E-Mail object to send the forwarded e-mail that is waiting in a queue.

Server and queue strategy-linked nodes appear when a strategy containing the Forward E-Mail object is used in a Business Process.

Reply E-Mail From External Resource

This object takes an External Resource Reply inbound e-mail as input, extracts the external resource reply text from it, creates a Customer Reply outbound e-mail with it, and submits it to Interaction Server.

Server and queue strategy-linked nodes appear when a strategy containing the Reply E-Mail from External Resource object is used in a business process.

Screen

Use to request Classification Server to screen text-based interactions for certain words or patterns of words using a rule that has been set up in Knowledge Manager.

Requires that you select the Classification Server to be used for screening, as well as a language and a screening rule.

Server strategy-linked nodes appear when a strategy containing the Screen object is used in a Business Process.

MultiScreen

Use to request Classification Server to screen text-based interactions for certain words or patterns of words using multiple rules that have been set up in Knowledge Manager. The difference between Screen and MultiScreen is that MultiScreen can use multiple screening rules, supplies additional return options, and does not require a conditional test to determine whether a match occurred.

Server strategy-linked nodes appear when a strategy containing the MultiScreen object is used in a Business Process.

Classify

Use to request Classification Server to assign one or more categories to text-based interactions. The categories can then be used to select a standard response, as well as for routing or reporting.

Requires that you select a Classification Server.

The input parameters include the minimum relevancy each category must have in order for this object to consider an interaction as belonging to that category (threshold), and whether to analyze only for the Parent categories set up in Configuration Manger, or for both Parent and Child categories.

Server strategy-linked nodes appear when a strategy containing the Classify object is used in a Business Process.

Attach Categories

This object allows you to manually emulate the results of the Classify object’s request to Classification Server to attach one or more classification categories to an interaction.

Example use cases:

  • Use when creating a strategy in which screening results determine what categories to attach to an interaction with an Attach Categories object.

  • Use when creating a strategy in which an If object creates an expression that is based on categories that are manually attached to interaction with an Attach Categories object. URS analysis (true/false) of the expression determines interaction path in strategy.

You can also segment interactions based on categories using the Classification Switch Segmentation object and/or use categories to select a standard response.

Create Interaction

Use the Create Interaction object to have URS request that an interaction record be created in the Universal Contact Server database for a customer contact. This object applies to all interaction types other than voice, chat, or e-mail.

Create E-Mail Out

Use the Create E-Mail Out object to create an outbound e-mail interaction. It is especially useful for outbound e-mail campaigns.

Create Notification

Use the Create Notification object to create an informational e-mail to a customer. The notification e-mail may contain the information itself, or it may link the customer to a location on a website where he or she can access the requested information. This e-mail may be in response to interactions in any media.

CreateSMS

The CreateSMS object generates a new outbound e-mail with a format that you can customize using standard responses and field codes. This e-mail is sent through an external SMTP server to an Email-To-SMS gateway. Such messages are used for sending short text-based messages to cell phones, personal organizers, and so on.

Identify Contact

Use the Identify Contact object to create a new contact, identify an existing one, and to update user data associated with the interaction.

Update Contact

Use to update contact information in the UCS database with new information taken from data associated with the interaction.

See also:

Routing Strategies for Non-Voice Interactions

The Route Interaction Routing object

The Queue Interaction Routing object

The Workbin Routing object

The Classify Segmentation object

The Screen Segmentation object

See Genesys Multimedia 7.6 Deployment Guide for information about E-mail Server Java, Interaction Server, Genesys multimedia interaction processing, and Open Media.


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Outbound Objects

Objects in the Outbound object toolbar are used for proactive routing interactions that are classified as open-media interactions, and that are processed using the outbound_preview media type.

Use these objects to manage outbound campaigns.

Summary information on each Outbound object is presented below. For detailed information, see the Universal Routing 7.6 Reference Manual.

Add Record

Automatically builds a Calling List by adding a new record to the specified Calling List.

Do Not Call

Adds a customer's contact information to a specified Do Not Call List and marks the corresponding record as Do Not Call.

Note: Use the Do Not Call and Processed objects to finalize Outbound record processing. You cannot use other Outbound objects to process records with the same Record Handle after using the Processed or Do Not Call objects in a strategy flow.

Processed

Has URS request (through Interaction Server) that Outbound Contact Server finish processing a record created as a result of a previous customer interaction.

Note: Use the Do Not Call and Processed objects to finalize Outbound record processing. You cannot use other Outbound objects to process records with the same Record Handle after using the Processed or Do Not Call objects in a strategy flow.

Update Record

Updates a Calling List record that you specify via a RecordHandle parameter.

Reschedule

Reschedules a customer interaction from the specified Calling List. A record is typically rescheduled during a call when a customer requests a callback at a certain time.


Resource Management

Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Resource Management Objects

Objects in the Resource Management toolbar enable you to control workflow by changing resource states.

The following table shows summary information on each Resource Management object:

Set Strategy State

Activates or deactivates a strategy.

Set Agent DND State

Turns DND off or on for a specified Agent.

Set Agent Media State

Sets the state of an Agent as Ready or Not Ready for a specified media type.

Force Logout

Forces an Agent to log out.


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

SMS Objects

Objects in the SMS objects toolbar are used for creating and sending SMS messages.

The following table shows summary information on each SMS object:

Create SMS Out

Creates an SMS interaction for an outbound SMS message.

Send SMS Out

Tells the SMS Server to send an SMS message.


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Positioning Tools

Use the positioning tools to fine-tune the arrangement of objects in the Routing Design window. These tools are especially helpful in large strategies where you may want to position objects very precisely in order to save space.

There are three types of tools: Align, Nudge, and Arrange.

Align Tools

After you enable them, these tools align strategy/subroutine object icons in the Routing Design window.

Align Top
Aligns icons along their top edge.

Align Middle
Aligns icons along their vertical centers.

Align Bottom
Aligns icons along their bottom edge.

Align Left
Aligns icons along their left edge.

Align Center
Aligns icons along their horizontal centers.

Align Right
Aligns icons along their right edge.

Enabling/Using the Align Tools

In the Routing Design window:

  1. Hold down the Ctrl key and select the first object you want to align.

  2. Continue holding the Ctrl key and select the second object. The Align tools become enabled. The second object selected is highlighted in red.

  3. Continue holding the Ctrl key and select the remaining objects. The last object selected is now highlighted and serves as the basis for alignment. To de-select an object, hold down the Shift key and click.

Note: The basis for alignment cannot be a connection line.

  4. Click the applicable tool to align the icons.

Nudge Tools

These tools move an object one pixel at a time in the selected direction.

Note: To move an object 5 pixels at a time, hold down the Shift key while you click a Nudge button.

Nudge Up
Moves the object icon up.

Nudge Down
Moves the object icon down.

Nudge Left
Moves the object icon to the left.

Nudge Right
Move the object icon to the right.

Arrange Tools

These tools change the order in which items (including comments, objects, and connectors) overlap. The Arrange buttons become active when you select objects to be rearranged.

Front
Moves the selected items so that they cover any items in the strategy that they overlap.

Back
Moves the selected items so that they lie beneath any items in the strategy that overlap them.

Forward
Moves the selected items so that they move up one level in a stack of overlapping items. This command applies only when items overlap.

Backward
Moves the selected items so that they move down one level in a stack of overlapping items. This command applies only when items overlap.

Order Default

Moves the selected items on top of all other items and arranges them in the following order: comments on the bottom, objects above comments, and connectors above objects. If an item overlaps another item of the same type, they can appear in any order. To further refine the layering, select the item to adjust and use the Front, Back, Forward, or Backward commands to achieve the desired order.


Variables Toolbar

Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Variables Tool

The Variables toolbar contains only the Variables button.

The Variables button opens the Variable List, which enables you to view, create, edit, or delete variables that are used in strategies and subroutines.


Interaction Routing Designer Interface > Toolbars > Routing Design Window Toolbars

Compile and Check Integrity Tools

The Compile and Check Integrity tools appear together on a toolbar.

Compile

The Compile button generates a compiled version of the strategy. When you compile a strategy, IRD checks it for errors.

Check Integrity

The Check Integrity button checks for invalid object references within a strategy.


Shortcut Bar

Interaction Routing Designer Interface > Shortcut Bars

Shortcut Bars Overview

Shortcut bars are used to access the various reusable objects available in IRD. These bars are located in the Shortcut bar on the left side of the Main window. You can also select a type of object from the View menu.

There are five Shortcut bars: Interaction Design (which by default appears only if you have installed Genesys Multimedia), Routing Design, Monitoring, Event Log, and Export/Import. Click a shortcut bar in the following figure to jump to a description of that bar's functionality.

Note: To customize the objects that appear on the Shortcut bar, change the settings on the View tab of the Routing Design Options dialog box.

Interaction Design Bar

Business Processes

Select the Business Processes icon to display the Business Processes List. Double-click a Business Process to open it in the Interaction Design window.

Note: By default, this shortcut bar appears only if Genesys Multimedia is installed in your environment.

Routing Design Bar

Strategies

Click the Strategies icon to display existing Strategies or create new ones.
For more information, see Creating a New Strategy.

Subroutines

Click the Subroutines icon to display existing Subroutines or create new ones.
For more information, see Creating a Subroutine.

Routing Rules

Click the Routing Rules icon to display existing Routing Rules or create new ones.
For more information, see Creating a Routing Rule.

Business Rules

Click the Business Rules icon to display existing Business Rules or create new ones.
For more information, see Business Rules: Overview .

Attributes

Click the Attributes icon to display existing Attributes or create new ones.
For more information, see Configuring Attributes.

Interaction Data

Click the Interaction Data icon to display existing Interaction Data or create new ones.
For more information, see Configuring Interaction Data.

Statistics

Click the Statistics icon to display existing Statistics or create new ones.
For more information, see Configuring Statistics.

Schedules

Click the Schedules icon to display existing Schedules or create new ones.
For more information, see Creating Schedules.

List Objects

Click the List Objects icon to display existing List Objects or create new ones.
For more information, see Creating List Objects.

Macro

Click the Macro icon to display existing Macros or create new ones.

Once you have configured a macro, you can reuse it. For this reason, it is listed along with the other IRD reusable objects in the Routing Design bar.

Macros are also strategy-building objects that are accessible from within a strategy by clicking the Miscellaneous objects icon. For more information on macros, see the Miscellaneous Objects topic.

Monitoring Bar

Loading

The Loading icon displays the Loading view, which enables you to load a strategy on individual route points. You can also monitor interaction flows, which enable you to evaluate how well your strategies are working, from this view. Click Monitoring on the Shortcut bar to display this icon.

For more information, see Loading on One Routing Point.

Group Loading

The Group Loading icon displays the Group Loading view, which enables you to load a strategy on a group of route points. Click Monitoring on the Shortcut bar to display this icon.
For more information, see Loading on a Group of Routing Points.

Event Log

Event Log

The Event Log icon displays the Event Viewer, which provides a way to see the contents of the Event Log file.

Export/Import Bar

Solution export

Enables you to export strategies and subroutines, as well as other objects, such as routing rules, interaction data, attributes, business rules, statistics, macros, and so on.

Solution import

Enables you to import strategies and subroutines, as well as other objects, such as routing rules, interaction data, attributes, business rules, statistics, macros, and so on.

To import these objects, you must first perform an export by using the Solution export view.


Interaction Routing Designer Interface > Shortcut Bars

Interaction Design Bar

The Interaction Design bar enables you to view currently configured Business Processes, to edit them, and to configure new ones. It appears on the left side of the Interaction Routing Designer main window, as shown below.

When you create a new Business Process or open an existing one, it appears in the Interaction Design window.


Interaction Routing Designer Interface > Shortcut Bars

Routing Design Bar

The Routing Design bar gives access to reusable objects and data that you use to create, edit, and deploy routing strategies. It appears on the left side of the Interaction Routing Designer main window.

In the following figure, click any object in the Routing Design bar for information about that object type.


Interaction Routing Designer Interface > Shortcut Bars

Monitoring Bar

The Monitoring Bar is shown below. It enables you to:

  • Load and release routing strategies from a route point or a group of route points.

  • Monitor strategies to gauge their effectiveness.

  • Debug strategies.

In the following figure, click Loading or Group Loading on the Monitoring bar for more information.


Interaction Routing Designer Interface > Shortcut Bars

Event Log Bar and Event Viewer

The Event Log bar gives access to the Event Viewer. The Event Viewer displays the contents of the Event Log file, which records user activities and results. You can also customize the Event Log.

The color of the word LOG in the status bar indicates the following:

  • If LOG appears in gray, there are no new messages since the last time you viewed the Event Log.

  • If LOG appears in blue, there are new information messages since the last time you viewed the Event Log.

  • If LOG appears in red, either there are error messages or the log you are viewing is not the current one to which error messages are being written. If LOG appears in red when the current action did not result in an error, this indicates that the log contains new error messages since last time you viewed the log.

Note: The Event Log file is generated for only one instance of IRD, which is consistent with the Genesys warning in the Universal Routing 7.6 Deployment Guide that only one instance of IRD should be installed per desktop. If you are running a second IRD instance from the same desktop, a sharing violation message appears, and the Event Log viewer for the second IRD instance is blank.

Event Log IDs

If a log event is related to a request that IRD sends to a server (usually Configuration Server), this log event contains a reference ID, which appears in the ID column. This is the reference ID of the corresponding request and can be used to track the server's handling of the IRD request in the log for that server.

Note: This reference ID is completely different from any IDs that may be reported in the body of the message under message Details.

Event Log Customization

To customize the Event Log, do the following:

  1. In the IRD main window, click the Event Log shortcut bar.

  2. Click the Event Viewer icon.

  3. Right-click inside the pane that displays the log entries to bring up a context menu.

  4. Select Properties.

In the Event Log Properties dialog box, you can set Event Log filters and file properties.

Event Log Shortcut Menu

Right-click inside the Event Viewer to bring up a menu with the following items:

  • New closes the current log file and opens a new log file.

  • Open closes the current log file and enables you to select from previously created log files.

  • Refresh reapplies the current log settings to all contents of the current log file.

  • Order Default restores the original order of log messages (they can be sorted by different fields).

  • Properties opens the Event Log Properties dialog box.


Interaction Routing Designer Interface > Shortcut Bars

Export/Import Bar

The Export/Import bar, shown below, enables you to export and import strategies and subroutines, as well as other objects, such as routing rules, interaction data, attributes, business rules, statistics, macros, and so on. You can select from a number of export/import formats for strategies and subroutines: .rbn (the default for strategies and subroutines), .zcf, .xml, or .kvl. For objects other than strategies and subroutines, .kvlt is the only supported format.

Note: As an alternative, to export and import entire strategies or subroutines, use the Export to File and Import from File commands on the File menu in the IRD main window. For information about this alternative export/import process, see Exporting and Importing Entire Strategies.


Interaction Routing Designer Interface > Output Pane

Output Pane Overview

The Output pane shows information about the item selected in the List pane or about the strategy or subroutine that is open in the Routing Design window. It may have one or more tabs, depending on what you selected.

  • For all Routing Design shortcut bar objects, the Output pane contains the Details tab.

  • When you select the Loading icon in the Monitoring bar, the Output pane contains the Connections, Configuration, and Monitoring tabs.

  • When you open a strategy or subroutine in the Routing Design window, and then select the Output Window command from the View menu, the Output pane contains the Find in Strategy, Errors in Strategy, and Information tabs.

The Details Tab

When you select a strategy, subroutine, routing rule, business rule, attribute, interaction data, statistic, schedule, list object, or macro from the List pane, its details appear in the Details tab of the Output pane (shown below).

Notes:

  • All possible information appears only when you are in Check Integrity mode (you have selected View > Check Integrity from the menu). When you are in Normal mode, Used In, Uses, and Warning information does not appear.

  • No information appears on the Details tab when you select a Business Process on the Business Process List pane.

If the item selected on the List pane has any errors (that is, it is marked in the list with a red cross), information about the errors is also displayed in the Details tab.


Loading View Output Pane

Interaction Routing Designer Interface > Output Pane

The Loading View Output Pane

When you select the Loading icon in the Monitoring bar, the Output pane contains the Connections, Configuration, and Monitoring tabs.

The Connections Tab

This tab displays the servers to which the Universal Routing Server (URS) you selected in the Loading list must be connected—that is, those that appear on the URS Application object's Connections tab, which you configure in Configuration Manager. The name, type, host, port, and connection status (Unknown, Connected, or Not active) for each server appear in the Connections tab list.

Connection information is provided to IRD by URS by way of the Message Server. If Unknown appears in the Connection column for the Message Server, then there is no live connection between IRD and URS through the Message Server.

Note: You may have two Message Servers connected to URS, one that provides monitoring for IRD, and a second Message Server for logging purposes.

Connections Status Light

The color of the light indicates status as follows:

  • If URS is successfully connected to all servers, the Connections status light is green.

  • If URS is disconnected from at least one server, the Connections status light is red.

  • If IRD doesn't know the Connections state of URS with its servers (for example, if there is no Message Server to report) or if URS attempts to connect to a server, but the server has not yet answered, the Connections status light is yellow.

See Also: Status Light

For information on configuring multiple Message Servers, see the Universal Routing 7.6 Deployment Guide.

The Configuration Tab

This tab displays the configuration status and details of the Universal Routing Server (URS) that you selected in the Loading list pane. It also displays any action that might be required to correct a status error.

The Monitoring Tab

The Monitoring tab displays the status of the connections listed in the Connections tab and provides details concerning the status of the URS you selected in the Loading list pane. It also displays any action that might be required to correct a status error.


Routing Design Window Output Tab

Interaction Routing Designer Interface > Output Pane

The Routing Design Window Output Pane

To open the Output pane in the Routing Design window, either:

  • Select Output Window from the View menu. When opened in this window, the Output pane contains the Find in Strategy, Errors in Strategy, and Information tabs.

  • Hover the cursor over the bar separating the Routing Design window workspace from the status bar at the bottom of the window. When it changes to a double-headed arrow ( [image]), click and drag the bar upward until the Output pane appears.

The Find in Strategy Tab

When you use the Search function to locate text strings used in a strategy or subroutine, including objects, rules, functions, and so on, the results appear in the Find in Strategy tab.

See also: Searching for Text Strings

The Errors in Strategy Tab

When you use the Check Integrity tool to locate invalid references in a strategy, the invalid references appear in the Errors in Strategy tab.

See also: Checking References Using Check Integrity

The Information Tab

This tab informs you if another user makes and changes to the strategy that you have open (for example, if the other user locks it).

See also: Locking Strategies and Subroutines


Interaction Routing Designer Interface

Status Bar

The Status Bar appears across the bottom of the main window and the Routing Design window. It consists of six parts: help information, progress bar, status light (in main window only), LOG (in the Event Viewer only), capitals lock, numbers lock, and scroll lock.

  • The Help information section tells you to press F1 to open the Help file. You can also open the Help file by selecting Help Topics from the Help menu.

  • The Progress Bar appears when IRD is executing certain commands. For example, in the Strategy List view, the bar shows the progress of reading strategies from the Configuration Layer or importing strategies from another environment. In the Routing Design strategy view, the bar shows the progress of checking integrity, searching, saving, or compiling a strategy.

  • The Status Light indicates whether or not the necessary connections to Message Server are in place for monitoring.

    • A red status light indicates that IRD is not connected to any of the Message Servers listed in Configuration Server. You cannot monitor strategies when the status light is red.

    • A yellow status light indicates that the status is unknown. This can occur when IRD has more than one Message Server, and only some of them are connected. It can also occur if IRD is attempting to connect to Message Server, but Message Server has not yet answered. Upon a positive answer, the status light turns green. Upon a negative answer, the status light turns red.

    • A green status light indicates that all the necessary connections to Message Server are in place, and you can monitor strategies.

  • LOG changes color to indicate the status of the IRD Event Log.

  • The Capitals Lock displays CAP when Caps Lock is set on the keyboard.

  • The Numbers Lock displays NUM when the Num Lock is set on the keyboard. When set, the arrow keys are not available for moving from item to item within windows.

  • The Scroll Lock displays SCRL when Scroll Lock is set on the keyboard. However, the Scroll Lock key is disabled in IRD, and pressing it has no effect.


Interaction Routing Designer Interface > List Pane

List Pane: Overview

The List pane, located in the main window, lists objects configured for the selected tenant. The List pane shows only one type of object at a time. Select the object type by clicking its icon on the Shortcut bar. By default, the Strategies list is shown when you open IRD.

  • By default, lists appear in descending order. Each list is shown under the Configuration Layer folder in which it is stored (often, the folder name is Scripts). Click the header of the Name column to switch to ascending sort order.

Note: Sorting by using the Name column applies to folders as well as objects. Sorting by any other column rearranges only the objects within the current folder.

  • You can filter the list by typing the desired text in the filter field. There are filter text boxes at the top of each List pane column. As you enter text, all objects in the list that match the text that you enter are displayed; those that don't match are hidden.

Note: The filter fields are case-sensitive. Filtering is not applied to the folders, but only to IRD objects.

  • You cannot edit or delete Configuration Layer folders from IRD. You must make such changes in Configuration Manager.

  • You can only create new objects in a folder if you have security permission to do so. This security permission applies to the Configuration Layer folder and cannot be changed in IRD.

  • You can move objects to a different location in the Configuration Layer:

    • For all objects except strategies and subroutines (that is, for Routing Rules, Business Rules, Attributes, Interaction Data, Statistics, List Objects, Schedules, and Macros), change the location on the Config. Layer Location tab of the object's properties dialog box.

    • To move strategies and subroutines to another location in the Configuration Layer, use the Save As command and then select the location on the Config. Layer Location tab in the Save As dialog box.

The following types of objects can appear on the List pane:

  • Interaction Design Shortcut Bar

    • Business Processes

  • Routing Design Shortcut Bar

    • Strategies

    • Subroutines

    • Routing Rules

    • Business Rules

    • Attributes

    • Interaction Data

    • Statistics

    • Schedules

    • List Objects

    • Macros

  • Monitoring Shortcut Bar

    • Loading view (lists the route points on which you can load a strategy)

    • Group Loading view (lists the route points on which you can load a strategy)

  • Event Log Shortcut Bar

    • Event Viewer

Note: When you create a new strategy or subroutine, or open an existing one, it appears in the Routing Design window. When you create a new Business Process or open an existing one, it appears in the Interaction Design window.


Business Process List

Interaction Routing Designer Interface > List Pane

Business Processes List

Open the Business Processes list from the main window by clicking the Interaction Design shortcut bar and then the Business Processes icon. The List pane displays all of the Business Processes that are configured for the selected tenant.

Notes:

  • Unlike strategies, you cannot save Business Processes in a tree of customized folders and subfolders that appears on the Business Processes List pane. Business Processes can be saved only in the predefined default Script folder.

  • No information appears on the Details tab of the Output pane when you select a business process on the List pane.

When you create a new business process or open an existing one from the List pane, the Business Process opens in the Interaction Design window.

The Business Processes list pane contains these columns:

Name—The name of the Business Process.

Description (Optional)—A description of the Business Process. Descriptions can be helpful in indicating what the Business Process might be used for.

Access—The permissions that a user has for reading, creating, changing, or deleting the Business Process. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.


Interaction Routing Designer Interface > List Pane

Strategies List

To see the Strategies list, click Routing Design in the Shortcut bar on the main window, then click the Strategies icon. The List pane shows all of the strategies available for the selected tenant.

Note: The Strategies list also appears by default when you first open IRD.

If you are in Check Integrity view (select View > Check Integrity in the IRD main window), strategies that are loaded on a routing point appear in green. Strategies with an invalid reference are marked with a red X. For details, see Checking for Invalid References.

The Strategies list contains the following columns:

  • Name—The name of the strategy.

  • Description—(Optional) A description of the strategy. Descriptions can be helpful in indicating what the strategy might be used for.

  • Ready—An X in this field indicates that the strategy is ready to be loaded.

Note: A strategy is available for use as soon as it contains bytecode. A strategy that has some compilation errors but that contains bytecode can be loaded on a routing point. For more information about bytecode, see Components of a Strategy and Importing a Strategy.

  • Loaded—A green X indicates that the strategy is loaded on a routing point.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the strategy. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions and instructions for setting up permissions.

  • Trace—Displays an X if you selected Trace On from the shortcut menu that appears when you right-click a strategy in the list. Once you set Trace On, you can select Trace View from the same shortcut menu, which enables you to view interaction counts and percentages for the individual objects in the strategy.

When you set Trace On, the interaction counts and percentages shown in Trace View include all interactions sent from other strategies. This may happen if you use the Switch-to-Strategy object.

  • Locked—Displays a v if you have locked the strategy. Displays an x if another user has locked the strategy.

The Details tab appears below the List pane on the Output pane. It includes information about when the strategy was created and updated, whether it is loaded on a routing point, information about the Configuration Database objects used in the strategy, whether the strategy contains any errors, and, if the strategy is locked, the name of the host that locked it.

See also: Creating a New Strategy


Subroutine List

Interaction Routing Designer Interface > List Pane

Subroutines List

To see the Subroutines list, click Routing Design in the Shortcut bar on the main window, then click the Subroutines icon. The List pane shows all of the subroutines that can be used in strategies or other subroutines for the selected tenant.

Note: If a subroutine name appears in green, it is being used in a strategy. If you select a subroutine, the Details tab displays the names of the strategies in which it is used.

The Subroutines list contains the following columns:

  • Name—The name of the subroutine.

  • Description (Optional)—A description of the subroutine. Descriptions can be helpful in indicating what the subroutine might be used for.

  • Ready—An X indicates that the subroutine was successfully compiled and is ready to be used in a strategy or another subroutine.

Note: A subroutine is available for use as soon as it contains bytecode. A subroutine that has some compilation errors but that contains bytecode can be included in a strategy that is loaded on a routing point. For more information about bytecode, see Components of a Strategy and Importing a Strategy.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the subroutine. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

  • Trace—Displays an X if you selected Trace On from the shortcut menu that appears when you right-click a subroutine in the list. Once you set Trace On, you can select Trace View from the same shortcut menu, which enables you to view interaction counts and percentages for the individual objects in the subroutine.

When you set Trace On, the interaction counts and percentages shown in Trace View include all interactions sent from other strategies.

  • Locked—Displays a v if you have locked the subroutine. Displays an x if another user has locked the subroutine.

The Details tab appears below the List pane on the Output pane and includes information about when the subroutine was created and updated, input and output parameters, whether it is used in a strategy or another subroutine, and, if the subroutine is locked, the name of the host that has locked it.

The Details tab appears on the and includes information about when the subroutine was created and updated, .

See also: Creating a Subroutine


Interaction Routing Designer Interface > List Pane

Routing Rules List

To see the Routing Rules list, click Routing Design in the Shortcut bar on the main window, then click the Routing Rules icon. The List pane shows all of the routing rules that are defined for the selected tenant.

The Routing Rules list contains the following columns:

  • Name—The name of the routing rule.

  • Description (Optional)—A description of the routing rule. Descriptions can be helpful in indicating what the routing rule might be used for.

  • Type—The type of routing rule. The possible types are Force, Load balancing, Percentage, Service level, Statistics, Switch-to-Strategy, and Workforce.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the routing rule. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes information about the routing rule and whether it is used in a strategy.

See also: Creating a Routing Rule


Interaction Routing Designer Interface > List Pane

Business Rules List

To see the Business Rules list, click Routing Design in the Shortcut bar on the main window, then click the Business Rules icon. The List pane shows all of the business rules that are configured for the selected tenant.

Expand a business rule in the Name column to see the attributes associated with the business rule.

The Business Rules list contains the following columns:

  • Name—The name of the business rule.

  • Value—The values of the attributes that define the business rule.

  • Description (Optional)—A description of the business rule. Descriptions can be helpful in indicating what the business rule might be used for.

  • Details—The actual value of the chosen attribute.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the business rule. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes information about the business rule and whether it is used in a strategy.

See also: Creating a Business Rule


Interaction Routing Designer Interface > List Pane

Attributes List

To see the Attributes list, click Routing Design in the Shortcut bar on the main window, then click the Attributes icon. The List pane shows all the configured attributes.

Attributes are considerations, or decision factors, that are selected based on interaction data or functions. They are used only in business rules.

Note: If an attribute appears in green, it is being used in a business rule.

The Attributes list contains the following columns:

  • Name—The name of the attribute. Expand the attribute to see the values associated with it.

  • Value—The values (if any) for the interaction data or function associated with the attribute.

  • Description (Optional)—A description of the attribute. Descriptions can be helpful in indicating what the attribute might be used for.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the attribute. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes the name of the business rule (if any) in which the attribute is used.

See also: Configuring Attributes


Interaction Routing Designer Interface > List Pane

Interaction Data List

To see the Interaction Data list, click Routing Design in the Shortcut bar on the main window, then click the Interaction Data icon. The List pane shows information about existing Interaction Data that has already been defined in IRD. Interaction Data is organized by Configuration Layer folder.

Interaction data is information that is attached to an interaction. In order to use the interaction data in a strategy, you must first define the data in IRD. For example, a strategy can get data from an IVR in the User Data attribute within the EventRouteRequest message and then use the data to make routing decisions.

Note: If interaction data appears in green, it is being used in an attribute.

The Interaction Data list contains the following columns:

  • Name—The name of the interaction data object.

  • Type—The type of interaction data. Possible types are string, integer, and float.

  • Description (Optional)—A description of the interaction data. Descriptions can be helpful in indicating what the interaction data might be used for.

  • Values—The valid values (if any) for the interaction data. These values appear in the Values list when the interaction data is selected in an Expression.

  • Minimal Value—The minimal value (if any) for the interaction data.

  • Maximal Value—The maximum value (if any) for the interaction data.

  • Default Value—The default value (if any) for the interaction data.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the attribute. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes the name of the attribute (if any) in which the interaction data is used.

See also: Configuring Interaction Data


Interaction Routing Designer Interface > List Pane

Statistics List

To see the Statistics list, click Routing Design in the Shortcut bar on the main window, then click the Statistics icon. The List pane shows information about existing statistics. Statistics are organized by Configuration Layer folder.

If a statistic is listed in green, it is in use.

The Statistics list contains the following columns:

  • Name—The name of the statistic.

  • Type—Whether the statistic type is Predefined or Custom.

  • Category—The statistical category. For a list of categories, see the Universal Routing 7.6 Reference Manual.

  • Subject—The subject of the statistic, either AgentStatus or DNAction.

  • Filter—The filters, if any, that have been applied to the statistic.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the statistic. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes the name of the routing rules (if any) and strategies in which the statistic is used.

See also: Configuring Statistics


Interaction Routing Designer Interface > List Pane

Schedules List

To see the Schedules list, click Routing Design in the Shortcut bar on the main window, then click the Schedules icon. The List pane shows all defined schedules that can be loaded on a routing point, organized by the Configuration Layer folders in which they are saved.

The Schedules list contains the following columns:

  • Name—The name of the schedule.

  • Description (Optional)—A description of the schedule. Descriptions can be helpful in indicating what the schedule might be used for.

  • Loaded—A green X indicates that the schedule is loaded on a Universal Routine Server.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the schedule. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes information about when the schedule was created and updated, the schedule logic, and the version of script language used to create schedule.

See also: Scheduling the Loading of Strategies


Interaction Routing Designer Interface > List Pane

List Objects List

To see the List Objects list, click Routing Design in the Shortcut bar on the main window, then click the List Objects icon. The List pane shows all defined lists of data that you might use in multiple strategies, organized by the Configuration Layer folder in which they are stored. You can then refer to the list rather than having to refer to each item separately. This also has the advantage of enabling you to edit the list without having to update the strategy.

For example, you might create one list of 800 numbers used for customer service and another of those used for technical support. This eliminates the need to list each 800 number individually in your strategies.

The List Objects list contains the following columns:

  • Name—The name of the list object.

  • Description (Optional)—A description of the list object. Descriptions can be helpful in indicating what the list object might be used for.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the list object. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes information about where the list is used.

See also: Cr eating Lists


Interaction Routing Designer Interface > List Pane

Macros List

To see the Macros list, click Routing Design in the Shortcut bar on the main window, then click the Macros icon. The List pane shows all existing macros, both the predefined macros and the macros that you created. They are listed under the Configuration Layer folder in which they are stored.

The Macros list contains the following columns:

  • Name—The name of the macro.

  • Description (Optional)—A description of the macro. Descriptions can be helpful in indicating what the macro might be used for.

  • Access—The permissions that a user has for reading, creating, changing, or deleting the macro. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions, and for instructions for setting up permissions.

The Details tab appears on the Output pane (below the List pane) and includes information about where the macro is used.

See also: Miscellaneous Objects


Loading List Overview

Interaction Routing Designer Interface > List Pane > Loading List

Loading List: Overview

The Loading list pane displays the instances of URS, the switches and the routing points on which you can load a strategy or a schedule. It also indicates which strategies and schedules are currently loaded.

  • To open the Loading list, click the Monitoring shortcut bar, then click the Loading icon.

In the Loading view, the Output pane includes three tabs: Connections, Configuration, and Monitoring.

You can search for a specific routing point from the list, or you can filter the list so that it shows those objects that match the text that you enter.

The Loading list contains the following columns:

  • Routing Server—The names of all URS instances found in the Configuration Server for the selected Tenant. Expand the URSs in this column to see the switches under each URS, and expand the switches to see the routing points under each switch.

If you have primary and backup URSs, their status is also indicated by the color of their icon (blue indicates active, red indicates stand-by, and gray indicates URS is not running or the connection chain between URS, Message Server, and IRD is broken).

Note: You cannot monitor a URS that is not running.

  • Strategy/Schedule—The name of the strategy or schedule that has been loaded on a routing point. You can sort strategies in ascending or descending order by clicking the header cell of the Strategy/Schedule column.

  • Entered—The number of interactions that have entered a routing point since URS last started in Primary (rather than Backup)mode.

  • Routed—The number of interactions that have been routed from a routing point since URS last started in Primary (rather than Backup)mode.

  • Abandoned—The number of interactions that were abandoned while at a routing point since URS last started in Primary (rather than Backup)mode.

  • In Process—The number of in-process interactions currently on a routing point.

  • Access—The permissions that a user has for loading and releasing strategies and schedules. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions and instructions for setting up permissions.

  • Trace—Displays an X if you selected Trace On from the shortcut menu that appears when you right-click a routing point in the list. Once you set Trace On, you can select Trace View from the same shortcut menu, which enables you to view interaction counts and percentages for the individual objects in the routing point.

See also:

Loading Strategies

Monitoring Strategies


Interaction Routing Designer Interface > List Pane > Loading List

Loading List: Searching for Routing Points

You can use the Loading view's search function to locate one or more routing points across all URSs and all switches. To do so:

  1. From the Shortcut Bar in the IRD main window, click the Monitoring bar, then click Loading.

    The Loading view opens, showing all the URSs in Configuration Manager.

  2. Enter your search string in the text box above the List pane. The search function is case-sensitive.

You can search using a filter. Possible values for the filter are: *string, string*, or *string*. In the example below, asl* is used as the search string.

Note: You cannot enter a segment of the routing point name without an asterisk (*) to replace the missing pieces. You must either enter the entire name, or use * to replace any part of the name you do not type in. For example, to search for all routing points with e-mail in their name, enter *e-mail*.

  3. Click the Search icon [image].

If IRD finds the search string, the content of Loading list changes. It includes only those URSs with routing points that match the search string.

  4. Expand the URSs and their associated switches to view the routing points that match the search string.

  5. To return to the complete Loading list, you have two options:

  • Delete the search string then click the Search icon [image].

  • Enter an asterisk (*) in the search field then click the Search icon.


Interaction Routing Designer Interface > List Pane

Group Loading List

Group Loading speeds the process of loading the same strategy on all the DNs in a DN Group.

The Group Loading list pane displays the DN Groups for the Universal Routing Server (URS) selected in the drop-down list above the List pane. Expand the DN Groups to see the routing points in each DN Group and what strategy, if any, is loaded on routing point.

  • To open the Group Loading list, click the Monitoring shortcut bar, then click the Group Loading icon.

The columns in the Group Loading list are explained below.

Note: Using the Ctrl or Shift keys to select, you can copy the contents of some or all rows in the Group Loading list to the Clipboard, and then copy them into a spreadsheet to print as a report.

The columns in the Group Loading list are the following:

  • Object—The names of the DN Groups and their associated routing points. All DN Groups configured in the selected Tenant are listed.

  • Strategy—The name of the strategy currently loaded on each routing point.

  • Router—The URS that handles the group of routing points on which a strategy is loaded. Select the URS from the drop-down list above the List pane.

  • Type—The type of the DN Group, for example, routing point, service number, and so on.

  • Switch—The switch on which a routing point is located.

  • Tenant—The tenant to which the DN Groups belong. Select the tenant from the drop-down list above the Shortcut bar.

In single-tenant environments, only the one tenant appears in the drop-down list.

In multi-tenant environments, only DN Groups configured for specific tenants appear. DN Groups configured directly under Environment do not appear.

  • Access—The permissions that a user has for loading and releasing strategies from DN Groups. These permissions are set up in Configuration Manager. See Establishing Access Control for Access definitions and instructions for setting up permissions.

See also: Loading on a Group of Routing Points


Routing Design Window

Interaction Routing Designer Interface

The Routing Design Window

The Routing Design window displays a graphical view of the composition of a strategy or subroutine.

To open the Routing Design window:

  • Click the Routing Design shortcut bar to open it, then click Strategies to open a strategy or Subroutines to open a subroutine. Or select Strategies or Subroutines from the View menu.

  • For an overview of the various Routing Design window toolbars, see Routing Design Window Toolbars Overview.

This topic briefly explains how to:

  • Customize the Routing Design window.

  • Open the Output pane.

  • Create a new strategy or subroutine.

  • Edit an existing strategy or subroutine.

To customize the Routing Design window:

  • Select Routing Design Options from the Tools menu in either the Main window or the Routing Design window. This opens the Routing Design Options dialog box.

To create a strategy or subroutine:

  1. Select New from the File menu or click the New icon on the Main window toolbar. Enter a name and description, then click OK.

The Routing Design window opens, containing the Entry object, which appears in the upper-left corner.

  2. Use the toolbar to place objects and define their properties.

To edit a strategy or subroutine:

  1. Double-click any strategy or subroutine in the list to open it in the Routing Design window.

  2. Double-click an object in the strategy or subroutine to edit its properties.

To open the Output pane in the Routing Design window:

  • Select Output Window from the View menu. When opened in this window, the Output pane contains the Find in Strategy, Errors in Strategy, and Information tabs.

See also:

Setting Routing Design Options

Output Pane Overview

Creating a New Strategy

Creating a Subroutine

Editing a Strategy


Trace View Window

Interaction Routing Designer Interface

The Trace View Window

The Trace View window enables you to monitor the real-time flow of interactions through a strategy on a single route point or all the route points on which the particular strategy is loaded.

The Trace View window shows all the interactions that entered the route point or strategy since you selected Trace On.

  • To reset the numbers, close the Trace View window, right-click the route point or strategy, and select Trace Off. Then, turn Trace back on and re-open the Trace View window.

To open the Trace View window for a single route point (shown below):

  1. Click the Monitoring shortcut bar, then click the Loading icon.

  2. Right-click a route point in the Loading list and then select Trace On.

Note: There must be a strategy loaded on the route point to use Trace View.

  3. Right-click the route point again. The shortcut menu now includes the Trace View option. Select Trace View.

To open the Trace View window for a strategy:

  1. Click the Routing Design shortcut bar then click the Strategies icon.

  2. Right-click a loaded strategy and select Trace On.

Note: You can only open the Trace View window for strategies that have been loaded on at least one route point. Such strategies appear in green in the Strategies list.

  3. Right-click the strategy again. The shortcut menu now includes the Trace View option. Select Trace View.

The Trace View window opens. It shows the number and the percentage of interactions that take each path through the strategy. These figures include interactions on every route point on which the strategy is loaded.

See also: Monitoring Strategies


Interaction Design: Overview

Interaction Routing Designer Interface > Interaction Design Window

Interaction Design Window: Overview

The Interaction Design window provides an interface for configuring Business Processes, which direct incoming non-voice interactions through various processing objects in order to deliver an appropriate response to the customer.

The Interaction Design window also performs the following functions:

  • Graphically represents the flow between queues, views, and routing strategies.

  • Enables you to see the entire interaction-processing picture as a whole.

  • Provides a Strategy Activation Wizard for loading strategies on virtual routing points.

Access the Interaction Routing Designer (IRD) Interaction Design window as follows:

  1. In the IRD Main window, click Interaction Design.

  2. On the Shortcut bar, click Business Processes.

  3. Do one of the following depending on whether you want to edit/view or create a Business Process:

  • To edit or view a Business Process, double-click it on the List pane.

  • To create a new Business Process, select New from the File menu; click the New icon ( [image]); or right-click the Scripts folder on the List pane, and then select New.

Any of these actions open the Interaction Design window. The following figure shows the Interaction Design window with a sample Business Process selected, and with the Queues folder expanded.

For more information on customizing the display and using the Interaction Design window see the following:

  • Interaction Design Window Elements

  • Interaction Design Window Options

  • Interaction Design Window Menus

  • Interaction Design Window Objects

See also:

  • Understanding Business Processes: Overview

  • Universal Routing Business Process User's Guide


Interaction Routing Designer Interface > Interaction Design Window > Window Elements

Interaction Design Window Elements: Overview

The Interaction Design window has three areas:

  • The Object Browser (dockable) displays Business Processes, queues, views, subroutines, and strategies (including strategy-linked nodes, such as stop nodes and target nodes) in a hierarchical (tree) structure.

  • The Workflow Viewer area displays the interaction flow graphically.

  • The Log Viewer area (dockable) consists of three tabs, the Log tab, which displays log events and status, the Configuration Updates tab, and the Search Results tab.

You can resize each area individually, or resize the entire window, by clicking and dragging the edges.

The window also includes a menu bar and a toolbar.


Object Browser in Main Window

Interaction Routing Designer Interface > Interaction Design Window > Window Elements

Object Browser

The following figure shows the Object Browser outlined in red. You can hide the browser by clicking the Close button (X) in its top-right corner. The Object Browser is also dockable, which means that you can detach and reposition it by clicking and dragging the double lines above the browser tree.

You can also hide and dock the Object Browser by right-clicking in it and selecting the appropriate item from the shortcut menu (you might have to scroll down the menu to see the all of the options).

The Object Browser displays the available configuration objects in a hierarchical structure that shows parent-child relationships between objects:

Business Processes

Queues

       Views

Workbins

       Views

Strategies

      Agents

      Targets

      Third-party servers

      Stop interaction nodes

Subroutines

      Agents

      Targets

      Third-party servers

      Stop interaction nodes

Useful Views

      Global View

      Deployment view

Media Servers

      Email Servers

              Endpoints

      Chat Servers

              Endpoints

      Open Media Servers

              Endpoints

Independent Objects

      Various configuration objects that do not belong to any Business Process

Note: In the Object Browser, the object icons that are used in a workflow include a small yellow arrow. Activated strategies are marked with a small green arrow.

Independent Objects

An Independent Objects folder is located at the bottom of the Object Browser tree. It contains independent objects, which are those that do not belong to any Business Process.

  • You can select an object that appears in the Independent Objects folder, and drag and drop it into the appropriate folder of a Business Process. For example, you can select a strategy and drop it into the Strategies folder of a Business Process.

  • After the object belongs to a Business Process (though it might not actually be used in the Business Process), it no longer appears in the Independent Objects folder.


Interaction Routing Designer Interface > Interaction Design Window > Window Elements

Useful Views

The Object Browser within the Interaction Design window includes a folder called Useful Views. This folder contains the Global view and the Deployment view.

The Global View

The Global view shows all of the Business Processes that you have created, the Media Servers that you are using, and the relationships between the Business Processes. These relationships involve exchanges of interactions. In other words, the Global view shows the big picture of how interactions are created and handled through the entire workflow sequence.

Note: You can open any Business Process in the Global view by double-clicking it.

The Deployment View

The Deployment view shows how applications are deployed, and how they interact. The applications are grouped by host. You can print the Deployment view.

You can also:

  • View the properties of any application shown in the Deployment View.

  • Configure settings that enable you to customize the Deployment view.

Viewing Application Properties

To view the properties for any application in the Deployment view, right-click it, and select Properties. The Properties dialog box appears.

The Properties dialog box is read-only. It provides the following information:

  • For an application—The name of the application, its type, its port number, and the solutions to which the application belongs.

  • For a host—The host name, IP address, and operating system.

  • For a switch—The switch name and type.

Viewing Deployment View Settings

You can also see the settings for the Deployment view as a whole by right-clicking Deployment View in the Object Browser tree, and then selecting Properties. The Deployment View Properties dialog box appears.

  • To change the settings, click Define on the Deployment View properties dialog box. The Deployment View Filter dialog box appears.

The Deployment View Filter dialog box has two tabs:

  • Show Solutions—Lists all the Solutions that are configured in Configuration Manager.

  • Show Applications—Lists all the application types that are configured in Configuration Manager.

The dialog box also includes two check boxes:

  • Show Applications That Do Not Belong to Any Solution—If selected (the default setting), the Deployment view displays all application, including those that do not belong to a solution.

If you clear this check box, the Deployment view displays only applications that belong to the solutions that you select.

  • Show Non Connected Applications—If selected (the default setting), the Deployment view displays applications that are not connected to any other object.

If you clear this check box, the Deployment view displays only applications that are connected to another application or to a switch.


Interaction Routing Designer Interface > Interaction Design Window > Window Elements

Yellow Arrow

After you use an object in a Business Process, it is marked with a small yellow arrow in the Object Browser ( [image]).

The yellow arrow is helpful for working with a large Business Process, when you cannot see all objects at once, and you are unsure whether a particular object has been dropped into the viewer.

  • If you see the yellow arrow, the object has been dropped into the viewer.

  • If you delete a previously dropped object from the Business Process, the arrow disappears.

Note: Strategies that have been activated are marked with a small green arrow ( [image]).


Workflow Viewer in Main Window

Interaction Routing Designer Interface > Interaction Design Window > Window Elements

Workflow Viewer

The following figure shows the Workflow Viewer outlined in red.

The selected Business Process appears in the Workflow Viewer as a directed graph.

  • To add an object to a Business Process, drag it from the Object Browser and drop it into the viewer.

  • You can reposition the objects as you like. However, Genesys recommends that you allow Interaction Routing Designer (IRD) to automatically position objects according to its arranging algorithm.

  • Specify the interaction flow by connecting the objects.

  • Align objects selecting Arrange Objects from the Business Process menu. You can also change the default arrangement settings on the Arranging Options tab of the Options dialog box, which you access from the Tools menu.

  • You can group objects and apply an informative label to the group. This makes it easy for you call attention to sections of a Business Process that form a logical or functional unit.


Interaction Routing Designer Interface > Interaction Design Window > Window Elements

Log Viewer

The following figure shows the Log viewer outlined in red. You can hide this viewer by clicking the Close button (X) or you can detach and reposition it by clicking and dragging the double lines on the left side, below the Close button.

The Log Viewer contains three tabs: Log, Configuration Updates, and Search Results.

Log Tab

The Log tab displays a running log of events as you makes changes to interaction workflows. For example:

---------------------- Configuration Loading ------------------
Warning: View 'Outbound ABC1' was assigned to Business Process 'ABC Simple BP'

Configuration Updates Tab

The Configuration Updates tab displays the status of changes that you make to the configuration from Configuration Manager. For example:

-------------------------- Connected --------------------------
5/24/2004 2:34:47 PM: Queue 'Queue1' has been deleted from configuration server

When you change option values for objects in Configuration Manager, Interaction Design displays the following message on the Configuration Updates tab:

Interaction <interaction_name> has been changed. If you want to accept these changes, refresh workflow.

To save the changes that you made in Configuration Manager, select the Lose the changes and reload configuration radio button on the Refresh Options dialog box.

Search Results Tab

The Search Results tab displays the results of a search that you perform using the Find command. For details, see Using the Find Command.

Hiding/Redisplaying the Log Viewer Tabs

To clear, hide, redisplay, or dock the tabs in the Log Viewer (Log, Configuration Updates, and Search Results):

  • Right-click in the Log Viewer and then select the appropriate function.

You can also redisplay the tabs after hiding them by selecting Log from the View menu.


Interaction Routing Designer Interface > Interaction Design Window > Window Elements

Toolbar

The toolbar contains the following buttons:

Backward/Forward | Switches back and forth between the Business Processes and Useful Views that were previously opened during the current session. The keyboard shortcut for the Backward button is Alt+left arrow. The keyboard shortcut for the Forward button is Alt+right arrow.
Save | Saves any configuration changes performed in Interaction Design window. The keyboard shortcut is Ctrl+S.
New Business Process | Adds a new Business Process object in the Object Browser, and assigns a temporary name, which you can change.
New Queue | Adds a new Queue object in the current Business Process, and assigns a temporary name (which you can change) in the Object Browser). Click in the Workflow Viewer to place the object. To assign properties, double-click the object.
New Workbin | Adds a new Workbin object in the current Business Process. Click in the Workflow Viewer to place the object. To assign properties, double-click the object.
New Strategy | Opens the IRD Routing Design window, where you can create a new Strategy object.
Print | Opens the print dialog box so that you can print the currently active interaction workflow, the Global view, or the Deployment view, depending on your selection in the Object Browser. The keyboard shortcut is Ctrl+P.
Help | Opens Interaction Routing Designer Help.


Interaction Design Options: Overview

Interaction Routing Designer Interface > Interaction Design Window > Options

Interaction Design Window Options: Overview

Selecting Options from the Tools menu opens the Options dialog box. This dialog box contains four tabs:

  • Configuration Tab

  • Appearance Tab

  • Workflow Settings Tab

  • Arranging Options Tab

Note: Options that you specify in the Options dialog box of the Interaction Routing Designer (IRD) main window do not apply to the Interaction Design window. For example, selecting the Autosave timer option does not save Business Processes. Therefore, make sure that you save your work regularly.


Interaction Routing Designer Interface > Interaction Design Window > Options

Configuration Tab Options

The Configuration tab is displayed when the Options dialog box first appears.

This tab contains the following check boxes:

Fix Referential Integrity Errors Automatically (on load)

Select to instruct the application to automatically correct such errors when it loads the Business Process.

For example, if you reassigned objects from one Business Process to another, this change appears in the Log Viewer when you open the Business Process.

Remove Unused Submitter from Configuration (on save)

Select to remove unused Submitter lines that do not connect a View object to a Strategy object.

This can occur if you removed a strategy or view from the configuration, but did not remove the submitter. In this scenario, the submitter is useless.


Interaction Routing Designer Interface > Interaction Design Window > Options

Appearance Tab Options

The Appearance tab contains the following options:

Labels Section

Note: The Labels section enables you to configure the names for objects. Object names are saved in the Scripts folder in the Configuration Database. The Configuration Database does not allow you to use the same name for two objects, even if the objects are of different types, but you can edit the object names in the Interaction Design window to bypass this restriction.

Note: This applies only to objects created in the Interaction Design window. All objects created in the main IRD window or the Routing Design window show their real configuration names in Business Processes, regardless of which option you select.

Namespace Relative

Select to have the Business Process show the result of manually editing a Queue, View, or Workbin object name in the browser or viewer after it has first been saved as a Script object in the Configuration Database.

For example, you might have a Queue object called Inbound e-mails1 and an associated View object named Inbound e-mails2 (see the left-hand figure, below). If you want to name both objects Inbound e-mails, select the Namespace Relative option and edit the object names in the Interaction Design window Object Browser or Workflow Viewer (see the right-hand figure, below).

Note: Editing the object names in the Interaction Design window does not change the name in the Scripts folder.

Real Configuration Names

Select to have the browser or viewer show the object's Script name in the Configuration Database (as in the left-hand figure, above).

Both

Select to show both the edited and Script names of objects (with the Script name in parenthesis).

Fonts Section

Elements

Click Change to specify the font type, style, and the size of the text associated with the elements (for example, Strategy objects, Queue objects, Target nodes, and so on) that are used in the Business Process.

Exits

Click Change to specify the font type, style, and size of text associated with exits (for example, connectors) that are used in the Business Process.

Log

Click Change to specify the font type and size of text displayed in the Log Viewer.

Lower Section

Accurate Printing

Select if you are printing a Business Process that contains overlapping objects, to ensure that all object details print, and that tiny white spaces do not appear.


Interaction Routing Designer Interface > Interaction Design Window > Options

Workflow Settings Tab Options

The Workflow Settings tab contains the following check boxes, which enable you to specify whether each type of object that is listed should be displayed (check box selected) or hidden in Business Processes as displayed in the Workflow Viewer:

Targets | Select to display routing strategy targets as strategy-linked nodes.
Servers | Select to display routing strategy actions (such as those performed by servers) as strategy-linked nodes.
Stops | Select to display routing strategy Stop Interaction objects as strategy-linked nodes.
Edges to Subroutines | Select to hide subroutines and the lines that show connections from strategies to subroutines from the Workflow Viewer display. Doing so reduces the complexity of the layout, making it easier to interpret. Hiding these objects does not remove them from the Business Process.


Interaction Routing Designer Interface > Interaction Design Window > Options

Arranging Options Tab

The Arranging Options tab contains the Accounting for Labels section and two Spacing settings.

Accounting for Labels

The check boxes in the Accounting for Labels section enable you to specify how large labels can be, so that Interaction Routing Designer (IRD) can accommodate the space needed for labels when it arranges objects.

  • You can specify the maximum height (vertical) and width (horizontal) for labels. If you clear a check box, IRD does not consider space requirements for labels in the corresponding dimension.

Spacing

To adjust the spacing between objects and their labels, enter the desired number of pixels in the Spacing Between Ranks (pixels) and Spacing Inside Ranks (pixels) text boxes.

  • The Spacing Between Ranks option sets the number of pixels between one column of objects and the column next to it. You can enter any number between 16 and 160.

  • The Spacing Inside Ranks option sets the number of pixels between the objects in a single column. You can enter any number between 16 and 96.


Interaction Design Menus: Overview

Interaction Routing Designer Interface > Interaction Design Window > menus

Interaction Design Window Menus: Overview

The menu bar at the top of the Interaction Design window contains the following menus:

  • File

  • Edit

  • View

  • Business Process

  • Tools

  • Help

Note: The window's title bar shows the name of the selected Business Process.


Interaction Routing Designer Interface > Interaction Design Window > menus

File Menu

The File menu contains the following items:

Refresh | Reloads the configuration from Configuration Manager, and displays it in the viewer area. The keyboard shortcut is F5.
Save | Saves any configuration changes performed in Interaction Design window. The keyboard shortcut is Ctrl+S.
Import | Opens the Import dialog box. Note: You can import any previously exported Business Process to the active Tenant configuration environment.
Export | Opens the dialog box so that you can export the Business Process to a file. Note: You can later import the exported Business Process to a different Tenant.
Print | Opens the print dialog box so that you can print the currently active Business Process, the Global view, or the Deployment view, depending on your selection in the Object Browser. The keyboard shortcut is Ctrl+P.
Print Preview | Opens a window that displays a preview of the printed output, with buttons that enable you to zoom in and out.
Print Setup | Opens a dialog box that enables you to change print settings.
Close | Closes the Interaction Design window.


Edit Menu_ID

Interaction Routing Designer Interface > Interaction Design Window > menus

Edit Menu

The Edit menu contains the following items:

Undo

After you perform an action on an object, the Undo command becomes Undo <action>. For example, Undo Creating or Undo Updating or Undo Deleting appear after you perform the corresponding action. The keyboard shortcut is Ctrl+Z.

Redo

Select Redo <action> after using Undo <action> to go back to the most recent edit.

After you disconnect an object in the Workflow Viewer, the wording changes to Undo Hide. Selecting Redo restores the deleted connection in the Viewer.

The keyboard shortcut is Ctrl+Y.

Note: After selecting any of the Undo or Redo commands, save the Business Process. After you first select an Undo or Redo command, the tree view shows the change, but the change exists only in a temporary buffer. To make the change permanent, save the Business Process; otherwise, all your changes will be lost.

Find

Opens the Find dialog box, which enables you to search for objects throughout all Business Processes and Independent Objects in the Interaction Design window. For information on how to use this command, see Using the Find Command.

Note: Menu wording may change depending on the action selected.


Interaction Routing Designer Interface > Interaction Design Window > menus

View Menu

The View menu contains the following items:

Object Browser | Removes the Object Browser from view and enlarges the Workflow Viewer area. Click again to bring the Object Browser back into view.
Properties | Displays the Properties dialog box for the selected object.
Log | Removes the Log Viewer from view and enlarges the Workflow Viewer area. Click again to bring the Log Viewer back into view.
Toolbar | Removes the toolbar from view. Click again to bring the toolbar back into view.
Status Bar | Removes the bottom status bar from view. Click again to bring the status bar back into view.
Grid | Removes the grid lines in the viewer and replaces them with a white background. Click again to bring the grid lines back into view.
Page Layout | Displays lines that indicate the print boundaries.
Zoom In | Magnifies the objects in the viewer. The keyboard shortcut is + (plus sign).
Zoom Out | Returns objects to their previous magnification. The keyboard short cut is - (minus sign).
Zoom Normal | After you use Zoom In more than once, select to return objects immediately to normal magnification.


Interaction Routing Designer Interface > Interaction Design Window > menus

Business Process Menu

The Business Process menu contains the following items:

New Business Process

Removes the current Business Process from the Workflow Viewer so that you can start a new Business Process. The Object Browser gives the new Business Process a temporary name, which you can change.

New Queue

Defines a new interaction queue. The Object Browser gives the new queue a temporary name, which you can change. After you rename the new queue, drag it from the Object Browser to the Workflow Viewer.

New Synthetic Queue

Defines a new synthetic queue. A synthetic queue is one that is composed of multiple interaction queues, which simplifies configuration of interaction-processing within a Business Process.

For example, you might define a Tenant Synthetic Queue that includes all queues in a Tenant, so that by putting the synthetic queue into a Business Process, you can enable processing of all interactions in all queues within a Tenant.

New View

Defines a new view. This command becomes available when you select a queue or a workbin in the Workflow Viewer. The Object Browser gives the new view a temporary name, which you can change. The new view is attached to the selected queue or workbin.

New Strategy

Opens the New dialog box in which you name and describe a new routing strategy, and from which the Routing Design window opens, where you can create the strategy. Saving the strategy creates a Script object in the Configuration Database.

After this, you can drag the new routing strategy from to Object Browser to the Workflow Viewer.

New Workbin

Adds a new workbin object to the Business Process that is displayed in the Object Browser.

Add Endpoint

Adds a Media Server Endpoint, which specifies where to put an interaction for further processing by Interaction Server. This command becomes available when you select a Media Server in the Media Server folder.

Delete

Deletes an item. This command becomes available when you select an object in the Object Browser.

Note: If you are deleting a Business Process, this command prompts you to confirm the deletion and then deletes the Business Process and its associated objects.

Disconnect and/or Hide

Disconnects and removes an object from the Workflow Viewer, but does not delete the item from the Object Browser. This command becomes available when you select an object in the Workflow Viewer. If you change your mind, select Undo Clear from the Edit menu. The keyboard shortcut is Del (Delete key).

Arrange Objects

Organizes the objects in the Workflow Viewer so that they are aligned with each other.


Interaction Routing Designer Interface > Interaction Design Window > menus

Tools Menu

The Tools menu contains the following items:

Activate Strategy (ies)

Launches the Strategy Activation Wizard, which provides a convenient way to create a Virtual Routing Point on a switch for the purpose of loading/activating routing strategies.

This command becomes available when you select an individual strategy or a Business Process in the Object Browser. When you select a Business Process, this command enables you to activate several strategies at once.

You can also right-click a strategy in the Workflow Viewer for a currently open Business Process, and then select Activate Strategy from the shortcut menu.

This command requires that a connection be configured in Configuration Manager from the switch to Interaction Server. If such a connection does not exist, selecting this command launches the Strategy Activation Wizard, which guides you through the connection process.

Note: After you activate a strategy (or strategies), the Activate Strategy command remains available for that strategy, because you also can activate it for another Universal Routing Server.

Deactivate Strategy (ies)

Opens the Deactivate 'strategy_name'_Strategy dialog box, in which you can either click Deactivate to deactivate the highlighted strategy, or click Unload to unload it from the routing point. To leave the strategy active, click Cancel.

This command becomes available when you select an activated strategy in the Object Browser or the Workflow Viewer, and the Business Process that contains it is open.

When you select a Business Process in the Object Browser, this command enables you to deactivate several strategies at once.

You can also right-click a strategy, and then select Deactivate Strategy from the shortcut menu.

Edit/View Strategy

Opens the selected routing strategy in the Routing Design window, from which you can view, edit, and save it. This command becomes available when you select a routing strategy in the Object Browser or Workflow Viewer.

You can also right-click a strategy, and then select Edit/View Strategy from the shortcut menu.

Options

Opens the Options dialog box.


Interaction Routing Designer Interface > Interaction Design Window > menus

Help Menu

The Help menu contains the following commands:

Help Topics | Opens Interaction Routing Designer Help.
About IRD | Displays the release and copyright information for Interaction Routing Designer.


Interaction Routing Designer Interface > Interaction Design Window > menus

Shortcut Menus

A shortcut menu appears when you right-click certain objects in the Workflow Viewer or the Object Browser. The content of the shortcut menus varies, depending on they type of object that you right-click.

Note: Not all commands appear in all shortcut menus.

The tables below list the Object Browser and Workflow Viewer objects that have shortcut menus. The commands in the various menus, listed in alphabetical order, are described in the Shortcut Menu Descriptions table (below).

Object Browser Shortcut Menus

In the Object Browser, you can right-click these objects for a shortcut menu:

Folders

Objects

Views

  • Queues Folder

  • Strategies Folder

  • Subroutines Folder

  • Workbins Folder

  • Independent Objects Folder

  • Media Servers Folder

  • Useful Views Folder

  • Business Processes

  • Strategies

  • Queues

  • Server, Target, and Stop Nodes

  • Endpoints

  • Views

  • Workbins

  • Media Servers

  • Independent Objects

  • Global View

  • Deployment View

Workflow Viewer Icon Shortcut Menus

Workflow Viewer Work Area

Objects

Right-click any open space in the Workflow Viewer for a shortcut menu.

Note: This shortcut menu also has a submenu if you select New in the initial shortcut menu.

  • Strategies

  • Queues

  • Server, Target, and Stop Nodes

  • Connectors

  • Media Servers

  • Views

Shortcut Menu Descriptions

Menu Command

Description

Activate Strategy

Launches the Strategy Activation Wizard, which provides a convenient way to create a Virtual Routing Point on a switch for the purpose of loading/activating the routing strategy that you selected in the Object Browser.

This command requires that you configure a connection in Configuration Manager from the switch to Interaction Server. If such a connection does not exist, the Strategy Activation Wizard notifies you.

Then, after running Configuration Manager and connecting Interaction Server to the switch, click Next. The Wizard dialog box appears.

Note: After you activate a strategy, this command remains available for that strategy, because you can activate it for another Universal Routing Server.

Add Endpoint

Adds an Endpoint to a Media Server.

Allow Docking

If a checkmark appears in front of Allow Docking:

  • You can manipulate the user interface by moving the Object Browser area separately from the Workflow Viewer. To remove or insert a checkmark, select Allow Docking.

  • You can place the Object Browser anywhere on your desktop. Simply click and hold down the mouse button, and then move the double bars. You can even place the browser so that it appears in its own window on your desktop, or below or above the viewer.

When you position the Object Browser manually, an indicator line appears, showing where it will be positioned after you release the mouse button.

To return the browser to its default position on the left side of window:

  1. Right-click in the Object Browser, and then select Allow Docking. The checkmark next to Allow Docking disappears and the browser appears disconnected from the viewer.

  2. Right-click in the Object Browser, and then select Allow Docking so that the checkmark reappears.

  3. Move the Object Browser within the viewer. Notice the indicator lines that appear as you move the browser within the viewer.

  4. When the indicator line appears up and down, release the mouse button. The Object Browser appears in its default position.

Bring Forward / Send Back

If objects are overlapping, this command changes the position of the selected object relative to the others in the stack.

Deactivate Strategy

Deactivates the selected strategy. You must do this before you can access the strategy from the Strategies List pane for edit or view operations.

Delete

Removes the selected item after prompting you to confirm the deletion.

Disconnect and/or Hide

When a connector is selected, this command removes it from the display. When an object is selected, this command removes the object and any connected objects from the display. This command does not remove the object from the Business Process.

Edit/View Strategy

Opens the selected strategy in the Routing Design window. This command becomes available when you select a routing strategy in the Object Browser.

Follow

For objects that reference (are shortcuts to) the original version of the object, which is in another Business Process, this command switches to the Business Process that contains the original object.

For example, a Queue object in one Business Process can be a shortcut to the actual Queue object, which was created in another Business Process. This might happen if you decide to break up a large Business Process into smaller associated processes.

Note: The Follow command appears in the Strategy and Queue shortcut menus if the selected object is referenced by an object in another Business Process.

Grid

Toggles on (checked) and off. When checked, the Workflow Viewer displays a grid behind the objects.

Hide

Hides the selected item (Object Browser or Log Viewer) from view. To bring the item back into view, select it from the View menu.

Label / Group

Enables you to create a group of objects with an informative label. For more information on this command, see Grouping and Labels.

Locate

Highlights the selected object in the Workflow Viewer.

New Business Process

Adds a Business Process object in the Object Browser and gives it a temporary name, which you can change.

New Queue

Creates a new interaction queue.

New Strategy

Creates a new strategy.

New View

Adds a new View object to the Object Browser and gives it a temporary name, which you can change.

Open Business Process

Activates the Business Process that you selected in the Object Browser, and displays it in the Workflow Viewer.

Page Layout

Toggles on (checked) and off. When checked, displays lines that indicate page borders for printing.

Properties / Properties Of

Opens the Properties dialog box, in which you can view and (sometimes) modify settings for the object. If the command appears in the menu as Properties Of, a submenu offers a choice of objects for which you can view properties.

Rename

Highlights the name of the selected object so you can delete it or change it.

Show the View

Displays the Global View or the Deployment View displayed in the Workflow Viewer.

Zoom In / Out / Normal

Changes the zoom setting for the Workflow Viewer.


Interaction Design Objects: Overview

Interaction Routing Designer Interface > Interaction Design Window > objects

Interaction Design Window Objects: Overview

Definitions for all configuration objects that are used in a Business Process reside in the Scripts folder in Configuration Manager.

Note: You can only save Business Processes in folders on your network file system; unlike Interaction Routing Designer (IRD) .rbn files, you cannot save Business Processes to a database.

When naming objects, keep in mind that you cannot use the same name for more than one View object per queue. The names of queues and workbins must be unique within a Business Process. The names of strategies must be unique within a Tenant.

The following are the contact-center objects that you define in a Business Process:

  • Queues

  • Synthetic Queues

  • Workbins

  • Views

  • Submitters

  • Strategies

  • Business Processes

  • Endpoints

In addition, certain objects may create Strategy-Linked Nodes.

Following Objects

For objects that reference (are shortcuts to) other objects in another Business Process, select the object, right-click, and then select Follow to switch to the Business Process that contains the referenced object. For example, a Queue object in one Business Process can reference the Queue object in another Business Process.


Interaction Routing Designer Interface > Interaction Design Window > objects

Queue Object

A queue is a logical parking place for an interaction during processing. The Queue Properties dialog box contains the Script Name and Description text boxes, the Enabled check box (which is selected by default), and the and the Default check box (which indicates that this queue is the default queue for the Business Process).

Configuration of the default Queue and default Business Process simplifies Media Server configuration and enables submitting of interactions without having to specify the initial interaction queue.

Note: Only one queue in a Business Process can be set as the default queue.

At a very high level, a Queue object in a Business Process is used as follows:

  1. An interaction starts in the first inbound queue in the Business Process.

  2. Interaction Server pulls the interaction from the queue, based on the criteria defined in a View object, and submits it to a routing strategy or to another queue.

  3. If the interaction is sent to a routing strategy, the routing strategy routes the interaction to a target, but not necessarily the final target. The target can be another queue, an Agent, or a server.

  4. The target processes the interaction and places it into another queue (defined in a Business Process).

  5. This process continues until processing is stopped, or the interaction reaches some final (outbound) queue (defined in a Business Process).

The Genesys Samples demonstrate how interactions can move from a queue to subsequent processing points.

Special Note About Routing Queue Objects

When a routing strategy (Strategy object) that is used within a Business Process contains an IRD Multimedia object that names a queue, a queue of the same name is linked to the routing strategy in the Business Process. The example below shows the Inbound e-mail preprocessing routing strategy linked to the Inbound e-mail postprocessing queue.

You can easily tell whether the creator of the Business Process manually dragged the queue node into workflow, or whether the queue node is linked to a routing strategy that was created in the Routing Design window.

Routing strategy–linked queue nodes flow out of the right side of a Strategy object. For example, in the preceding figure, the Inbound e-mail failure queue is the strategy-linked queue node connected to the Inbound e-mail preprocessing strategy.

A single interaction workflow can contain queues that reside in multiple Business Processes. The icons for such queues contain an upward-pointing arrow in the lower-left corner. This indicates that the icon is a shortcut to the actual queue.

Viewing a Queue in Configuration Manager

After you define a queue and save it in a Business Process, you can also view it in Configuration Manager as a Script object of the InteractionQueue type.

Warning! Use only use the Interaction Design window to edit object properties. Do not alter the definition of any Business Process object in Configuration Manager, otherwise referential integrity might be lost.

See Also:

  • Adding a Queue Object

  • Example Business Process


Synthetic Queue Object

Interaction Routing Designer Interface > Interaction Design Window > objects

Synthetic Queue Objects

A synthetic queue is a logical grouping of interaction queues. Synthetic queues are intended to simplify workflow definition by enabling you to specify interaction processing by multiple queues in a single step.

There are three types of synthetic queues, which are distinguished by their colors from blue Interaction Queues ( [image]), as shown in the following table:

Object Icon | Synthetic Queue Type | Description
 | BusinessProcess | A Business Process Queue represents interactions located in any queue that belongs to the same Business Process as the Business Process Queue. A Business Process Queue can be used to define processing for all interactions of a given Business Process.
 | Synthetic | A Synthetic Queue represents interactions located in any queue that is listed in the Synthetic Queue configuration. A Synthetic queue can be used to define processing for all interactions in a specific group of Interaction Queues.
 | Tenant | A Tenant Queue represents interactions located in any queue that belongs to the same tenant as the Tenant Queue. A Tenant Queue can be used to define processing for all interactions that belong to a tenant.

Note: You cannot place interactions into synthetic queues. Synthetic queues are designed to be used for creating View objects that can process all interactions in any queue included in the synthetic queue.

Viewing a Synthetic Queue in Configuration Manager

After you define a synthetic queue and save it in a Business Process, you can also view it in Configuration Manager as a Script object of the InteractionQueue type.

Warning! Only use the Interaction Design window to edit object properties. Do not alter the definition of any Business Process object in Configuration Manager, otherwise referential integrity might be lost.

See Also:

  • Adding a Queue Object

  • Example Business Process


Interaction Routing Designer Interface > Interaction Design Window > Objects

Workbin Object

A workbin is a target.

  • A strategy within a Business Process can send interactions to workbin targets.

  • Agents can pull interactions from workbins.

You can create a workbin for a specific Agent, group of Agents, place, or group of places.

You configure workbin objects in a strategy. When you add a strategy that contains workbins to a Business Process, these workbins automatically appear in the Business Process, like other targets.

When an interaction is placed in the Workbin, the Agent(s) that are associated with the workbin might receive a notification.

For an explanation of the Workbin Properties dialog box, see Adding a Workbin Object.


Interaction Routing Designer Interface > Interaction Design Window > Objects

View Object

A view provides a way to define the criteria for pulling interactions from a queue or a workbin and submitting them to the appropriate routing strategies. It specifies the conditions under which interactions are pulled, and the order.

When you define a view, it appears in the Object Browser underneath its associated object (queue or workbin). It also appears in the Workflow Viewer as a small globe attached to its associated object, as shown below.

For an explanation of how to configure a View object, see Adding a View Object.

Same Queue, Different Views

You can define multiple View objects for a single Queue object.

  • Example #1: You may want to define multiple views for a queue if you need to deliver interactions from one queue to different strategies. For example, assume that E-Mail Server Java submits all e-mails into one queue, but there are two separate strategies: one for normal e-mails, and another for nondeliverable e-mails. In this case, you may wish to specify two views.

  • Example #2: You may want to define multiple views for a queue for the purpose of priority escalation. One view could be used to pull an interaction for standard processing by a strategy that delivers it to an Agent. Another view could be used to pull an interaction for special processing by a strategy that changes the interaction's priority and then places it back into the same queue.

If you configure multiple views for the same queue, and the view's selection conditions overlap, the same interaction can potentially be selected by more than one view. However, the check-out/check-in mechanism ensures that the same interaction cannot be selected for processing by more than one view at the same time.

Viewing a View in Configuration Manager

After you define a view and save the Business Process, you can also view it in Configuration Manager as a Script object of the InteractionView type.

Warning! Use only the Interaction Design window to edit view properties. Do not alter the definition of any Business Process object in Configuration Manager; otherwise, referential integrity may be lost.

See Also:

  • Adding a View Object


Interaction Routing Designer Interface > Interaction Design Window > Objects

Submitter Object

When you connect a View through its output port to a routing strategy, this action defines criteria based on which a Submitter directs Interaction Server to take specific interactions from the queue, and submit them to the routing strategy.

  • A Submitter object is the connector between a queue or workbin and the routing strategy to which the View directs interactions. Each Submitter connects one View to one routing strategy (as shown in the following figure).

When a Submitter object exists, Interaction Server submits to the strategy all interactions that reside in the queue and satisfy the rules of the View.

Viewing a Submitter in Configuration Manager

After you define a Submitter and save the Business Process, you can also view it in Configuration Manager as a Script object of the InteractionSubmitter type.

See Also:

  • Adding a Submitter Object


Interaction Routing Designer Interface > Interaction Design Window > Objects

Strategy Object

In a Business Process, a Strategy object typically appears as the target of a View object (connected by a Submitter object). Strategies are constructed using the various strategy-building objects.

Notes:

  • A particular Strategy object can be used only once in a Business Process, but it can be used in multiple other Business Processes.

  • The icons for strategies used in multiple Business Processes contain an upward-pointing arrow in the lower-left corner. This indicates that the strategy was first used in another Business Process.

  • When a Strategy object is automatically or manually placed in the Workflow Viewer for a Business Process, its icon appears in the Object Browser with a small yellow arrow in the bottom-right corner. This indicates that the strategy is being used in the Business Process.

  • The icons for activated strategies appear in both the Workflow Viewer and in the Object Browser with a small green arrow in the upper-right corner.

  • Any strategy in your Business Process that uses a Multimedia object automatically appears in the Workflow Viewer. If, after placing the Strategy object in the Workflow Viewer, you remove all Multimedia objects from the strategy, IRD removes all strategy-associated objects from the Workflow Viewer, but does not automatically remove the Strategy object itself. If you wish to remove the Strategy object from the Workflow Viewer, you must do so manually.

IRD Strategies List and Interaction Design Window

After you open the Interaction Design window, the Object Browser lists all Strategy (routing strategy) objects that are included in the Strategies List in the IRD main window. Those used in a Business Process are listed under it.

Strategies that are not used in a Business Process are listed in the Independent Objects folder. Some of these may not be applicable to your Business Processes—for example, strategies that handle only voice interactions.

Expanding such a Strategy object displays a list of the Agents, Agent groups, and targets (such as servers) that appear as strategy-linked nodes.

Note: A routing strategy must be assigned and activated in order to send interactions to the entry-level queue in a Business Process.

See Also:

  • Adding a Strategy Object


Interaction Routing Designer Interface > Interaction Design Window > Objects

Business Process Object

A Business Process object defines interaction processing steps that enable you to handle specific business objectives. To do this, it uses Queue, View, Strategy, and Workbin objects.

The names of your Business Process objects are displayed as headings in the Object Browser.

Using Business Processes

In order to route interactions from one Business Process object to another, you build routing strategies that include Queue Interaction objects. For example, assume that you want to connect Business Process A, which contains routing strategy A, to Business Process B, which contains routing strategy B. In this case, you simply make the input queue for routing strategy B the same as the output queue for routing strategy A.

A Queue or Strategy can be used in multiple Business Processes. The icons for such Queues or Strategies appear in the Workflow Viewer with an upward-pointing arrow in the lower-left corner. This indicates that the icon is a shortcut to the actual Queue or Strategy.

Default Business Process

You can set a Business Process to be the default Business Process for the Tenant. Configuration of the default Queue and default Business Process simplifies Media Server configuration and enables submitting interactions without having to specify the initial interaction queue.

Notes:

  • See the Multimedia documentation for how to develop a Media Server object that takes advantage of the default Business Process and default Queue configuration.

  • Only one Business Process within a Tenant can be set as default.

Switching to a Different Business Process

In order to view the objects within a Business Process, you must open the process. To change the Business Process object that is displayed in the Workflow Viewer, right-click the Business Process that you want to open, and then select Open the Process from the shortcut menu.

Viewing a Business Process in Configuration Manager

After you define a Business Process object in the Interaction Design window and save it, you can also view it in Configuration Manager as a Script object of the Business Process type.

Warning! Use only use the Interaction Design window to edit the properties of a Business Process. Do not alter the settings for any Business Process object in Configuration Manager; otherwise, referential integrity may be lost.


Strategy Linked Nodes

Interaction Routing Designer Interface > Interaction Design Window > Objects

Strategy-Linked Nodes

When a strategy processes an interaction, it is eventually routed to an Agent, placed into a queue, or stopped (which indicates that no more processing is necessary). In some cases, the strategy needs to create a new interaction—for example, by calling a third-party server that creates a new interaction, such as Acknowledge, CreateSMS, and so on. The various possible destinations (queue, stop, Agent, third-party server) are called strategy-linked nodes. They represent the possible outcomes when a strategy processes an interaction.

  • For complete list of objects that generate strategy-linked nodes in a Business Process, see the "Summary of Multimedia Objects" table in the Universal Routing 7.6 Reference Manual.

Interaction Routing Designer (IRD) shows such possible ways of processing an interaction processing in the Workflow Viewer. To distinguish existing interactions from new ones, the lines connecting an object that creates a new interaction and the destination for the new interaction are red instead of black.

  • If a strategy places the interaction in a queue, IRD inserts a queue node, and draws a connection between the strategy and the queue.

  • If a strategy stops interaction processing, IRD inserts a stop node and connects it to the strategy.

  • If a strategy calls a third-party server that creates a new interaction and places it into a queue, IRD inserts the server node, and connects it to both the strategy and the queue.

  • If a strategy routes the interaction to an Agent, IRD inserts a target node, and connects it to the strategy. If the Agent is supposed to stop interaction processing, IRD inserts a Stop node, and connects it to the target node. If the Agent is supposed to place the interaction into a queue, IRD connects the target node to the queue. If the Agent is supposed to create new interaction and place it in a queue, IRD connects the target node to the queue with a red line.

For example, assume that a strategy specifies two queues to which interactions should be directed, Interactions with new contacts and Interactions with existing contacts. When the strategy is placed into a Business Process, these queues, and their connections with the strategy, appear without having to be manually created (see the first following figure).

Note: You cannot remove the connector between the strategy and the strategy-linked node by deleting it.

A saved Strategy object in a Business Process can automatically link to the following object types:

  • Queues —If the Strategy object uses an IRD Multimedia or Routing object that names a queue, a queue icon (node) with the same name is linked to the strategy in the Business Process. In the following figure, Interactions with new contacts and Interactions with existing contacts are queue nodes.

  • Servers—If the Strategy object names a third-party server, a Server object appears in the Business Process with the name of the action that it performs. The following figure shows an example of a Server object (Acknowledge). Because the Acknowledge object creates a new outgoing interaction, this interaction and its target are also inserted into the Business Process. Therefore, in this figure, the red line is the automatically placed connector between the Acknowledge object and its target (not shown).

  • Target Nodes—If the Strategy object uses an IRD Route Interaction object that specifies a routing target, such as a person (representing an Agent, supervisor, QA, or another person defined in Configuration Manager), a node with the same name appears in the Business Process. The following figure shows an example of a Target node (sschlich) is shown below. Target-type nodes can also represent Agent groups, campaign groups, place groups, and places.

  • Stop Nodes—If the Strategy object uses the IRD Stop Interaction Multimedia object, a Stop node appears in the Business Process, as shown in the following figure.

Note: To specify which objects are displayed in the Workflow Viewer, use the Workflow Settings tab of the Options dialog box.

For information about the specific IRD objects that trigger strategy-linked nodes in a Business Process, see the Universal Routing Business Process User's Guide.


connectors

Interaction Routing Designer Interface > Interaction Design Window > Objects

Connector Lines

Connector lines join one object in a Business Process to another. When the line connects a Queue object and a Strategy object, this connector is called a Submitter object.

  • A black line indicates an existing interaction.

  • A red line indicates a new interaction that is created as processing moves from the object of origin to the target object.

Depending on the type of object, connectors may be placed automatically (which displays as a dotted line), or you may need to place them manually (which displays as a solid line).

  • To add a connector, hover your cursor over the object where the connector should start. When the cursor becomes a pointing hand, hold down the left mouse button and move the cursor to the object where the connector should end.

  • To delete a connector, select it, and then press the Delete key; or, right-click the connector, and then select Disconnect and/or Hide from the shortcut menu.

Note: You cannot delete a connector that has been automatically placed, or delete the object to which it connects. Instead, you must edit the object that generated the automatically-placed connector so that it no longer contains that particular strategy-linked node.

Note: To remove an object from a Business Process: in the Object Browser, drag it from the Business Process folder and drop it into the Independent Objects folder.

Reshaping the Connector Line

  • To reshape a connector, select it, place the cursor over one of the red X's that mark the ends of the lines and the control points along the line's Bezier curve, and drag the X to a new location. Continue moving the red X's until the line is placed as you want it.


Interaction Routing Designer Interface > Interaction Design Window > Objects

Media Server Object

To start handling a customer interaction, you must place it in a Business Process. The only way to do this is to use a Media Server object, which then directs the interaction to an interaction queue. Normally, the Media Server object is the first object in a Business Process or a series of linked Business Processes, but in some cases, you may also use Media Server objects elsewhere.

Note: The small globe that is attached to the Media Server object (shown at the top of this page) represents an Endpoint object.

Genesys Media Servers

The Genesys Multimedia software components include E-mail Server Java and Chat Server, which process e-mail and chat interactions, respectively. You can also configure Third-Party Server objects, which can handle any type of media. Your enterprise’s Media Servers appear as Media Server objects in a Media Servers folder in the Interaction Design window.

  • E-mail Server Java interfaces with the enterprise mail server and the Genesys Web API Server; bringing in new e-mail interactions from customers, and sending out replies or other outbound messages.

  • Chat Server works with Web API Server to open, conduct, and close chat interactions between Agents and customers.

  • Third-Party Server objects work with whichever server handles the media type that corresponds to the media that is configured for the Third-Party Server Media Server object.

For more information about the Media Servers, start with the Multimedia 7.6 Deployment Guide.


Interaction Routing Designer Interface > Interaction Design Window > Objects

Endpoint Objects

An Endpoint connects a media server with a queue in a Business Process. All types of media servers (e-mail, chat, and so on) eventually submit interactions to Interaction Server.

Endpoints are able to connect Media Servers and queues, because both Media Servers and Interaction Routing Designer (IRD) understand them. Each Endpoint maps itself to a queue in a Business Process. The following figure illustrates this concept.

How Interaction Server Determines the Initial Interaction Queue

A Media Server can use either its own configuration or the Endpoint configuration to provide the queue name when it submits interactions to Interaction Server. If the Media Server does not provide a queue when it submits an interaction, Interaction Server uses the Endpoint configuration or the default Business Process and default queue configuration to resolve which interaction queue to use.

The following steps are performed to resolve the queue:

  • If the Media Server provides a Tenant identifier or if Interaction Server detects that the Media Server is configured to support only one Tenant, then only interaction queues that belong to that Tenant are considered. If any other queue is specified, the submit request is rejected.

  • If the Media Server provides a queue name in the submit request and the queue exists, this queue is used as the initial interaction queue for the new interaction.

  • If the queue that is provided does not exist, but a Business Process with that name does exist, and there is a default queue that has been defined for this Business Process, the default queue is used as the initial interaction queue for the new interaction.

  • If exactly one Endpoint has been defined for the Tenant, the queue specified in the Endpoint configuration is used as the initial interaction queue for the new interaction.

  • If there is a default Business Process configured for the tenant, and there is a default queue for this Business Process, then this default queue is used as the initial interaction queue for the new interaction.

Endpoints in the Interaction Design Window

The Object Browser in the Interaction Design window contains a Media Servers folder. This folder contains all of the Media Servers that are defined in IRD's configuration environment. Expanding a Media Server in the Object Browser displays its Endpoints.

Multiple Endpoints

If the Business Process design handles various categories of interactions, you may want more than one Endpoint for a particular Media Server (as shown in the following figure).

For example, assume that you have an e-mail Business Process that handles multiple major categories of interactions: sales, service, and information. Assume also that there are three queues in the Business Process, each of which accepts interactions for one of the three categories.

To implement this in a Business Process:

  1. Define two new Endpoints for the Media Server, one each for sales and service, and configure the default Endpoint to handle information e-mails.

  2. Connect each of the three Endpoints to its corresponding queue in the Business Process.

  3. Because E-mail Server Java works with E-mail Accounts, use Configuration Manager to associate the E-mail Accounts with the three Endpoints.

For information about Endpoints in the Media Server Application object in Configuration Manager, see the Multimedia 7.6 Reference Guide.

See Also:

  • Adding an Endpoint


Interaction Routing Designer Interface > Interaction Design Window > Objects

Grouping and Labels

You can create a group of objects within a Business Process and label it. This enables you to mark out, for easy viewing, a set of objects that have something in common. The following figure shows an example of a group of object that are used for processing Open Media interactions.

You can also create a label that is not connected to a specific object or group—for example, in order to add a comment about the Business Process. For details, see Creating an Unattached Label, below.

To create a group:

  1. Select the objects that you want to group by clicking each one as you hold down the Ctrl key.

  2. Right-click any of the selected objects, and then select Label/Group from the shortcut menu. The Group Properties dialog box appears.

  3. In the Label text box, enter the text that you want to use as the group's label.

  4. If you want the group to have a border (to set the objects in it apart visually), select the Has Border check box. (This check box is selected by default.)

  5. If you want the label text to wrap, select the Multiline check box. (This check box is selected by default.)

Note: The Multiline word wrapping functionality works differently than in text editors such as Notepad. It affects how the text looks when it appears on the Workflow Viewer, not how it looks as you type it in. The text does not show as wrapped until it appears on the Workflow Viewer.

  6. If you want the group to be handled and arranged as a unit, select the Subgraph check box. Selecting this check box automatically selects the Has Border check box as well.

  7. In the Align section, select the appropriate options to position the label where you want it. You can select either Left or Center and either Top or Bottom. (Top and Left are selected by default.)

  8. Click OK.

The new group, with its label, appears in the Workflow viewer.

To remove an object from a group:

  • Right-click the object, and then select Remove from Group from the shortcut menu.

To remove a group, do one of the following:

  • Remove all the objects from the group one by one.

  • Right-click the group border or the group label and then either select Disconnect And/Or Hide from the shortcut menu, or press the Delete key.

To change the properties of a group:

  • Right-click the group border or the group label and select Properties from the shortcut menu.

To add an object to a group:

  • Create a new group that includes all of the objects that you want grouped.

Grouping Considerations

  • An object cannot belong to more than one group.

  • You cannot create nested groups (that is, one group cannot contain another group).

Creating an Unattached Label

To place a label in an open area of a Business Process:

  1. In the Workflow Viewer, right-click the spot where you want the label. The Label Properties dialog box opens.

  2. Enter the text to be displayed in the Workflow Viewer.

  3. If your label has more than one line, select a radio button to set the text alignment. The alignment setting does not affect single-line labels.

  • To create a multi-line label, press Enter each time you want to start a new line. Text is not automatically broken into separate lines as you enter it.

  4. Click OK.

The label appears in the Business Process.

  • To move the label, left-click it, and continue to hold down the left mouse button as you drag the label to a new location.

  • To edit the label, right-click it, and then select Properties from the shortcut menu.


Setting Routing Design Options

Setting Routing Design Options: Overview

Most IRD settings are configured in the Routing Design Options dialog box.

  • This section of the Help also explains how to set Event Log properties.

The Routing Design Options dialog box enables you to customize the Routing Design window.

  • To open the Routing Design Options dialog box, select Routing Design Options from the Tools menu from the Main window or the Routing Design window.

Use the Routing Design Options dialog box to:

  • Change the graph settings.

  • Specify storage settings.

  • Set default fonts.

  • Control which objects appear in the Routing Design window, the Interaction Design window, Monitoring view, and from the Event Log Viewer.


Setting Routing Design Options

Graph Settings

The graph settings in the Routing Design window enable you to determine what the window looks like and how objects behave when you place them there.

To change graph settings:

  1. From the Tools menu, select Routing Design Options. The Routing Design Options dialog box opens.

  2. Click the Graph Settings tab. Select or clear any of the following options, and then click OK to save your settings.

Show Properties On Drop

Automatically opens the Properties dialog box for an object when you place an object in the Routing Design window.

Show Conditions On Graph

The output ports of some objects (Segmentation objects, the If object) have conditions that specify when the control flow will go through these ports. If enabled, this option directs IRD to label all connection lines going from the ports of such objects with their conditions.

Note: Whether you select this option or not, you can see the condition by hovering the cursor over the connection line going from the object’s output port, or by hovering over the object’s output port itself while holding down the [Shift] key.

Show Monitor Labels On Graph

Displays text boxes similar to those that show real-time distribution numbers and percentages in Monitoring view. Use these monitor labels to arrange objects in preparation for monitoring a strategy so that there is enough space between objects for the Monitoring view labels. Do not select this option for normal viewing.

When this option is selected, note the following:

  • These are placeholder labels. They do not show numbers and percentage of interactions. Actual figures appear only when you monitor the strategy in Monitoring view.

  • The connectors between objects are sometimes visible through the labels.

Note: When you open the Properties dialog box for any object, this option is automatically cleared and the placeholder monitor labels disappear. You must reopen the Routing Design Options dialog box and select this option again to see the labels.

Round Angle Connections

Changes the form of lines connecting strategy objects from rectangular to rounded, which can sometimes clarify strategy flow.

Show Description of Objects On Graph

IRD provides most strategy objects in the Routing Design window with a short description. If enabled, this option directs IRD to show the object description on top of each object. If you move an object, the object description moves with it.

IRD automatically creates a default object description based on the object's properties. This description is automatically updated when the object's properties are updated. You can also manually edit the descriptions. After you manually edit an object description, IRD retains the manually-entered description even if you subsequently update the object's properties.

You can return to the default object description by right-clicking the object and selecting Set default.

Notes:

  • Objects with conditions (Segmentation objects, the If object, as described in Show Conditions On Graph, above) have no description of their own.

  • Whether you select this option or not, you can see the short object description by hovering the cursor over the object while holding down the [Shift] key.

  • In addition to this short description, you can provide any object with any number of attached comments. To do so, right-click inside the Routing Design window workspace and select Attach comments. Comments are also moved together with the object. Attached comments are always displayed, regardless of this option's setting.

  • If you enable this option, when you print a strategy, these description labels are printed also.


Setting Routing Design Options

Storage Settings

Every strategy consists of a Script object plus an .rbn file. Storage settings control how IRD works with .rbn files.

You can specify the location where strategy .rbn file is stored in one of following ways:

  • Set a default storage location for each Tenant in Configuration Manager.

  • Set the storage location when saving a strategy.

To view or edit storage settings:

  1. From the Tools menu, choose Routing Design Options. The Routing Design Options dialog box opens.

  2. Select the Storage Settings tab.

  3. Keep the default working directory or browse to a different one.

The working directory is the location where IRD creates temporary files when you work with strategies. By default the working directory is where IRD was installed.

The IRD user must have write permissions to the working directory. If for some reason this default location is not acceptable (for example, if you do not have write permission to the location where IRD is installed) change the location.

For more information about the working directory, see About the Working Directory.

Note: Never use the IRD working directory as the permanent storage location of the .rbn file for any strategy.

  4. Select the Autosave Timer option to automatically save a currently active and open strategy or subroutine at a specified interval while the strategy or subroutine is being edited. If IRD shuts down or freezes, you can restore the last autosaved version.

  5. Click the up or down arrows to set the Autosave interval. This is the number of minutes after which IRD should automatically save any active and open strategy or subroutine.

  6. Normally you should leave Compatible strategy saving mode cleared (the default). Select this option only if you want to save a strategy created using IRD 7.6 in compatible mode so that it can be opened with an older version of IRD (previous to 7.1). When cleared, IRD saves the strategy in a memory-efficient format.

  7. Click OK.

About the Working Directory

In the working directory, IRD creates the log and importstr subdirectories. Depending on your activities in IRD, the working directory can also contain the following files: import.log (after importing), export.log (after exporting), copyas.log (after performing a save as), and save.log (after saving).

  • IRD uses the log subdirectory to store Event Log files.

  • IRD uses the importstr subdirectory as a temporary storage location for .rbn files for currently opened strategies or subroutines.

About the importstr Subdirectory

  • When you open an existing strategy for editing, a temporary file, called <file_name>.rbn, is immediately created in the importstr directory.

  • When you create a new strategy, a <file_name>_temp.rbn file is created at the Autosave timer interval, if you have not yet saved manually.

  • The first time you open the Save dialog box for a new strategy, a <file_name>.ooo file is created. When you save manually, the <file_name>.ooo and the autosave <file_name>_temp.rbn file are deleted. They are replaced with the <file_name>.rbn file. After that, at each Autosave Timer interval the <file_name>_temp.rbn file is recreated and stores updates until you manually save again.

Note: Genesys recommends periodically checking the content of the importstr folder for cleanup purposes. Under certain conditions, the temporary .rbn, .str, and .ooo files automatically generated for a new strategy are not automatically deleted from importstr folder. This may happen for various reasons, including an unexpected IRD shutdown, an abnormal user exit, or a disconnect from Configuration Server.

See also:

Strategy Storage Location When Saving

Default Storage Location by Tenant

Restoring from a Temporary File


Setting Routing Design Options

Default Font

To change the default font used for strategy and subroutine comments, object descriptions, and connector descriptions:

  1. From the Tools menu, choose Routing Design Options. The Routing Design Options dialog box opens.

  2. Select the Default font tab.

  3. Select your preferred font settings.

  4. Click OK to save the settings and close the dialog box.

Note: When you change the default font, IRD does not automatically apply the new font to previously-created objects. You must manually change the font in existing comments and descriptions.


Setting Routing Design Options

Views Tab Settings

The Views tab enables you to select which objects appear in the Main window's Shortcut bar and View menu. For example, if you never use macros in your strategies, you may want to remove the Macros icon from the Shortcut bar.

To change the Main window View settings:

  1. From the Tools menu, choose Routing Design Options. The Routing Design Options dialog box opens.

  2. Select the Views tab. The Views tab of the dialog box contains a list of the object types that you can display in the Routing Design window. By default, all object types are selected.

  3. To customize the settings, clear the Default check box to activate the scroll bar so that you can see all of the object types.

  4. Clear the check boxes for any object types you want to remove from the Main window Shortcut bar and View menu.

Notes:

Clearing a check box makes that object type unavailable for use in strategies or subroutines. Nor can you view that object type in the Main window List pane.

You cannot clear the Routing Design or Strategies check boxes.

  4. Click OK. The new settings take effect immediately.


Setting Routing Design Options

Event Log Filter Properties

The Event Log Properties dialog box contains two tabs, Filter and File.

  • Filter—Enables you to set the event sources and types written to the Event Log, the date range, and the diagnostic level.

  • File—Enables you to set the maximum log file size and the maximum number of log files before the oldest is automatically deleted.

The Working directory specified in the Storage Settings tab of Routing Design Options dialog box controls the location of the log.

To open the Event Log Properties dialog box:

  1. From the Shortcut Bar, click Event Log, or select View Log from the View menu.

  2. In the Event Log List pane, right-click and select Properties from the shortcut menu.

The Event Log Filter Tab

To configure the Filter tab:

  1. Indicate from which applications the Event Log should record event messages by selecting one or more of the Event Sources check boxes.

  2. Indicate the event types to be logged by selecting one or more of the Event Types check boxes.

  3. Click the down arrow next to the From: text box and select Event First or Event On. If you select Event On, select the starting date and time for logging.

  4. Click the down arrow next to the To: text box and select Last Event or Event On. If you select Event On, select the ending date and time for logging.

Note: If you select Event First and Event Last, the log shows all events, despite any other date and time selection.

  5. In the Level of diagnostics text box, select a level from 1 to 3. The higher the number, the more information is logged.

  6. Click OK.


Setting Routing Design Options

Event Log File Properties

The Event Log Properties dialog box contains two tabs, Filter and File.

  • Filter—Enables you to set the event sources and types written to the Event Log, the date range, and the diagnostic level.

  • File—Enables you to set the maximum log file size and the maximum number of log files before the oldest is automatically deleted.

The Working directory specified in the Storage Settings tab of Routing Design Options dialog box controls the location of the log.

To open the Event Log Properties dialog box:

  1. From the Shortcut Bar, click Event Log, or select View Log from the View menu.

  2. In the Event Log List pane, right-click and select Properties from the shortcut menu.

The Event Log File Tab

To configure the File tab:

  1. The Log name text box is read-only and identifies the log file you are currently viewing.

  2. Type in a value or click the up and down arrows to specify the Maximum log size. This is the size the log file can reach, in kilobytes, before IRD creates a new log file.

  3. Type in a value or click up and down arrows to specify the Maximum number of log files that can accumulate before the oldest is automatically deleted.

  4. Click OK.


Preparation and Planning: Overview

Preparation & Planning

Preparation & Planning: Overview

Before you begin to use Interaction Routing Designer (IRD) for the first time:

  • Obtain write permission for the directory where IRD is installed.

  • Set the Graph and Autosave options, and set a default storage location. See Setting Routing Design Options.

  • Review the IRD Configuration Constraints for limitations on lengths of object names and other similar considerations.

Planning a Strategy

Creating a strategy without preliminary planning greatly increases the likelihood that your strategy will function differently than you intended. To save time and reduce aggravation, before you begin constructing a strategy you should:

  1. Plan the overall voice routing strategy flow. For an overview of the preparation required for non-voice strategies, see Planning a Non-Voice Strategy.

Note: For examples to use as guides, see Sample Strategies. Also see Universal Routing 7.6 Strategy Samples. Each resource contains samples of both voice and non-voice strategies.

  2. Define reusable objects and data.

  3. Create the Configuration objects that you intend to use in the strategy.

  4. Create the necessary objects for querying a database in Configuration Manager.

You are now ready to create the strategy.

When you are finished creating a strategy, see Loading a Strategy and Editing and Managing Strategies.


Preparation & Planning

IRD Configuration Constraints

When creating or modifying strategies and Business Processes in IRD, note that:

  • The names of all IRD reusable objects and data (strategies, routing rules, schedules, and so on) as well as Interaction Design window configuration objects (Business Processes, queues, and so on) are limited to alphanumeric characters and cannot begin with a space, an underscore, or a hyphen. Please note that although some IRD objects allow you to enter names containing special characters, Genesys strongly recommends not using them.

  • The maximum length of an IRD object name is shorter than the maximum length of any Configuration Server object name, which is 254 bytes (characters). For example, the name of a strategy can contain only 194 characters. However, the maximum length of all Interaction Design objects is 254 bytes, which corresponds to the Configuration Server limit.

  • The underscore (_) is the only character that you can use in the middle of the name of any strategy, reusable object, service, method, method parameter, or any other strategy object that results in the execution of an external or internal service or procedure. Specifically, using commas and square brackets as data separators can make IRD incorrectly interpret the entered values if those symbols are used in Voice Treatment, Data and Services, Multimedia, or Outbound objects.

  • Using single quotation marks in the key field of a key/value pair in the following IRD objects causes bogus data to be displayed in the value field: Send Email, Acknowledgement, Autoresponse, Create Email Out, Create SMS, and Create Notification objects.

  • Integer variables can have a maximum value of around four billion, with a range of -2 billion to +2 billion. If a value exceeds the maximum for an integer variable, the number wraps back around. If the number is larger than largest allowed number, the integer variable wraps to a negative number. If the value number is smaller than the smallest allowed number (around negative four billion), the integer variable wraps back into being positive. In any case, the returned number will be an error.

  • Skill expressions (used by the Selection and Service Level Routing objects) cannot exceed 100 elements (skill names, numbers, comparisons, and logical operands), that is, a skill expression should have no more than 25 constructions, such as English > 1. This limitation is especially important to observe with Service Level routing rules, which use skills internally, i.e., every skill criteria used in a Service Level routing rule generates 1-3 constructions like Skill > Number.

  • The maximum size of an overall skill expression (as text) cannot exceed 10239 bytes.

  • The length of a string using the format "placename@statservername.AP agentname@statservername.A" for any routing target cannot exceed 253 bytes.

  • The maximum length of a request to Custom Server or DB Server through XData (used for 5.x strategies) cannot exceed 10239 bytes.

  • When creating a list of key/value pairs that use a string format (example: aaa:5|gggg:123|...), the maximum Key length cannot exceed 1000 bytes and the maximum length of one key/value pair cannot exceed 4096 bytes.

  • When using the Database Wizard object to query a database, the maximum size of a SQL statement created by the Database Wizard cannot exceed 1010 bytes.

  • When using the IRD statistical adjustment functions, the name of an object plus the name of the statistic cannot exceed 250 bytes.

  • The name of a single target (including skill groups) cannot exceed 256 bytes.

If you do not observe these limitations, the result could be routing to an incorrect destination, URS unexpectedly shutting down, or not performing a requested operation.


Preparation & Planning

Universal Contact Server Database

The Universal Contact Server (UCS) database stores information about customers (contacts), as well as contact history. When you create classification categories, screening rules, and standard responses, Knowledge Manager writes them to the UCS database.

Creating Interaction Records in the UCS Database

In most cases, interaction records are created in the UCS database without URS involvement.

  • For voice interactions, after an Agent clicks Mark Done in Genesys Desktop, the UCS Database is updated. Agents and supervisors can also use the Genesys Desktop application to add and edit contacts and contact history in the UCS Database, as explained in Genesys Desktop Help.

  • For e-mail interactions, which arrive via the enterprise e-mail server or from a website via the Web API Server, E-mail Server Java stores the body of the interaction in the UCS Database and sends the operational data to Interaction Server.

  • For web media, such as chat, Chat Server writes the contents of each chat session to the UCS Database.

Creating Open Media Interactions in the UCS Database

For Open Media interactions, no records are created in the UCS Database unless you use the Open Media UCS API or the Create Interaction object.


Preparation & Planning

Establishing Access Control

Access control enables you to set up permissions for objects. You can specify permissions for individual objects, groups of objects, and user groups for these objects. Permissions are set using Configuration Manager.

  • The permissions are No Access, Read, Change, Full Control, and Special Access.

  • Within the Special Access permission, you can select Full Access or any combination of Read, Create, Change, Execute, Delete, Read Permissions, Change Permissions, and Read and Execute.

When a user logs into Interaction Routing Designer (IRD), he or she is granted access to objects based on his or her group membership and object permissions. The Access setting appears in the List view for each object for IRD, according to following table.

Access Control Type | Appears in IRD List View As (R=Read, H=Change, D=Delete)
No Access | Does not display
Read | R
Change | RHD
Full Access | RHD
Special Access | Depends on the option(s) selected: Full Access: RHD Read: R Create: R Change: RH Execute: R Delete: RD Read Permissions: R Change Permissions: R Read and Execute: R

See Strategies List pane for a figure that shows how the Access settings are displayed.

Note: Because access control can be specified for .rbn files (the strategy file as stored in Configuration Server), you can deny access to any strategy used in production.

To set up permissions:

  1. Launch Configuration Manager.

  2. Select the object or the folder for which you want to set up permissions.

    Strategy objects are grouped together in folders. See Components of a Strategy for information on where objects are located in Configuration Manager.

  3. Right-click and choose the Properties command from the submenu to display the properties dialog box.

  4. On the Security tab, click Permissions to open the Object Permissions dialog box.

  5. In the Name section, select the name of the individual or group for which you want to set up the permission.

  6. From the Type of Access drop-down list, select the access level.

  7. Click OK to close the Object Permissions window, and OK again to close the dialog box.

See also:

  • "Interaction Routing Designer Objects" chapter in the Universal Routing 7.6 Reference Manual for more information on access control.

  • Framework 7.6 Configuration Manager Help for more information on Configuration Manager and using the Security tab.


Preparation & Planning

Components of a Strategy

The following components make up a strategy:

  • A strategy configuration object (also called a Script object)&emdash;Stores strategy information such as the compiled bytecode, size, path, and other properties in the Configuration Layer.

  • An .rbn file&emdash;Stores the graphical elements of a strategy or subroutine.

  • Transaction configuration objects&emdash;Objects such as routing rules, interaction data, business rules, attributes, and statistics used in the strategy and stored in the Configuration Layer. All objects created in IRD are saved here except strategies, subroutines, and schedules.

  • Field, Format, and Table Access configuration objects&emdash;Objects required when the strategy includes a database object used for describing SQL select statements and stored procedures; these objects are also stored in the Configuration Layer.

  • Other Configuration objects such as Persons and Queues.

Note: If an IRD strategy uses Switch-to-strategy routing rules or subroutines, then the .rbn files, Script objects, and Transaction objects used by the other strategies are components of the parent strategy. These components must also be provided when sharing a strategy.

See also:

  • Importing a Strategy


Planning a Voice Strategy Overview

Preparation & Planning > Planning a Voice Strategy

Planning a Voice Strategy: Overview

Before you begin building a voice interaction strategy by opening the Routing Design window and placing objects in a logical sequence, you should plan out the flow. Building a voice routing strategy can involve the following objects/phases:

  1. Identifying your customer.

  2. Segmenting the interactions.

  3. Applying additional processing, which is usually done using the objects from the Miscellaneous Objects toolbar, such as Function, Macro, If expression, or Call Subroutine; or you may attach data using the Multi-Attach object.

  4. Routing the interactions.

As a voice interaction makes its way through its life cycle, you may specify types of processing, such as:

  • Voice Treatments.

  • Database lookups.

  • Error processing.

See also:

Understanding Business Attributes

Understanding Service Objectives

Sample Strategies

Creating a New Strategy


Preparation & Planning > Planning a Voice Strategy

Identification Phase

The identification phase involves analyzing who is contacting you. In particular, you need to decide what information about your customers will best determine how to direct each caller to the most suitable target and how to collect it. This information is made available in the form of interaction data.

Interaction data is attached to the interaction and can then be used for screen pops, reporting, and routing. Data gathered in the identification phase can be used in strategy objects. Interaction data of some sort is required for Segmentation.

You might analyze your customers by asking yourself:

  • Are your customers calling for a variety of different services?

  • Are your customers dialing different access numbers?

  • Do your customers require different levels of support?

  • Do you have customers who need help in different languages?

There are a number of ways to determine who the customer is or what services they require and then attaching that information to the interaction.

  • Most information about the customer is used in the form of interaction data, the values for which can come from an IVR, an e-mail header, or a database lookup. You must configure the interaction data in order to use it in a strategy.

  • The customer's ANI or DNIS can be retrieved from the switch.


Segmentation

Preparation & Planning > Planning a Voice Strategy

Segmentation Phase

The Segmentation phase comes after you have identified the customer. You can segment incoming customer interactions to take different paths in strategy by:

  • ANI (originating phone number)

  • DNIS (dialed phone number)

  • Date

  • Day of Week

  • Time of Day

  • Classification Code (non-voice routing strategy)

  • Screening Rule (non-voice routing strategy)

You can also segment incoming interactions using the Generic Segmentation object. In this case, routing decisions are made based on an expression you create in Expression Builder. For example, the customer tier (silver, gold, platinum) may determine how the interaction should be routed.

In the Segmentation phase you can also apply business rules based on the attributes of the interaction.


Preparation & Planning > Planning a Voice Strategy

Routing Phase

The Routing phase determines the target for the interaction. Use objects from the Routing Object toolbar in this phase. When routing voice interactions, the Routing phase typically occurs after Segmentation and, optionally, operations using objects from the Miscellaneous Objects toolbar.

Note: It takes only one Routing object to deliver an interaction.

Post-Routing Restrictions

You can only use post-routing objects after a Routing object. You cannot use the following objects in post-routing:

  • Routing objects, with the exception of Switch to Strategy.

  • Voice Treatment objects. (Although you can apply busy treatments during the Routing phase.)

You cannot use the following functions in post-routing:

  • DeliverToIVR

  • SuspendForTreatmentEnd

  • SelectDN

  • SuspendForDN

  • RouteCall

  • DeliverCall

  • Translate

  • GetRemoteAccessCode

  • AnswerCall

  • ReleaseCall


Preparation & Planning > Planning a Voice Strategy

Error Processing

There are a two main ways to process errors when an interaction flows to the red port.

  • Route the interaction to the default destination. If you do not connect anything to the red port, the interaction is routed to the default destination.

  • Use the Error segmentation object to segment by error type any interactions that return errors.

Using the Error Segmentation Object

To use the Error segmentation object:

  1. Connect the Error Segmentation object to the red port of an object that can generate an error.

  2. From the Function drop-down list, select the object to which the Error Segmentation object is connected.

  3. From the Error drop-down list, select the error conditions you want to intercept and handle.

See also:

Universal Routing 7.6 Reference Manual, which provides error definitions for functions.

Compiling, Checking, and Debugging Strategies, which explains how to check a strategy for errors.


Preparation & Planning

Planning a Non-Voice Strategy

You must define certain objects in Knowledge Manager in order for the definitions to carry over from the Universal Contact Server Database to the Configuration database. Once in the Configuration Database, you can select the objects in IRD. For example:

  • In order for a Screening Rule to be available in the IRD Screen object, you must first define it in Knowledge Manager.

  • In order for an Agent to be available as a target in the Route Interaction object, that Agent must be configured as a Person in Configuration Manager.

Because of these dependencies, Genesys recommends that you configure objects for non-voice routing strategies in the following order:

  1. Start with Knowledge Manager to define classification Categories, Standard Responses, Screening Rules, and Field Codes.

  2. Next, use Configuration Manager to define Skill, Person, Agent Group, Place, Place Group, and Business Attribute objects in Configuration Manager.

  3. Use the Interaction Design window to define Business Process objects. Once you have saved your Business Process objects in the Configuration Database, they become available for selection in IRD.

  4. Use the Routing Design window to create routing strategies.

  5. Edit your business processes by selecting the Strategy objects that you configured in the Routing Design window and connecting them to queues using Submitter objects.

If you proceed in this sequence, you will be able to select whatever object you need at any point. For more information, see the Universal Routing Business Process User's Guide.


Preparation & Planning

Using Knowledge Manager

Certain objects that you define in Knowledge Manager are saved in the Configuration Database and appear in Configuration Manager as business attributes. You can then use these objects when creating non-voice routing strategies, which are incorporated into Business Processes.

For example, in Knowledge Manager you can configure:

  • Classification categories and category trees that are used by the Classify and Classification Segmentation objects.

  • Screening rules used by the Screen, MultiScreen, and Screen Segmentation objects.

  • Standard responses (including field codes and custom variables) used by the Acknowledgement, Autoresponse, Chat Transcript, Forward Email, CreateEmailOut, CreateNotification, and CreateSMS objects.

See the Multimedia 7.6 Knowledge Manager Help and the Framework 7.6 Configuration Manager Help for additional information on how to configure Knowledge Manager objects and how they appear in Configuration Manager.


Preparation & Planning > Configuration Manager Preparation

Configuration Manager Preparation: Overview

Note: The information in this section presents only a brief overview of certain Configuration Manager functionality and objects. For more detailed information on this user interface, open the Framework 7.6 Configuration Manager Help from inside Configuration Manager.

Configuration Manager is the Genesys interface used to configure your Environment and Resources. Most configuration that directly affects routing is done in the subdirectories under the Resources directory.

Routing configuration performed using Configuration Manager includes:

  • In the Environment Folder:

    • Manual configuration of the URS and IRD Application objects, if required. In most cases, these applications are installed using the Configuration Wizards and no manual configuration is necessary.

  • In the Resources Folder:

    • Service objectives.

    • Business attributes.

    • Default storage locations for each Tenant (in a multi-tenant environment only).

    • Custom Server application configuration.

    • Fields, Formats, and Table Accesses (if you plan to use the Database Wizard object to perform database queries using SELECT statements)

    • Filters (if you plan to use Custom Statistics)

    • Skills (for skills-based routing)

    • Statistical Days, Statistical Tables

    • Time Zones


Preparation & Planning > Configuration Manager Preparation

Configuration Layer Constraints

When planning a strategy or a business process, familiarize yourself with the restrictions listed below. These restrictions apply to configuration performed using Configuration Manager.

  • See IRD Configuration Constraints for additional limitations that affect settings and objects configured in IRD.

Warning! If you do not observe these limitations:

  • Interactions may be routed to an incorrect destination.

  • URS may unexpectedly shut down.

  • URS may not perform a requested operation.

The limitations include the following:

  • The maximum length of any Configuration Server object name cannot exceed 256 bytes (a limitation that is automatically enforced by Configuration Server).

  • When configuring Employee IDs, Login IDs, Place names, DN numbers, and Switch names that will be used for defining routing targets, the maximum length cannot exceed 63 bytes.

  • When a URS name is added to a T-Server name and they are connected through a Load Distribution Server, the sum of the bytes in the names cannot exceed 126 bytes.

  • When defining Agent states in the Annex or Options tab of a URS Application (such as when preparing to use the UseAgentState function in IRD), the maximum number of user-defined Agent states cannot exceed 32 states.

  • Names of skills, if used in skill expressions, cannot exceed 126 bytes.

  • The Priority of an interaction cannot exceed 1,000,000,000.


Service Objectives

Preparation & Planning > Configuration Manager Preparation

Understanding Service Objectives

Service objectives set the baseline service quality you are trying to meet for a defined type of interaction and customer.

Objective Table records are used in voice routing strategies:

  • When using the FindServiceObjective function, to locate the predefined service objectives that should be applied to incoming interactions.

  • When entering a value for the Service Objective field in the Multi-Attach object. Here you have the option of using the service objective you set in Configuration Manager or overriding it with a different value.

To use service objectives in your routing strategies, configure them in the Objective Tables directory, located in the Configuration Manager Resources directory.

An Objective Table record includes a service objective goal and a service objective delta time. You can set these parameters for various combinations of media type, service type, and customer segment.

See also:

  • For more information on defining Objective tables, see the Framework 7.6 Configuration Manager Help.

  • For more information on using Service Objective for Business Priority Routing, see the Universal Routing 7.6 Deployment Guide.


Business Attributes

Preparation & Planning > Configuration Manager Preparation

Understanding Business Attributes

Business attributes are objects that you can configure to represent certain routing and workflow processes or functions. For example, a business attribute might represent a standard e-mail response, a screening rule, a service objective, a customer segment, and so on.

Business attributes can serve as the basis for routing decisions, for fine-tuning routing strategies, and to generate reports that focus on business objectives.

Where Business Attributes Are Configured

Business attributes can be:

  • Predefined by Genesys. These predefined business attributes can be customized.

  • User-configured in Configuration Manager. Configuration Manager has a Business Attributes directory under the Resources directory (in a single-tenant environment) or for each Tenant (in a multi-tenant environment).

  • User-configured in Knowledge Manager. These business attributes then appear in Configuration Manager.

Note: For more information on business attributes, including those that cannot be changed, see the Multimedia 7.6 User's Guide.

IRD Objects that Use Business Attributes

In IRD, the following objects use business attributes:

  • The Acknowledgement, Autoresponse, Forward E-Mail, Redirect E-Mail, Reply E-Mail From External Resource, and Send E-Mail objects enable you to select an E-mail Accounts business attribute, which is associated with an e-mail address defined in Configuration Manager.

  • The Acknowledgement, Autoresponse, Chat Transcript, Forward E-Mail, and Redirect E-Mail objects enable you to select a standard response. To do so, select a business attribute from the Category Structure directory in Configuration Manager that represents the standard response text initially defined in Knowledge Manager.

  • Both the Acknowledgement and Autoresponse objects include the Field Codes option, which you can use to personalize the standard responses initially created in Knowledge Manager.

  • The Classify object contains Root and Categories fields, which use business attributes that represent e-mail classification categories initially created in Knowledge Manager. These business attributes are located in the Category Structure directory in Configuration Manager .

  • The Screen and MultiScreen objects use Screening Rules, which are business attributes. These are initially created in the Knowledge Manager Screening tab.

  • The Stop Interaction object requires you to select a Reason Code, a business attribute that is configured in Configuration Manager.

  • The If and Generic Segmentation objects enable you to select business attributes when constructing an expression.

  • The MultiAttach object uses the following business attributes:

  • Customer Segment. A category based on the customer's revenue potential to the enterprise relative to a business line (for example, Platinum and Gold customers).

  • Service Type. The service a customer is requesting (for example, Sales or Customer Service).

  • Service Objective. The acceptable amount of time before an interaction reaches its target.


Preparation & Planning > Configuration Manager Preparation

Default Storage Location by Tenant

In a multi-tenant environment, each tenant can have a different default storage location for .rbn files (which contain the graphical portion of a strategy). This default appears in the Save dialog box when you save a strategy.

Notes:

In IRD, the Storage Settings tab of the Routing Design Options dialog box lets you specify a Working directory where you can save strategy files. The Working directory can be different from the tenant's default storage location, and overrides the default setting.

Provide superadministration access for users of the same Configuration Server storing the strategy configuration objects for multiple tenants.

To set the default storage location in Configuration Manager:

  1. Open the Properties dialog box for the selected tenant.

  2. In the Annex tab, create a new section called strategy .

  3. In the strategy section, define the location and path for the default storage file.

  • If the default storage location is a network drive, use file for the location option (quotes are automatically inserted). Enter the directory path as the value for the path option.

  • If the default storage location is the Configuration Server database, use database as the value for the location option (quotes are automatically inserted). In this case, you do not need to enter a value for the path option.


Preparation & Planning > Configuring Database Queries

Configuring Database Queries: Overview

You can design strategies that gather customer and other types of information from a database. You can use either a SQL database or a non-SQL database.

For example, assume your IVR prompts callers for their account number. You can then design a strategy that performs a database lookup using the customer's account number to get the customer's first name. Once retrieved, the customer's first name can be sent to the Agent with a screen pop.

Preparation

To query a database, you must first create the following objects in Configuration Manager: Format, Field, and Table Access. When you place a Database Wizard object in a strategy, these configuration objects are used to access the database information.

  1. Collect all information regarding the tables, formats, and fields for the database information using the Table Formats worksheet provided in the Universal Routing 7.6 Deployment Guide.

  2. Create Format, Field, and Table Access objects in the Configuration Database. There are two methods for doing this:

    • Universal Routing Configuration Wizard

    • Manually Using Configuration Manager

Creating a Database Object

Once you complete the Configuration Database setup, you are ready to create a Database Wizard object .


Configuring Table Access Using the Wizard

Preparation & Planning > Configuring Database Queries

Configuring Table Access Using the Configuration Wizard

Use the Universal Routing Configuration Wizard to create Configuration objects only when creating a new solution. To create objects for an existing solution, use Configure Table Access in Configuration Manager.

Prior to running the Configuration Wizard, create a Table Formats worksheet that contains full information about the database fields in your Configuration Database. You will use this information when configuring Universal Routing using the Wizard.

  1. Launch the Genesys Wizard Manager from the Windows Start menu, log in, and then launch the Enterprise Routing Wizard.

  2. Follow the steps in the wizard to create the solution.

    During the solution configuration, the wizard prompts you to create Formats, Fields, and Table Access objects. Use the information from your Table Formats worksheet to proceed through the wizard windows.

    Warnings!

  • Field information must match database information. Field name, Database Type, Length, and the Primary, Unique, and Nullable settings must be defined exactly as they are in the database.

  • Table names and fields names in databases are limited to letters, numbers, and underscores and must begin with letters. No spaces or special characters can be used.


Preparation & Planning > Configuring Database Queries

Configuring Table Access in Configuration Manager

In the Configuration Manager, create the Configuration objects, Format, Fields, and Table Access as required for your strategy.

Warning! Table names and fields names in databases are limited to letters, numbers, and underscores and must begin with letters. No spaces or special characters can be used.

Creating a Format

  1. Launch Configuration Manager.

  2. In Resources or in a tenant folder, select the Formats folder and either choose File > New > Format from the Menu bar or right-click and choose New > Format.

  3. Enter a format name and description (optional) and click OK.

Creating Fields

  1. In Configuration Manager, select a format from the Formats folder.

  2. Right-click on the format to display the shortcut menu.

    Create all fields at once using the field wizard (or one at a time using New > Field) from the shortcut menu.

  3. Choose Wizard > Configure and select the Fields tab.

  4. Create as many fields as necessary using the Add button.

    Warning! Field information must match database information. Field name, Database Type, Length, and the Primary, Unique, and Nullable settings must be defined exactly as they are in the database.

  5. Once you define all format fields, click OK to exit the field wizard.

Note: You can use fields created for one format in other formats. Simply right-click the format and choose New > Shortcut to Field. Then, select a predefined field displayed in the Field folder.

Creating Table Access

  1. In Configuration Manager, select the Table Access folder and either choose File > New > Table Access from the menu or right-click the object and choose New > Table Access.

    The Table Access properties dialog box appears.

  2. Enter a unique name for Table Access.

  3. From the Table Type drop-down list, select User-Defined Type.

  4. Select a database access point from the DB Access Point drop-down list or browse to select the access point.

  5. Select a format that you previously created.

  6. Enter the Database Table name.

    Warning! The Database Table name must be entered exactly as it appears in your database.

  7. Click OK to save the settings and close the dialog box.

Warning! Formats cannot be associated with any Table Access if you want to edit them. To edit a format already associated with one or more Table Accesses, delete the associated Table Accesses first.

See the Framework 7.6 Configuration Manager Help for more information on dialog box fields associated with creating object for database access.


Preparation & Planning > Creating Reusable Objects and Data

Creating Reusable Objects and Data: Overview

Interaction Routing Designer (IRD) enables you to create the following reusable objects and data, which can then be used in strategies and (in most cases) subroutines:

  • Strategy

  • Subroutines

  • Routing Rules

  • Business Rules

  • Attributes

  • Interaction Data

  • Statistics

  • Schedules

  • List Objects

  • Macros

Note: You can also copy existing objects and edit the copies.

The Add Item and Delete Item Icons

Many of the configuration dialog boxes for reusable objects use these icons.

Use the Add Item button to add a line item in the properties box of an object such as a business rule or a routing rule.

Use the Delete Item button when you have extra line items in a properties box or if you want to delete a line.


Viewing Strategies

Preparation & Planning > Creating Reusable Objects and Data

Viewing Strategies and Other Reusable Objects

Using IRD, you can view and edit already-created reusable objects as well as creating new ones.

  • You can view or edit one or more strategies at the same time. Strategies and subroutines each open in a separate Routing Design window with its own menu and toolbar, which is especially helpful when you are using subroutines in a strategy.

  • When you open any other reusable object, its settings window appears, enabling you to edit the settings.

To view a strategy or other reusable object:

  1. From the Routing Design shortcut bar, click the icon for the reusable object type, or select it from the View menu.

Note: With the exception of strategies and subroutines, you cannot open more than one reusable object of a particular type at one time.

  2. On the List pane, double-click the strategy or other reusable object you wish to view.

Note: You cannot view a strategy that is currently loaded. If you select a loaded strategy, a message notifies you that you must release the strategy before viewing or editing it.

See also:

Routing Design Window

List Pane: Overview


Preparation & Planning > Creating Reusable Objects and Data

Creating a Subroutine

Subroutines (sometimes called substrategies) are strategies called from within a strategy or another subroutine.

  • Like strategies, subroutines can contain any IRD object or function.

  • Like other reusable objects, subroutines can be used in any strategy.

  • Variables created in subroutines can be copied into other strategies or subroutines. For information about copying variables from one strategy or subroutine to another, see Exporting and Importing Variables.

  • Genesys supplies several utility subroutines that can be used for customized (that is, not out-of-the-box) load balancing. These are contained in the RLU.zcf file that is in the installation package for Universal Routing 7.6. Each utility subroutine accepts a comma-separated list of targets. A corresponding ”selecting” subroutine then returns the optimal target. For details about these subroutines, see the "Load Balancing" chapter in the Universal Routing 7.6 Deployment Guide.

Note: A subroutine can be changed even if it is called by a strategy that has been loaded on a route point. See Editing a Subroutine for how to edit subroutine input and output parameters.

To create a subroutine:

  1. On the Routing Design Bar, click Subroutines; or select Subroutines from the View menu.

  2. From the File menu, click New; or right-click any folder or subfolder on the List pane; or right-click a column header on the List pane. The New subroutine dialog box opens.

  3. Enter a name and a description (optional), and then click Next. The Input parameters dialog box opens.

  4. Create input parameters for the subroutine if you want to pass values from the strategy in which the subroutine is incorporated to the subroutine. If you do not want to pass values, ignore this section and click Next.

To create an input parameter:

  1. Click the Add Item ( [image]) button.

  2. Enter the parameter name.

  3. Select a type (STRING, FLOAT, or INTEGER).

  4. (Optional) Select a subject. The subject identifies the kind of input parameter you are using. Possible values are Statistic, Strategy, Subroutine, List, Interaction Data, Business Attribute, Application, and Virtual Queue. When you edit the value of this input parameter in the Call Subroutine strategy object, IRD uses that value to present a list of available configuration objects of the specified kind. This enables you to select the object you want, rather than having to type in its name. By default (when you have not selected a subject) IRD presents a list of variables.

  5. Click the Add Item ( [image]) button again to enter another input parameter.

When you have finished entering input parameters, click Next.

  5. Create output parameters for the subroutine using the Add Item ( [image]) button to pass values from the subroutine back to the strategy, then click Finish. If you do not want to pass values, ignore this section and click Finish.

The subroutine opens in the Routing Design window.

  6. Build the subroutine just as you would create any strategy. Once you create a subroutine, use it in a strategy by placing a Call Subroutine object in the strategy.

You assign values from the main strategy to the input and output parameters in the Call Subroutine object that you place in the main strategy. Each subroutine input and output parameter must be assigned to a unique input or output value in the Call Subroutine object.

Warning! Make sure that the subroutine ends with an Exit object. Otherwise, the interaction is routed to the default destination. If the subroutine contains branches, be sure that each branch ends with an Exit object.

For more information, see the "Interaction Routing Designer Objects" chapter in the Universal Routing 7.6 Reference Manual.


Creating a Routing Rule

Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Routing Rule: Overview

By creating routing rules, you can make reusable routing decisions based on complex target-selection logic. Once you have created routing rules, you can use them in any strategy or subroutine by inserting one of the Routing objects.

Routing rules are configured separately from the strategies that use them and are available to all strategies. However, you can create a new routing rule from any of the routing rule objects while you are creating a strategy or subroutine.

You can change routing rules dynamically without recompiling or re-loading a the strategy or subroutine in which they appear.

Warning! Although you can edit an existing routing rule at any time, the changes will immediately affect all currently-loaded strategies that use that rule. So, before editing a routing rule check which strategies use the rule.

To create a new routing rule:

  1. From the Shortcut bar, select Routing Rules, or select Routing Rules from the View menu.

  2. From the File menu, click New; or right-click any folder or subfolder on the List pane; or right-click a column header on the List pane.

  3. In the New dialog box, select the Type of routing rule you want to create.

  4. Enter a name and description, then click OK.

    Note: The description is optional.

  5. For the next step, see one of the topics listed below.

To create a new routing rule from a Routing Object that you have placed in a strategy or subroutine:

  1. Click the button in the Routing Objects toolbar for the type of routing rule you want to use.

  2. Click New Rule in the dialog box that appears.

    Note: You can also select an existing routing rule. The Routing Rule list is sorted alphabetically. To reverse the sort order, click the Routing Rule header.

  3. For the next step, see one of the following topics:

Creating a Force Routing Rule

Creating a Switch-to-Strategy Routing Rule

Creating a Load Balancing Routing Rule

Creating a Service Level Routing Rule

Creating a Percentage Routing Rule

Creating a Statistics Routing Rule

Creating a Workforce Routing Rule

Creating Properties in the Busy Tab

Warning! Variables cannot be used in routing rules. If you manually enter the name of a variable in a routing rule and use the routing rule in another strategy, the variable will be interpreted as a string constant.

Note: When defining routing rules, you can use ACD Queue, Routing Point, and other DN types for the type of target in Percentage, Statistic, and Force routing-rule objects. You can also use ACD Queue and Routing Point for the target type in the Selection object.

See also:

Configuring Properties in the Busy Tab

Routing Rules

Compiling a Strategy

Checking References Automatically


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Routing Rules

IRD can select a target according to reusable routing rules for Service Level, Load Balancing, Percentage, Statistics, or Workforce. You can also specify routing rules that Force interactions to a specified target and that Switch to Strategy. Once a routing rule has been created, you can use it with the corresponding Routing object to simplify strategy development.

Force | Used with the Force object to distribute interactions to a destination on a specified switch.
Load balancing | Used with the Load balancing object to distribute interactions evenly between specified queues.
Percentage | Used with the Percentage allocation object to distribute interactions between targets, according to specified percentages.
Service level | Used with the Service level distribution object to distribute interactions within the specified time to Agents with specified skill levels.
Statistics | Used with the Statistics object to distribute interactions evenly between targets, based on statistics.
Switch-to-Strategy | Used with the Switch-to-Strategy object to initiate a new strategy for the interaction. Note: Once the interaction has been switched to the new strategy, it cannot return to the original strategy.
Workforce | Used with the Workforce object to route an interaction based on an activity created in Workforce Management (WFM) and stored in the WFM database.

See also:

Creating a Routing Rule

Routing Objects

Universal Routing 7.6 Reference Manual


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Force Routing Rule

If you are not in the Force routing rule dialog box, see Creating a Routing Rule.

To create a new routing rule for your Force object:

  1. Enter a name and a description (optional) on the General tab of the Force routing rule dialog box that opens when you click New Rule.

  2. Click the Force tab.

  3. Select a switch, a type of destination, and a DN number for the specific destination.

  4. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this routing rule.

  5. Click OK.

See also:

Routing Rules

Routing Objects


Creating Switch to Strategy Routing Rule

Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Switch-to-Strategy Routing Rule

If you are not in the Switch to strategy routing rule dialog box, see Creating a Routing Rule.

To create a new routing rule for your Switch-to-Strategy object:

  1. Enter a name and a description (optional) on the General tab of the Switch-to-Strategy routing rule dialog box that opens when you click New Rule.

  2. Click the Strategy tab.

  3. Select a tenant from the Tenant Name drop-down list.

  4. Select a strategy from the Strategy Name drop-down list.

  5. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this routing rule.

  6. Click OK.

See also:

Routing Rules

Routing Objects


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Load Balancing Routing Rule

If you are not in the Load balancing routing rule dialog box, see Creating a Routing Rule.

To create a new routing rule for your Load Balancing object:

  1. Enter a name and a description (optional) on the General tab of the Load balancing routing rule dialog box that opens when you click New Rule.

  2. Click the Load balancing tab.

  3. Click Add Item [image] .

    Note: If you make a mistake, you can delete an item by clicking Delete Item [image] .

  4. Select a switch and an ACDQueue to be the first target.

  5. Repeat Steps 2 and 3 until you have specified all the targets among which you want to distribute the interactions.

  6. If you want to use a virtual queue for reporting purposes, select Use Virtual Queue, and then choose the switch and alias of the virtual queue from the drop-down list. Its number appears automatically.

  7. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this routing rule.

  8. Click OK.

See also:

Routing Rules

Routing Objects


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Service Level Routing Rule

If you are not in the Service level routing rule dialog box, see Creating a Routing Rule.

To create a new routing rule for your Service Level object:

  1. Enter a name and a description (optional) on the General tab of the Service level routing rule dialog box that opens when you click New Rule.

  2. Click the Service level tab.

  3. On the Statistics pane, select the Stat Server that is to provide the statistical information used to evaluate the best target for routing.

  4. Select the name of the statistic that you want URS to use when evaluating service levels. Select the Min or Max radio button to indicate whether URS should use the target with the least or greatest value for the selected statistic.

  5. If you want to specify an Agent Group, select the Use Agent Group check box, and then choose an Agent Group from the drop-down list.

    Use the Best Fit pane to define the Agents with the skill sets required to handle the interactions. However, if you want to narrow the pool of Agents before applying the best fit rule, specify an Agent Group.

  6. To change the Service factor, select the Distribute check box, and then adjust the percent of interactions and the number of seconds.

  7. In the Best fit box, click Add Item [image].

  • Select a Skill.

  • Select a Level for the skill: High (8-10), Medium (4-7), or Low (0-3).

  • Select the Importance of the skill: Critical, High, Medium, or Low.

Note: If you make a mistake, you can delete an item by clicking Delete Item [image].

Importance controls when Agents with different skill levels are targeted to improve the service level. If the importance of a skill is set to Critical, an Agent must have the specified skill level to handle the related interaction.

Note: Importance does not apply when the Service Factor box is cleared. In this situation, a Service Level routing rule works like a skill-based routing rule, which uses a skill expression. The skill range is defined by the chosen level.

  8. Repeat step 5 until you have specified all the targets among which you want to distribute interactions.

  9. If you want to use a virtual queue for reporting purposes, select Use Virtual Queue, and then choose the switch and alias of the virtual queue from the drop-down list. Its number appears automatically.

  10. Select the Busy tab to set Busy Treatments, Threshold, Timeout, and Default Destination.

Note: To fulfill a Service level routing rule, the timeout should be greater than or equal to the specified time in the service factor parameter.

  11. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this routing rule.

  12. Click OK.

See also:

Routing Rules

Routing Objects


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Percentage Routing Rule

If you are not in the Percentage routing rule dialog box, see Creating a Routing Rule.

To create a new routing rule for your Percentage object:

  1. Enter a name and a description (optional) on the General tab of the Percentage routing rule dialog box that opens when you click New Rule.

  2. Click the Percentage tab.

  3. In the Type box, select a target type from the drop-down list.

    For a description of target types in routing objects, see the Interaction Routing Designer Objects chapter in the Universal Routing 7.6 Reference Manual.

  4. Click Add Item [image] .

    Note: If you make a mistake, you can delete an item by clicking Delete Item [image] .

  5. Choose a destination name. Select the percentage of interactions you want routed to this target.

Note: Use ACDQueue or route point target types when interaction volume is high and you need to use a Virtual Queue. Otherwise, Universal Routing Server sends the interaction to the first available target despite the condition set in the Percentage routing rule.

Note: IRD does not limit the sum of the target percentage to 100. If the percentages add up to greater than 100, all percentages are adjusted to equal 100.

  6. Repeat Steps 4 and 5 until you have specified all the targets among which you want to distribute the interactions.

  7. If you want to use a virtual queue for reporting purposes, select Use Virtual Queue, and then choose the switch and alias of the virtual queue from the drop-down list. Its number appears automatically.

  8. Select the Busy tab to set Busy Treatments, Threshold, Timeout, and Default Destination.

  9. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this routing rule.

  10. Click OK.

See also:

Routing Rules

Routing Objects


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Statistics Routing Rule

If you are not in the Statistics routing rule dialog box, see Creating a Routing Rule.

For a list of recommended statistics that can be defined and used, see the "User-Defined Statistics" section in the Universal Routing 7.6 Reference Manual.

Note: A target in a strategy is specified as Name@statserver.type. If any one of the components of the target name (name or Stat Server or type) is different from that of another target, URS considers them to be different targets. Stated another way, two targets that send interactions to the same Agent but that specify different Stat Servers are different targets.

To define a statistics routing rule:

  1. Enter a name and a description (optional) on the General tab of the Statistics routing rule dialog box that opens when you click New Rule.

  2. In the Statistics routing rule dialog box, click the Statistics tab.

  3. Select a Stat Server and the name of the statistic you want to use from the drop-down list.

  4. Select Min if you want to route to the available target with the minimal value for the statistic. Select Max if you want to route to the available target with the maximal value.

  5. In the Type box, select a target type from the drop-down list.

    For a description of target types in routing objects, see the Interaction Routing Designer Objects chapter in the Universal Routing 7.6 Reference Manual.

  6. Under Targets, click Add Item [image] .

    Note: If you make a mistake, you can delete an item by clicking Delete Item [image] .

  7. Choose a destination name.

    -OR-

    If you selected a Skill as the target type, click the arrow button in the Expression box. Using Expression builder, create an expression for the skill.

  8. Repeat Steps 5 and 6 until you have specified all the targets among which you want to distribute the interactions.

  9. If you want to use a virtual queue for reporting purposes, select Use Virtual Queue, and then choose the switch and alias of the virtual queue from the drop-down list. Its number appears automatically.

  10. Click the Busy tab to set Busy Treatments, Threshold, Timeout, and Default Destination.

  11. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this routing rule.

  12. Click OK.

See also:

Routing Rules

Routing Objects


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Creating a Workforce Routing Rule

If you are not in the Workforce routing rule dialog box, see Creating a Routing Rule.

To create a new routing rule for your Workforce object:

  1. Enter a name and a description (optional) on the General tab of the Workforce routing rule dialog box that opens when you click New Rule.

  2. Click the Workforce tab.

  3. Select a Stat Server and the name of the statistic from the drop-down list.

    Universal Routing Server (URS) uses this information to determine which Agent to route an interaction to if more than one Agent scheduled for that activity is available.

  4. Select Min if you want to route to the available Agent with the minimal value for the statistic. Select Max if you want to route to the available Agent with the maximal value.

  5. Type the name of the activity exactly as defined in the WFM Configuration Utility.

    Note:     The activity name is case sensitive.

    Warning!     Because WFM data is not integrated with Configuration Layer data, name changes made to an activity in the WFM database do not automatically apply to workforce routing rules using that activity. You must also change the activity names in the Workforce routing rule.

    For information on defining activities, see the Workforce Management 7.6 Configuration Utility Help.

  6. Enter the Routing cut-off time for the activity.

    This value represents the period before the end of the specified activity that URS stops sending interactions to an Agent.

    Note:     When deciding on the routing cut-off time, consider the duration of a typical interaction and how much time (the threshold) that an Agent can reasonably allow an interaction to overlap into the time designated for the next scheduled activity. For example, if the typical interaction lasts 3 minutes and the threshold is 2 minutes, the cut-off time might be the difference between them or 1 minute.

  7. If you want to use a virtual queue for reporting purposes, select Use Virtual Queue, and then choose the switch and alias of the virtual queue from the drop-down list. Its number appears automatically.

  8. Click the Busy tab to set Busy Treatments, Threshold, Timeout, and Default Destination.

  9. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this routing rule.

  10. Click OK.

See also: Routing Objects


Preparation & Planning > Creating Reusable Objects and Data > Creating a Routing Rule

Configuring the Busy Tab for Routing Rules

The Busy tab in the Service Level, Statistics, Percentage, or Workforce routing rules enables you to apply Busy Treatments, set a Prediction Threshold, configure a Timeout, and specify a Default Destination.

Timeout

The timeout specifies the amount of time, in seconds, URS is given to make a routing decision. At the end of this period, the interaction:

  • Goes to the red port, where you can use the Error segmentation object to direct the interaction depending on the error type.

  • Goes to the optional default destination, if you specify one here. See Default Destination for more information.

Note: If you do not specify a destination for interactions after timeout, the interactions are automatically routed to the default destination.

Service Level Timeout

In a Service Level routing rule, URS checks the state of the routing rule every 10 seconds, so the timeout is rounded up to the nearest 10 seconds. If the timeout is set to zero, URS actually waits 10 seconds. Similarly, if the timeout is set to 15 seconds, the rule does not timeout until 20 seconds.

Note: For a Service Level routing rule to work correctly, the timeout should be greater than or equal to the time specified in the service factor parameter.

Prediction Threshold (Optional)

The Prediction Threshold predicts the possibility that the next interaction will be routed successfully.

  • To use a Prediction Threshold, select the Use Threshold check box on the Prediction pane, and then enter a percentage in the percentage text box.

The value you enter represents the percentage of interactions that must have been successfully routed in the past in order to predict successful routing in the future. For a detailed explanation of how the prediction threshold works, see the "Default Destination, Prediction, and Timeout" section in the "Routing Objects" chapter of the Universal Routing 7.6 Reference Manual.

Default Destination

Routing objects can contain a default destination that temporarily overrides the default destination specified in the configuration option default_destination or by the default DNs at the route point. If the timeout is his expired and the interaction has not been routed, the interaction goes to the destination specified here, rather than to the red port. The interaction is then considered successfully routed.

To specify an optional default destination on the Busy tab to use after timeout:

  1. Select Distribute to destination.

  2. Select a switch, a type of target, and a number for the destination from the drop-down list.

    The destination types available are ACDQueue and routing point only.

See also:

Applying Busy Treatments

Error Processing

Creating a Routing Rule


Preparation & Planning > Creating Reusable Objects and Data > Business Rules

Business Rules: Overview

Business rules are used to simplify strategies by combining several segmentation criteria into one object. Business rules are not required to build strategies. However, because they combine a number of criteria into a single object, they can save time in the long run. Business rules are defined independently from the strategies and subroutines that use them and are available to all strategies and subroutines.

By creating business rules, you can segment interactions according to attributes. If the interaction matches all the specified attributes, the interaction is routed to the corresponding target.

For example: If an e-mail about investing arrives from a Platinum customer, then send it to...

Once you have created a business rule, you can insert it in multiple strategies using the Business Segmentation object. If an interaction flowing through a Business Segmentation object matches all the attributes specified in a given business rule, that business rule is applied to the interaction.

The Business Segmentation object, which segments according to business rules, is best used before a Routing object. For example, placing a Service Level routing object after a Business Segmentation object enables you to determine the service level required for a particular type of customer or under a specific set of circumstances. Sample D shows how this is done.

The Business Segmentation object has the following hierarchical relationships:

  • The properties of the Business Segmentation object are one or more business rules.

  • Business rules are defined by one or more attributes and their values.

  • The values of attributes are derived from interaction data or from functions.

Creating a business rule is a multi-stage process:

  1. Configure Interaction Data.

  2. Configure Attributes.

  3. Create a Business Rule.


Preparation & Planning > Creating Reusable Objects and Data > Business Rules

Configuring Interaction Data

Interaction data can be used in expressions to route an interaction based on information about the interaction, such as information entered by the customer.

The interaction data List pane displays a list of the data that has been configured and can be attached to interactions. You can also create, edit, or delete interaction data.

To configure interaction data:

  1. From the Shortcut bar, click Interaction Data, or select Interaction Data from the View menu.

    The Interaction Data view appears. Existing interaction data appears on the List pane.

  2. From the File menu, select New, or right-click any folder or subfolder on the List pane, or right-click a column header on the List pane.

  3. In the Properties dialog box, complete the following:

Name | Enter a descriptive name. The name will appear as a selection in Expression builder menus.
Type | Choose the value type: STRING, INTEGER, or FLOAT.
Values | Create a list of possible values, separated by commas. This field is optional. Note: Once you define values, they appear in a list and become the only values that can be selected for the interaction data.
Default | Enter the default value. This field is optional.
Description | Enter a description. This field is optional.

  4. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this Interaction Data object.

  5. Click OK.

The new interaction data appears on the List pane.

See also: Sample E: Attributes, Business Rules and Database Lookup


Preparation & Planning > Creating Reusable Objects and Data > Business Rules

Configuring Attributes

Attributes are considerations, or decision factors, used to build business rules. An attribute is defined with expressions, using functions or interaction data. They appear on the Attributes List pane.

Attributes can include such items as hours of operation (off-hours, business hours), customer needs (account balance, loan), language (English, Spanish), or a customer value (Tier A, B, C).

  1. In the Attributes view, click New, or right-click any folder or subfolder on the List pane, or right-click a column header on the List pane.

    The Attributes properties dialog box is displayed.

  2. Enter a name and description for the attribute.

  3. Under Values, click Add Item [image].

    Note: If you make a mistake, you can delete an item by clicking Delete Item [image].

  4. Enter a value for the attribute.

    For example, if the attribute is based on interaction data for language preference, the first value might be English and the second value might be Spanish.

  5. In the Expression field, click the arrow.

    The Expression builder opens.

  6. Create an expression for the attribute.

    In the example from Step 4, the expression might look like this:

UData['lang_key'] = '1'

    The customer pressed 1 for English, so the interaction data (UData) lang_key has a value of 1.

  7. Repeat steps 3 through 6 until you have finished entering all the possible values for the attribute.

  8. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this Attribute.

  9. Click OK.

See also:

Sample D

Business Rules: Overview

Creating a Business Rule


Preparation & Planning > Creating Reusable Objects and Data > Business Rules

Creating a Business Rule

For an explanation of business rules and how they work, see Business Rules: Overview.

Before you begin: You must configure interaction data (if applicable) and attributes.

Note: If you make a change to a business rule, you must recompile the strategies that use that rule if you want the changes to affect the strategies. If you want a strategy to keep the old settings for business rule, you must not make any changes to the strategy; otherwise, the updated business rule will apply. If you delete a business rule, the strategies using that rule will not be affected unless they are opened in Edit mode and saved again. If a Business Segmentation object contains a rule that has been deleted, the interactions flow to the error port.

To create a business rule:

  1. From the Shortcut bar, select Business Rules. You can also select Business Rules from the View menu.

  2. From the File menu, click New; or right-click any folder or subfolder on the List pane; or right-click a column header on the List pane.

  3. In the Business Rule properties dialog box, enter a name and description.

  4. In the Attributes section of the dialog box , click Add Item [image].

    Note: If you make a mistake, you can delete an item by clicking Delete Item [image].

  5. Select the name of the attribute you want to use from the drop-down list.

    Note: To create a new attribute, click the New attribute button [image] .

    For more information, see Configuring Attributes.

  6. Repeat Steps 4 and 5 until you have finished creating the business rule.

  7. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this Business Rule.

  8. Click OK.


Preparation & Planning > Creating Reusable Objects and Data

Configuring Statistics

Use the Statistic properties dialog box to create new statistics for use in Statistics routing rules. For examples of user-defined (custom) statistics, see the Universal Routing 7.6 Reference Manual.

Note: To create a new statistic based on an existing one, first create a copy, and then edit the copy.

To open the Statistics dialog box:

  1. From the Shortcut bar, click Statistics or select Statistics from the View menu.

    The Statistics list appears. All existing statistics appear on the List pane.

  2. Choose the statistic to be edited. To create a new statistic, choose File > New from the main menu, or right-click any folder or subfolder on the List pane, or right-click a column header on the List pane. The Statistics dialog box opens.

  3. Configure the statistic, using the information below as a guide.

Name

The name of the statistic. Statistic names must begin with a letter. They can consist of letters, digits, and underscores. The name cannot contain spaces.

Category

The statistical category (for example, TotalTime, ElapsedTimePercentage).

Queue/RoutePoint statistic

If you select this check box, only the subjects and masks appropriate for queues and route points appear in the Subject, Active Mask, and Relative Mask fields. In that case, values for the statistic are collected only for queues or route points, including virtual ones.

If cleared, the resulting statistic collects values only for Agents, Places, Groups of Agents, or Groups of Places.

Subject

The subject for the statistic. Depending on the object type you select, the subject can be DN Action, DN Status, AgentStatus, PlaceStatus, GroupStatus, or CampaignAction.

Interval

Time interval in which the statistical information is collected. This interval can be set to:

  • Last Seconds—A user-defined fixed-length interval. Data is collected for the specified number of seconds before the moment when the value is calculated.

  • Last Calls—The number of calls specified in the field to the right of the radio button.

  • Growing Window—From the moment Stat Server began collecting information to the moment the statistic is computed.

  • Since Login—For Agent-based statistics.

Filter

Selects a filter for the statistic. A filter controls which calls are counted in the computation of the statistic. Only filters defined as Transactions in Configuration Manager are displayed in the drop-down list, but you can manually enter filters defined as Stat Server options.

Time range (Left and Right)

Positive integers designating the lower (Left) and upper (Right) limits of a time range, in seconds, for the duration of the specified action or status. Used by statistics of category CurrentNumberInTimeRange or CurrentNumberInTimeRangePercentage.

Java (Extension and Subcategory)

If you select Java Category from the Category drop-down list, the Java pane becomes active. You can select the Java extension and subcategory for the static you are creating. For more on using Java extension statistics, see the Stat Server 7.6 User's Guide.

Active Mask

Describes the actions or statuses counted in the calculation of the statistic (or in the numerator of the statistic if it measures a relative quantity). The Active Mask is sometimes called the Main Mask.

Relative Mask

Describes the actions or statuses counted in the calculation of the denominator for a statistic that measures a relative quantity. For other statistics, leave empty.


Preparation & Planning > Creating Reusable Objects and Data

Creating Lists

A List object can contain strings of any nature (for example, DNIS or ANI strings), which can be used in strategies and subroutines.

For example, you may decide to create a list of toll-free numbers. Rather than reference each individual toll-free number in a strategy, you can logically group the toll-free numbers together in a List object and use it in a strategy. Then, when you need to add or edit the toll-free numbers, you do not need to edit the strategy. You just add to or edit the list.

Use the Function object to check for the presence of a particular List element (ListLookupCfg) or to get the properties of a List element (ListGetDataCfg).

To create a List object:

  1. From the Shortcut bar, select List Objects, or select List Object from the View menu.

  2. From the File menu, click New, or right-click any folder or subfolder on the List pane, or right-click a column header on the List pane. The List Objects dialog box opens.

  3. Enter a name that is appropriate for all the List elements to be included in this List object.

  4. Enter a Description (optional).

  5. Click Add Item [image] to open the Item dialog box use for configuring each List element.

Note: If you make a mistake, you can delete an item by clicking Delete Item [image].

  6. Enter the name for the first list element. For example, if you are creating a list of toll-free numbers for various regions, enter the first toll-free number in the Name field.

After filling in the Name field, you have two options:

  • You can define Key and Value properties for the List element. In this case, go directly to Step 7.

  • If you do not wish to configure properties, click OK to return to the List Objects dialog box. Continue entering the remaining List elements by repeating Steps 5 and 6.

  7. Optional step. To define properties after naming the List element, click Add Item [image] and enter Key/Value pairs.

Providing Key/Value pairs for a List element enables you to store information in the Configuration Database and then retrieve it from the strategy.

Genesys recommends this as a way to retrieve user-defined data from Configuration Server. Use a List object that contains all the required data instead of overloading Application options with user-defined data.

When you have finished entering Key/Value pairs, click OK in the Item dialog box.

  8. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this List object.

  9. When you have finished defining all List elements, click OK in the List Objects dialog box.


Preparation & Planning > Creating Reusable Objects and Data > Creating Macros

Creating Macros: Overview

A macro is an object that enables you to combine several functions and (optionally) expressions into one reusable block. It is both a reusable object and a strategy-building object. You create a macro from one or more IRD objects, including their parameters.

A macro works like a user-defined function. That is, the same object, set of objects, and/or parameters can be defined once in a macro and can then be repeatedly re-used.

To use a macro:

  1. Place the Macro object in a strategy or subroutine

  2. Select the macro you need from the list of available macros

IRD supplies five predefined macros that you can copy and edit:

  • ComplexSample

  • DelimitTargetList

  • MakeAgentNotReady (uses the SendRequest function)

  • RedirectCall (uses the SendRequest function)

  • RedirectCallMakeNotReady (uses the SendRequest function)

  • SimpleSample

See also:

Understanding the Predefined Macros

Creating a New Macro

Using a Macro


Preparation & Planning > Creating Reusable Objects and Data > Creating Macros

Understanding the Predefined Macros

The predefined macros, as well as being useful in themselves, can provide models to help you create a new macro. This topic discusses two of the predefined macros in some detail:

  • As an example, this topic looks in detail at the MakeAgentNotReady macro.

  • This topic also provides an explanation of how you can use the DelimitTargetList macro, which enables you to reformat an output list of targets based on replacement parameters that you enter.

There are six predefined macros: SimpleSample, ComplexSample, RedirectCall, RedirectCallMakeNotReady, MakeAgentNotReady, and DelimitTargetList.

T-Library Functions in Predefined Macros

Three of the six predefined macros use both the IRD SendRequest function and T-Library functions.

Note: For information about specific T-Library functions and events, see the Voice Platform SDK 7.6 .NET API Reference or Java API Reference. If you are interested in learning more about events and call models, see the Genesys 7 Events and Models Reference.

The IRD macros and the associated T-Library functions are as follows:

IRD Macro Name | T-Library Function
MakeAgentNotReady | TAgentSetNotReady
RedirectCall | TRedirectCall
RedirectCallMakeNotReady | TRedirectCall, TAgentSetNotReady

MakeAgentNotReady Macro: Example

Follow the steps below to review the MakeAgentNotReady predefined macro:

  1. In the Routing Design shortcut bar, click Macro to display the Macros list. Double-click the MakeAgentNotReady macro to open its properties dialog box.

As the following figure shows, the Description field on the General tab refers to the T-Library TAgentSetNotReady function.

  2. On the Parameters pane, notice the queue parameter. You will enter a value for this parameter when you use the macro in a routing strategy.

  3. Click the Definition tab.

  4. Notice that the macro also uses another function, SendRequest.

SendRequest is a function, available for selection in the IRD Function object, that makes it possible for Universal Routing Server to send T-Library Request messages to T-Server. SendRequest takes two parameters: Type and Request.

The following figure shows the IRD Function object for SendRequest. The available T-Library Request message types appear in the drop-down menu that lists the values available for the Type parameter.

Note: You cannot open the Function properties dialog box from the macro.

In this macro, the Type RequestAgentNotReady results in the execution of the TAgentSetNotReady function. Similarly, the next value in the drop-down menu, RequestAgentReady, results in the execution of T-Library TAgentSetReady function, and so on.

Note: For more detail on the parameters specified after SendRequest, refer to the Voice Platform SDK 7.6 .NET API Reference or Java API Reference, TAgentSetNotReady function. The full expression in the body of the macro is SendRequest[RequestAgentNotReady, Cat['thisdn:', Dest[], '|21:', queue,'|16:', 6]]. The number 21 maps to AttributeThisQueue, which you can find by looking up TAttribute and locating 21 in the enumerated list of attributes. The number 16 maps to AttributeAgentWorkMode, also in the enumerated list. The number 6 can be found by looking up TAgentWorkMode, which shows that AgentWalkAway=6.

  5. Returning to the properties dialog box for the macro, note the Macro's body pane in the Macro Definition tab (see the second figure, above).

  6. Under the Macro's body, note the queue parameter. It maps to the queue parameter, which is listed in the General tab as a parameter for which you must enter a value when you use the macro. You are prompted for a value for queue when you place a Macro object in a strategy or subroutine and configure it to use the MakeAgentNotReady macro.

  7. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this Macro object.

See Using a Macro for instructions on how to insert a macro into a strategy or subroutine.

DelimitTargetList Macro

The DelimitTargetList macro enables you to reformat an output list of targets based on replacement parameters that you enter. Use the DelimitTargetList macro to check or to reformat the output returned from a database (without the need to manipulate the output data using String functions), or to create a properly-formatted input target list for another operation.

DelimitTargetList enables you to specify:

  • A new target list. This is a variable that stores the results of reformatting the target list.

  • The old target list. This is a string or variable for a comma-separated target list such as one returned by the IRD SelectTargetsByThreshold function (described in the Universal Routing 7.6 Reference Manual).

  • The new delimiter to be used to separate each item on the reformatted target list.

  • Start (prefix) and end (suffix) characters to pre-pend and append to each element.


Preparation & Planning > Creating Reusable Objects and Data > Creating Macros

Creating a New Macro

You can create a new macro by setting up an entirely new one or by editing one of the predefined ones. Before using either method, review the Understanding the Predefined Macros topic.

Note: If you wish to create a new macro that uses T-Library functionality, you should be thoroughly familiar with the T-Library SDK, as described in the Voice Platform SDK 7.6 .NET API Reference or Java API Reference. Or consult Genesys Professional Services.

To create a new macro:

  1. In the Routing Design shortcut bar, click the Macros icon [image] to display the Macros list.

  2. Follow the steps below for creating a new macro or editing a predefined one.

Editing a Predefined Macro

Follow the steps below to edit a predefined macro:

  1. Right-click one of the predefined macros and select Create Copy from the shortcut menu.

A new macro is created, named Copy of <original macro name>. For example, you might create a macro named Copy of MakeAgentNotReady.

  2. Double-click the copy to open its properties dialog box.

  3. In the General tab, edit the Description and (if necessary) the Parameters.

  4. In the Definition tab, edit the text in the Macro's body pane.

  5. Click Verify.

  6. If verification is successful, click OK. If not, edit the macro body until it can be successfully verified.

Create a New Macro

  1. Select New from the File menu, or right-click any folder or subfolder on the List pane, or right-click a column header on the List pane. This action opens the Macro dialog box with empty General and Definition tabs.

  2. In the General tab:

  • Name the macro.

  • Describe the macro.

  • (Optional) Click Add Item [image] to name any parameters for which the user must enter values when inserting the macro into a strategy or subroutine.

  3. Click the Config. Layer Location tab. If desired, click in the Tree text box to select a different location for this Macro object.

  4. Click the Definition tab.

  5. Click the Complex macro check box, if necessary. That is, if you intend to use a condition that can be defined in the Expression Builder to determine whether to perform an action.

  6. Complete the Macro's body pane.

You can enter multiple functions or expressions in a single macro. To do so, type or paste the next function definition or expression immediately after the first. You do not need to use any special separation characters.

If creating a macro that uses a function, you may wish to copy and paste the function definition from the Expression pane in the Function Properties dialog box.

For example, a section from the Function properties dialog box for the Update function appears as shown below. In this case, you would copy Update['qa_review_flag','0']from the Expression pane and paste on the Macro's body pane in the Macro dialog box Definition tab.

As an alternative, if you defined Value as a parameter in the macro's General tab, you would paste Update['qa_review_flag', Value] onto the Macro's body pane Then, you would be prompted to enter a value for Value when you insert the macro into a strategy or subroutine.

  7. When you have entered the entire macro definition onto the Macro's body pane:

  • Click Verify.

  8. When the macro can be verified successfully, click OK.


Preparation & Planning > Creating Reusable Objects and Data > Creating Macros

Configuring Macro Parameters

When naming a parameter in the Macro dialog box, you can use any name (IRD does not validate parameter names).

If the macro uses an IRD function, and you want the macro to require that the user enter a value for the parameter when inserting the macro into a strategy or subroutine, it is advisable to enter the parameter name as it appears in the documentation.

  • In some cases, the parameter is associated with a function documented in the Universal Routing 7.6 Reference Manual.

  • In other cases, the parameter is associated with a T-Library function documented in the Voice Platform SDK 7.6 .NET API Reference or Java API Reference.

When configuring macro parameters, you have two alternatives:

  • Configure the parameters and require the user to enter values for the parameters when inserting the macro into a strategy or subroutine.

  • Enter the parameters and values in the macro definition.

For example, you can create a macro that uses the Update function, which removes old data and attaches new data to an interaction. The Update function description specifies two parameters: Key and Value. Key and Value also appear under Parameter in the IRD Function properties dialog box for the Update function, as shown in the following figure.

Configuring Parameters Only in the Macro

If you want the macro user to enter a value for a parameter when inserting the macro into a strategy or subroutine, use the same parameter name in the General tab of the Macro properties dialog box as appears in the IRD Function object properties dialog box, shown above.

For example, if you want the macro user to enter a value for Customer Segment, enter value as a parameter on the General tab.

When you complete the macro body on the Definition tab, use the same value parameter, but without quotes.

Then, when you place the Macro object in a strategy and select this macro, the dialog box prompts for the value parameter. The following figure shows the Call macro properties dialog box after you enter gold as a value for the value parameter then click Add and Verify.

Entering Parameters and Values in the Macro Definition

Alternatively, you can enter all parameters and their values in the macro definition. If you use this method, the Call Macro properties dialog box does not prompt you for parameters.


Preparation & Planning > Creating Reusable Objects and Data > Creating Macros

Using a Macro

After you create a macro, you can use it in a strategy or subroutine

  1. When working in the Routing Design window, click the Macro button [image] under Miscellaneous objects.

  2. Click on the workspace to insert the Macro object.

  3. Double-click the Macro object to open the Call Macro Properties dialog box. All existing macros are listed.

  4. Select a macro.

  5. If required, enter values for the parameters.

  6. If necessary, create new variables by clicking the Variables button to bring up the Variables List dialog box.

  7. Click Add.

  8. Click Verify.

Note: You must connect the green port of certain macros to an Exit object. These macros are RequestRedirectCall, RedirectCall, and RedirectCallMakeNotReady.


Preparation & Planning > Creating Reusable Objects and Data > Creating Macros

Simple Versus Complex Macros

A simple macro is a sequence of actions, one after the other, usually (but not necessarily) performed by IRD objects.

A complex macro uses a condition, which can be defined in the Expression Builder, to determine whether to perform an action. If the condition is true, an action is performed, such as executing a function call.

With the exception of ComplexSample, all the other predefined macros are simple macros.

To create a complex macro:

  1. In the Definition tab of the Macro Properties dialog box, select the Complex Macro check box.

  2. Enter the functions and expressions that make up the complex macro in the Macro's body.

  • Separate the condition and the action with a hyphen (-) and a forward angle bracket (>).

  • Use a pound (#) sign for comments.

When entering the functions and expressions, you can cut and paste from the Expression Builder.

The following figure shows the Macro's body pane for the predefined macro, ComplexSample.


Creating a New Strategy

Creating a New Strategy: Overview

A strategy is made up of objects that instruct Universal Routing Server (URS) how to handle an interaction, connected together in a logical sequence that ensures that as many interactions as possible are handled the way you have decided is best.

Before You Start

To avoid errors, backtracking, unintended routing results, and other frustrations, before you begin to create a new strategy you should:

  • Complete all preparation and planning, including creation of objects to be used in strategies in Configuration Manager, Knowledge Manager, and IRD.

  • Review the IRD Configuration Constraints.

  • Review the sample strategies, which provide guidelines that can help you design your own strategies.

Note: If you are creating a strategy to be used in a Business Process to route non-voice interactions, also see Routing Non-Voice Interactions: Overview and Designing Business Processes: Overview.

Strategy Locking

In release 7.6 and later, IRD enables you to lock strategies to prevent possible conflicts that might occur when more than one person tries to edit a strategy at the same time. If you try to open a strategy that another person has locked, you will receive a warning message informing you that the strategy is already opened by another user for editing.

For more information, see Locking and Unlocking Strategies.

Create a New Strategy

  1. On the Routing Design shortcut bar, click the Strategies icon; or select Strategies from the View menu; or right-click any folder or subfolder under the Scripts folder on the List pane; or right-click a column header on the List pane.

Note: You can also create strategies in the Interaction Design window. For details, see the Interaction Workflow Designer section of this help file.

  2. From the File menu, choose the New command, or click the New icon on the Menu bar; or right-click any folder or subfolder on the List pane; or right-click a column header on the List pane. The New dialog box opens.

  3. Enter a name and (optionally) a description for the new strategy. The Description field is activated when you enter a name in the Name text box.

Note: Although a description is optional, Genesys recommends that you enter a description that clearly identifies the strategy's purpose.

  4. Click OK. The Routing Design window opens with the new strategy's Entry object in the upper left corner of the workspace.

  5. Use the toolbar to place objects in the strategy.

  6. Configure object properties.

  7. Connect the objects and insert comments.

  8. Compile the strategy.

  9. Save the strategy.

  10. Load the strategy.

See also:

  • Input and Output Ports

  • Inserting Comments

  • Using Variables in a Strategy

  • Using the Database Wizard Object

  • Building Expressions

  • Attaching Business Attributes

  • Attaching and Updating Data

  • Applying Busy Treatments

  • Creating Virtual Queues

  • Using the Call Subroutine Object

  • Compiling, Checking, and Saving

  • Error Processing

  • Routing Non-Voice Interactions


Creating a New Strategy

Locking Strategies and Subroutines

In release 7.6 and later, IRD can lock a strategy or subroutine to warn others that it is in use. Locking indicates that you have a strategy open for editing and that no one else should edit it until you have finished.

  • When you try to open a strategy or subroutine locked by another user, IRD generates a warning message notifying you that the strategy is locked.

  • If necessary, you can override a lock set by another user. If you do so, the user who set the lock is notified in the Information tab of the Routing Design window's Output pane. The name of the host computer from which the lock was set appears on the IRD main window's Details pane, below the Strategies or Subroutines list.

Note: You will not receive a warning if another user modifies any reusable objects, such as subroutines, routing rules, interaction data, and so on, that appear in a strategy you have locked.

The Locked column on the Strategies and Subroutines list panes shows the locking status:

  • If the column is empty, the strategy or subroutine is unlocked.

  • If the column contains a v, the strategy or subroutine is locked by the current user.

  • If the column contains an x, the strategy or subroutine is locked by a different user.

Note: Locking a strategy or subroutine does not prevent another user from making changes to it. The locking functionality provides a "good faith" warning that is intended to prevent accidental editing conflicts.

If you lock a strategy or subroutine, it remains locked until you unlock it, or until another user overrides your lock. This enables you to lock a strategy or subroutine while you make changes over the course of several sessions. Other users can view the strategy or subroutine, but they cannot save changes to it unless they override your lock.

Notes:

  • The identity of the user who set a lock is established by the name of the host computer from which the lock was set. If another person accesses IRD from your computer, strategies or subroutines that you have locked are available for editing. As a consequence, if you lock a strategy or subroutine, and then try to edit it from another computer, you must override your own lock in order to make the edits.

  • IRD generates a warning message when you try to restore another version of locked strategy, or to import strategy with the same name as a locked one. In either case, the operation is automatically canceled.

  • Earlier releases of IRD do not lock strategies or subroutines, and they also disregard lock settings created in IRD 7.6.

Locking or Unlocking a Strategy or Subroutine

To lock or unlock a strategy or subroutine:

  1. Click Strategies or Subroutines on the IRD main window's shortcut bar to open the Strategies list or the Subroutines list.

  2. Right-click the strategy or subroutine you want to lock or unlock.

  3. Select Lock or Unlock from the shortcut menu. Only the applicable command appears in the shortcut menu.

Overriding a Lock Set by Another User

To lock a strategy or subroutine for your own use, or to unlock a strategy or subroutine locked by another user:

  1. Right-click the strategy or subroutine.

  2. Select Lock (to lock the strategy or subroutine for your own use) or Unlock (to unlock the strategy or subroutine).

A confirmation dialog box appears, noting that the strategy or subroutine is already locked by another user.

  3. Click Yes to reset the lock, or to unlock the strategy or subroutine. To leave the lock that was set by the other user in place, click No.

Note: If you are editing a strategy or subroutine, and another user sets a lock on it or overrides your lock, that information appears on the Information tab, which is located at the bottom of the Routing Design window.


Creating a New Strategy

Placing Objects

When you create a new strategy, it automatically opens in the Routing Design window. The new strategy's Entry object ( [image]) appears in the upper left corner of the workspace.

You build a strategy by placing objects, defining object properties, and connecting the objects. Each object represents a condition, an action, or a treatment.

Note: From the Routing Design window, you can export strategy objects in text format, and then import them into other strategies or subroutines. For details, see Exporting and Importing, below.

To place objects:

  1. On the toolbar, click an object from one of the following subtoolbars: Voice Treatments, Data and Services, Segmentation, Routing, Miscellaneous, Multimedia, or Outbound.

If creating a voice routing strategy, a Segmentation object is frequently the next object after the Entry object.

If creating an non-voice routing strategy, review Universal Routing Strategy Samples and Universal Routing Business Process User's Guide. Also see the Creating Non-Voice Routing Strategies: Overview topic.

  2. In the Routing Design window, click inside the workspace where you want to place the object. The new object appears.

Note: If you cannot insert an object, a circle with a backslash appears.

  3. Configure the object's properties. To open the properties dialog box, right-click the object and select Properties from the shortcut menu.

Note: To have the Properties dialog box open automatically every time you inset a new object, open the Routing Design Options dialog box and select the Show Properties on Drop check box.

  4. Place and configure the second object.

Note: You can place an object anywhere in the workspace as long as there is enough space to draw a connector between each object. However, to ensure that there is enough space between objects to see the labels in the Trace View window when monitoring your strategy, open the Routing Design Options dialog box and select the Show Monitor Labels on Graph check box.

  5. Connect the objects.

To insert an object between two already-connected objects:

  1. Delete the connector between the two existing objects. You cannot move a connector from one object to another.

  2. Insert the new object between or near the two existing objects.

    Note: You may have to rearrange the objects to create enough space for the new one.

  3. Connect the objects in the new arrangement.

Exporting and Importing Objects

To export an object from the Routing Design window:

  1. Right-click the object that you want to export, and then select Export object from the shortcut menu.

The Select file for export dialog box opens.

  2. Enter a file name for the exported object, then click Save.

Note: The only available file type is .kvlt.

When you import, you have the option of changing object properties in the text file before finalizing the import. To import an object into the Routing Design window:

  1. Right-click anywhere in the work area of the Routing Design window, and then select Import object from the shortcut menu.

The Import strategy objects dialog box opens.

  2. Click Load Data. The Select import file dialog box opens.

  3. Navigate to and select the .kvl or .kvlt file for the object that you want to import, then click Open.

The properties for the selected object are displayed in text format in the Import strategy objects dialog box.

  4. To view the settings that control how the object appears in the Routing Design window workspace, select Show gui.

  5. (Optional) Edit the object's properties. If necessary, use the Find and Replace buttons to locate and replace information.

  6. When the object is correctly configured, click Insert.

The object appears in the Routing Design window workspace.


Creating a New Strategy

Configuring Object Properties

After you place an object in the Routing Design window, configure the object's properties in its Properties dialog box. You can configure properties before or after connecting the object to another object (or objects).

  1. Place an object in the Routing Design window.

  2. If the Properties dialog box does not open automatically, double-click the object or right-click it and select Properties from the shortcut menu.

    Note: The Show Properties on Drop setting controls whether or not the Properties dialog box opens automatically. For more information, see Setting Routing Design Options.

  3. Enter or select parameters in the Properties dialog box. Some parameters can be selected from drop-down lists only.

For detailed descriptions of the parameters, see Universal Routing 7.6 Reference Manual.

Special Note on Compilation Errors Related to Required Fields.

When you click OK in an object's Properties dialog box, IRD sets all object properties to a default value. If a field is left blank, IRD sets its value to zero (0). IRD detects whether or not all required fields are completed after you click OK. If IRD detects that one or more required fields are empty, IRD generates a strategy compilation error. (No compilation error is generated if only optional fields are empty.) If you open an object's Properties dialog box, do not enter any values, then click Cancel, IRD generates a compilation error. IRD assumes that one or more required fields were left empty.

  4. Click OK in the Properties dialog box.

Note: When you open the Properties dialog box for any object, the Show Monitor labels on Graph option (if selected) is automatically cleared in the Routing Design Options dialog box. The monitor labels that appeared in the Routing Design window disappear.

Troubleshooting Object Properties

If an object's Properties dialog box does not open correctly, you can edit the object's properties in plain text. To do so:

  1. Right-click the object, and then select Properties as text from the shortcut menu.

The Edit strategy objects dialog box opens, showing the object's properties in plain text format.

  2. Edit the object properties as desired. If necessary, you can use the Find and Replace buttons to locate and replace specific text.

  3. Select the Show gui check box to see the values set for the location and port assignments of the object as it appears in the Routing Design window.

  4. Click Update to save your changes or Cancel to exit without changing the object.

Note: Genesys recommends that you limit the changes that you make to the names of configuration objects, and/or any function or expression strings that they contain.

See also:

Expression Building


Creating a New Strategy

Connecting Objects

Connecting objects sets up the sequence of steps that you want the strategy to execute in order to handle an interaction correctly. You can connect objects before or after configuring object properties.

Connections run from an output port (green) of one object to the input port (yellow) of one or more other objects. If an object has no connection to its input port, it will not be active (with the exception of the Entry object). Use the red output port for error processing.

  • Note: You can change the default port locations and connector shapes.

To connect objects:

  1. Click the green output port on the first object.

    The cursor turns into cross-hairs with a movable line attached.

    Note: Right-click if you want to cancel the action.

  2. Click the yellow input port for the next object or click anywhere inside it.

    The two objects are now connected.

  3. As you create the strategy, continue connecting each green output port to the input port of the next object.

    Note: Some objects have more than one green output port because when you segment, each segment you create has a separate output port. To see what criteria are used to send interactions to each output port, press the Shift key and hover your cursor over the green output port until this information appears.

  4. If you are using the Error Segmentation object, connect it to the red port.

Changing Connector Shapes

By default, connectors are straight lines that form right angles when they change direction. To use curved connectors:

  1. Select Tools > Routing Design Options from the Main window menu bar or the Routing Design window menu bar.

  2. On the Graphs tab, select the Round Angle Connections check box.

  3. Click OK.

To return to right-angle connectors, open the Routing Design Options dialog box and clear the Round Angle Connections check box.


Creating a New Strategy

Input and Output Ports

Every IRD object has at least one connection port. Most have at least three, indicated by Green, Yellow, and Red circles.

Note: You can customize port locations and connector shapes.

Green

The output port. Use this port to make a connection to another object.

Yellow

The input port. Use this port to make a connection from another object.

Note: Input ports accept multiple connections.

Red

Depending on the object, use the Red port to specify how to handle errors or as a segment representing the default condition.

  • In Segmentation objects, the red port represents the default condition.

  • In Routing objects, an interaction flows to the red port if it was not routed because of an Error or Timeout.

  • In all other objects, the red port represents an error. To segment interactions based on the errors that sent them to the red port, use the Error Segmentation object.

Changing the Default Port Location

In complex routing strategies, you may want to change where the ports are located in order to simplify the layout in the Routing Design window workspace. To do so:

  1. Right-click the object and select Port location from the shortcut menu.

The Port location dialog box opens.

  2. Select the locations for the ports from the drop-down menus.

The "Default" port is the red port.

  3. To return to the default port location settings, click Default. The returns the input port to the left, the output port to the right, and the error port to the bottom of the object.

  4. Click OK.

See also:

Connecting Objects

Error Processing

Sample B


Creating a New Strategy

Inserting Comments

IRD enables you to insert explanatory comments in your strategies and subroutines and to edit them. Comments appear as text boxes and are not attached to objects. You can insert comments anywhere in the Routing Design window. You can move or edit a comment at any time.

To insert a comment:

  1. Right-click anywhere in the Routing Design window workspace.

  2. From the shortcut menu, select Insert Comments.

  3. Position the cursor where you want the comment and then left-click. A new comment text box appears.

Note: If you right-click, you cancel the insert-comment process.

  4. Double-click the comment text box so that the default text is highlighted, and then enter your comment.

  5. When you are finished, left-click anywhere outside the comment text box.

Notes:

  • To have IRD display object conditions and descriptions or to change the default comment font, use the Routing Design Options dialog box.

  • To move a comment text box, select it and then drag it.

  • To resize a comment box, use the sizing handles.

  • To cut or copy a comment, right-click the comment text and select Cut or Copy.

  • To change the appearance or behavior of a comment, right-click it and then select Properties.

Editing Comment Properties

To edit the comment text:

  • Double-click the comment to highlight the text and then enter the new text.

To change the appearance or behavior of a comment:

  1. Right-click it and then select Properties.

  2. Change the settings in the various tabs explained below, then click OK to save your changes.

General—Enables you to enter a name for your comment. The Type text box is read-only and simply indicates the nature of the comment.

Edit—Enables you to control whether comments can be selected and how they can be moved or resized.

Text—Enables you to edit the text of the comment and to specify whether it appear on one line or multiple lines.

Line—Enables you to change the appearance of the line around the text box.

Fill—Enables you to add fill to the text box.

Font—Enables you to change the comment font. However, to change the default comment font, use the Font tab in the Routing Design Options dialog box.

Position and Size—A read-only tab that gives the current location and size of the comment text box.

Note: Although they appear in the Properties dialog for comments, Allow Rotation, Allow Vertex Editing, and Allow Scaling are not actually available functionality.


Creating a New Strategy > Using Variables

Using Variables: Overview

A variable is a user-defined parameter that can represent any value in a strategy. You can use variables in the Selection and Route Interaction Routing objects, in Treatment objects, in objects that call expressions (such as Generic Segmentation and If), and in the Function object. Variables can be copied from one strategy to another by exporting them from one strategy and then importing them into another.

Warning! Variables cannot be used in business attributes, routing rules, or business rules. If you manually enter the name of a variable in a business rule, routing rule, or business attribute and then use it in another strategy, IRD interprets the variable as a string constant.

  • To use a variable in a strategy, you must first create and initialize it according to its type and purpose. For example, if you create a variable to be used as a parameter value of some function, then check the function description in the Universal Routing 7.6 Reference Manual to determine the proper type and possible values of this parameter.

Note: Variable-driven strategies are an advanced feature in IRD. They are recommended for the user with a background in programming.

Advantages of Using Variables

If you create variables for a strategy, you can reuse the same variables in different objects in the same strategy. In this way, you can build a variable-driven strategy.

Using this method (instead of building one strategy for each route point for one routing purpose), you can build a generic strategy for all routing points with a general purpose. Then, within the strategy, use the variable values to refine the routing decision.

Using Variables in Routing Objects

You can use variables in the Selection and Route Interaction objects. All variables must already have been created so that you can select them from the object's properties dialog box.

In the Selection object, use a variable for:

  • The value of parameters of treatments that have parameters.

  • The value of the timeout in the Treatments pane of the Busy tab.

In the Selection and Route Interaction objects, use a variable for:

  • The name of a Stat Server for targets of type Skill in the Target Selection tab.

Note: You cannot specify the name of a Stat Server as a variable for targets of Type other than Skill in the Target Selection tab of the Selection properties dialog box.

  • The name of a statistic in the Statistics section of the Target Selection tab.

  • Timeout Sec in the Targets pane of the Target Selection tab.

  • The name of a Virtual Queue from the Alias drop-down list in the Virtual Queue pane of the Target Selection tab.

Using Variables in Treatment Objects

You can use a variable in any mandatory Treatment object that has parameter and value pairs in the Parameters tab of the Treatment object's properties dialog box. If you do not want to use a variable, you can use an integer for the value of the parameter of any Treatment object.

Using Variables in Expressions

You can use a variable for any functions or object that calls an expression.

  • In any Expression Builder dialog box or Skill Expression properties dialog box, you have the option to specify a variable in the Value field. For example, you can choose a variable from the Value list in the Expression Builder to use as a comparable for the right side of an expression.

  • You can create expressions using the appropriate dialog boxes in the following objects: Assign (Assign properties dialog box), Generic Segmentation (Expression Builder dialog box), Function (Function properties dialog box), If (If expression properties dialog box), Attributes (Expression properties dialog box).

See also:

Creating Variables

Using Variables in Functions

Exporting and Importing Variables

Expression Building: Overview

Sample D: Create a Variable


Creating a New Strategy > Using Variables

Creating Variables

You can create variables by clicking the Variables button on the toolbar. You can also click the Variables button in the Database Wizard; in the If, Assign, MultiAssign, or Function properties dialog boxes; or when building expressions.

Note: A variable can only be used in the strategy in which it was created. If created in a subroutine, variables are specific to that subroutine and cannot be used by any strategy or subroutine in which the subroutine is used.

To create variables:

  1. Click Variables in the toolbar ( [image]) . The Variable List dialog box appears, displaying all defined variables and enabling you to add, edit, or delete variables.

Note: The Subroutine Variable List dialog box appears when creating variables within a subroutine.

  2. Click Add Item [image] to create a variable or select an existing variable to edit it. The Variable list dialog box contains the following elements:

Variable: an alphanumeric name limited to a maximum of 64 characters (1 character per byte); the underscore character (_) can appear in the name. The first character of the name must not be a number.

Variable names cannot include mathematical symbols, hyphens, quotes, or double-byte characters (international only) or be a function name. Variable names also cannot begin with BL (case-sensitive). BL is an internal identifier used by IRD. Variables can be defined with multi-byte characters, but an error occurs when those variables are processed.

Type:

Variable Type | Values
STRING | Character strings
INTEGER | 32-bit integers
FLOAT | Floating-point decimals

Note: The first time you create a variable in IRD, no default variable type displays in the field. The first type you select becomes the default type until you create a new variable with a different type.

Scope: Choose local or script variable.

  • Local: A local variable is created when the strategy is started on a particular interaction and is destroyed when the strategy for the interaction ends. The value of a local variable for one interaction has no effect on the value of the same local variable for another interaction.

  • Script: A script variable is created when the strategy is preloaded and is destroyed when the strategy is released from URS’s memory. Every run of the strategy can change the value of the same script variable. Use script variables with caution. (One possible use is as counters over all interactions processed by the same strategy.)

Input/Output: (subroutine parameters only):

  • Input: An input parameter used to pass data from the calling strategy to the subroutine.

  • Output: An output parameter used to pass data from the subroutine to the calling strategy.

  3. Click OK.

To edit variables:

  1. Click Variables.

  2. In the dialog box, select the variable you want to edit.

  3. Edit the variable.

To delete variables:

  1. Click Variables.

  2. In the dialog box, select the variable you want to delete.

  3. Click Delete.


Creating a New Strategy > Using Variables

Using Variables in Functions

The Function object contains a list of functions that can be used to handle interactions during a strategy. See the Universal Routing 7.6 Reference Manual for detailed function descriptions.

For any function that has at least one parameter with no predefined values, the Function properties dialog box enables you to define the parameter value as a variable.

To configure a parameter as a variable in the Function properties dialog box when the variable does not yet exist:

  1. In the Function properties dialog box, click Variables to bring up the Variable list dialog box.

  2. Click Add Item [image] to create a variable.

  3. Return to the Function properties dialog box and click the Value field to open the drop-down list.

  4. Select the variable that you want to use for the value of the parameter.


Creating a New Strategy > Using Variables

Exporting and Importing Variables

To take a variable definition created in one strategy and use it in another, you must export the variable, and then import it into another strategy.

To export a variable:

  1. Open the strategy that contains the variable to be exported. The strategy opens in the Routing Design window.

  2. On the Routing Design window, click the Variables ( [image]) icon.

The Variable list dialog box opens.

  3. Select the variable that you want to export, then click the Export to file ( [image]) button.

  4. Browse to the location where you want to save the variable, enter a file name for the variable, then click Save.

Note: Variables are saved as text (.txt) files.

To import a variable:

  1. Open the strategy into which you want to import the variable. The strategy opens in the Routing Design window.

  2. In the Routing Design window, click the Variables ( [image]) icon.

The Variable list dialog box opens.

  3. Click the Import to file ( [image]) button.

  4. Browse to the location where you saved the variable, select it, then click Open.

The variable is added to the list of variables in the Variables list dialog box. You can now use it in the strategy.


Creating a Database Object: Overview

Creating a New Strategy > Using the Database Wizard Object

Using the Database Wizard Object: Overview

When included in a strategy, the Database Wizard object [image] queries a database for customer information. The information can then be attached to the call or assigned to a variable.

Placing a Database Wizard object in a strategy automatically launches the Database Wizard for creating the object in that strategy.

You can make database queries for systems that use:

  • SQL databases through a Database Server

  • Non-SQL databases through a Custom Server

Warning! Before using the Database Wizard, you must create configuration objects that query your database.

Warning! Table names and fields names in databases are limited to letters, numbers, and underscores; they must begin with letters. No spaces or special characters can be used.

Warning! Use only a SELECT statement in a query.

  • Do not use any other commands, such as CREATE TABLE or INSERT. Even though you can type in these commands, Genesys does not support them (nor does Genesys support other commands that require a write-to-database operation).

  • Do not use quotes with String constants that are used in strategies; place a space after an equal sign; or use multiple-line SQL statements in Query mode. You must enter SQL statements as single lines.

You can use the Database Wizard object to query a database that uses a SQL Database Server with a:

  • Select statement.

  • Stored procedure.

  • Query.


Using a SQL Select Statement

Creating a new strategy > Using the Database Wizard Object

Using an SQL Select Statement

To create a Database Wizard object that uses an SQL SELECT statement to retrieve database data for your strategy:

  1. Place a Database Wizard object in your strategy.

    The Database Wizard opens.

  2. In the Database Wizard, select the Database Server option, if it is not already selected.

  3. Select the DB Access Point/DB Server and the Select option. All available DB Access Points are listed.

Note: When you edit a SQL Select statement, the name of the DB Server appears in the Select server area. If you change the DB Server, the current definition of the Where expression (step 7 below) becomes invalid and must be re-entered.

  4. Click Next.

    A database table associated with the DB Access Point appears in the Show fields from the table (table access) field and its related fields appear in the Select field from the list area. These fields are based on the format associated with the Table Access, which queries the Database table. If you have not created Format, Fields, or Table Access objects, see Configuring Database Queries.

    Note: The Show fields from the table (table access) drop-down list displays all tables in the database.

  5. Select the field names from the list for this SQL statement and click > to add names to the statement.

    The order in which you select the fields is the order in which they are added to the statement.

    The field names appear in the right window with the name of the table preceding the field name. These first elements of the SQL statement also appear in the lower window.

    Note:     Click >> to add all fields to the statement.

  6. Click Next.

  7. Define the SQL statement using the Expression Builder.

  • Create a Where expression.

  • In the First Operand box, select a table and a field.

  • Select a relation symbol.

  • In the Second Operand box, select either the Variable or Table option. If you select the Variable option, enter a variable or select one from the drop-down list. If you select the Table option, select the table and field name from their drop-down lists.

    Note:     Create a new variable or edit an existing variable by clicking Edit var.

  • Click Add to create the expression. This information now appears in the SQL section of the window.

  • To verify the expression, click Verify.

  • Click Next.

  8. If desired, select the sorting order for the retrieved information.

  • Select a table.

  • Select the field to sort.

  • Select the sorting order, ascending or descending.

    Note:     You can specify a sort order for each of the fields shown in the fields drop-down list.

  • Click Next.

  9. If applicable, click the Do not use output values box and continue with step 11.

  10. Choose a Format output from the Assign Output or Attach Output sections.

If you attached the output, click Finish.

If you assigned the output, click Next.

  • If you assigned the output to a variable, a dialog box opens where you can edit the variable or define a new variable. Define a new variable by clicking Edit Variables to bring up the Variable List dialog box. When through editing or defining the variable, click Finish.

  • If you assigned the value of the key-value pairs to a variable, a dialog box opens where you can map output keys to variable names or define a new variable. Define a new variable by clicking Edit Variables to bring up the Variable List dialog box. When through mapping, click Finish.

  • If the output is a string of values separated by a user-defined separator and you wish to assign the output to separate variables, a dialog box opens. Here you can select/enter the separator and select the variables. Define a new variable by clicking Edit Variables to bring up the Variable List dialog box. When through editing or defining the variables, click Finish.

Note: If commas are specified as the separators and the field type uses commas (for example, currency), then this field type must be redefined as float; otherwise, values containing commas are interpreted as multiple values and separated accordingly.


Using a SQL Stored Procedure

Creating a new strategy > Using the Database Wizard Object

Using an SQL Stored Procedure

To create a Database Wizard object that uses an SQL stored procedure to retrieve database data for your strategy:

  1. Place a Database Wizard object in your strategy.

    The Database Wizard opens.

  2. In the Database Wizard, select the Database Server option, if it is not already selected.

  3. Select the DB Access Point/DB Server from the list in the Select server section.

  4. Select Procedure from the Select the type of data access expression section.

  5. Click Next.

    The Procedure window appears.

  6. In the Name field, enter the name of the stored procedure from your database.

  7. If desired, define key-value pairs for the stored procedure.

    • Click Add to open the Arguments dialog box.

    • Define the pairs you require.

    • Click OK in the Arguments dialog box.

Note: When defining key-value pairs for the stored procedure, you have the option to choose a variable for the value of the key in the Arguments dialog box. In the Arguments dialog box, you can also click Edit Variables to open the Variable list dialog box. In the Variable list dialog box, you can add or delete variables. Click OK to return to the Arguments dialog box.

  8. Click Next.

    If you do not create any key-value pairs, clicking Next displays a dialog box warning you of their absence. Click OK to proceed.

  9. Optional. If applicable, click the Do not use output values box and continue with step 11.

  10. Choose a Format output option from the Assign or Attach sections.

  11. Assign or attach the appropriate data, if required, based on the previous selection; then click Finish.

    For output options requiring a symbol separator, select a symbol from the window or enter one in the Other field.

    Note:     If commas are specified as the separators and the field type uses commas (for example, currency), then this field type must be redefined as float; otherwise, values containing commas are interpreted as multiple values and separated accordingly.


Creating a new strategy > Using the Database Wizard Object

Using a SQL Query

To create a Database Wizard object that uses an SQL query to retrieve database data for your strategy:

  1. Place a Database Wizard object in your strategy.

    The Database Wizard opens.

  2. In the Database Wizard, select the Query option.

  3. Click Next.

  4. Enter the query in the SQL window.

  5. Click Next.

  6. Under Using output values, click the appropriate button to either:

    • Assign the query output to a variable or attach it to the interaction. If you assign the output, click Next and continue with the next step.

    • Attach the query output to the interaction. If you attach the data, click Finish.

  7. If you assigned the output to a variable, you can either:

    • Select the variable and click Finish.

    • Click Edit Variables to define the variable using the Variable List dialog box. When through defining the variable, click Finish.


Creating a New Strategy > Using the Database Wizard Object

Querying a Custom Server

For systems that do not use standard SQL databases, Custom Server enables you to make database queries by invoking a stored procedure.

  1. Place a Database Wizard object in your strategy.

    The Database Wizard opens.

  2. In the Database Wizard, select the Custom Server option.

  3. Select the Custom Server from the list in the Select server section of the Database Wizard dialog box.

  4. Click Next.

    The Procedure window appears.

  5. In the Name field, enter the name of the stored procedure from your database.

  6. If desired, define key-value pairs for the stored procedure, click Add, and enter the information. Define the pairs you require. When all pairs are defined, click Next.

    If you do not create any key-value pairs, clicking Next displays a dialog box warning you of their absence. Click OK to proceed.

  7. Choose a Format output option from the Assign or Attach sections and click Next.

  8. Assign or attach the appropriate data, if required, based on the previous selection.

    For output options requiring a symbol separator, select a symbol from the window or enter one in the Other field.

  9. Click Finish.

Note: Custom Server supports primary and backup modes of operation. If you are using a Custom Server and the primary Custom Server stops running, the Local Control Agent automatically switches the process requirement of Universal Routing Server (URS) from the primary to the backup Custom Server.

To capture information on any interaction that URS has not completed routing during the failover from the primary to the backup Custom Server, use the Error Segmentation object. In the Error Segmentation object, you can specify parameters to segment errors according to error type.

If you do not use the Error Segmentation object, the interaction is routed to the default destination.

See also:

Using an SQL Stored Procedure

Miscellaneous Objects

Error Processing

Universal Routing 7.6 Deployment Guide for information about configuring Custom Server


Format Output for Database Information

Creating a new strategy > Using the Database Wizard Object

Formatting Database Information

When creating a Database Wizard object, you must specify the format output for the retrieved information in the Database Wizard. You have format options for either assigning output to a variable or attaching output to the interaction. The Assign Output options require variable definitions. The Attach Output options require key-value definitions.

Assign Output Options

All Assign Output options involve assigning one or more variables to the output. If you have not created variables using the Variable button in the strategy toolbar or through an expression builder for this strategy, you can create them using the Database Wizard.

Select one of the following Assign options:

Assign output value to a variable. Output value is always considered as a string, integer or float.

Assigns the output retrieved from the database to a variable.

Assign value(s) of the key-value pairs to variable(s) by mapping output key(s) to variable name(s). Output format: "Key1:Value1|Key2:Value2|
Key3:Value3|..."

Assigns the values retrieved from the database to selected variables. Output must be formatted as "KeyN:ValueN."

In the window following the Using Output Values window, assign the key-value pair to the variables. Enter a key name and select a variable for the value.

Assign each value to a variable when the output is a string of values separated by a user-defined separator. Output format:

"Value1<sep>Value2<sep>..."

Assigns the value retrieved from the database to selected variables. Output must be separated by a symbol.

In the window following the Using Output Values window, assign the variables and select a symbol separator.

Attach Output Options

All Attach Output options involve attaching key-value pairs associated with database information to an interaction. These key-value pairs must be configured before this information can be attached. See Configuring Interaction Data.

Select one of the following Attach options:

Attach key-value pair(s) as defined by key(s) in the output format:
"Key1:Value1|Key2:Value2|
Key3:Value3|..."

Attaches output retrieved from the database as key-value pairs to an interaction and displays the information in KeyN:ValueN pairs.

Attach key-value pair(s) by replacing key(s) in the output format: "Key1:Value1|Key2:Value2|
Key3:Value3|..."

Attaches output retrieved from the database as selected key-value pairs to an interaction. Output must be formatted as "KeyN:ValueN."

In the window following the Using Output Values window, assign the key-value pairs of the output to an interaction data key for the interaction. Enter an output key name and select the interaction data key from the associated interaction data previously created.

Attach key-value pair(s) by assigning interaction data key to members of output values separated by a user-defined separator. Output format: "Value1(sep)Value2(sep)..."

Attaches output retrieved from the database as selected key-value pairs to an interaction. Output must be separated by a symbol.

In the window following the Using Output Values window, select the interaction data key and a symbol separator.


Creating a New Strategy

Requesting Web Services

Use the Web Service object to interact with Web-based applications (Web services) outside of Genesys applications. You specify request parameters, what type of data you expect to be returned, and what to do with the returned data. This object can be used in both voice and non-voice routing strategies.

To use the Web Service object:

  1. From the Data and Services toolbar, click the Web Service object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General, Security, and Result tabs.

  4. Click OK.

For additional information on using this object, including how the Web Service object works, consult the Universal Routing 7.6 Reference Manual.

General Tab

You can fill in the General tab by importing a WSDL file or by filling in the fields manually.

Import WSDL

To complete the General tab by importing a WSDL file:

  1. Click Import WSDL. The Import WSDL dialog box opens.

  2. Enter the URL for the WSDL file or click Browse and then navigate to it.

  3. Click Get.

  4. Enter the service name and method name that you want IRD to use from the WSDL file.

  5. Click OK.

IRD fills in the dialog box parameters from the WSDL file.

Note: The list of supported data formats is limited. Therefore, IRD may not be able to import some WSDL files.

Fill in the General Tab Manually

To complete the General tab by filling in the properties fields:

  1. In the Web Service URL text box, enter the URL for the Web service you want to access (mandatory).

For example: http://services.xmethods.net:80/soap/servlet/rpcrouter

  2. In the Method name text box, enter the remote procedure(method) name (mandatory).

For example: getTemp

  3. In the Method namespace text box, enter the XML namespace, which is a collection of names having the general form "ns1=http://example.com/...". If you specify multiple namespaces, they should be separated by commas.

A namespace represents an application-dependent or context-dependent URI that is used in XML documents as an element type and attribute name. Usually the namespace is mandatory, but in some cases it may be empty, depending on the web service. If empty, only default namespaces are used.

For example: ns=urn:xmethods-Temperature

  4. In the SOAPaction text box, you can enter optional HTTP header data.

  5. On the Request parameters pane, click the Add ( [image]) button to add a new entry. A row appears under the Key and Value columns.

  6. Enter the request parameters in the form of key-value pairs. These are the parameters for the procedure (method).

These function parameter values can be obtained from the Web service description on the Web service provider's website or from the WSDL description file.

Entering parameters is usually mandatory, but in some cases may not be necessary, depending on the Web service.

For example:

Key =zipcode, value=94546

Key=acctnum, value=5390021

  7. Configure the Result tab and the Security tab.

  8. Click OK.

Result Tab

The Result tab of the Web Service properties dialog box enables you to specify how to handle the output received from your Web service request.

To configure the Result tab:

  1. Select one of the radio buttons, described below.

  • Select Do not use output value if you do not want to use the returned values in any of the ways listed below.

  • Select Assign output value(s) to variable(s) by mapping SOAP response value(s) to variable names if you want to assign any returned output values to variables.

When you select the Assign option and click the Add button ( [image]), any predefined variables appear for selection in the Output values area.

When linking output values to variables, the key must be the full path to the appropriate parameters in the SOAP response, for example: getTempResponse.return. Continue adding rows until you have assigned all the returned values to variables.

  • Select Attach key-value pair(s) by replacing key(s) in the output format with the interaction data key(s) if you want to attach returned output values to the interaction. When you select the Attach option and click the Add button ( [image]), all interaction data keys appear for selection in the Output values area. .

Select one or enter an interaction data name and the corresponding key from the return on the Output values pane. The key must be the full path to the appropriate parameter(s) in the SOAP response.

  2. Click OK.

Security Tab

The Security tab enables you to configure the requirements that are necessary for your request to access the specified Web service.

Note: You can create variables for any values that should appear in the drop-down lists. For information about creating variables, see Using Variables: Overview.

To configure the Security tab:

  1. On the HTTP Authentication pane, select the radio button that corresponds to the desired security level.

Basic authenticated access passes any name and password data in 64-bit encoding. Digest authenticated access passes any name and password data in encrypted format.

  2. If you selected Basic authenticated access or Digest authenticated access, and a name and password are required to access the Web service, enter the name and password information in the Name and Password text boxes.

  3. (Optional) On the SOAP Security pane, enter a value in the Actor/role text box, or click the arrow to select a value from the drop-down list.

The value for the Actor/role text box should be a specific server component on the Web service site that should process the SOAP security parameters. If you enter an incorrect component name, your request is rejected.

  4. Click the arrow to the right of the Type text box to select a value from the drop-down list. You can select BinarySecurityTokenPEM, UserNameTokenDigest, or UsernameTokenText.

  5. After you select the SOAP security type, if authentication information is required, enter the corresponding values for the key-value pairs to be used.

  • For BinarySecurityTokenPEM, the key is Name, and the value must be the path to the PEM file.

  • For UserNameTokenDigest and UsernameTokenText, the keys are Name and Password.

  6. After you have completed the Security tab, complete the General and Result tabs (if you have not already done so), then click OK.


Creating a New Strategy > Expression Building

Building an Expression

To build an expression:

  1. On the Toolbar, select the object that will use the expression.

For example, place an If object in the Routing Design window workspace. Double-click the If object to open the dialog box that is used for building the expression.

  2. From the Type list, select a data type.

    Note: For Functions, you can either select a category or select All Functions to see a complete list.

  3. From the Name list, select the data to use in the comparison.

    Note: You can type the first letter of the function name to avoid scrolling through the list.

  4. From the Operator list, select a comparison symbol.

  5. From the Value list, select a comparable.

    Note: To add a variable to the Value list, click Variables. If you need to create a variable, see Creating Variables.

  6. Click the Add button to insert the first part of the expression into the Expression text box.

  7. If you want to create a second comparison, click AND or OR to insert a connector.

  8. Repeat Steps 1 through 6 until your expression is complete.

    Note: To change the order of operation, type parentheses directly in the Expression text box. For more information, see the "Interaction Routing Designer Objects" chapter in the Universal Routing 7.6 Reference Manual.

  9. To verify that the expression is valid, click Verify.

    If you choose to verify the expression and it is valid, your expression appears in green. If the expression is invalid, a message warns you that there is a syntax error and your expression appears in red. Correct the invalid expression and verify it again.

  10. Click OK.


Creating a New Strategy > Expression Building

expression building: Overview

An expression consists of one or more conditions joined by the connectors AND (&) and OR (|). A number of objects use expressions to determine the appropriate routing path for interactions.

When you build an expression, it consists of a selection from the Name list, which appears on the left side of the connector and a selection from the Value list, which appears on the right.

For more information about expressions, see the "Interaction Routing Designer Objects" chapter in the Universal Routing 7.6 Reference Manual.

The objects that enable you to build expressions are as follows:

  • Assign

  • MultiAssign

  • Generic Segmentation

  • Function

  • Multi Function

  • If

  • Attributes

Skill expressions are a specialized type of expression that enable you to route based on required skills and skill levels. You can create skill expressions for the following objects:

  • Selection object for the Skill Type

  • Route Interaction object for the Skill Type

  • Statistics object for the Skill Type

  • Function object or Multi Function object for CreateSkillGroup, CountSkillInGroup, GetSkillInGroup, MultiSkill, and RequestedSkillExpression functions

The following figure shows the Expression Builder dialog box as it appears in the If object. No matter which object you use to build expressions, the dialog box contains the same areas and controls. Click any active spot in the figure for a description of that area or control.

See also: Building an Expression

Expression Builder Dialog Box Properties

  • Expression Text Box—The Expression text box displays the expression that you create by selecting from the items on the Data pane. You should not type directly in this box except to:

    • Add parentheses to change the order of operation.

    • Delete a mistake.

  • Data Pane—The Data pane contains menus and buttons used to build expressions.

  • Type List—Enables you to select Interaction Data, a Function, or a Variable for the left side of the expression. The options listed differ depending on what type of object you are creating. In the Skill expression properties dialog box for the functions, you can create expressions for the Skill, Statistic, and Variable Types.

  • Name List—Enables you to select the specific Function, Interaction Data, or Variable to use for the left side of the expression.

  • Operator List—Choose a comparison symbol from the Operator list to connect the left side of the expression (Name) to the comparable (Value). The following table shows the comparison symbols used in logical expressions:

Symbol | Meaning | Example | Symbol | Meaning | Example
!= | not equal to | Day != Sunday | = | equal to | Day = Monday
< | less than | Time < 16:00 | > | greater than | Time > 9:00
<= | less than or equal to | Day <= Friday | >= | greater than or equal to | Day >= Monday

  • Value Text Box and List—The text box enables you to choose or manually enter a comparable for the right side of the expression. You can use either a variable or constant for the comparable for interaction data and most functions. (You cannot use a variable for Time and Date functions.) Alternatively, you can select a value from the list below the text box. Click Variables to add a variable to this list.

  • Add Button—Click to add the expression to the Expression text box.

  • Verify Button—Click to check for errors in your expression. The expression turns green if there are no errors and red if IRD finds errors in the syntax. If the expression is invalid, you receive a message warning you of a syntax error. Correct any incorrect variables or connectives (+, -, |, /, *, and so on) and then verify the expression again.

  • AND Button—Use to insert the AND (&) connective to join two or more comparisons. When you use this connective, all conditions must be met for the expression to be true.

  • OR Button—Use to insert the OR (|) connective to join two or more comparisons. When you use this connective, the expression is true if any condition is met.

  • Variables Button—Click to add a variable so that you can select it from the Type or Values list.


Creating a New Strategy

Attaching Business Attributes

The Multi Attach object enables you to attach business attributes, such as service type, customer segment, or service objective to an interaction. You can also use the Multi Attach object to attach requested skills. You can then segment interactions using this information or you can use it later in the strategy.

Note: Use of business attributes is optional.

To attach business attributes:

  1. From the Miscellaneous toolbar, click the Multi Attach object ( [image] ) and then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box if it is not already open. The dialog box contains four radio buttons: Update, Attach, Business Attributes, and Requested Skills.

  3. Select the Business Attributes radio button to display Attribute and Value columns for Service Type, Customer Segment, and Service Objective.

  4. Configure one or more business attributes by specifying a value or using a variable.

To configure the Service Type and Customer Segment business attributes:

  1. Click in the Value column to display a down arrow.

  2. Click the down arrow to open the Key dialog box.

  3. In the Key dialog box, click the Type down arrow and select the attribute type or select Variable.

  4. In the Value field, click the down arrow and select the attribute name or the predefined variable name.

  5. Click OK.

To configure the Service Objective business attribute:

  1. Click inside the Value column. The predefined service objectives appear.

  2. If you wish to override the predefined service objectives, enter a value.

To attach Requested Skills:

  1. Click the button to add an item [image] .

  2. Click the down arrow to bring up the Key dialog box.

  3. In the Key dialog box, click the Type down arrow and select the attribute type or select Variable.

  4. In the Value field, click the down arrow and select the attribute name or the predefined variable name.

  5. Click OK.

  6. Under Value in the General tab, enter a number to define the minimum required skill level.

For more detailed information on attributes, see the Universal Routing 7.6 Reference Manual.


Multi Attach Object: Updating/Attaching Data

Creating a New Strategy

Attaching and Updating Data

The optional MultiAttach object enables you to attach or update one or more pieces of data such as account or menu selection data that the customer entered via an IVR. This data can be either predefined interaction data or the contents of a variable.

To update or attach data:

  1. From the Miscellaneous toolbar, click the Multi Attach object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box if it is not already open. The dialog box contains four radio buttons: Update, Attach, Business Attributes, and Requested Skills.

  3. To update interaction data or the contents of a variable, select the Update radio button. To attach interaction data or the contents of a variable to the interaction, select the Attach radio button. In either case, the remainder of the configuration is the same.

  4. Click the Add Item button ( [image]) to bring up the Key dialog box.

  5. Click the down arrow in the Key column to bring up the Key text box where you can select a Type, either Interaction Data or Variable.

  7. Click the down arrow in the Value field and select a value. For example, if the attribute is based on interaction data for language preference, the first value might be English and the second value might be Spanish.

  8. Click OK in the Key dialog box. This returns you to the Multi Attach properties dialog box where you can specify more data to attach or update.

  9. When you have finished attaching or updating data in the Multi Attach properties dialog box, click OK.

Attach and Update can also be done using the Function object. Unlike the MultiAttach object however, each Function object can only use a single Attach or Update function.

The SetDelayedAttach[true/false] strategy function is now available for explicit use after an Attach or Update function. This function was previously used implicitly inside the MultiAttach object.

All invocations of an Attach or Update function that are made after SetDelayedAttach[true] will not result in update requests to the T-Server until either SetDelayedAttach[false] is called or the strategy executing for this call is suspended for some reason.

Note: If the strategy is suspended for any reason, the attachment or update occurs automatically.


Creating a New Strategy

Applying Busy Treatments

Busy treatments determine what happens to an interaction while it is waiting for a target to become available. You can use them in the Selection object (as shown in the following figure) and in some Routing rules.

Notes:

  • The exact number of prompts that IRD allows for busy treatments depends on the size of the prompt parameters. As a general example, if the prompt IDs are nine digits, IRD can compile a strategy with 20 prompts.

  • The Load Balancing Routing object does not use busy treatments because the target type, ACDQueue, is always available.

To apply busy treatments:

  1. Create a routing rule or open the properties dialog box for the Selection object.

  2. Click the Busy tab and select Use treatments.

Note: For routing rules that use busy treatments, the Busy tab has other options which are explained in Configuring the Busy Tab for Routing Rules.

  3. Click Add Item [image] , and then select a treatment from the drop-down list.

  4. Click the arrow under Parameters. (This arrow only appears when you click in a Parameters field).

    The Parameters dialog box opens.

  5. Enter a value for each parameter, then click OK to close the dialog box and return to the Treatments tab.

  6. Select or enter a number (in seconds) for the timeout.

    The timeout specifies how long the busy treatment is applied.

For some treatments, such as Play Announcement, you must know the length of the treatment so you do not specify a timeout that will cut off the treatment. If you specify a timeout greater than the length of the treatment, T-Server ignores the timeout.

  7. Repeat Steps 3 through 6 until you have configured each treatment you want to use.

To set Default Destination, Prediction Threshold, and Timeout for Routing Rules, see Configuring the Busy Tab for Routing Rules.

Note: In the Selection object, you can select a variable for the value of each parameter. You can also select a variable for Timeout from the Timeout drop-down list.

For more information about busy treatments, see the Universal Routing 7.6 Reference Manual.

See also:

Sample B: Day of Week, Time, Routing Rules, IVR


Creating a New Strategy

Creating Virtual Queues

Use virtual queues to specify how to route an interaction if none of the specified targets are available. You can configure virtual queues for certain Routing objects. Certain Functions enable you to specify the value of a virtual queue as a variable.

  • Routing objects—Load Balancing, Percentage, Service level, Statistics, and Workforce routing rules; and the Selection object.

  • Functions—CallsDistributed, CallsEntered, ClearTargets, DistributedPercentage, DistributedWaitingTime, NotDistributedPercentage, NotDistributedWaitingTime, SelectDN, and SetVQPriority.

Virtual Queues in Routing Objects

To configure a virtual queue in a Routing object:

  1. In the Virtual Queue section of the properties dialog box, select the Use Virtual Queue check box.

  2. Choose a switch from the Switch drop-down list.

  3. Choose an alias from the Alias drop-down list. You can also choose a variable from the Alias drop-down list.

A number appears automatically. The number is a DN number associated with the switch.

  4. Click OK.

Note: Genesys recommends that you create a virtual queue for reporting (for target types other than ACD Queue) if the routing target is not a real object in a PBX that provides reporting on interaction statistics. If the switch CTI link does not support ACD Queue statistics and messaging, then you must create a virtual queue for ACD reporting.

Virtual Queues in Function Objects

To define a virtual queue in a Function object:

  1. In the Function properties dialog box, select VirtualQueue as the value for the Object parameter on the Parameter/Value pane. The text box in the Value column for the Virtual Queue Name parameter becomes active.

  2. Click inside the text box in the Value column for the Virtual Queue Name parameter. They Key dialog box opens.

  3. In the Key dialog box, click the Value down arrow and select the virtual queue.

  4. Click OK in the Key dialog box.

See also:

Creating Variables

Configuring the Busy Tab for Routing Rules

Routing Rules


Creating a New Strategy

Using the Call Subroutine Object

The Call Subroutine object enables you to use a subroutine in a strategy or another subroutine. Before you can use this object, you must create the subroutine that this object will call.

To use the Call Subroutine object:

  1. In the Miscellaneous toolbar, click the Call Subroutine object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Open the properties dialog box.

  3. Select a subroutine from the Subroutine Name list.

If the subroutine includes input and output parameters, they appear on the Input Parameters and Output Parameters panes.

  4. If there are input and output parameters, enter or select a value from the Value list for each parameter. The list of values presented is based on the Subject that you specified when you created the input parameter in the subroutine. Then click OK.

For input parameters, the value can be a string constant or a variable. For output parameters, the value must be a variable.

For example, if you created an AcctNum variable for the customer's account number in the original strategy and you created an AcctNumSub parameter in the subroutine, you can select the AcctNum variable from the Value list for this parameter. The value of the AcctNum passes to the AcctNumSub parameter in the subroutine.

Warning! Every subroutine output parameter must be assigned to a unique Call Subroutine output parameter.

For more information about input and output parameters and using the Call Subroutine object, see the "Interaction Routing Designer Objects" chapter in the Universal Routing 7.6 Reference Manual.


Saving a Strategy

Saving a Strategy: Overview

Note: Compiling a strategy does not automatically result in IRD saving the strategy. In order for the strategy to be listed in the Strategies list, you must save it. You can save a strategy even if you cannot compile it because it is invalid.

Strategies consist of two parts:

  • The graphic elements (those that appear in the GUI), which are saved as an .rbn file in the storage location you specify.

  • The Script part, which by default is saved in the Scripts folder in the Configuration Database.

Notes:

  • When you save a strategy, URS stores it in memory so that it can save the strategy at any time.

  • If you used any item from the Page Setup menu, the Save changes to strategy? message may appear when you attempt to close a strategy that has not been modified.

  • When you save a strategy for which the number of characters in the strategy name exceeds the number of characters allowed (194), IRD displays the following message: Cannot open file. Disk is full or there is a sharing violation.

After you have initially saved the strategy or subroutine, you can set the Autosave function. IRD then automatically saves your work at the intervals you set. If necessary, you can return to an autosaved version.

  • You can also back up and restore strategies.

To save a strategy or a subroutine:

  1. Open strategy or subroutine you want to save in the Routing Design window.

  2. Select one of the following from the File menu:

Save

If you are creating a new strategy, the first time you select Save from the File menu, the Save dialog box opens. You cannot change the strategy name, but you can change the RBN File Path (network drive or database) and the Script object save location in the Configuration Layer (as viewed in Configuration Manager).

After the initial save, selecting Save from the File menu saves the strategy but the dialog box does not appear. To re-open the dialog box, you must select the Save As option.

Save As

Opens the Save As dialog box where you can save the strategy under a new name, change the storage location (network drive or database) or change the Script object folder in the Configuration Layer (as viewed in Configuration Manager).

  3. Complete the fields in the resulting Save or Save As dialog box.

  4. Click OK in the dialog box. Only the graphical portion of the strategy or subroutine is saved in the chosen location.

Warning! A strategy or subroutine (.rbn file) should not be shared by multiple Configuration Servers. This occurs if you import a strategy or subroutine from the same storage location used by one Configuration Server into another Configuration Server. If you make changes, the script object for the strategy or subroutine changes in both Configuration Servers. To prevent changes to both script objects, copy the .rbn file to another location and import that strategy or subroutine into the second Configuration Server.

See also: Components of a Strategy


Saving a Strategy

Strategy Storage Location when Saving

When a strategy is saved, copied or imported:

  • The GUI portion is saved as an .rbn file on a network/local drive or in the database. This location appears on the Details tab when you select the strategy or subroutine on the List pane.

  • The script portion is saved in the Configuration Database (Configuration Layer) as a Script object.

Use the Save and Save As dialog boxes to specify both the .rbn and script storage locations.

Note: The same dialog box is used for the Save As and Copy functions, but the Strategy Name field is writable for Save As and Copy.

To configure the save settings for your strategy:

  1. Complete the Storage Location tab. The following table discusses each field on the Storage Location tab.

Strategy Name

The strategy name is initially entered in the dialog box that appears when you select Strategies in the Design bar then click File > New. After the initial save, you can change this field for Save As and Create Copy operations.

RBN File Path

A default path, stored in Configuration Layer, appears the first time you save. Subsequently, IRD displays the last path used for the current tenant, which is stored in the Registry. If the Registry is empty, the IRD executable directory is used.

Click the browse button ( [image]) to select a new .rbn file path location. You can change this field for Save, Save As, and Create Copy operations.

Different tenants can have different default storage locations.

Note: Do not select the \...\GCTI\IRDesigner\importstr directory as a new .rbn file path location. This directory was designed to serve as a place for creating and keeping the temporary .rbn files. If you try to save to this directory, an error message appears warning that strategy with such name is already exists.

Store to database

The database used is the Configuration Server database. The table name is ird_strategies. If security is a consideration, you may wish to store to a database. For example, if you are a Service Provider, you may not want your Subscribers to have access to your corporate drives. In this case, saving to the database in the preferred method.

Note: In order to enable Store to database checkbox, a Database Access Point must appear in the Connections tab of the IRD Application in Configuration Manager.

Different tenants can have different default storage locations.

  2. Click the Config. Layer Location tab to see where the strategy is stored in the Configuration Layer. To change this location:

  3. Click in the Tree text box.

  4. Select the desired location from the tree view that appears.

  5. Click OK.

Notes:

  • If you intend to allow other users access to your strategies, store them on a network drive rather than your local drive.

  • If you want to share editing of strategies, make sure to include the network drive name when you set the path in the RBN File Path field.


Backing Up and Restoring a Strategy: Overview

Saving a Strategy > Backing Up and Restoring Strategies

Backing Up and Restoring Strategies: Overview

To back up your work on strategies and subroutines you can:

  • Set IRD to create automatic backups of your strategies as you work on them using Autosave.

  • Manually create backup versions.

You have two options for restoring strategies:

  • Restoring a previous version

  • Restoring a strategy from a temporary file when Autosave Timer is active


Saving a Strategy > Backing Up and Restoring Strategies

Backing Up a Strategy

Each time you edit a strategy, you can back up the previous version. You can keep multiple versions of a strategy and revert back to an older version at any time.

Note: Keeping more than a few versions of a strategy may slow down the backup and restore procedures.

To back up a strategy:

  1. Open the strategy in the Routing Design window.

  2. From the File menu, click Backup.

    The Backup Version dialog box appears.

  3. Enter a version number and a description of the version.

To delete a strategy version:

  • Select the version from the Available versions list in the Backup Version dialog box, then click Delete.

See also: Restoring a Previous Version


Saving a Strategy > Backing Up and Restoring Strategies

Restoring a Previous Version

If you have backed up versions of a strategy, you can restore any version you wish.

Note: You cannot restore a previous version of a strategy if the current version is loaded to a route point. The following procedure explains what to do in this situation.

To restore a previous version of a strategy:

  1. If you want to save the current version, back it up now.

  2. If the strategy is not loaded, proceed to Step 3. If the current version is loaded to a route point, do the following:

  1. Create a copy of the strategy, and then load the copy on the route point (without first releasing the original).

Warning! Releasing a currently loaded strategy is not recommended. Doing so causes all interactions to be routed to the default destination. Instead, load one strategy directly over the currently loaded strategy.

  2. Restore the previous version of the original strategy, as explained in Steps 3-5 below.

  3. Load the restored version of the original strategy on the route point, replacing the copy you made of the original.

  3. Open the strategy in the Routing Design window.

  4. From the File menu, choose Restore.

    The Restore Version dialog box opens.

  5. Select the version you want to restore, then click OK.

    The version you selected is now the current version.


Saving a Strategy > Backing Up and Restoring Strategies

Restoring from a Temporary File

Files that were automatically saved when the Autosave Timer feature was activated can be restored using this command from the File menu.

To restore a temporary file:

  1. Open the strategy you want to restore.

  2. Choose Restore from temp. from the File menu
    The strategy returns to the most recent autosaved appearance.

Note: The temporary file is deleted when you save the file using Save from the File menu or press CTRL+S.


Routing Non-Voice Interactions: Overview

Routing Non-Voice Interactions

Routing Strategies for Non-Voice Interactions: Overview

The key difference between routing voice and non-voice interactions is that non-voice interactions are generally routed using business processes. A Business Process is a composite of multiple strategies, each of which handles a specific aspect of interaction processing. In contrast, voice interactions are usually routed by a single strategy that takes into account all possible paths the call might take.

  • A voice strategy usually directs a voice interaction through the entire routing cycle of the call, from the time the call arrives at the contact center to the point when the call is routed to an Agent.

  • A non-voice routing strategy used in a Business Process may only perform one aspect of processing, after which it sends the interaction to a queue or workbin for processing by another strategy. The next strategy may be in the same Business Process or in a different one.

See the Voice Vs. Non-Voice Strategies topic for examples.

Objects Used in Non-Voice Strategies

The objects used for creating strategies in business processes, are located in various places on the Routing Design window toolbar:

  • The Data and Services toolbar. The External Services object is used only in non-voice strategies. The Database Wizard and Web Service objects can be used in both voice and non-voice strategies.

  • The Segmentation objects toolbar. You can use any segmentation object except the DNIS and ANI objects in non-voice routing strategies. The Classify Segmentation object and the Screen Segmentation object are used only in non-voice routing strategies.

  • The Routing objects toolbar. You can use the Route Interaction, Workbin, and Queue Interaction objects in non-voice routing strategies. All other objects are used only when routing voice interactions.

  • The Miscellaneous objects toolbar. You can use any Miscellaneous object in a non-voice routing strategy.

  • The Multimedia objects toolbar. Multimedia objects are used only in non-voice routing strategies.

  • The Outbound toolbar. The Add Record, Do Not Call, Processed, UpdateRecord, and Reschedule objects are designed to be used to route proactive Open Media interactions that have the outbound_preview media type.

  • The Resource Management toolbar. You can use the objects in this toolbar to control workflow and set resource (strategy and Place or Agent) states.

  • The SMS toolbar. You can use the objects in this toolbar to create and send SMS messages.

Note: Voice Treatment objects apply only to voice interactions.

See also:

Understanding Business Processes

Multimedia Toolbar Objects

Routing Objects for Multimedia Interactions

Routing Outbound Interactions

Requesting an External Service

Segmenting Non-Voice Interactions

Routing Outbound Interactions


Voice Vs Non-Voice Strategies

Routing Non-Voice Interactions

Voice vs. Non-Voice Strategies

The design of non-voice strategies used in a business process differs from the design of a voice routing strategy. This is true because of the role that a strategy plays in the routing life-cycle of each interaction type.

  • A non-voice routing strategy used in a Business Process may only perform one aspect of processing and then write the interaction to a queue or workbin for processing by another strategy. A strategy in a Business Process can be understood only in relation to the strategies that come before and after it in the interaction-processing sequence.

  • A single voice strategy usually directs a call from the time it arrives at the contact center to the point when it is routed to an Agent.

Example Business Process

  1. Strategy #1 in a Business Process routes an interaction to an Agent workbin. The Agent constructs a response and places it in an interaction queue.

  2. A view (created in the Interaction Design window) attached to the queue extracts the interaction and a submitter object (created in the Interaction Design window) submits the interaction to strategy #2. This second strategy routes the interaction to a workbin for quality assurance (QA).

  3. Based on the results of the QA review, the interaction is routed back to the Agent to be reworked (strategy #3) or is sent to the customer.

Example Chat Strategy

The following figure shows a strategy used in a Business Process that determines whether a waiting interaction will be processed online (immediately) or offline (later). In either case, the interaction is routed to a queue for further processing by the next strategy in the Business Process.

Example E-mail Strategy

The following figure shows an e-mail handling strategy that could be used after the preprocessing stage of a Business Process (automatic acknowledgement, screening, and so on). Since previous strategies in the Business Process have performed other functions, this strategy only does one thing—it uses the Route Interaction object to route e-mail to Agents.

Example Voice Strategy

The following figure shows a voice strategy that segments incoming interactions based on Caller-Entered-Digits (CEDs) and routes the calls based on the caller's language preference. In this case, a single strategy controls the entire routing process.


Routing Non-Voice Interactions

Understanding Business Processes

A Business Process is a logically-ordered series of strategies that work together to direct non-voice interactions through various queues and to various targets in order to get the appropriate response to the customer. Business processes are stored in and executed by Interaction Server.

During its lifetime, an interaction may undergo pre-processing (such as classification and screening), and then handling by Agents, supervisors, and QA. During this time, an interaction may be submitted to different routing strategies and pulled out of/placed into various queues a number of times.

Routing strategies used in business processes function much like "stepping stones" between queues. A single Business Process can encompass multiple routing strategies. Each strategy may automatically produce one or more strategy-linked nodes when inserted into the Business Process.

To open a Business Process:

  1. Click the Business Processes icon on the Interaction Design shortcut bar, or you can select Business processes from the View menu.

  2. Double-click an existing Business Process to open it in the Interaction Design window. Or select New from the File menu to create a new Business Process.

Business processes open in the Interaction Design window.

Using Strategies in Business Processes

The following figure shows an example of a Business Process that includes three routing strategies: 75TechpubsSort, 75POMProcessing, and 75TechpubsAcknowledge.

See also:

Routing Non-Voice Interactions: Overview

Voice Vs. Non-Voice Strategies

Interaction Design Window

Strategy-Linked Nodes

Interaction Server

Universal Routing Business Process User's Guide

Universal Routing Strategy Samples


Multimedia Toolbar Objects Overview

Routing Non-Voice Interactions > Multimedia Toolbar Objects

Multimedia Toolbar Objects: Overview

Multimedia objects are located in the Multimedia toolbar.

The Multimedia objects are:

  • Stop Interaction, which is used to notify Universal Contact Server that interaction processing has stopped.

  • Acknowledgement, which is used to create an automatic acknowledgment from your standard response library.

  • Autoresponse, which is used to create an automatic response from your standard response library.

  • Chat Transcript, which is used to attach a transcript of a chat session to an e-mail.

  • Send E-Mail, which is used to send an e-mail that is waiting in a queue.

  • Redirect E-Mail, which is used to redirect an e-mail to an external address with no expectation of a response.

  • Forward E-Mail, which is used to forward an e-mail to an external address when you expect a response.

  • Reply E-Mail from External Resource, which is used take an inbound e-mail from an external resource, extract the reply text from it, create an outbound reply e-mail to the customer, and submit the e-mail to Interaction Server.

  • Screen, which is used to filter text interactions for specific words or patterns of words based on the screening rule provided by URS.

  • MultiScreen, which is used to filter text interactions for specific words or patterns of words based on multiple screening rules.

  • Classify, which is used to assign classification categories to an interaction.

  • Attach Categories, which is used to attach classification categories to an interaction after the interaction has been processed using the Classify object.

  • Create Interaction, which is used to create an interaction record for an open media interaction in the Universal Contact Server database.

  • CreateEmailOut, which is used to create an outbound e-mail, for example one used in an outbound e-mail campaign.

  • Create Notification, which is used to create an outbound email that contains information requested by a customer or which points the customer to the location of the requested information.

  • CreateSMS, which is used to create messages in Short Message Service protocol, used to send messages to cell phones, personal organizers, and so on.

  • Identify Contact, which enables you to search for customer information from the UCS database that matches the customer data attached to an interaction. You can use Identify Contact to retrieve all data related to the matching customer from the UCS database and use the data to make routing decisions. Identify Contact also enables you to create a contact if one matching the attached data does not exist.

  • Update Contact, which enables you to change the values for customer information for already-existing contacts and to add new information to their UCS database profiles.

Other interaction-processing objects, located in other toolbars, enable you to:

  • Route Objects for Multimedia Interactions.

  • Request an External Service.

  • Segment on Classification Code.

  • Segment on Screening Rule.


Stop Interaction Object

Routing Non-Voice Interactions > Multimedia Toolbar Objects

The Stop Interaction Object

The Stop Interaction object causes URS to perform two actions.

  • Send a request to Interaction Server to stop interaction processing. If you selected the Notify check box and UCS returns an error, URS skips this step, interaction processing does not stop, and the interaction exits through the red (error) port of the Stop Interaction object.

  • (Optional) If you have selected the Notify checkbox in the Stop Interaction object's Properties dialog box, URS notifies UCS (Universal Contact Server), through Interaction Server, that interaction processing is to be stopped for a particular strategy that is a part of a Business Process.

The Stop Interaction object generates a Stop node in a Business Process.

To use the Stop Interaction object:

  1. From the Multimedia toolbar, click the Stop Interaction object ( [image] ) and place it in the Routing Design window to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. In the Reason text box, click the drop-down arrow and select a reason code.

When you place the Stop Interaction object in a strategy, the resulting properties dialog box prompts you to select a reason code. Configuration Manager predefines the following reason codes as Business Attributes: Normal, AutoResponded, Terminated, Sent, Forwarded, and Redirected.

You can extend the list by adding reason codes that are specific to your site.

  4. Select the Notify check box to enable the optional fields in this pane.

  5. (Optional) Select the Delete check box to have UCS delete the interaction from its database. For example, the interaction may not be required for reporting or interaction history.

  6. (Optional) Select UCS to notify UCS that interaction processing has stopped or Third-Party Server to notify a third-party server, such as an open Media Server, that interaction processing has stopped.

Note: You can notify either UCS or a third party server; you cannot notify both.

  7. If you selected UCS, click the drop-down arrow in the Application text box and select the appropriate UCS application name.

  8. If you selected Third-Party Server:

  1. Click the Application type drop-down arrow and select a type defined in the Configuration Server database.

  2. Click the Application drop-down arrow and select the Application name of the third-party server.

  3. Enter the type of notification in the Service field. By default, this is Ixn.

  4. Enter the Name of the notification service in the Name field. By default, this is StopProcessing.

  8. Click OK.

For additional information on the Stop Interaction object, including returned results and fault codes, see the Universal Routing 7.6 Reference Manual.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Creating an Acknowledgement

The Acknowledgement object instructs Universal Routing Server to send a message to E-mail Server Java (if the incoming interaction was an e-mail) or to the appropriate Media Server (if the incoming interaction was in another medium, such as fax)requesting the creation of an acknowledgement message. This type of standard response usually explains that the customer's interaction was received and will be answered by an Agent.

You can send an Acknowledgement for any type of incoming interaction.

Note: Standard responses are configured outside of IRD using Knowledge Manager.

To create an Acknowledgement object:

  1. On the Multimedia toolbar, click the Acknowledgement object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Under Operation mode, select Email, Open Media, or 6.x Compatible.

  • Use Operation mode 6.x if your environment is running Internet Contact Solution 6.5.x with a routing solution.

  4. The options available in this dialog box depend on your selection on the Operation mode pane. Fill in the fields in the dialog box, following the appropriate set of instructions, given below.

  5. Click OK after configuring the settings in the dialog box.

Email and Open Media Modes

If you select Email or Open Media:

  1. From the E-mail Server drop-down list, select the Application name (defined in Configuration Manager) for the E-mail Server Java to be notified of the existence of this acknowledgement.

Note: If you select Open Media, this should be the E-Mail Server Java that has been adapted to handle the appropriate media type.

  2. Click in the Output queue text box and then select the queue in which E-mail Server should place the acknowledgement.

  3. If applicable, select Get standard response from UserData. If you select this option, the Select standard response button is disabled. This option uses the classification codes returned by the Classify object and stored in the interaction to get a standard response.

  4. If applicable, select Select standard response. Use this option to manually select an attribute (defined in Configuration Manager) representing an existing standard reply for the acknowledgement. If the selected standard response contains custom field codes, the Key field on the Field Codes pane is populated with one or more custom field code variables.

Note: IRD does not support the use of periods or commas in the names of keys for Standard Response Field Codes.

  5. If you selected Open Media, select the source of the address—User Data or Customer Profile—on the Address pane.

Note: This pane appears only if you select Open Media. If you selected Email, this area is empty.

  6. If you want the acknowledgement to attach the original message, select Include original message into reply.

  7. If you do not want to create a new record in the Contact Server database (contact history) for the acknowledgement, select Do not thread.

  8. (Optional) Use the Field codes area to assign values to custom field code variables that have been defined in Knowledge Manager, as described in the Multimedia 7.6 User's Guide. If you click the Add Item button ( [image] ) to add a new entry, a new row appears in the Key and Value areas.

Example of Field Code Usage:

In Knowledge Manager, you defined a custom variable called WesternAgentGroup. In the Acknowledgement object, you entered WesternAgentGroup in the Key area, and "Hello you have reached the western Agent group. Welcome." in the Value area.

You used this custom variable in a field code and then used that field code in a standard response that you subsequently specified in the General tab of the Acknowledgement object.

The string "Hello you have reached the western Agent group. Welcome." replaces the variable WesternAgentGroup in the acknowledgement message.

  9. Complete the Format tab.

  10. Complete the Result tab.

  11. Click OK.

Note: The Acknowledgement object only creates the message. Use the Send E-mail object to send an acknowledgement that is waiting in a queue.

For more detailed information on these operation modes, as well as returned results and fault codes, see the Universal Routing 7.6 Reference Manual.

Operation mode 6.x

To configure the Acknowledgement object after selecting Operation mode 6.x, do the following:

  1. In the Acknowledgement receipt field, click the down arrow and select an identifier for the acknowledgement text.

  2. Select Include original message into reply if you want to include the original message with the acknowledgement receipt in your reply.

  3. Click OK.

For more detailed information on the 6.x operation mode, see the Universal Routing 7.6 Reference Manual.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Creating an AutoResponse

Use this object to generate (but not send) an automatic response using text from your standard response library. This response can be sent in reply to an incoming interaction in any medium.

Note: Standard responses are configured outside of IRD using Knowledge Manager.

To create an Autoresponse object:

  1. On the Multimedia toolbar, click the Autoresponse object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Under Operation mode, select Email, Open Media, or 6.x Compatible.

  • Use Operation mode 6.x if your environment is running Internet Contact Solution 6.5.x with a routing solution.

  4. The options available in this dialog box depend on your selection on the Operation mode pane. Fill in the fields in the dialog box, following the appropriate set of instructions, given below.

  5. Click OK after configuring the settings in the dialog box.

Email and Open Media Modes

If you select Email or Open Media:

  1. From the E-mail Server drop-down list, select the Application name (defined in Configuration Manager) for the E-mail Server Java to be notified of the existence of this autoresponse.

Note: If you select Open Media, this should be the E-Mail Server Java that has been adapted to handle the appropriate media type.

  2. Click in the Output queue text box and then select the queue in which E-mail Server should place the autoresponse.

  3. If applicable, select Get standard response from UserData. If you select this option, the Select standard response button is disabled. This option uses the classification codes returned by the Classify object and stored in the interaction to get a standard response.

  4. If applicable, select Select standard response. Use this option to manually select an attribute (defined in Configuration Manager) representing an existing standard reply for the autoresponse. If the selected standard response contains custom field codes, the Key field on the Field Codes pane is populated with one or more custom field code variables.

Note: IRD does not support the use of periods or commas in the names of keys for Standard Response Field Codes.

  5. If you selected Open Media, select the source of the address—User Data or Customer Profile—on the Address pane.

Note: This pane appears only if you select Open Media. If you selected Email, this area is empty.

  6. If you want the autoresponse to attach the original message, select Include original message into reply.

  7. If you do not want to create a new record in the Contact Server database (contact history) for the autoresponse, select Do not thread.

  8. (Optional) Use the Field codes area to assign values to custom field code variables that have been defined in Knowledge Manager, as described in the Multimedia 7.6 User's Guide. If you click the Add Item button ( [image] ) to add a new entry, a new row appears in the Key and Value areas.

Example of Field Code Usage:

In Knowledge Manager, you defined a custom variable called WesternAgentGroup. In the Autoresponse object, you entered WesternAgentGroup in the Key area, and "Hello you have reached the western Agent group. Welcome." in the Value area.

You used this custom variable in a field code and then used that field code in a standard response that you subsequently specified in the General tab of the Autoresponse object.

The string "Hello you have reached the western Agent group. Welcome." replaces the variable WesternAgentGroup in the autoresponse message.

  9. Complete the Format tab.

  10. Complete the Result tab.

  11. Click OK.

Note: The Autoresponse object only creates the message. Use the Send E-mail object to send an autoresponse that is waiting in a queue.

For more detailed information on these operation modes, as well as returned results and fault codes, see the Universal Routing 7.6 Reference Manual.

Operation Mode 6.x

To configure the Autoresponse object in 6.x mode, do the following:

  1. In the Relevancy Threshold box, select or enter the minimum threshold that the relevancy value must have for URS to request that the automated response be sent.

    E-mail Server Java attaches the relevancy value to the message.

  2. Select Terminate Routing if you do not want a message to continue being routed after an automated response is sent.

    If you select Terminate Routing (the default), URS sends a RequestRouteCall message with Type=Rejected after the automated response is sent.

If you clear Terminate Routing, routing continues through the strategy, enabling other routing rules to be applied for routing the message to an Agent.

  3. Select Include original message into reply if you want to include the original message with the automated response in your reply.

  4. Click OK.

For more detailed information on the 6.x operation mode, see the Universal Routing 7.6 Reference Manual.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Attaching a Chat Transcript

Use this object to create (but not send) a message that is generated from your site’s Standard Response Library and which has the customer’s chat transcript attached. You can attach a chat transcript to an e-mail or to a message in any type of open media that your environment supports, such as fax or instant messaging.

To use the Chat Transcript object:

  1. From the Multimedia toolbar, click the Chat Transcript object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General, Format, and Result tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. In the E-mail Server drop-down list, click down arrow and select the Application name for the E-mail Server that URS should notify (via Interaction Server).

  2. Click in the Output queue text box to display a drop-down list of available output queues. Select the Output queue where E-mail Server should place the e-mail and its attached chat transcript.

  3. Click in the Standard text box to display a drop-down list of Autoresponse Business Attributes. These are already-prepared text responses to be used as automated replies from the contact center to the customer when transmitting the chat transcript.

Note: IRD does not support the use of periods or commas in the names of keys for Standard Response Field Codes.

  4. On the Address pane, select one of the radio buttons:

  • Select Use UserData to have E-mail Server retrieve the customer's e-mail address from the interaction User Data. For example, the customer might have been prompted to enter his or her e-mail address at the start of the chat session.

  • Select Use Customer Profile to have E-mail server retrieve the customer’s e-mail address from the customer’s profile in the Contact Server Database.

  5. Select the Do not thread check box if you do not want to create a new record in the Contact Server database for the e-mail accompanying the chat transcript.

Format Tab

To configure the Format tab:

  1. If applicable, click the drop-down arrow in the From: text box and select a From address for the standard response. All names listed are E-mail Accounts Business Attributes.

  2. If applicable, click the Add button to the right of the Cc text box and select an address to copy into the standard response. All names listed are E-mail Accounts Business Attributes.

  3. To exclude addresses that were in the original e-mail from this response:

  1. Click the Add button to the right of the Exclude these addresses text box. The Select Addresses dialog box appears.

  2. Click Variable if the addresses are contained in a variable.

  3. Select an address to exclude then click Add.

  4. Repeat Steps a–c until all addresses to be excluded appear in the Exclude these addresses text box.

  4. If applicable, enter new subject line text for the standard response in the Subject text box.

See Configuring the Result Tab for explanations of the Result tab settings.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Sending an E-mail

Use the Send E-Mail object to send an e-mail waiting in a queue that was previously created with the Acknowledgement, Autoresponse, Chat Transcript, Forward E-Mail, or Redirect E-Mail object.

To use the Send E-Mail object:

  1. From the Multimedia toolbar, click the Send E-Mail object ( [image]), then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General and Format tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. In the E-mail server drop-down list box, select the E-mail Server Java application that will send e-mail. If you leave this field empty, Interaction Server uses the first available E-mail Server Java named in its Connections list.

  2. To have automatically-generated e-mail that informs you of the delivery status of the message or the message disposition (deleted, sent, and so on), select the appropriate check box(es).

  3. To specify the contents of the message header for this e-mail, click the Add Item icon ( [image]) and enter or select from the drop-down list the desired key and value in the Header Fields pane. You can add multiple key-value pairs to be included in the header.

  4. Click the Format tab.

Format Tab

To complete the Format tab:

  1. If applicable, click the drop-down arrow in the From: text box and select a From address for the standard response. All names listed are E-mail Accounts Business Attributes.

  2. If applicable, click the Add button to the right of the Cc text box and select an address to copy into the standard response. All names listed are E-mail Accounts Business Attributes.

  3. To exclude addresses that were in the original e-mail from this response:

  1. Click the Add button to the right of the Exclude these addresses text box. The Select Addresses dialog box appears.

  2. Click Variable if the addresses are contained in a variable.

  3. Select an address to exclude then click Add.

  4. Repeat Steps a–c until all addresses to be excluded appear in the Exclude these addresses text box.

  4. If applicable, enter new subject line text for the standard response in the Subject text box.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Redirecting an E-mail

Use the Redirect E-Mail object when sending an incoming message to an external address without expecting a response or any further processing. Use the Forward E-Mail object when you expect a response.

The Redirect E-Mail object supports transfers to external resources, such as off-site functional experts or product specialists (Knowledge Workers).

The Redirect E-Mail object is a request to E-mail Server for method Redirect to create the redirected e-mail. Use the Send E-Mail object to send the redirected e-mail waiting in a queue.

To use the Redirect E-Mail object:

  1. On the Multimedia toolbar, click the Redirect E-Mail object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General and Format tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. For E-mail server, select the name of the E-mail Server Java application that should send the redirected e-mail.

  2. For Output queue, select an interaction queue where E-mail Server Java will find the e-mail to be redirected. All interaction queues defined in the Interaction Design window are listed.

  3. For Address, enter an e-mail address or select an address that is represented by an E-mail Accounts Business Attribute.

  4. Select the Do not thread check box if you do not want to create a new record in the Contact Server database for the redirected e-mail.

Format Tab

To complete the Format tab:

  1. If applicable, click the Add button to the right of the Cc text box and select an address to copy into the standard response. All names listed are E-mail Accounts Business Attributes.

  2. To exclude addresses that were in the original e-mail from this response:

  1. Click the Add button to the right of the Exclude these addresses text box. The Select Addresses dialog box appears.

  2. Click Variable if the addresses are contained in a variable.

  3. Select an address to exclude then click Add.

  4. Repeat Steps a–c until all addresses to be excluded appear in the Exclude these addresses text box.

  4. If applicable, enter new subject line text for the standard response in the Subject text box.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Forwarding an E-mail

Use the Forward E-Mail object when sending an incoming message to an external address when you expect a response, such as during Agent collaboration. Use the Redirect E-Mail object if you do not expect a response.

The Forward E-Mail object is a request to E-mail Server Java to create the e-mail to be forwarded. Once the reply arrives as an inbound e-mail from the external resource, use the Reply E-Mail From External Resource object to create the reply outbound e-mail.

To use the Forward E-Mail object:

  1. On the Multimedia toolbar, click the Forward E-Mail object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General and Format tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. From the E-mail server drop-down list, select the name of the E-mail Server Java application that should send the forwarded e-mail.

  2. Click in the Output queue text box to select an interaction queue where E-mail Server Java will find the e-mail to be forwarded. All interaction queues that have been configured in the Interaction Design window are listed.

  3. Click in the Standard text box to select an Autoresponse business attribute that represents the standard response text to be used when forwarding the email.

Note: IRD does not support the use of periods or commas in the names of keys for Standard Response Field Codes.

  4. From the Address drop-down list, select an E-mail Accounts business attribute associated with an e-mail address.

Format Tab

To complete the Format tab:

  1. To add e-mail addresses, click Add (to the right of the Cc text box). In the Select addresses dialog box that appears, select an address. All the names are E-mail Accounts business attributes.

  2. If necessary, enter a different Subject for the e-mail subject line.

  3. Click OK.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Reply E-Mail From an External Resource

An external resource is an object outside the contact center. It may be an external Agent or another contact center.

The Reply E-Mail From External Resource object takes an inbound e-mail from an external resource as input, extracts the reply text from it, creates an outbound e-mail reply to the customer, and submits the outbound e-mail to Interaction Server using the specified queue. See Background for more information.

The external e-mail addresses are taken from Configuration Manager's Business Attribute E-mail Accounts directory.

To use the Reply E-Mail From External Resource object:

  1. On the Multimedia toolbar, click the Reply E-Mail From External Resource object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General and Format tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. From the E-mail server drop-down list, select the name of the E-mail Server Java application that should send the redirected e-mail.

  2. Click in the Output queue text box to select an interaction queue where E-mail Server Java will find the e-mail to be redirected. All interaction queues that have been configured in the Interaction Design window are listed.

  3. Select Include original message into reply if you want to copy the text of the forwarded message to which this e-mail is the reply.

  4. Click OK.

Background

You can forward an inbound e-mail to an external resource (any e-mail address) using either a routing strategy (Forward E-Mail object) or Genesys Agent Desktop (the Forward to External Resource feature). The external resource then replies to this e-mail (using regular e-mail software, such as Microsoft Outlook). At that point, the following occurs:

  • The reply e-mail comes back into Genesys Multimedia to E-mail Server Java.

  • E-mail Server Java identifies the e-mail as an External Resource Reply, and then submits it to Interaction Server.

  • Interaction Server submits the e-mail to Universal Routing Server according to URS’s own policies and queues.

At this point, the reply is extracted from the External Resource Reply e-mail and used to create the reply e-mail for the customer. (The External Resource Reply message is formatted a special way to enable this process to occur.)

You can direct the final outbound e-mail customer reply:

  • Directly to the customer via the Send E-Mail object in the routing strategy.

  • To an Agent for QA review.

  • As a draft to the Agent who originally forwarded the message.

For additional information on the Reply E-Mail From External Resource object, including returned results and fault codes, see the Universal Routing 7.6 Reference Manual.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Configuring the Format Tab

The Acknowledgement, Autoresponse, and Reply E-Mail From External Resource objects use the same Format tab.

Note: The e-mail addresses from which you can select appear in the form of aliases. These aliases are E-Mail Account business attributes.

To use the Format tab:

  1. Select Reply or Reply to All to indicate whether the e-mail response should be sent to all e-mail addresses contained in the original e-mail (Reply to All) or just the e-mail sender (Reply).

  2. To add more e-mail addresses to the response e-mail, select Custom. Selecting Custom activates the commands on the Custom pane of the dialog box.

  3. To add addresses that appeared in the original e-mail, select the Original Email from check box. This adds addresses contained in the original e-mail From line to the response e-mail To line.

  4. Click the Add button to open the Select Addresses dialog box.

You can select an e-mail alias from the list or use the contents of a variable. Use standard Windows Ctrl and Shift functionality to select more than one address from the list. Then, click Add, and the selected e-mail aliases appear in the appropriate text box on the Custom pane.

  5. To add e-mail addresses contained in the original e-mail To line to the response e-mail To line, select the Original E-mail To (All to) check box. Click the Add button to open the Select Addresses dialog box and follow the instructions in Step 4.

  6. To select an e-mail address for the From line, select the Original E-mail To Pop Client check box. Click the drop-down arrow and select an e-mail alias.

  7. To add e-mail addresses contained in the original e-mail Cc area to the response e-mail Cc area, select the Original E-mail Cc check box. Click the Add button to open the Select Addresses dialog box and follow the instructions in Step 4.

  8. To exclude certain e-mail addresses, enter them in the Exclude these addresses text box or click Add to open the Select Addresses dialog box. To use the Select addresses dialog box, follow the instructions in Step 4.

  9. To have the response e-mail use the subject from the Standard Response Library's response, select the Use from SRL check box. To enter a Subject, clear the check box and type the subject in the text box.

Note: This check box does not appear on the format tab of the Reply E-Mail From External Resource object.

  10. Click OK.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Screening an Interaction

Use the Screen or the MultiScreen object to instruct Classification Server to filter (screen) interactions for specific words or patterns of words based on one or more screening rules provided by URS.

The typical way to process the result is to assign the screening result to a variable and then, using that variable, further process the interaction.

Before configuring the Screen dialog box, learn your site’s screening rules and their corresponding screening rule IDs. Initially, these are defined in Knowledge Manager and are then automatically carried over to Configuration Manager, where they appear in the Business Attributes, Screening Rules folder. Once the carry-over occurs, IRD’s Screen object dialog box displays screening rule display name.

Note: In release 7.2 and higher, these objects are used for all text-based media.

How Screening Works

If Classification Server finds a match, it returns a response that contains the following, as shown in Example 2 below:

Key | Value
ScreenRuleName | The name of the screening rule.
Id | The actual identifier of the screening rule in the UCS Database.
ScreenRuleMatch | True (if Classification Server finds a match), or False (if it does not find a match).

The interaction is then directed to the green port, after which you can set up the strategy to handle the interaction in various ways, based on the attached result of the screening.

If Classification Server does not receive some required parameters or parameters are incorrect, it returns a FaultCode value and string, as described in the Universal Routing 7.6 Reference Manual.

Example 1

Assume that you write the results to a variable and that the variable is equal to:

ScreenRuleName:””|Id:””|ScreenRuleMatch:false|return:ok

In this case, the message does not match the rule.

Example 2

Assume that you write the results to a variable and that the variable is equal to:

00001a05F5U900QW:TestDSL|ScreenRuleName:TestDSL|Id:00001a05F5U900QW|ScreenRuleMatch:true|return:ok

In this case, the message matches the rule.

Creating a Screen Object

To create a new Screen object:

  1. From the Multimedia toolbar, click the Screen object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. From the Classification drop-down list on the General tab, select a Classification Server from those in the Configuration Server database. If you leave this field empty, Interaction Server uses the first available Classification Server named in its Connections list.

  4. From the Language drop-down list, select the language of the incoming interaction. You must select a language in order for the strategy to compile.

  5. From the Screening rule drop-down list, select a screening rule ID from those in Configuration Manager. You must select a screening rule in order for the strategy to compile.

  6. Complete the Result tab. If you write the results to a variable, the variable can be parsed by URS and attached to the interaction for further use in the strategy. You can also attach all the parameters to the interaction’s User Data. This enables you to analyze this User Data to make further routing decisions.

  7. Click OK.

For additional information on the Screen object, including returned results and fault codes, see the Universal Routing 7.6 Reference Manual.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Screening Using Multiple Rules

The MultiScreen object works in a manner that is similar to how the Screen object works. Both objects request Classification Server to filter interactions for specific words or word patterns based on screening rules created in Knowledge Manager. You can then use the Screen Segmentation object to process the results of the MultiScreen object.

Note: In release 7.2 and higher, this object is used for all text-based media.

The differences between Screen and MultiScreen are that MultiScreen:

  • Can use multiple screening rules.

  • Supplies additional return options.

  • Does not require a conditional test to determine whether a match occurred.

Note: See Screening an Interaction for background information on screening.

Creating a New MultiScreen Object

To use the MultiScreen object:

  1. From the Multimedia toolbar, click the MultiScreen object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. From the Classification drop-down list on the General tab, select a Classification Server from those in the Configuration Server database. If you leave this field empty, Interaction Server uses the first available Classification Server named in its Connections list.

  4. From the Language drop-down list, select the language of the incoming interaction. You must select a language in order for the strategy to compile.

  5. On the Get screened data from pane, select whether to search for screening data in User Data, from a variable, or from the UCS database.

  6. By default the All Rules check box is selected.

  • To use all screening rules, leave the check box selected and skip to Step 5.

  • To select from among the screening rules, clear the All Rules check box and follow Steps a–d below. The Screening rules text box appears. To add selected screening rules:

  1. Click the ( [image] ) button to add a new entry in the Screening rules text box. A new row appears under Screening rules. Click inside the row to display a drop-down arrow.

  2. Click the drop-down arrow to display identifiers for the existing screening rules. If the identifiers do not sufficiently describe the screening rules, you can look up the rules in Configuration Manager under Business Attributes, Screening Rules. Or look up the screening rule in Knowledge Manager, where it was originally defined.

  3. Select a screening rule identifier.

  4. Continue to add screening rules in this fashion until you have added all the rules you want to use.

Note: The MultiScreen object does not generate an error message if you fail to select a Root name. However, if you do not select a Root, no screening occurs, because Classification Server requires a Root name in order to perform a screening request.

  7. Configure the Return pane to specify what form the results should take.

  • Select Rules only to return only the screening rule identifiers when a match is found.

  • Select Categories only to return categories associated with standard responses. This can be used later in the strategy to select a Standard Response.

  • Select Matched pairs only to return pairs each consisting of a screening rule identifier and the specific string of words in the interaction that matches the screening rule.

For example a rule screening for credit card numbers could return the key-value pair "ScrKey_credit_number" "1111-2222-3333-4444"

  • Select All to return rules, matched pairs, and categories.

Note: If you select Categories Only or Matched Pairs only, IRD also returns rules.

  8. Complete the Result tab. If you write the results to a variable, the variable can be parsed by URS and attached to the interaction for further use in the strategy. You can also attach all the parameters to the interaction’s User Data. This enables you to analyze this User Data to make further routing decisions.

  9. Click OK.

For additional information on this object, including returned results and fault codes, see the Universal Routing 7.6 Reference Manual.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Classifying an Interaction

Use the Classify object to have URS instruct Classification Server to assign one or more categories, configured in Knowledge Manager, to an interaction.

Note: In release 7.2 and higher, this object is used for all text-based media.

You can use category information to:

  • Segment interactions using the Classification Segmentation object.

  • Select a standard response when using the Acknowledgement or Autoresponse objects.

Notes:

If the interaction cannot be classified into an existing category based on analysis of the interaction, this is noted in the data attached to the interaction (or written to a variable) and the interaction continues through the green port.

If your site's classification categories have not yet been defined in Knowledge Manager, use the Screen object instead of the Classify object.

To use the Classify object:

  1. From the Multimedia toolbar, click the Classify object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. In the Classification drop-down list, select the Application name of the Classification Server as it appears in the Configuration Server database.

  4. In the Root drop-down list, specify the top-level classification category by selecting the name of a directory that appears in Configuration Manager in the Business Attributes > Category Structure folder.

For more information on Root folders, see the Universal Routing 7.6 Reference Manual.

  5. In the Confidence text box, enter a number from 1 to 100 that reflects the minimum relevance percentage that each classification category must have in order for Classification Server to consider an interaction as belonging to that category.

  6. On the Get classified data from pane, select whether to search for classification data in User Data, from a variable, or from the UCS database.

  7. To select individual categories for classification, select the All Tree check box.

Under Categories, if you select All Tree, the classification categories tree is disabled. Classification Server analyzes interactions for all categories under the specified Root.

If All Tree is cleared, the categories tree is activated so you can select individual categories. The categories tree reflects Knowledge Manager categories and is read from the Universal Contact Server database.

A cleared checkbox instructs Classification Server to consider interaction relevance for both parent and child categories.

Note: You must select at least one category from the tree; otherwise, no classification can occur, because classification cannot be performed on the basis of the Root category only.

  8. On the Subcategories using pane, the radio buttons are activated if the All Tree check box is cleared. The Subcategories using selection determines whether Classification Server should consider parent and child categories.

  • Select No to have the only selected categories considered. No child categories are considered.

  • Select Direct to have Classification Server consider only the direct children of selected (parent) categories.

  • Select All to have Classification Server consider all children of selected (parent) categories.

  9. Complete the Result tab.

The standard way to deal with classification results is to attach them to the interaction’s User Data in the Result tab. See the Universal Routing 7.6 Reference Manual for details.

  10. Click OK.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Attaching Interaction Categories

This object enables you to manually emulate the results of the Classify object’s request to Classification Server to attach one or more classification categories to an interaction.

Background

A category is a code used for the purpose of categorizing an interaction based on analysis of its content. Once set up in Knowledge Manager, classification categories carry over to Configuration Manager, where they appear in the Category Structure subdirectory in the Business Attributes directory.

For more information on setting up categories and standard responses, see the Multimedia 7.6 User’s Guide.

Use Cases

Use the Attach Categories object when:

  • Creating a strategy where screening results determine what categories to attach to an interaction with Attach Categories object.

  • Creating a strategy where an If object creates an expression based on categories manually attached to interaction with the Attach Categories object. URS analysis (true/false) of the expression determines the interaction's path through the strategy.

You can use categories to segment interactions using the Classification Segmentation object and to select a standard response.

Using the Attach Categories Object

To use the Attach Categories object:

  1. From the Multimedia toolbar, click the Attach Categories object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. From the Root Name drop-down list, select the Root folder containing the categories you wish to attach. The Root folder you select determines the categories that appear for selection in the Category dialog box (see step 5). The Root Name text box must contain a valid value; otherwise you cannot compile the strategy.

  4. Click the new entry ( [image] ) button to add a new entry in the Category list.

  5. Click inside the new row to open the Category dialog box. Available categories appear under the selected Root Name.

  6. Select a category, then click OK. The Category dialog box closes, and the category path (for example: books.self-help) appears in the Attach Categories dialog box as a row under Category.

  7. The % (percentage) field is set by default to 75%, which reflects the minimum relevancy the category must have in order for Classification Server to consider an interaction as belonging to that category. You can change the default to any value between 1–100. Zero is not a valid value.

  8. Repeat these steps if you wish to attach another category to the interaction.

  9. Click OK.

For additional information on this object, including returned results and fault codes, see the Universal Routing 7.6 Reference Manual.


Create Interaction Object

Routing Non-Voice Interactions > Multimedia Toolbar Objects

The Create Interaction Object

Use the Create Interaction object to instruct Universal Contact Server (UCS) to create an interaction in the UCS Database and associate it with an existing customer contact or with a newly-created contact. You can also specify the content of the interaction.

See Recommendations for recommendations on how to use the Create Interaction object when dealing with large quantities of interaction data.

One of the possible scenarios for using the Create Interaction object is to record Open Media interactions, which are not otherwise stored in the UCS Database. For example, you might have a scenario similar to this:

  1. An Open Media server submits interactions to Interaction Server with the content of the interaction attached as User Data.

  2. A strategy executed by URS uses the Create Interaction object to create an interaction in the UCS database and to store interaction-related data.

  3. When the interaction is routed to an Agent, the Agent Desktop application accesses the UCS Database to obtain the content of the interaction and display it to the Agent.

For more information, see Multimedia 7.6 Deployment Guide.

The UCS Database can store three types of interaction content:

  • Text—Plain text that does not need special tools or formatting in order to be displayed to an Agent.

  • Structured Text—For example, html or XML files.

  • Binary Data—Any binary data associated with an interaction, such as an e-mail attachment, fax, or image.

Configuring the Create Interaction Object

To configure the Create Interaction Object, click the Create Interaction icon on the Multimedia subtoolbar ( [image]), open the objects Properties dialog box, and then fill in the fields in the General and Result tabs.

To configure the General tab:

  1. Click the drop-down arrow in the Contact Server text box and select a Universal Contact Server Application. This application must already exist in the Configuration Database.

  2. Depending on the type of data included in the interaction, fill in the Text, Structured Text, and Data panes.

  • If the interaction is plain text, click the down arrow in the User Data Key text box on the Text pane and select a variable that contains the User Data key or enter a string for the User Data Key contained in the incoming interaction. The value of User Data that corresponds to key specified in this field is stored in UCS database as plain text.

  • Under Content, Structured Text, User Data Key, click the down arrow and select a variable that contains the User Data key or enter a String for the User Data key contained in the incoming interaction. The value of User Data that corresponds to the key specified in this field will be stored in the UCS database as interaction’s Structured Text. .

In the next field, MIME refers to Multipurpose Internet Mail Extensions, which is a common method for transmitting non-text files via Internet e-mail. If you wish to see a complete list of MIME types, see the Create Interaction object description in Universal Routing 7.6 Reference Manual.

Under Content, Structured Text, MIME Type, enter the MIME type or select from the list to indicate a type of interaction content under the category of Structured Text. Select one of the following: text/html, text/plain, text/rich text, text/html. What you select here assists the Agent Desktop Application in choosing the proper application to process or display this part of interaction. This field cannot be empty if the Structured Text, User Data Key text box contains a value.

  • Use the next field if the incoming interaction contains Binary Data. Under Content, Data, User Data Key, click the down arrow and select a variable that contains the User Data key or enter a String for the User Data key contained in the incoming interaction. The value of User Data that corresponds to the key specified in this field will be stored in the UCS database as an interaction’s binary content.

Under Content, Data, MIME Type, enter the MIME type or select a value to indicate the interaction content type under the category of Data:

application/msword, application/octet-stream, application/postscript, application/rtf, application/vnd.ms-powerpoint, application/vnd.ms-project, application/vnd.viso, application/voicexml+xml, application/xml, application/xml-dtd, application/zip, audio/basic, audio/mpeg, audio/mpeg4-generic, image/g3-fax, image/gif, image/jpeg, image/tiff, message/delivery-status, message/http, message/news, message/partial, message/rfc822, message/sip, message/sipfrag, message/tracking-status, multipart/alternative, multipart/form-data, multipart/mixed, multipart/parallel, multipart/voice-message, text/html, text/plain, text/richtext, text/xml, video/DV, video/JPEG, video/MPEG, video/mpeg4-generic, video/quicktime, video/raw.

This information helps Agent Desktop Application to choose the proper application to process or display this part of the interaction. This field cannot be empty if the Data, User Data Key text box contains a value.

  3. (Optional) Select Bind with contact to have UCS look for a customer contact record and associate it with the interaction. If a contact record is not found, it will be created. By default this option is cleared.

  4. (Optional) Select Can be parent if this interaction can have child interactions. By default this option is selected.

  5. (Optional) Select Create contact if you want to create an entry for this contact in the UCS database if one does not yet exist. This check box is only active if you also select the Bind with contact check box.

  6. (Optional) Select Do not thread to prevent this interaction from being threaded under another interaction (which is specified by under key ParendID in UserData) in the contact’s history in the UCS database. By default this option is selected.

See Configuring the Result Tab for help with the Create Interaction object Result tab.

Recommendations

When interaction content is expected to be large, Genesys recommends:

  • Using the Create Interaction object as early as possible in a strategy.

  • Emptying the values of keys used for interaction content (if Create Interaction was processed successfully) after interaction data is stored in the UCS database. This prevents large amounts of User Data from being passed between applications while large interactions are processed. To empty keys, use the Multi Attach object to update attached data for these keys with empty values.

After all required interaction data is stored in the UCS Database, emptying interaction data unimportant for routing in Interaction Server minimizes the amount of data transferred between Interaction Server, URS, Stat Server and certain Genesys Framework components. This can result in increased performance.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Configuring the Result Tab

IRD uses the same Result tab for the Acknowledgement, Autoresponse, Chat Transcript, Classify, Screen, MultiScreen, Create Interaction, Identify Contact, CreateEmailOut, CreateNotification, CreateSMS, and External Service objects.

Note: Not all options apply to all of the objects that use a Result tab.

Use the information below to complete the Result tab for the Acknowledgement, Autoresponse, Chat Transcript, Classify, Screen, MultiScreen, Create Interaction, Identify Contact, CreateEmailOut, CreateNotification, CreateSMS, and External Service objects:

  1. Select one of the radio buttons, described below.

  • Select Do not use output value if you do not want to use the returned values in any of the ways listed below. Do not use this option for the Classify, Screen, or MultiScreen objects.

  • Select Attach output value if you want to attach returned values to the interaction. This is the default for the Acknowledgement, Autoresponse, Chat Transcript, and External Service objects. This option is also recommended for processing the Classify object's results.

  • Select Assign output value to a variable if you want to assign any returned output values to a variable. (The variable must already have been defined.) When you select this option, a drop-down menu appears so you can select the variable. This option is not recommended for the Classify object.

  • Select Assign values of the key-value pair if you want to assign values in the returned array of classification pairs to a variable. If you select this option, the Result tab displays the Output values pane. Use this option for the Screen and MultiScreen objects. You can also use it for the External Service object.

  2. If you selected the Assign values of the key-value pair radio button, click the Add button to add a variable and specify which returned value should be linked to it. Continue adding rows until you have assigned all the returned values to variables.

For an example, see the Universal Routing 7.6 Reference Manual.

  3. Click OK.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Creating an Outbound E-Mail

Use the Create Email Out object when creating a new e-mail message to an external address. For example, you might send outbound e-mail to your customers advertising a special promotional offer.

The Create Email Out object is a request to E-mail Server Java to create the e-mail to be sent. Use the Send Email object to send the e-mail after you have created it.

To use the Create Email Out object:

  1. On the Multimedia toolbar, click the Create Email Out object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General, Format, and Result tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. From the Email server drop-down list, select the name of the E-mail Server Java application that should send the e-mail.

  2. Select Create new interaction to have a new interaction created in the UCS database for this e-mail.

  3. Click in the Output queue text box to select an interaction queue where E-mail Server Java will find the e-mail. All interaction queues that have been configured in the Interaction Design window are listed.

  4. Select whether to insert the text from a standard response that has been attached as user data or select a different one.

To select a standard response, click in the Standard text box to select an Autoresponse business attribute that represents a standard response text or a category.

Note: IRD does not support the use of periods or commas in the names of keys for Standard Response Field Codes.

  5. On the Address pane, select whether the address to which this e-mail is to be sent should be taken from user data or the customer profile stored in the UCS database.

  6. If this e-mail is in response to a prior interaction, you can select the Include original message into reply check box.

  7. If this e-mail is a reply to an earlier interaction, select the Do not thread check box to keep this e-mail from being stored as a continuation of the earlier interaction.

  8. To you use field codes (optional), click in the text boxes in the Key and Value columns and select the appropriate keys and values. For example, to personalize the e-mail, you might select a key-value pair that inserts the customer's name in the e-mail.

Format Tab

To complete the Format tab:

  1. Select the alias for the e-mail address from which the e-mail should come.

  2. If you want to customize the subject, enter text for the e-mail subject line. Or select the Use subject from SRL check box to have the subject drawn from the standard response library.

  3. Click OK.


Creating a Notification

Routing Non-Voice Interactions > Multimedia Toolbar Objects

Creating a Notification E-Mail

A notification is an outbound e-mail that provides information to a customer. For example, a customer may have requested some information, either in an e-mail or in some other type of interaction. Or the notification may simply include a link to the requested information.

The Create Notification object is a request to E-mail Server Java to create the e-mail to be sent. Use the Send E-Mail object to send the notification e-mail after you have created it.

To use the Create Notification object:

  1. On the Multimedia toolbar, click the Create Notification object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General, Format, and Result tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. From the E-mail server drop-down list, select the name of the E-mail Server Java application that should send the e-mail.

  2. Click in the Output queue text box to select an interaction queue where E-mail Server Java will find the e-mail. All interaction queues that have been configured in the Interaction Design window are listed.

  4. Select whether to insert the text from a standard response that has been attached as user data or select a different one.

To select a standard response, click in the Standard text box to select an Autoresponse business attribute that represents a standard response text or a category.

Note: IRD does not support the use of periods or commas in the names of keys for Standard Response Field Codes.

  5. If this e-mail is in response to a prior interaction, you can select the Include original message into reply check box.

  6. To use field codes (optional), click in the text boxes in the Key and Value columns and select the appropriate keys and values. For example, to personalize the e-mail, you might select a key-value pair that inserts the customer's name in the e-mail.

Format Tab

To complete the Format tab:

  1. Select the alias for the e-mail address from which the e-mail should come.

  2. If you want to customize the subject, enter text for the e-mail subject line. Or select the Use subject from SRL check box to have the subject drawn from the standard response library.

  3. Click OK.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Creating an SMS Message

Use the Create SMS object to create an outbound message in Short Message Service format (used to send messages to cell phones, for example). The Create SMS object creates a specially designed e-mail message that is converted using an E-Mail-to-SMS gateway.

  • For details about the supported gateways and the format you must use in your e-mail, see the section on the Create SMS object in the Universal Routing 7.6 Reference Manual.

The Create SMS object is a request to a specially configured E-mail Server Java to create the SMS message. Use the Send E-Mail object to send the SMS message after you have created it.

Note: Do not confuse the Create SMS object with the Create SMS Out object on the SMS toolbar. The Multimedia Create SMS object creates a specially configured e-mail-type message that is sent by the E-Mail Server. The Create SMS Out object uses ESP technology to create an SMS message that is sent by the SMS Server.

To use the Create SMS object:

  1. On the Multimedia toolbar, click the Create SMS object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General, Format, and Result tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. From the E-mail server drop-down list, select the name of the E-mail Server Java application that should send the message.

  2. Click in the Output queue text box to select an interaction queue where E-mail Server Java will find the message. All interaction queues that have been configured in the Interaction Design window are listed.

  4. Select whether to insert the text from a standard response that has been attached as user data or select a different one.

To select a standard response, click in the Standard text box to select an Autoresponse business attribute that represents a standard response text or a category.

Note: IRD does not support the use of periods or commas in the names of keys for Standard Response Field Codes.

  5. On the Address pane, select whether the address to which this e-mail is to be sent should be taken from user data or the customer profile stored in the UCS database.

  6. If this SMS message is a reply to an earlier interaction, select the Do not thread check box to keep this message from being stored as a continuation of the earlier interaction.

  7. To you use field codes (optional), click in the text boxes in the Key and Value columns and select the appropriate keys and values. For example, to personalize the message, you might select a key-value pair that inserts the customer's name in the message.

Format Tab

To complete the Format tab:

  1. Select the alias for the address from which the message should come.

  2. If you want to customize the subject, enter text for the e-mail subject line. Or select the Use subject from SRL check box to have the subject drawn from the standard response library.

  3. Click OK.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Identifying a Contact

Use the Identify Contact object to modify the information or add new information concerning an existing contact in the Universal Contact Server (UCS) database.

This object can also return the last contacted Agent for each media type for this contact and identify a preferred Agent, if this information is available for the contact. To use this feature, you must include the relevant information in the User Data. For details, see the description of the Identify Contact object in the Universal Routing 7.6 Reference Manual.

To use the Identify Contact object:

  1. On the Multimedia toolbar, click the Identify Contact object ( [image]) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. On the General tab, select a contact server from the Contact server drop-down list.

  4. To have UCS create a new contact if no contact matches the data attached to the interaction, select the Create Contact check box.

  5. Select the Return Unique check box if you only want UCS to return data when a single contact matches the data attached to the interaction. The data then returned includes all contact information in the database.

  6. To have UCS replace data in the database with any new values included in the data attached to this interaction (assuming that UCS has identified a contact), select the Update User Data check box.

  7. Configure the Results tab.

  8. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.


Routing Non-Voice Interactions > Multimedia Toolbar Objects

Updating a Contact

Use the Update Contact object to modify the information or add new information concerning an existing contact in the Universal Contact Server (UCS) database.

To use the Update Contact object:

  1. On the Multimedia toolbar, click the Update Contact object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Select a contact server from the Contact server drop-down list.

  4. By default, UCS updates the contact information based on user data attached to the interaction. To specify certain information to update (instead of updating all contact attributes based on all user data), select the Use Data From Parameters check box.

If you selected the Use Data From Parameters check box:

  1. Click in the text box under the Key column and then select a key from the drop-down list that appears.

  2. Enter a value for the parameter in the Value column.

  5. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.


Routing Objects for Multimedia Interactions Overview

Routing Non-Voice Interactions > Routing Objects for Multimedia Interactions

Routing Objects for Multimedia Interactions: Overview

Certain objects on the Routing toolbar are used for processing non-voice interactions. These are:

  • Route Interaction, which enables you to select a target. This object is used with both voice and non-voice interactions.

  • Workbin, which enables you to send an interaction to a storage location associated with an Agent, Agent Group, Place, Place, or Place Group. The interaction remains in the workbin until pulled out for further processing.

  • Queue Interaction, which enables you to place an interaction in a queue that you have created in the Interaction Design window.

See also:

Routing Non-Voice Interactions

Multimedia Toolbar Objects

Requesting an External Service

Segmenting Non-Voice Interactions


Route Interaction Object

Routing Non-Voice Interactions > Routing Objects for Multimedia Interactions

The Route Interaction Object

The Route Interaction object enables you to select one or more target objects—Agent, Agent Group, Place, Place Group, Skill, or Variable—for either voice or non-voice interactions.

Strategy-Linked Nodes

When the strategy is used in a Business Process, the Route Interaction object generates strategy-linked nodes. In the following figure, the Process ABC strategy uses the Route Interaction object, which routes the interaction to an Agent (E-mail distribution). The Agent creates a response and places the existing interaction in a queue (Outbound queue).

Note: Always finish an interaction routing strategy used in a Business Process with one of these routing objects: Stop Interaction, Queue Interaction, Route Interaction, or Workbin.

The Route Interaction object contains two tabs: Interaction Queue and Target Selection.

See also:

Queuing an Interaction


Routing Non-Voice Interactions > Routing Objects for Multimedia Interactions

Sending interactions to Workbins

A workbin is a storage area associated with an Agent, Agent Group, Place, Place, or Place Group. Use the Workbin object to route an interaction, such as an e-mail, to a workbin.

For example, an Agent Workbin may hold an Agent's draft e-mail responses. Once created in the Interaction Design window, workbins appear for selection in the Workbin object.

Note: Always finish an interaction routing strategy used in a Business Process with one of these routing objects: Stop Interaction, Queue Interaction, Route Interaction, or Workbin.

The Workbin object has three tabs: General, Interaction Queue, and Target Selection.

To fill in the General tab:

  1. Click the drop-down arrow in the Owner Type text box and select one of the following: Agent, Agent Group, Place, Place Group.

The list of available Target types in the Target Selection tab depends on the Owner type you select in the General tab. This is because each workbin type is applicable only to a specific target type.

Warning! If you change the Owner type in the Workbin object properties dialog box in the Interaction Design window, you must also change it in the strategy in which the Workbin is used in the Routing Design window. If not, an error is not generated should the wrong Owner type be selected in the Workbin properties dialog box shown above. An error is not generated because the Check Integrity mechanism is not designed to check for wrong types of existing objects.

  2. In the Workbin name text box, enter the name of or select a workbin. Workbins are organized by business process.

Note: You must already have created the workbin in the Interaction Design window.

  3. Select the Use logged in Agents only check box to have URS check Agents' status and route only to an Agent who is currently logged in.

  4. (Optional) Specify an Interaction Queue.

  5. Select a Target.

  6. Click OK.


Routing Non-Voice Interactions > Routing Objects for Multimedia Interactions

Configuring The Interaction Queue Tab

To fill in the Interaction Queue tab in either the Route Interaction or Workbin object:

  1. From the Routing toolbar, click the Route Interaction object ( [image] ) or Workbin object ( [image]) and then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box. The Interaction Queue tabs for the Route Interaction object and the Workbin object are identical.

Note: Configuring the Interaction Queue tab is optional; the Target Selection tab is required.

  3. If the incoming interaction is the same as that going to a target, configure the Queue for Existing Interaction pane. If you are creating a new interaction that is to be sent to the target, configure the Queue for New Interaction pane. In either case, follow these steps:

  1. Click the Add Item ( [image] ) button.

  2. Click in the empty text box under Queues to activate a drop-down arrow.

  3. Click the drop-down arrow and select an interaction queue. You must already have created the queue the Interaction Design window. The Stop Processing value is predefined.

  4. Click in the empty text box under Description to activate a drop-down arrow.

  5. Click the drop-down arrow and enter or select a description that will appear on the Agent desktop to tell the Agent where to place the interaction for further processing.

For example, after the Agent constructs a response, the response may need to be checked by QA. In this case, the description would prompt the Agent to place the interaction in the queue used by QA.

  6. If there is more than one queue, repeat Steps a-e.

  4. Complete the Target Selection tab.

  5. Click OK.


Routing Non-Voice Interactions > Routing Objects for Multimedia Interactions

Configuring the Target Selection Tab

To open the Target Selection tab in either the Route Interaction or Workbin object:

  1. From the Routing toolbar, click the Route Interaction object ( [image] ) or Workbin object ( [image]) and then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Click the Target Selection tab. The Target Selection tabs for the Route Interaction object and the Workbin object are identical.

To complete the Target Selection tab:

  1. Click the Add Item ( [image] ) button. This activates the Targets pane.

  2. Click in the empty text box under Type and a drop-down arrow appears. Click the drop-down arrow and select the target type.

  • For the Route Interaction object, you can select Agent, Agent Group, Place, Place Group, Variable, or Skill.

  • For the Workbin object, you can select Agent, Agent Group, Variable, or Skill.

The type of target selected affects the target names that appear in the Name column.

  3. Click in the empty text box under Name and a drop-down arrow appears. Click the drop-down arrow and select the specific target.

If you select Skill as the target type, the Skill Expression Properties dialog box opens. Use this dialog box to construct a skill expression. See the Universal Routing 7.6 Reference Manual if you need help constructing a skill expression.

  4. Click in the empty text box under Stat Server and a drop-down arrow appears. Click the down arrow and the Key dialog box appears.

  5. In the Key dialog box, click the Value down arrow and select the name of the Stat Server to supply statistical information used for routing.

  6. If URS should consider more than one target after the number of seconds specified in Timeout, click Add Item ( [image] ) and add another target.

  7. (Optional) On the Statistics pane, select Min or Max to indicate whether URS should use the minimum or maximum value of the statistic you specify.

  • If you selected Min or Max, click the Statistics drop-down arrow and select the statistic you want to be used when more than one target is available.

  8. (Optional) Clear the Clear Targets check box if you want the targets listed to continue as possible targets after the interaction moves on through the strategy and encounters other Selection objects. If the Clear Targets check box is selected, targets specified in this object are no longer considered after the interaction moves further along in the strategy or subroutine.

  9. (Optional) In the Timeout text box, enter the number of seconds an interaction should wait for a target to become available. If the timeout expires, the interaction is routed to the red port.

Note: If more than one target is available from the target list when an interaction encounters the Route Interaction object, URS uses the Statistics information at the top of the dialog box to determine which target receives the interaction.

  10. (Optional) On the Virtual Queue pane, set a virtual queue for the object by selecting the Use Virtual Queue check box and then specifying the Alias, Switch, and Number for the virtual queue.

  11. Click OK.

See also:

Creating Virtual Queues

Universal Routing 7.6 Reference Manual


Queue Interaction Object

Routing Non-Voice Interactions > Routing Objects for Multimedia Interactions

The Queue Interaction Object

Use the Queue Interaction object to place an interaction into a queue that you have created in the Interaction Design window.

Each Queue Interaction object in a routing strategy generates a strategy-linked node in a business process. The following figure shows a routing strategy in a Business Process that generates three strategy-linked queue nodes.

The Inbound e-mail preprocessing strategy uses four Queue Interactions objects so four strategy-linked queue nodes appear in the Business Process: E-mails to route to original Agent, Inbound e-mail postprocessing, Collaboration reply e-mails, and Inbound e-mail failure analysis.

Note: Always finish a routing strategy used in a Business Process with one of these routing objects: Stop Interaction, Queue Interaction, Route Interaction, or Workbin.

To place an interaction in a queue:

  1. From the Routing toolbar, click the Queue Interaction object then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. On the Interaction queue pane, select the name of the queue into which the interaction should be placed.

Note: When used in a routing strategy that is part of a business process, the Queue Interaction object generates a queue node.

For additional information on the Queue Interaction object, see the Universal Routing 7.6 Reference Manual.


Requesting External Service

Routing Non-Voice Interactions

Requesting an External Service

Use the External Service object in non-voice routing strategies to exchange data with third party (non-Genesys) servers that use the Genesys Interaction SDK or any other server or application that complies with Genesys Interaction Server (GIS) communication protocol.

Note: To use this object, you must already have created the third-party server or application in Configuration Manager. Before completing the object properties dialog box, you must already know the names of the services, methods, and signatures (requested input/output parameters) provided by the external service.

To use the External Service object:

  1. From the Databases and Services toolbar, click the External Services object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General and Result tabs.

  4. Click OK.

For additional information on using this object including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual.

General Tab

To complete the General tab:

  1. Click the drop-down arrow in the Application type text box and select the appropriate application type.

  2. Click the drop-down arrow in the Application name text box to select the appropriate application from those configured in the Configuration Database.

  3. In the Service text box, enter the name of the Service as specified in the selected server or application.

  4. In the Method text box, enter the name for the Method as specified in the selected server or application.

  5. On the Parameters pane, click the ( [image]) button to add a new entry. A row appears under the Key and Value columns.

  6. Click the row in the Key column to display a drop-down arrow. Click the drop-down arrow and enter an input parameter name.

  7. Click the row in the Value column to display a drop-down arrow. Enter or click the drop-down arrow and select the name of the variable that contains the value.

  8. Select the Default Timeout check box to use the default of 30 seconds. Clear the check box to enter a different timeout value. If URS receives no response from the external service within the specified timeout, it generates an error and sends the interaction to the red output port.

  9. Configure the Result tab.

  10. Click OK.


Routing Non-Voice Interactions > Segmenting Non-Voice Interactions

Segmenting Non-Voice Interactions: Overview

When creating non-voice routing strategies to be used in business processes, you can segment interactions to take different paths in a strategy by using the following Segmentation objects:

  • Generic Segmentation

  • Classify

  • Screen


Routing Non-Voice Interactions > Segmenting Non-Voice Interactions

Segmenting with the Generic Segmentation Object

The Generic Segmentation object causes interactions to take different paths in the strategy based on a logical expressions created in the Expression Builder. For an voice routing strategy example, see Sample D. For e-mail routing strategy examples, see Universal Routing Strategy Samples.

To use the Generic Segmentation object:

  1. On the Segmentation toolbar, click the Generic object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box. The image below shows a fully-configured properties dialog box.

  3. Click Add Item [image] to create the first segment.

Note: If you make a mistake, you can delete an item by clicking Delete Item [image] .

  4. For the first segment, click the down arrow ( [image]) in the Expression column to open the Expression Builder.

  1. Under Type, select Interaction Data, Business Attributes, or All Functions. The contents of the Name column change depending on the type of data you select.

  2. Under Name, select a type of interaction or a business attribute or the name of a Function.

  3. If necessary, enter values for the parameters on the Parameter/Value pane.

  4. Select the appropriate Operator.

  5. Enter a value in the Value field.

  5. Click Add to create the expression, then click Verify if you want to verify that the expression is valid.

  6. Click OK to close the Expression Builder.

  7. Repeat Steps 3–6 for the next segment.

  8. Click OK when through creating segments to close the Generic segmentation properties dialog box. The Generic Segmentation object shows a port for each expression.

  9. Create and connect the appropriate object to each port.


Routing Non-Voice Interactions > Segmenting Non-Voice Interactions

Segmenting on Classification Code

The Classify Segmentation object ( [image] ) segments incoming interactions to take different paths in a routing strategy based on classification categories.

Background

The Classification Segmentation object enables you to direct interactions to different targets based on categories returned by the Classify object or assigned manually using the Attach Categories object.

IRD chooses the category with the highest relevancy and compares it to the categories configured for each of the outlet ports of the Classify Segmentation object. It then routes incoming interactions based on this comparison. If no categories in the Classify Segmentation object properties dialog box are equal to the highest one, the incoming interactions are sent to the default port.

To use the Classification Segmentation object:

  1. On the Segmentation toolbar, click the Classify object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. If classification results are contained in a variable, select Classify by variable and select the variable from the drop-down menu.

  4. If classification results are not contained in a variable:

  1. Use the Root Name drop-down list to specify the root folder under Category Structure in Configuration Manager

  2. Click the Add Item button ( [image] ) to add the first segment.

  3. Click in the row in the Expression column to activate the drop-down arrow. Click the drop-down arrow to open the Category dialog box, which contains a list of categories under the Root directory you specified above.

  4. Select the category you want to use for the segment then click OK. Follow Steps a–c until you have configured all segments.

  5. Click OK.

Note: If you import a strategy from IRD 7.0 that contains a Classify Segmentation object, IRD generates the following error when you click OK in the object's Properties dialog box: Invalid data type supplied for property assignment. The value in the Root Name drop-down box disappears after the import is complete. If you save such a strategy, the object's output ports disappear.


Segmenting Based on Screening Rule

Routing Non-Voice Interactions > Segmenting Non-Voice Interactions

Segmenting Based on Screening Rules

The Screen Segmentation object sends incoming interactions to different targets in a routing strategy based on results of the Screen or MultiScreen objects.

To use the Screen Segmentation object:

  1. On the Segmentation toolbar, click the Screen object ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. If screening results are contained in a variable, select Screen by variable and select the variable from the drop-down menu.

  4. If the screening results are not contained in a variable:

  1. Select the Language of the screening rule.

  2. Click the Add Item button ( [image] ) to add the first segment.

  3. Click in the row in the Expression column to activate the drop-down arrow. Select a screening rule from the drop-down list.

Note: IRD incorrectly allows you to edit the Root Name box in the Screen Segmentation object's Properties dialog box.

  4. Repeat Steps a–c for the next segment.

  5. Click OK when through creating segments to close the properties dialog box. The Screen Segmentation object shows a port for each expression.

  6. Create and connect the appropriate object to each port.


Routing Outbound Interactions Overview

Routing Non-Voice Interactions > Routing Outbound Interactions

Routing Outbound Interactions: Overview

The Outbound toolbar in the Routing Design window provides strategy-building objects that support Genesys Outbound Contact, an automated product for creating, modifying, running, and reporting on outbound campaigns for proactive customer contact. Outbound Contact Solution (OCS) provides automated dialing and call-progress detection, so that an Agent is required only when a customer is connected.

Note: Outbound strategy-building objects are specifically designed to be used in strategies that are configured for proactive routing functionality, the essential element of which is communication between Universal Routing Server (URS) and Interaction Server, and between Interaction Server and OCS. All proactive routing interactions are classified as open-media interactions that are processed using the outbound_preview media type.

For additional information, see:

  • Outbound Contact 7.6 Outbound Contact Manager Help

  • Outbound Contact 7.6 Deployment Guide

  • Outbound Contact 7.6 Reference Manual

The following figure shows the toolbar buttons that appear when you click the Outbound icon on the Routing Design window toolbar:

The outbound routing objects are:

  • Add Record —Automatically builds a Calling List by adding a new record to the specified Calling List.

  • Do Not Call —Adds a contact record, such as a phone number or an e-mail address, to a specified Do Not Call List and marks the corresponding record as Do Not Call.

Note: Use the Do Not Call and Processed objects to finalize Outbound record processing. You cannot use other Outbound objects to process records with the same Record Handle after using Processed or Do Not Call in a strategy flow.

  • Processed —Has URS request (through Interaction Server) that Outbound Contact Server finish processing a record created as a result of a previous customer call.

Note: Use the Do Not Call and Processed objects to finalize Outbound record processing. You cannot use other Outbound objects to process records with the same Record Handle after using Processed or Do Not Call in a strategy flow.

  • Update Record —Updates a Calling List record that you specify via a RecordHandle parameter.

  • Reschedule —Reschedules a customer interaction from the specified Calling List. A record is typically rescheduled during a call when a customer requests a callback at a certain time.


Routing Non-Voice Interactions > Routing Outbound Interactions

Adding a Record of an Outbound Interaction

Use the Add Record object to automate building of Calling Lists by adding a new record to a specified Calling List. For example, you can use Add Record to automatically develop a Calling List, such as one to follow up on inbound calls that were abandoned during traffic peaks. You can then configure a routing strategy to detect abandoned calls and add records to the Calling List with the parameters of the incoming interactions. The Calling List can then be used by an outbound campaign that dials out to these customers during off-peak hours and has the Agent apologize and follow up.

For additional information on using this object, including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual and the section on updating call results and custom fields in the Outbound Contact 7.6 Reference Manual.

To configure the Add Record object:

  1. On the Outbound toolbar, click the Add Record icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General tab.

  4. Click OK.

Filling in Values on the General Tab

To fill in the General tab:

  1. Select an Outbound Contact Server from the OC server drop-down list.

  2. Select a Campaign from the Campaign drop-down list, or enter a variable that contains the Campaign name. This is a required field.

  3. In the Calling list text box, select the name (or variable containing the name) of the Calling List for the current interaction. Calling list is a required field.

  3. In the Timezone name text box, select a Configuration Server Time Zone name to associate with this record. Timezone name is a required field.

  4. In the Contact Info text box, enter or select a phone number, e-mail address, or other contact information for the customer. Contact Info is a required field.

  5. In the Contactinfo type text box, select the customer’s contact type defined in a Configuration Manager Enumeration table. This parameter is optional.

  6. In the Record type text box, select the record type code as defined in a Configuration Manager Enumeration table. This parameter is optional.

  7. In the Record status text box, select or enter a record status code as defined in a Configuration Manager Enumeration table. This parameter is optional.

  8. In the Call result text box, select or enter a result code as defined in a Configuration Manager Enumeration table. This parameter is optional.

  9. In the Attempts text box, select or enter the number of attempts to create the record or leave empty and use the default of 0.

  10. In the DateTime text box, select or enter when to schedule the callback or leave empty to use the default of 0. Use the format MM/DD/YY(YYYY) HH:MM.

  11. In the Call Time text box, select or enter the system time when the record was called, in seconds from 01/01/1970 (GMT) 00:00 or leave empty.

  12. In the Time From text box, select or enter the ”from” portion of the time period during which the record can be called. Use the number of seconds from midnight or leave empty to use the default of 28800 (8:00 AM).

  13. In the Time Until text box, select or enter the ”until” portion of the time period during which the record can be called. Use the number of seconds from midnight or leave empty to use the default of 64800 (6:00 PM).

  14. Use the UserData attributes area to define key-value pairs to be added/updated in the User Data.

To define key-value pairs, click the [image] button. A new row appears under the Key and Value headings. Under Key in the new row, select an existing User Data key. Under Value, select a strategy variable that contains the value or enter a value.

  15. Click OK.


Adding a Number to the Do Not Call List

Routing Non-Voice Interactions > Routing Outbound Interactions

Adding a Do Not Call Marker to a Record

Use the Do Not Call object to add a customer's contact information to a specified Do Not Call List and mark the corresponding record as Do Not Call.

Note: Use the Do Not Call object to finalize the Outbound record processing. You cannot use other Outbound objects to process records with the same Record Handle after using Do Not Call in a strategy flow.

For additional information on using this object, including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual and the section on updating call results and custom fields in the Outbound Contact 7.6 Reference Manual.

To configure the Do Not Call object:

  1. On the Outbound toolbar, click the Do Not Call icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General tab.

  4. Click OK.

To fill in the General tab:

  1. Select an Outbound Contact Server from the OC server drop-down list.

  2. Specify one of the following:

  • Record handle—Enter or select a variable for the Record ID assigned by Outbound Contact Server.

  • Contact info—Enter or select a variable for the phone number, e-mail address, or other appropriate contact information.

  • Customer ID—Enter or select a variable for the Customer ID.

  3. The All chain check box determines whether to update the record chain or just the single record. To mark all phone numbers, e-mail addresses, or other contact information from the record chain as Do Not Call, select this check box. To mark the contact information in only a single record, leave this check box clear.

  4. Click OK.


Routing Non-Voice Interactions > Routing Outbound Interactions

Marking an Outbound Interaction as Processed

Use the Processed object to mark a record as requiring no further handling. When an Agent finishes processing a Calling List record, Genesys Desktop sends a RecordProcessed event to indicate that the record is processed and OCS updates the record accordingly. Use the Processed object in a strategy to have URS request (through Interaction Server) that Outbound Contact Server finish processing a record created as a result of a customer inquiry.

Note: Use the Processed object to finalize Outbound record processing. You cannot use other Outbound objects to process records with the same Record Handle after using Processed object in a strategy flow.

For additional information on using this object, including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual and the section on updating call results and custom fields in the Outbound Contact 7.6 Reference Manual.

To configure the Processed object:

  1. On the Outbound toolbar, click the Processed icon ( [image]) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General tab.

  4. Click OK.

To fill in the General tab:

  1. Select an Outbound Contact Server from the OC server drop-down list.

  2. Enter or select a variable for the Record ID assigned by Outbound Contact Server.

  3. Use this area to define key-value pairs to be marked as processed in the User Data.

To define key-value pairs, click the [image] button. A new row appears under the Key and Value headings. Under Key in the new row, select an existing User Data key. Under Value, select a strategy variable that contains the value or enter a value.

  4. Click OK.


Routing Non-Voice Interactions > Routing Outbound Interactions

Updating an Outbound Interaction Record

Use this object to update a Calling List record that you specify via a RecordHandle parameter. For example, in Predictive dialing mode, this request can be used to overwrite the call result detected by call progress detection when needed. Or you can overwrite an answer call result with the wrong party call result.

Note: When URS executes this object in a strategy, it results in an External Service Request (through Interaction Server) to Outbound Contact Server. Since the request goes through Interaction Server, you must have the Genesys Multimedia product installed and an Open Media component to handle External Service processing.

For additional information on using this object, including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual and the section on updating call results and custom fields in the Outbound Contact 7.6 Reference Manual.

To configure the Update Record object:

  1. On the Outbound toolbar, click the Update Record icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General tab.

  4. Click OK.

To fill in the General tab:

  1. Select an Outbound Contact Server from the OC server drop-down list.

  2. Enter or select a variable for the Record ID assigned by Outbound Contact Server.

  3. Use this area to define key-value pairs to be added/updated in the User Data.

To define key-value pairs, click the [image] button. A new row appears under the Key and Value headings. Under Key in the new row, select an existing User Data key. Under Value, select a strategy variable that contains the value or enter a value.

  4. Click OK.


Routing Non-Voice Interactions > Routing Outbound Interactions

Rescheduling an Outbound Interaction

Use the Reschedule object to reschedule a customer interaction on a Calling List record. An interaction is typically rescheduled during a call when a customer requests a callback at a certain time.

Note: When URS executes this object in a strategy, it results in an External Service Request (through Interaction Server) to Outbound Contact Server. Since the request goes through Interaction Server, you must have the Genesys Multimedia product installed and an Open Media component to handle External Service processing.

For additional information on using this object, including returned results and fault codes, consult the Universal Routing 7.6 Reference Manual and the section on updating call results and custom fields in the Outbound Contact 7.6 Reference Manual.

To configure the Reschedule object:

  1. On the Outbound toolbar, click the Reschedule icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Configure the General tab.

  4. Click OK.

To fill in the General tab:

  1. Select an Outbound Contact Server from the OC server drop-down list.

  2. Enter or select a variable for the Record ID assigned by Outbound Contact Server.

  3. Enter or select a variable for the interval in minutes from the requested callback time.

  4. Click OK.


Routing Non-Voice Interactions > Routing SMS Interactions

Routing SMS Interactions: Overview

The SMS toolbar in the Routing Design window provides strategy-building objects that create and send SMS messages by using ESP.

Note: Do not confuse the Create SMS Out object on the SMS toolbar with the Create SMS object on the Multimedia toolbar. The Multimedia Create SMS object creates a specially-configured e-mail-type message that is sent by the E-Mail Server. The Create SMS Out object uses ESP technology to create an SMS message that is sent by SMS Server.

The following figure shows the toolbar buttons that appear when you click the SMS icon on the Routing Design window toolbar.

The SMS routing objects are:

  • Create SMS Out —Tells SMS Server to create a new SMS interaction for an outbound SMS message.

  • Send SMS Out —Tells SMS Server to send a specified SMS message.


Routing Non-Voice Interactions > Routing SMS Interactions

Creating SMS Interactions

Use the Create SMS Out object to instruct SMS Server to create a new SMS interaction that will be handled by using ESP technology.

Note: Do not confuse this object with the Create SMS object on the Multimedia toolbar. The Multimedia Create SMS object creates a specially-configured e-mail-type message that is sent by the E-Mail Server. The Create SMS Out object uses ESP technology to create an SMS message that is sent by SMS Server.

To configure the Create SMS Out object:

  1. In the Routing Design window, click the SMS icon ( [image] ).

  2. On the SMS toolbar, click the Create SMS Out icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  3. Double-click the object to open its properties dialog box.

  4. Configure the General and Result tabs.

  5. Click OK.

Filling In Values on the General Tab

To fill in the General tab:

  1. Enter the name of the SMS Server in the text box, or select the name from the drop-down list.

  2. Select the appropriate Interaction Subtype. The possible subtypes are Acknowledgement, Autoresponse, and Outbound New.

  3. Click in the Interaction Queue text box to open a list of available queues. Select the queue from which to send the SMS message.

  4. Define the Message Destination Number. This is the mobile telephone number of the person to whom the message is to be sent.

    1. Enter or select from the drop-down list the Source. The possible sources are User Data and Value.
      Note:       Although Contact appears in the drop-down list, it is reserved for future use.

    2. Enter (if you selected Value as the Source) or select (if you selected User Data as the Source) the Value for the Message Destination Number.

  5. Define the Message Source Number. This is the mobile telephone number from which the SMS message should appear to come.

    1. Enter or select from the drop-down list the Source. The possible sources are User Data and Value.

    2. Enter (if you selected Value as the Source) or select (if you selected User Data as the Source) the Value for the Message Source Number.

  6. Select or enter the Message Text. This is the content of the SMS message.

    1. Enter or select from the drop-down list the Source. The possible sources are User Data and Value.

    2. Enter (if you selected Value as the Source) or select (if you selected User Data as the Source) the Value for the message text.

  7. (Optional) Select the way you want to be notified of the SMS message's delivery outcome on the Message Delivery Report pane.

    1. Select the kind of response you want from the Delivery Type drop-down list. The choices are Ack (Acknowledgement), Delivered, and No Report.

    2. Enter the time in seconds that you want to allow before a message that indicates the success or failure of the delivery is generated. If you enter 0 seconds, the server sends any positive response as soon as it is received.

  8. The Extra Optional Parameters pane enables you to define additional message parameters or content, using previously configured key-value pairs. Click Add Item ( [image]) to enter an extra parameter. Click the X to delete any extra parameters you decide are unnecessary.


Routing Non-Voice Interactions > Routing SMS Interactions

Sending SMS Interactions

Use the Send SMS Out object to send an SMS message created by using the Create SMS Out object.

To configure the Send SMS Out object:

  1. In the Routing Design window, click the SMS icon ( [image] ).

  2. On the SMS toolbar, click the Send SMS Out icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  3. Double-click the object to open its properties dialog box.

  4. Configure the General and Result tabs.

  5. Click OK.

Filling In Values on the General Tab

To fill in the General tab:

  1. Enter the name of the SMS Server in the text box, or select the name from the drop-down list.

  2. Define the Message Source Number. This is the mobile telephone number from which the SMS message should appear to come.

    1. Enter or select from the drop-down list the Source. The possible sources are User Data and Value.

    2. Enter (if you selected Value as the Source) or select (if you selected User Data as the Source) the Value for the Message Source Number.

  3. (Optional) Select the way you want to be notified of the SMS message's delivery outcome on the Message Delivery Report pane.

    1. Select the kind of response you want from the Delivery Type drop-down list. The choices are Ack (Acknowledgement), Delivered, and No Report.

    2. Enter the time in seconds that you want to allow before a message that indicates the success or failure of the delivery is generated. If you enter 0 seconds, the server sends any positive response as soon as it is received.

  4. The Extra Optional Parameters pane enables you to define additional message parameters or content, using previously configured key-value pairs. Click Add Item ( [image]) to enter an extra parameter. Click the X to delete any extra parameters you decide are unnecessary.


Routing Non-Voice Interactions > Resource Management

Resource Management: Overview

The Resource Management toolbar in the Routing Design window provides strategy-building objects that enable you to control certain settings for strategies, Places, and Agents.

The following figure shows the toolbar buttons that appear when you click the Resource Management icon on the Routing Design window toolbar.

The Resource Management routing objects are:

  • Set Strategy State —Enables you to activate or deactivate a strategy.

  • Set Agent DND State —Enables you to turn DND off or on for a specified Place or Agent.

  • Set Agent Media State —Enables you to set the state of a Place or Agent as Ready or Not Ready for a specified media type.

  • Force Logout —Enables you to force a Place or an Agent to log out.


Routing Non-Voice Interactions > Resource Management

Setting a Strategy State

Use the Set Strategy State object as an additional method for managing workflows. Strategies can by activated or deactivated by an interaction that has specific properties.

When activating a strategy using the Set Strategy State object, the interaction server finds all switches for the tenant, then either creates VRPs in all the switches, or updates them if they already exist.

When deactivating a strategy using the Set Strategy State object, the interaction server finds all switches for the tenant and deletes from their DN lists all VRPs matching the StrategyName.

When unloading a strategy using the Set Strategy State object, the interaction server finds VRPs matching the StrategyName in all switches for the tenant and modifies the Annex in these VRPs accordingly.

To configure the Set Strategy State object:

  1. On the Resource Management toolbar, click the Set Strategy State icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Select a strategy from the drop-down list, or click Browse to select from the complete list of strategies for the current Tenant from the Select Strategy dialog box.

Note: Click a column header to re-sort the list or enter text in a filter text box to find matching text in a strategy name, description, or other column.

  4. Select either the Active or the Not Active radio button. The Active button activates the strategy; the Not Active radio button deactivates it. You can also select the Unload only check box. This check box will deactivate the strategy but will not remove the routing point to which it was loaded.

  5. Click OK.


Routing Non-Voice Interactions > Resource Management

Setting an Agent's DND State

Use the Set Agent DND State object to turn the Agent DND on or off when an interaction is directly routed to the Agent DN rather than through the use of targets.

To configure the Set Agent DND State object:

  1. On the Resource Management toolbar, click the Set Agent DND State icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Enter either the Place or the Agent whose DND state is to be changed.

    • To set the Place in which the DND state is to be changed, enter the Place name in the Place text box, or click the drop-down arrow to select the Place from a list. If you click the drop-down arrow, you can choose to select from a list of Places or variables.

    • To set the Agent whose DND state is to be changed, enter the Agent ID or click the drop-down arrow to select the Agent ID from a list. If you click the drop-down arrow, you can choose to select from a list of Agent IDs or variables.

  4. Click the radio button that corresponds to the DND state (On or Off) that you want to set.

  5. Click OK.


Routing Non-Voice Interactions > Resource Management

Setting an Agent's Media State

Use the Set Agent Media State object to change the Agent state from Not Ready to Ready—or vice versa—for a specified Media Type when an interaction is directly routed to the Agent DN rather than through the use of targets.

To configure the Set Agent Media State object:

  1. On the Resource Management toolbar, click the Set Agent Media State icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Enter either the Place or the Agent whose Media state is to be changed.

    • To set the Place in which the Media state is to be changed, enter the Place name in the Place text box, or click the drop-down arrow to select the Place from a list. If you click the drop-down arrow, you can choose to select from a list of Places or variables.

    • To set the Agent whose Media state is to be changed, enter the Agent ID or click the drop-down arrow to select the Agent ID from a list. If you click the drop-down arrow, you can choose to select from a list of Agent IDs or variables.

  4. Enter the Media Type whose state is to be changed, or click the drop-down arrow to select the Media Type from a list. If you click the drop-down arrow, you can choose to select from a list of Media Types or of variables.

  5. Click the radio button that corresponds to the state (Ready or Not Ready) that you want to set.

  6. Click OK.


Forcing an Agent to Logout

Routing Non-Voice Interactions > Resource Management

Forcing an Agent to Log out

Use the Force Logout object to log out a Place or an Agent when an interaction is directly routed to the Agent DN rather than through the use of targets.

To configure the Force Logout object:

  1. On the Resource Management toolbar, click the Force Logout icon ( [image] ) then click inside the Routing Design window workspace to insert the object.

  2. Double-click the object to open its properties dialog box.

  3. Enter either the Place or the Agent to be logged out.

    • To set the Place that is to be logged out, enter the Place name in the Place text box, or click the drop-down arrow to select the Place from a list. If you click the drop-down arrow, you can choose to select from a list of Places or variables.

    • To set the Agent who is to be logged out, enter the Agent ID, or click the drop-down arrow to select the Agent ID from a list. If you click the drop-down arrow, you can choose to select from a list of Agent IDs or variables.

  4. Click OK.


Designing Business Processes Overview

Designing Business Processes

Designing Business Processes: Overview

The Interaction Design window is an interface within Interaction Routing Designer (IRD), in which you create Business Processes. Like strategies, Business Processes direct incoming customer interactions through various processing objects in order to deliver an appropriate response to a customer. Business processes differ from strategies in that:

  • They route multimedia interactions only.

  • They incorporate strategies within them as processing steps.

Note: The Interaction Design bar and Interaction Design window appear within the IRD application only if your environment is configured with the Genesys Multimedia Routing components. If your Genesys environment does not include the Genesys Multimedia components, ignore the topics that cover the Interaction Design window and Business Processes.

Interaction Flow Within a Business Process

When creating a Business Process, you configure interaction processing points. A single Business Process can handle an interaction from the point at which the interaction arrives at the contact center, to the point at which a customer response is completed. Or, you can link Business Processes together to create more complex interaction workflows.

In general, a Business Process handles an interaction in the following way:

  1. A Media Server creates an inbound interaction and directs Interaction Server to place it into an inbound queue.

  2. The interaction is taken out of the queue and submitted to a routing strategy that uses various processing objects.

  3. The routing strategy performs the specified processing and eventually routes the interaction to a target—but not necessarily to the final target. For example, an e-mail interaction might be placed into an Agent workbin that is accessible via Genesys Agent Desktop, for construction of a response.

  4. The target processes the interaction and places it into another queue, where another strategy might process it. For example, a strategy might send an Agent’s draft e-mail response to a queue for Quality Assurance review.

  5. The cycle of going from queue to routing strategy to queue continues until processing is stopped, or until the interaction reaches some final routing strategy (usually an outbound sending strategy).

Business Processes in the Interaction Design Window

In addition to providing an interface for creating Business Processes, the Interaction Design window provides a graphical representation of the flow, enabling you to see the interaction processing as a whole.

Note: The Interaction Design window uses an efficient arranging algorithm that automatically places objects in a clear, organized layout. To make the graphics small enough for this Help file, objects have sometimes been manually rearranged. This tends to produce crowded, less-than-optimal layouts. For this reason, Genesys recommends that you make use of the arranging capabilities of the Interaction Design window.

Using Linked Business Processes

For more complex processing, interactions can be transferred through several Business Processes, each of which handles a logical phase of the interaction flow.

For example, you might have a Business Process that accepts an interaction, analyzes it, and then routes it to one of several targets. One of the targets might be the starting point of a second Business Process that handles only interactions requiring the input from workers with a particular speciality.

Note: The Interaction Workflow Samples component includes sample Business Processes that demonstrate how an interaction can flow from one to another.


Designing Business Processes

Example Business Process

The following figure shows an example of a Business Process in the Interaction Routing Designer (IRD) Interaction Design window. Some of the various objects that comprise a Business Process are summarized below.

Notes:

  • In order to view the objects in a Business Process, you must open it.

  • All objects used in a strategy are hidden if the Strategy object represents a shortcut to a strategy that was first assigned to a different Business Process and is now used in both Business Processes. To view the objects used in the strategy to which the shortcut points, you must locate the Business Process that owns the strategy and view it there. To do this, right-click the strategy shortcut, and then select Locate.

Queue Objects

A Business Process directs interactions into and out of queues. A Queue object in a Business Process represents a logical parking place (persistent queue) for an interaction during its lifetime at the contact center. You define some queues in the object browser of the Interaction Design window, and then manually place them into the Business Process; other queues nodes appear automatically in a Business Process, because they are linked to the routing strategy (strategy-linked nodes).

The same queue can be used in more than one Business Process. If this occurs, the Queue object displays an upward-pointing arrow in the lower-left corner of its icon, as shown above. This arrow indicates that the queue belongs to a different Business Process, and that the Queue object that appears here represents a shortcut to that queue.

View Objects

A Queue object has special ports for outgoing connections. Such ports, which appear as gray spheres, represent View objects. A View object defines a filter that specifies the order in which, and the conditions under which, Interaction Server should pull an interaction from a queue and submit it to a routing strategy.

You must create at least one view for each queue; otherwise, interactions will remain in that queue and never be processed. You might want to create multiple views for the same queue—for example, if you want e-mails from different types of customers to be handled differently, you would specify a set of conditions in each view, defining the type of customer e-mails it handles.

Strategy Objects

Routing strategies that are used in Business Processes function much like ”r;stepping stones” between queues. A Strategy object represents a routing strategy that performs operations associated with the IRD strategy-building objects.

The same strategy can be used in more than one Business Process. If this occurs, the Strategy object displays an upward-pointing arrow in the lower-left corner of its icon, as shown above. This arrow indicates that the strategy belongs to a different Business Process, and that the Strategy object that appears here represents a shortcut to that strategy.

You can locate the Business Process that owns the strategy by right-clicking the strategy, and then selecting Locate. The strategy is then highlighted in the object browser, under the Business Process that owns it.

A green arrow in the upper-right corner of a Strategy object's icon indicates that the strategy is activated.

When you place a Strategy object into a Business Process, target nodes (for example, Person and Server targets) might appear if they are linked to the routing strategy (strategy-linked nodes).

Submitters

Connecting a View object to a Strategy object defines a Submitter. A Submitter fetches interactions based on the criteria defined in a corresponding view, and then submits them to a routing strategy.

Media Server Objects

Media servers in your configuration environment can be placed into a Business Process, and their interactions can be sent to queues through the use of Endpoints.


Interaction Server

Designing Business Processes

Interaction Server's Role

Interaction Server executes Business Processes and, in doing so, communicates with Universal Routing Server (URS), which executes routing strategies. URS communicates with Interaction Server about e-mail, chat, and other non-voice interactions (it communicates with T-Server about voice calls).

Notes:

  • URS communicates with Interaction Server about e-mails, chats, and other multimedia types, but not voice. (URS communicates with T-Server about voice calls.)

  • Interactions that Interaction Server sends to URS are returned to Interaction Server if the target is unavailable.

  • URS and Interaction Server communicate using the T-Server message protocol, where all messages from URS to Interaction Server start with Request, and all messages from Interaction Server to URS start with Event.

Interaction Server communicates with URS using a subset of T-Server protocol. For more information on the basic message set (listed below), see the Universal Routing 7.6 Reference Manual.

RequestUpdateUserData, RequestAttachUserData, RequestDeletePair, RequestDistributeEvent for EventQueued, EventDiverted, EventPartyAdded, EventPartyRemoved, and EventAbandoned are supported.

The following message types for third party servers (such as Universal Contact Server and E-mail Server Java) are also supported:

Event | Direction | Comment
Request3rdServer | from URS to Interaction Server | Send a request for a third-party server operation to Interaction Server.
Event3rdServerResponse | from Interaction Server to URS | Returns the results of a third-party server operation.
Event3rdServerFault | from Interaction Server to URS | Supplies error information about a third-party server operation failure.

You can use these messages in the log file when diagnosing strategy/routing problems. For more information, see the section on User Data in Universal Routing 7.6 Reference Manual.

User Data

Because Interaction Server uses the T-Server message protocol to communicate with URS, all of the interaction properties are presented to URS in a UserData property of the T-Event structure. Here is a sample of part of an EventRouteRequest message that provides interaction data to URS:

'EventRouteRequest' message:

AttributeExtensions [bstr] = TKVList:

'STRATEGY_ID' [str] = "strategy_first"

AttributeThisQueue [str] = "asl_strategy_first"

AttributeThisDN [str] = "asl_strategy_first"

AttributeCallType [int] = 0

AttributeCallID [int] = 3829

AttributeMediaType [int] = -1

AttributeConnID [long] =

AttributeCustomerID [str] = "Genesys"

AttributeUserData [bstr] = TKVList:

'AccountBalance' [int] = 0

'CustomNumber2' [int] = 0

'CustomNumber3' [int] = 0

'Priority' [int] = 0

'ServiceObjective' [int] = 0

'InteractionId' [str] = "tst00004e20"

'TenantId' [int] = 101

'MediaType' [str] = "email"

'InteractionType' [str] = "Inbound"

'InteractionSubtype' [str] = "InboundNew"

'InteractionState' [int] = 1

'IsOnline' [int] = 0

'IsLocked' [int] = 0

'Queue' [str] = "queue_first"

'SubmittedBy' [str] = "Workflow Engine Tester"

'ReceivedAt' [str] = "2004-04-14T22:10:35Z"

'SubmittedAt' [str] = "2004-04-14T22:10:34Z"

'DeliveredAt' [str] = "2004-04-26T23:30:02Z"

'PlacedInQueueAt' [str] = "2004-04-23T18:04:10Z"


Interaction Queues

Designing Business Processes

Understanding Interaction Queues

Genesys Universal Routing uses interaction queues, synthetic queues, and virtual queues.

  • An interaction queue is a queue in a Business Process. Use the Interaction Design window to configure interaction queues. After you activate the Business Process, interactions are selected and extracted from queues, and submitted to routing strategies that send them to targets or other interaction queues. The definition of an interaction queue is stored as a Script object in the Configuration Database.

  • A synthetic queue represents a logical grouping of multiple interaction queues, enabling you to specify the interaction processing that is performed for all the queues as a stage of a workflow in a single step.

  • A virtual queue is not a physical queue, but a logical queue to which all interactions are queued if the specified targets in the routing objects within a routing strategy are not available. All interactions submitted to Universal Routing Server (URS) are placed in virtual queues.

URS communicates with Interaction Server about e-mails, chats, and other types of non-voice interactions, and with T-Server about voice calls. Interactions sent to URS from Interaction Server are returned to Interaction Server if the target is unavailable.

  • For sample Business Processes, which include sample queues and non-voice routing strategies, see Universal Routing Strategy Samples.

  • For more information about queues, see the Universal Routing Business Process User's Guide.


Designing Business Processes

Strategy-Linked Nodes

When you use a routing strategy in a Business Process, certain objects cause strategy-linked nodes to appear in the Business Process.

  • If you select an interaction queue, a queue node flows out the right side of the strategy.

  • If you select a server, a server node flows out the right side of the strategy.

  • If you select an Agent target or workbin, an Agent node flows out the right side of the strategy.

For example, the Process ABC e-mail routing strategy uses the Route Interaction object. The Properties dialog box for this object includes two tabs: Interaction Queue and Target Selection. When you use the Process ABC e-mail routing strategy in a business process, the Agent target, queue, and stop nodes automatically flow out the right side of the strategy.

  • The Agent target node (E-mail distribution) represents the Agent group specified on the Target Selection tab of the Route Interaction object.

  • The queue strategy-linked node (Outbound queue) represents the queue specified under Queue For New Interaction on the Interaction Queue tab of the Route Interaction object.

  • The stop node (Stop) represents the Stop Processing value in the Queue for Existing Interaction text box on the Interaction Queue tab of the Route Interaction object.

Note: A stop node also appears in a Business Process when you use the Stop Interaction object in a strategy.

For a complete list of objects that generate strategy-linked nodes in a Business Process, see the "Summary of Multimedia Objects" table in the Universal Routing 7.6 Reference Manual.


Genesys Ixn Workflow Samples

Designing Business Processes

Genesys Interaction Workflow Samples

When you install the Genesys Multimedia software components, you have the option of installing a component called Interaction Workflow Samples. The Samples component includes various Business Processes and associated queues, views, submitters, workbins, and routing strategies. The Samples also show how you can break down interaction processing into smaller step-numbered Business Processes that are connected via queues.

For detailed information about the Samples, see Appendix A, "Business Process Samples," in the Universal Routing Business Process User's Guide.


Designing Business Processes

Genesys E-Mail Processing

This topic presents a high-level description of Genesys e-mail processing to help you better understand how e-mails originate and move through the system.

Genesys e-mail processing occurs as follows:

  1. E-mail interactions arrive at E-mail Server Java.

    • If the customer sends an e-mail (for example, by using e-mail management software), the interaction arrives via the enterprise mail server.

    • If the customer fills out a web form, the interaction comes from Web API Server.

  2. E-mail Server Java assigns an inbound queue to the e-mail (as configured in the E-mail Server Java configuration object). It also sends operational data about the e-mail to Interaction Server, and it simultaneously stores the body of the e-mail in the Universal Contact Server (UCS) database.

  3. Interaction Server parks the e-mail’s operational data in its cache and starts processing the e-mail according to a Business Process.

  4. The e-mail is taken out of the queue and submitted to a routing strategy.

Note: During its lifetime, an e-mail might be submitted to different routing strategies and pulled out of/placed back into a queue multiple times.

  5. What happens next depends on the Business Process and the design of the routing strategies that it contains.

Processing can include:

    • Applying a screening rule.

    • Assigning one or more classification categories to the e-mail (if Content Analyzer is present).

    • Generating an automatic acknowledgment and/or standard response.

    • Routing the e-mail to a target—but not necessarily the final target: the target can process the e-mail and place it into another queue. Routing can also include sending an automatic acknowledgement to the customer.

Note: When an e-mail is ready to be routed to an Agent, Universal Routing Server (URS) tells Interaction Server which Agent should receive it. When the Agent's desktop receives from Interaction Server the operational data that identifies the e-mail, the desktop uses that information to retrieve the e-mail content (and any attachments) stored in the UCS database.

  6. A supervisor can intervene at various points for as long as the e-mail’s operational data remains in the Interaction Server’s cache.

  7. The Agent receives the interaction. If Content Analyzer is present, the e-mail might arrive with a category assignment and a suggested response. Otherwise, the Agent can search manually for suggested responses within a category.

  8. The Agent can then:

    • Simply reply to the e-mail. In this case, the Business Process defines the Agent’s Outbound queue.

    • Transfer it to another Agent.

    • Produce a collaborative response by consulting with other Agents.

  9. When the reply is finally released by the Agent or Agents, the Business Process can direct it to a senior Agent or supervisor for Quality Assurance (QA) review. The reviewer decides whether to let the reply continue through the outbound part of the Business Process, return it to the Agent for revision, or take other action.


Designing Business Processes

Business Processes Within a Workflow

An interaction workflow is a way of representing the procedure that a business uses to accomplish some business objective. This workflow can be broken down into various segments. Interaction Routing Designer (IRD) enables you to represent such segments as Business Processes.

  • A Business Process is a logically organized series of steps that, together, handle a task or some aspect of a task, and that therefore contribute to your overall workflow processing.

A Business Process moves multimedia (non-voice) interactions through various queues, routing strategies, workbins, and other objects. In doing so, it automates the processing of incoming customer interactions, with the purpose of delivering an appropriate response to the customer.

  • In the case of an e-mail interaction, an appropriate response might involve sending an e-mail that answers the customer's questions or concerns.

  • In the case of a chat interaction, an appropriate response might involve mailing product brochures to the customer.

  • In the case of a fax interaction, an appropriate response might involve sending an e-mail stating that the requested materials have been received, and so on.

The routing strategies within a Business Process perform more specialized tasks, which are associated with IRD strategy-building objects. For example, in the case of a Business Process that processes e-mails:

  1. The Business Process might first use Media Server and Endpoint objects.

  2. Next, the Business Process might use a view to specify which e-mails Interaction Server should extract from a queue and send to a strategy. For example, it might have every incoming e-mail sent to a strategy that determines whether the e-mail is new, or whether it is the result of previous processing (such as a reply from a collaborating Agent). Based on this determination, e-mails are sent to various other queues.

  3. From this point, the Business Process might use another strategy that routes any previously processed e-mails back to the workbin of the original Agent, and any new e-mails to a strategy that screens them for certain words or word patterns.


Preparing To Create BPs: Overview

Designing Business Processes > Preparing to Create Business Processes

Preparing to Create Business Processes: Overview

Preparation consists of the following tasks:

  • Studying the Genesys-supplied samples

  • Preparing the design of the interaction flows

  • Configuring prerequisite applications and objects


Designing Business Processes > Preparing to Create Business Processes

Analyzing Required Functionality

To isolate the interaction processing functionality that your contact center requires, start by asking the following questions:

  1. Of the various functionalities demonstrated by the Genesys-supplied samples, which is applicable to your site? Study the routing strategies (composed of strategy-building objects) and queues used by those particular samples.

  2. Are any of the specialized processing operations provided by the IRD Multimedia objects (available through strategies) applicable to your site?

  3. Does your contact center require any special interaction processing functionality that is not demonstrated by the samples or addressed by the IRD strategy-building objects?

  4. Can you use the IRD External Service object to supply this special interaction processing functionality? Does this special interaction functionality require its own Business Process, or will it be part of another Business Process? What queues and strategies are required in order to implement this special functionality?

  5. What are your contact center’s special conditions for extracting interactions from queues? You will need this information when you configure View objects.

  6. Make a list of the interaction processing functionalities that your site requires. Should you create one large Business Process to handle them, or build a number of smaller Business Processes and connect them via queues, as demonstrated by the step-numbered samples?


Designing Business Processes > Preparing to Create Business Processes > Design Preparation

Design Preparation: Overview

When planning an interaction workflow with its individual Business Process objects, start by considering the basic stages of interaction life-cycle processing. You can design Business Processes that encompass all stages, one stage, or multiple stages.

Although every site will have its own unique life-cycle processing stages, the following example stages are especially applicable to e-mail processing:

  • Pre-Route

  • Route-to-Target

  • Review

  • Pre-Send

Checking for Interaction Subtypes

Configuration Manager predefines Interaction Subtypes as Business Attributes.

During interaction processing within strategies, you can write these attributes to interactions. The attributes can then be used to determine processing status, as described in the section about creating strategies in the Universal Routing Business Process User's Guide.


Designing Business Processes > Preparing to Create Business Processes > Design Preparation

Pre-Route Stage

Ask yourself what types of processing should occur before an interaction is forwarded to an Agent. The activities in this stage could include (but they are not limited to):

  • Determining whether an interaction has already been processed by Genesys. This can be accomplished by determining whether the interaction contains an Interaction Subtype that indicates processing status.

  • If Content Analyzer is installed, sending interactions to Classification Server for assignment of one or more Category codes that you previously defined in Knowledge Manager.

  • Screening interactions for certain words or patterns of words.

  • Sending an acknowledgment and/or automatic Standard Response to the customer who initiated the interaction.

  • Determining the Agent who previously handled the interaction.

For more information about Knowledge Manager, Classification Server, and Training Server, see the Multimedia 7.6 User's Guide.

Routing Strategies Perform Pre-Route Activities

All of the activities listed above are handled by routing strategies that you place within Business Processes.

If you want a Business Process to perform pre-routing activities, you must first configure the appropriate routing strategies. After you configure strategies, you can view or select them in the Object Browser, and add them to the Business Process.

For information about configuring routing strategies, see Creating a New Strategy.


Route-To-Agent Stage

Designing Business Processes > Preparing to Create Business Processes > Design Preparation

Route-To-target Stage

The target to which the interaction is to be routed is not necessarily an Agent. For example, the interaction may be:

  • Sent to a queue for submission to other routing strategies and further processing.

  • Sent to a queue for failed interactions.

  • Forwarded outside the contact center to an expert, with the expectation of receiving a response.

  • Redirected to another Agent, without the expectation of receiving a response.

  • Routed to an Agent target for construction of a response.

After you determine the target, configure and save the required routing strategies in the Routing Design window. These routing strategies then appear as Strategy objects in the Object Browser, and you can be select them when you create a Business Process.


Designing Business Processes > Preparing to Create Business Processes > Design Preparation

Review Stage

Ask yourself who needs to review the response before it is sent back to the customer. The reviewer can be a manager, a supervisor, or a quality assurance (QA) person, provided that a record has been set up for the person in Configuration Manager. This stage matches the reviewer and the Agent (or Standard Response), and also establishes the criteria for review.

You may wish to have two different types of QA review:

  • A supervisor review to check the handling Agent’s skills.

  • An analysis to perform a ”sanity check”—for example, to prevent a bank account password from being sent out in an e-mail, or to screen e-mails for improper language.

This second type of review is covered in the pre-send stage.


Designing Business Processes > Preparing to Create Business Processes > Design Preparation

Pre-Send Stage

The cycle of going from queue to routing strategy to queue can continue until the interaction reaches some final outbound queue. The pre-send stage performs last-minute quality checking, and it allows for the attachment of additional information to interactions when needed.

Another way to understand the interaction life cycle is to study the Genesys-supplied Business Process samples.


Designing Business Processes > Preparing to Create Business Processes > Configuring Applications and Objects

Configuring Applications and Objects: Overview

After designing the various necessary Business Processes on paper, configure the following objects in the order shown:

  1. Knowledge Manager objects

  2. Configuration Manager objects

  3. Routing Strategy objects

  4. Resource Capacity rules


Designing Business Processes > Preparing to Create Business Processes > Configuring Applications and Objects

Order of Configuration

You must define certain objects in Knowledge Manager before they are available for selection in Configuration Manager. Similarly, certain objects must exist in Configuration Manager before you can select them when defining Interaction Routing Designer (IRD) strategy objects. Because of these dependencies, Genesys recommends that you configure objects in the following order:

  1. In Knowledge Manager, define any required classification Categories, Standard Responses, Screening Rules, Field Codes, and Custom Variables. After you save these in the Universal Contact Server (UCS) database, the object definitions carry over to the Configuration Database, and they are accessible to the strategy-building objects that use them.

  2. In Configuration Manager, define any required Skill, Person, Agent Group, Place, and Place Group objects, and certain Business Attribute objects. After you save these in the Configuration Database, you can select them in the IRD objects that use them.

  3. In the Interaction Design window, define Business Process objects, including Endpoints, queues, workbins, strategies, and views. After you save the definitions in the Configuration Database, you can select the names in the strategy-building objects that use them.

  • The Properties dialog box for most of the IRD Multimedia objects requires you to specify an interaction output queue. Before any interaction queue can be listed for selection in one of the Multimedia objects, you must first associate the queue with a Business Process in the Interaction Design window.

  • The Properties dialog box for the IRD Workbin object requires you to select a workbin name. In order for workbin names to be displayed for selection in the IRD Workbin object, you must associate Workbin objects with Business Processes in the Interaction Design window.

  4. In the Interaction Design window, define Endpoints, if they are not already defined in the Media Server's Application object.

  5. In the Routing Design window, create the required routing strategies. After the routing strategies exist, you can select them as Strategy objects in the Interaction Design window.

  6. Edit your Business Processes by pulling in existing Strategy objects, and by using Submitter objects to connect strategies to queues.

If you proceed in this sequence, you will be able to select the applicable objects.


Designing Business Processes > Preparing to Create Business Processes > Configuring Applications and Objects

Knowledge Manager Objects

At some point in a Business Process, you may want to screen an interaction for certain words or word patterns, analyze an interaction's content and assign Categories, or send a Standard Response. Before you can perform these functions, which will be done within a routing strategy, you must define these and certain other objects in Knowledge Manager.

After you define the objects, you will be able to select them in Interaction Routing Designer (IRD) and view them in Configuration Manager.

The following table lists the Knowledge Manager objects that are used in routing strategies.

Knowledge Manager Object

Used in Routing Strategies By

Classification Categories

  • The Classify object to automatically classify an interaction, based on its content.

  • The Attach Categories object to manually attach classification Categories to an interaction.

  • The Classify Segmentation object to cause interactions to take different paths in the strategy, based on an assigned classification Category.

  • Screen and Multi-Screen objects to return the Categories that are associated with Screening Rules.

  • Acknowledgement, Autoresponse, Create SMS, Create Notification, and Create E-mail Out objects to identify appropriate Standard Responses.

Standard Responses (which may include Field Codes and Custom Variables)

Acknowledgement, Autoresponse, Chat Transcript, Forward E-mail, Redirect E-mail, Create SMS, Create Notification, and Create E-mail Out objects.

Screening Rules

Screen, Multi-Screen, and Screen Segmentation objects to screen interactions for certain words or word patterns.

Categories

A Category is a classification code in a Knowledge Manager Category tree that is used to categorize interactions based on an analysis of their content. After you define Categories in Knowledge Manager and save them in the Universal Contact Server (UCS) database, the object names are written to the Configuration Database, and they are viewable in Configuration Manager, in the Category Structure folder under Business Attributes.

Standard Responses

A Standard Response is an automatic response (consisting of prewritten text from your Standard Response library) that is associated with a Category, and that can be sent to a customer. A Standard Response can be sent as-is, or you can customize it by using Field Codes and Custom Variables.

Field Codes

Field Codes are used to personalize Standard Responses—for example:

Dear <$Contact.FirstName$>,

&ldots;

<$Agent.Signature$>

In this response, there are two Field Codes. When an Agent inserts this response into an e-mail, the first Field Code, <$Contact.FirstName$>, is replaced by the contact’s first name as it appears in UCS. The second Field Code, <$Agent.Signature$>, is replaced by the Agent’s signature as it appears in Configuration Manager.

For more information about Field Codes, see the Multimedia 7.6 User’s Guide.

Custom Variables

Field Codes can also consist of Custom Variables, which can further particularize a Standard Response. For example, assume that:

  • In Knowledge Manager, you define a Custom Variable called WesternAgentGroup.

  • In the IRD Acknowledgement object in a strategy, you define the following parameters in the Field codes area.

    • Key: WesternAgentGroup

    • Value: Hello, you have reached the Western Agent Group. Welcome.

  • You use this Custom Variable in a Field Code, and then use that Field Code in a Standard Response that is subsequently specified on the General tab of the Acknowledgement object.

The result is that, in the acknowledgment message, the WesternAgentGroup variable will be replaced by the string, Hello you have reached the western Agent group. Welcome.


Designing Business Processes > Preparing to Create Business Processes > Configuring Applications and Objects

Configuration Manager Objects

At some point in a routing strategy that is used in a Business Process, you may want to:

  • Route interactions to Agents, Agent groups, places, place groups, or campaign groups.

  • Route interactions to other types of Person objects, such as those that represent quality assurance (QA) personnel, managers, or supervisors.

  • Route on the basis of Agent skill or skill level.

  • Make routing strategy decisions on the basis of Business Attributes, such as Service Type, Customer Segment, Interaction Type and Subtype, Disposition Code, or Media Type.

You also may want to:

  • Use external e-mail addresses in routing strategies (E-mail Accounts).

  • Retrieve information from a database, for use in routing strategies (Table Access).

Before you can use any of these objects in routing strategies, you must define them in Configuration Manager.

For detailed information about using Configuration Manager, see Framework 7.6 Configuration Manager Help.

Limitations

When developing a strategy or Business Process, take the following limitations into consideration:

  • Certain symbols must not be used in object names.

  • The names of all Interaction Routing Designer (IRD) reusable objects and data (strategies, routing rules, schedules, and so on), as well as Interaction Design window configuration objects (Business Processes, queues, and so on) are limited to alphanumeric characters, and they cannot begin with a space, an underscore, or a hyphen. Please note that, although some IRD objects allow you to enter names that contain special characters, Genesys strongly recommends that you not use them.

  • Although the Genesys Configuration Layer supports the full character set for use in object names, using certain characters can cause problems in the behavior of other Genesys applications.

  • The maximum length of any Configuration Server object name is 256 bytes (a limitation that is automatically enforced by Configuration Server).

  • The maximum length of Employee IDs, Login IDs, Place names, DN numbers, and Switch names that will be used to define routing targets is 63 bytes.

  • The maximum number of characters in a strategy name is 194 characters.

  • When a Universal Routing Server (URS) is connected to a T-Server through a Load Distribution Server, the sum of the bytes in the combined names of the URS and the T-Server cannot exceed 126 bytes.

  • When defining Agent states on the Annex or Options tab of a URS Application object (for example, when you prepare to use the UseAgentState function in IRD), the maximum number of user-defined Agent states is 32.

  • The names of skills, if they are used in a skill expression, cannot exceed 126 bytes.

  • The Priority of an interaction cannot exceed 1,000,000,000.


Designing Business Processes > Preparing to Create Business Processes > Configuring Applications and Objects

Resource Capacity Rules

Before activating interaction workflows, you may wish to configure Resource Capacity rules by using the Genesys Resource Capacity Wizard. Resource Capacity rules impact routing. This, in turn, impacts interaction workflows, which call one or more routing strategies.

Resource Capacity rules determine an Agent's ability to accept one or more simultaneous interactions of differing media types. After defining a complete set of available Agents (taking Resource Capacity rules into consideration if they have been configured), Universal Routing Server (URS) applies the routing selection criteria specified in the Strategy objects.

If more than one Agent is available, URS selects one, based on the value of a statistic specified in the routing strategy. If a statistic is not specified in the routing strategy, URS selects on the basis of Agent load (currently, it selects the Agent with the longest waiting time).

For more information about Resource Capacity rules, see the Genesys 7.6 Resource Capacity Planning Guide.


Designing Business Processes > Preparing to Create Business Processes > Configuring Applications and Objects

Creating Strategy Objects

To create the routing strategies that will be used in Business Processes, use one of the following methods:

  • Create strategies before you create Business Process objects. If you use this method, routing strategies that contain Multimedia objects will automatically be listed in the Object Browser. You can then manually place them into Business Processes.

  • Configure strategies during the same session in which you create a Business Process (by using the Edit/View command from the shortcut menu).

  • Create Business Processes in which the Strategy object serves as a placeholder for the strategy. Then, at a later time, you can configure the actual strategies in the Routing Design window.

Strategy Placeholders

The strategy placeholder method has the following advantages:

  • The Properties dialog box for most of the Multimedia objects requires you to specify an interaction output queue. However, in order for an interaction queue to be listed for selection in one of the Multimedia objects, it must first be associated with a Business Process.

  • The Properties dialog box for the Interaction Routing Designer (IRD) Workbin object requires you to select a workbin name. However, in order for workbin names to be listed for selection in the Workbin object, the Workbin object must first be associated with a Business Process.

For detailed information about creating routing strategies, see the "Creating a New Strategy" section in this Help file.


Designing Business Processes > Creating a Business Process

Creating a Business Process: Overview

Before starting Interaction Routing Designer (IRD) and creating a Business Process:

  1. Plan all of the Business Processes that you require.

  2. On paper, diagram each Business Process.

  3. Determine and/or configure the routing strategies that will be used in the Business Processes. At the very least, configure the routing strategy that will associate the interactions with the entry-level queue.

After completing these steps, create each Business Process by:

  1. Adding a Business Process object.

  2. Adding a Media server.

  3. Adding an Endpoint.

  4. Adding a Queue object.

  5. Adding a Synthetic Queue object.

  6. Adding a View object.

  7. Adding a Workbin object.

  8. Adding a Strategy object.

  9. Adding a Submitter object.

  10. Testing the Business Process workflow.

  11. If necessary, you can remove objects from a Business Process or delete a Business Process.

Notes:

  • In the Object Browser, the icons for objects that are used in a Business Process include a small yellow arrow.

  • Genesys recommends that you do not edit Interaction Design objects from Configuration Manager. If you do, note that Interaction Design does not automatically reset values modified in Configuration Manager for Queue, View, and Workbin objects. You must refresh the Interaction Design window (select Refresh from the File menu or press F5) to see the object updates.

Warning! Do not put a Business Process into a production environment until it has been thoroughly tested to ensure that it directs interactions as you intended.


Designing Business Processes > Creating a Business Process

Adding a Business Process Object

The first time that you use the Interaction Design window (a clean configuration), Interaction Routing Designer (IRD) creates a default Business Process object for you, which you can rename or use to create other Business Process objects. If necessary, you can remove objects from a Business Process or delete a Business Process.

To switch to another Business Process object in the Object Browser, do one of the following:

  • Right-click the Business Process that you want to open, and then select Open the Process from the shortcut menu.

  • Double-click the Business Process.

Note: You cannot view another Business Process by expanding it in the Object Browser.

You can create a new Business Process object from the IRD main window or from the Interaction Design window.

Creating a New Business Process from the IRD Main Window

To open the Interaction Design window and add a new Business Process object:

  1. In the IRD main window, click Interaction Design.

  2. On the Shortcut bar, click Business Processes.

  3. Do one of the following:

  • From the File menu, select New.

  • Click the New icon on the Menu bar.

  • Right-click any folder or subfolder on the List pane.

The Interaction Design window appears. A new object appears in the Object Browser with the temporary name selected.

  4. Continue with Step 2 in the next section.

Creating a New Business Process from the Interaction Design Window

To add a new Business Process object from within the Interaction Design window:

  1. Do one of the following:

    • From the Business Process menu, select New Business Process.

    • On the toolbar, click the New Business Process button.

    • Right-click the double-line bar at the top of the Object Browser.

A new Business Process object appears in the Object Browser, with a temporary name assigned.

If you decide that you do not want to create a new Business Process after all, select Undo Creating from the Edit menu.

  2. In the Object Browser, click the temporary Business Process name and edit it, supplying your own name. If you change your mind, click outside the new name, and then select Undo Updating from the Edit menu.

Note: IRD does not allow trailing spaces after a Business Process name. Any trailing spaces that you enter are ignored.

  3. In the Object Browser, click in a blank area outside the new Business Process name.

  4. Right-click the Business Process object, and then select Properties from the shortcut menu.

The Business Process Properties dialog box opens.

  5. In the Description text box, enter a description.

  6. If you want this to be the default Business Process for the current Tenant, select the Default check box. The default Business Process is marked with a bright-green square in the Object Browser ( [image]).

  7. Click the Close button (X).

After you define a new Business Process object, the next step is to add a Queue object. You can also add a Media Server object, in order to specify the initial inbound queue for the Business Process.

Deleting a Business Process

When you delete a Business Process, you also delete all of the objects it contains, including the .rbn files for the strategies. If you want to retain any of the strategies, queues, workbins, and so on, you must first remove them from the Business Process.

To delete a Business Process, and all of its included objects:

  1. Right-click the Business Process in the Object Browser tree, and then select Delete.

A confirmation dialog box opens, informing you that all associated objects will also be deleted.

  2. Click Yes in the confirmation dialog box to delete the Business Process, or No to preserve it.

To remove objects from a Business Process:

  1. Select the object in the Object Browser tree.

  2. Drag it to another Business Process or to the Independent Objects folder.

Notes:

  • You can drop the objects into the top-level folder for the Business Process to which you're moving the object, or the Independent Objects folder, or you can drop it into the folder for the object type within the Business Process or Independent Objects folder structure. For example, you can drop a Strategy object into the Strategies folder within a Business Process.

  • You can remove activated strategies from a Business Process. However, you cannot delete an activated strategy. To permanently delete a strategy, deactivate it first.


Designing Business Processes > Creating a Business Process

Adding a Media Server

Options in the Configuration Manager E-mail Server Java and Chat Server Application objects enable you to define default inbound queues. You can use these options, along with Endpoint objects, to direct incoming interactions from customers into an initial inbound queue in a Business Process.

Add use of a default queue, if no queue is otherwise specified.

E-mail Server Java, Chat Server, and Third-Party Server Media Server objects that you define in your configuration environment are automatically listed in the Object Browser of the Interaction Design window.

To use a Media Server object in a Business Process:

  1. In the Object Browser, expand the Media Servers folder.

  2. If the desired Endpoints are not yet associated with the Media Server(s), add the Endpoints.

  3. After you define the Endpoints, select the desired Media Server object in the Object Browser, and then drag it into the Workflow Viewer.

The next step is to add a Queue object.


Designing Business Processes > Creating a Business Process

Adding an Endpoint

You can add an Endpoint to a Media Server in various ways.

  1. Select Add Endpoint:

    • From the shortcut menu that appears when you expand the Media Servers folder in the Object Browser, and then right-click a Media Server.

    • From the shortcut menu that appears when you right-click a Media Server in the Workflow Viewer (if a Media Server has already been placed there).

    • From the Business Process menu, after first selecting a Media Server in the Object Browser or Workflow Viewer.

The new Endpoint appears in the Object Browser with a temporary name, which you can edit. If the Media Server is already in the Workflow Viewer, the new Endpoint, with its temporary name, appears as a port on the right side of the media server.

  2. Double-click the temporary name to edit it—for example, to supply a more descriptive name.

Connecting an Endpoint

Follow the steps below to connect the new Endpoint to a Queue object in a Business Process. Each Endpoint can be connected to only one queue.

Note: If the Business Process contains a default queue, you can only configure a single Endpoint, and it must link to the default queue. Please note that in the case in which this rule is accidentally not followed, such integrity errors will not be verified during the compilation of the Business Process.

  1. Drag the media server with the new Endpoint into the Workflow Viewer, if it is not already there.

  2. Connect the Endpoint to the queue.

Note: If an Endpoint is used in another Business Process, Interaction Routing Designer (IRD) enables you to draw the connector. In the Business Process that was already using the Endpoint, IRD outlines the Endpoint in red and no longer shows any connector. This ensures that a single Endpoint is connected to only one queue. In the preceding figure, Endpoint1 is already connected to a queue in another Business Process.

  3. Save the Business Process, as it exists so far, by selecting Save from the File menu (or by clicking the Save button on the toolbar).

Following an Endpoint

Double-clicking an Endpoint in the Workflow Viewer opens a Properties dialog box. If the Endpoint is connected to another object, the Refers To text box displays the names of the Business Process and object.

To find the object to which the Endpoint is connected, click Follow The Reference. IRD highlights the object in the Business Process.


Designing Business Processes > Creating a Business Process

Adding a Queue Object

The Properties dialog boxes for most of the Multimedia objects require you to specify an interaction output queue. Before any interaction queue can be listed for selection in one of the Multimedia objects, you must first associate the queue with a Business Process.

To add a Queue object ( [image]) to a Business Process by defining a new object in the Object Browser:

  1. Determine whether the desired queue is already defined, by expanding the tree in the Object Browser.

  2. If the queue is defined, select it, and then drag it into the Workflow Viewer. Proceed to Step 5.

If the queue is not yet defined, use one of the following methods to define it:

    • Under the Business Process object, right-click the Queues folder, and then select New Queue from the shortcut menu.

    • From the Business Process menu, select New Queue.

    • On the toolbar, click the New Queue button.

All of these actions create a new Queue object in the Object Browser, with a temporary name assigned.

  3. In the Object Browser, click the temporary queue name and edit it, supplying your own name.

  4. Select the Queue object, and then drag it into the Workflow Viewer. If you change your mind, select the object in the Workflow Viewer, and then press the Delete key.

  5. In the Workflow Viewer, double-click the Queue object. The Interaction Queue Properties dialog box opens.

  6. Use the information in the following table to complete the Interaction Queue Properties dialog box:

General Tab

Script Name

(Read-only) Displays the name that you assigned to the queue in the Object Browser.

Description

(Optional) Enter a description of the queue.

Enabled

Select to specify that the queue is ready to accept interactions. This check box is selected by default.

Note: You can also enable and disable a Queue object in Configuration Manager. Locate the Queue object in the Configuration/Resources/Scripts folder. On the General tab, select or clear the State Enabled check box to enable or disable (respectively) the Queue object.

Default

Select this check box to make this the default queue for this Business Process. A default queue is marked with a bright-green square in the Object Browser ( [image]).

Setting a queue as the default means that when you configure a new Media Server object for this Business Process, it automatically uses the selected queue.

Used In Tab

This read-only tab lists the Business Processes in which this queue has been placed.

  7. Click the Close button (X) in the upper-right corner of the Interaction Queue Properties dialog box to save your changes and close the dialog box. The Queue object remains selected in the Workflow Viewer.

  8. Save the Business Process, as it exists so far, by selecting Save from the File menu (or by clicking the Save button on the toolbar).

After you have placed a Queue object in the Business Process, the next step is to set up queue processing rules by adding a View object.

See also Adding a Synthetic Queue Object.


Designing Business Processes > Creating a Business Process

Adding a Synthetic Queue Object

A synthetic queue is a queue that is composed of multiple interaction queues. Creating a synthetic queue simplifies workflow configuration by enabling you to specify interaction processing by multiple queues in a single step.

Three types of synthetic queues can be created:

  • Business Process Queue

  • Synthetic Queue

  • Tenant Queue

To add a Synthetic Queue object to a Business Process by defining a new object in the Object Browser:

  1. Determine whether the desired queue is already defined, by expanding the tree in the Object Browser.

  2. If the queue is defined, select it, and then drag it into the Workflow Viewer. Proceed to Step 6.

If the queue is not yet defined, use one of the following methods to define it:

    • Under the Business Process object, right-click the Queues folder, and then select New Synthetic Queue from the shortcut menu.

    • From the Business Process menu, select New Synthetic Queue.

    • From the toolbar of the Interaction Design window, select the New Synthetic Queue icon ( [image]).

    • Right-click inside the Workflow Viewer, then click New > Synthetic Queue.

Either of these actions opens the Select Synthetic Queue Type dialog box.

  3. In the Type dropdown list, select the synthetic queue type for this synthetic queue (BusinessProcess, Synthetic, or Tenant, as described in the Synthetic Queue Object topic), then click OK.

These actions create a new Synthetic Queue object in the Object Browser, with a temporary name assigned.

  4. In the Object Browser, click the temporary name and edit it, supplying your own name.

  5. Select the Synthetic Queue object, and then drag it into the Workflow Viewer. If you change your mind, select the object in the Workflow Viewer, and then press the Delete key.

  6. In the Workflow Viewer, double-click the Synthetic Queue object. The Interaction Queue Properties dialog box opens.

  7. Use the information in the following table to set values in the Interaction Queue Properties dialog box:

General Tab (All Synthetic Queue Types)
Script Name | (Read-only) Displays the name that you assigned to the synthetic queue in the Object Browser.
Description | (Optional) Enter a description of the synthetic queue.
Enabled | Select this check box to specify that the synthetic queue is ready to process interactions. This check box is selected by default.
Used In Tab (All Synthetic Queue Types)
 | This read-only tab lists the Business Processes in which this synthetic queue has been placed.
Queues Tab ("Synthetic" Type Only)
 | Select the interaction queues to be included in this synthetic queue from the tree on this tab. The interaction queues are listed under the Business Processes in which they were initially configured.

  7. Click the Close button (X) in the upper-right corner of the Interaction Queue Properties dialog box to save your changes and close the dialog box. The Synthetic Queue object remains selected in the Workflow Viewer.

  8. Save the Business Process, as it exists so far, by selecting Save from the File menu (or by clicking the Save button on the toolbar).

After you have placed a Synthetic Queue object in the Business Process, the next step is to set up processing rules by adding a View object.


Designing Business Processes > Creating a Business Process

Adding a View Object

A View object defines the conditions under which Interaction Server pulls an interaction from a queue and places it either in another queue or in a workbin. In other words, it defines which interactions should be selected from an associated object, and where they should be sent.

Note: If no views are defined for a queue, no interactions are processed from that queue.

To add a View object to a selected object (queue or workbin) in a Business Process:

  1. Do one of the following:

    • In the Object Browser, right-click the queue to which you want to attach the view, and then select New View from the shortcut menu.

    • Select the queue in the Object Browser, and then select New View from the File menu.

A new View object appears in both the Object Browser and the Workflow Viewer, with a temporary name assigned.

  2. In the Object Browser, click the temporary view name and edit it, supplying your own name.

Note: View names must be unique within a single queue.

  3. Right-click the new View object, and then select Properties from the shortcut menu. The View Properties dialog box opens.

  4. Use the information in the following table to complete the View Properties dialog box:

General Tab

  • Name—(Read-only) Displays the name that you assigned in the Object Browser.

  • Description—(Optional) Enter a description of the View object. The description can be no longer than 58 characters.

  • Enabled—Select to activate the queue processing rules that are associated with this view. This check box is selected by default.

Note: You can also enable and disable a View object in Configuration Manager. Locate the View object in the Configuration/Resources/Scripts folder. On the General tab, select or clear the State Enabled check box to enable or disable (respectively) the view.

  • Check Interval—Enter the frequency (time interval), in seconds, with which Interaction Server checks the queue and, if necessary, adjusts the number of interactions that can be submitted to the strategy, based on options in the Scheduling tab. If you do not enter a value, Interaction Server uses the default value of 5 (five) minutes. You may wish to use this field for high-value interactions or time-sensitive conditions, such as when the check should be performed more frequently.

Condition Tab

Specify a SQL Where clause to define the conditions for interaction selection—for example:

customer_segment='gold' AND service_type='sales'

Do not use Attached Data for interaction attributes and values. Use AND when specifying more than one expression. When defining a View object, define conditions that process all interactions in the queue or workbin. Any interactions that are not covered by the conditions defined in a view remain there.

Warning! Be sure that the clause uses the correct syntax and form, because Interaction Routing Designer (IRD) does not verify syntax. For more information, see the appropriate SQL documentation.

Notes:

  • Expressions vary between underlying databases, but you can use generic expressions that provide a single interface that is independent of the underlying database (Oracle, Microsoft SQL, DB2). Such expressions are called translations. For information about translations, see the Multimedia 7.6 User's Guide.

  • For information about interaction attributes and their values, see the "Interaction Properties" chapter of the Multimedia 7.6 User's Guide.

Order Tab

Specify a SQL Order clause to define the order for pulling interactions—for example:

date desc, importance asc

Warning! Be sure that the clause uses the correct syntax and form, because IRD does not verify syntax. For more information, see the appropriate SQL documentation.

Scheduling Tab

Specify whether Interaction Server should take into account any schedule attached to an interaction (set with the ScheduledAt property) when drawing interactions from a queue.

For information about setting the ScheduledAt property, see the description of the View object Scheduling tab in the Universal Routing 7.6 Business Process User's Guide.

  • Ignore Scheduling (default)—Interaction Server disregards any schedule setting and submits interactions whenever other conditions are met.

  • Scheduled Only—Interaction Server processes only those interactions that are scheduled, ignoring non-scheduled interactions.

  • Scheduled and Unscheduled—Interaction Server processes all interactions, submitting scheduled interactions at the scheduled time and non-scheduled interactions when other conditions are met.

  • Unscheduled Only—Interaction Server skips scheduled interactions and processes only interactions with no schedule property attached.

Parameterized Conditions Tab

List the interaction properties that clients of Interaction Server can use in pull requests. Select from a standard list of interaction properties, or enter the names of custom properties that you have created. All listed conditions are evaluated.

For example, if you select the contact-id and media_type properties, a pull request could use contact-id=9305787829 and media_type=email to pull all e-mail interactions that are associated with contact 9305787829.

See Using the Parameterized Conditions Tab.

Database Hints Tab

(Optional) Enter hints for your database as plain text.

Segmentation Tab

Instructs Interaction Server to divide the total number of interactions allowed into the strategy so that an equal number enters it from each segmentation category that you specify.

  • For example, if you add the customer_segment segmentation parameter, Interaction Server processes an equal number of interactions for each customer segment that is represented in the queue.

This prevents the strategy from becoming full of interactions for a single segmentation category, leaving Agents trained for other categories idle.

  • Add, Edit, and Remove buttons—Enable you to specify a new segment, change an existing one, or delete an existing one.

  • Check Interval—Specifies the time, in seconds, that elapses before Interaction Server rechecks the queue and adjusts the number of interactions that can be submitted to the strategy according to segmentation options. If you do not specify a value, Interaction Server uses the default value (set in the General tab). Use this parameter when the default interval at which a queue is checked for new interactions is too long, causing highly time-sensitive interactions to remain in the queue too long.

  • Total Limit—Enables you to override the maximum number of interactions that can be submitted to a strategy according to the configured segmentation options. If you do not enter a value, Interaction Server uses the limits set in the strategy.

  5. Click the Close button (X) in the upper-right corner to save your changes and close the dialog box.

  6. Save the Business Process, as it exists so far, by selecting Save from the File menu (or by clicking the Save button on the toolbar).

After you have associated a queue or workbin with a View object, the next step is to add a Strategy object, in order to specify the routing strategy to which you want to submit interactions that are selected based on the conditions specified in the View object.

Using the Parameterized Conditions Tab

To specify conditions:

  1. In the View Properties dialog box, click the Parameterized Conditions tab.

  2. Click Add. A drop-down list appears.

  3. Select an interaction property from the drop-down list, or enter a custom property that you have created.

Note: For information about creating custom properties, see the ”Custom Properties” section of the "Interaction Properties" chapter in the Multimedia 7.6 User's Guide.

  4. If you want to add another condition, click Add again.

You can also edit or remove a listed condition by selecting it, then clicking the appropriate button.


Adding a Workbin

Designing Business Processes > Creating a Business Process

Adding a Workbin Object

A workbin is a temporary storage area associated with an Agent, Agent group, place, or place group.

The Properties dialog box for the Workbin object requires you to select a workbin name. In order for workbin names to be listed for selection in the Workbin object, you must first associate Workbin objects with Business Processes.

To add a Workbin object to the current Business Process:

  1. Select the Business Process.

  2. Do one of the following:

    • From the Business Process Menu, select New Workbin.

    • On the toolbar, click the New Workbin button.

A new Workbin object appears in the Workbins folder in the Object Browser, with a temporary name assigned.

  3. Click the temporary workbin name and edit it, supplying your own name for it.

  4. Right-click the Workbin object, and then select Properties from the shortcut menu. The Workbin Properties dialog box opens. It contains four tabs, General, Order, Used In, and Queue.

  5. Configure the workbin settings, using the information in the General, Order, Used In, and Queue sections below for assistance.

  6. Click the Close button (X) in the upper-right corner to save your changes and close the dialog box.

  7. Save the Business Process, as it exists so far, by selecting Save from the File menu (or by clicking the Save button on the toolbar).

  8. Note: The Workbin object is created in the Configuration Layer when you save it.

  9. Add the workbin to a Business Process by doing one of the following:

    • In the Routing Design window, add a Workbin object, and then specify this workbin on the General tab of the Workbin Properties dialog box. When you save the strategy, the workbin automatically appears in the Business Process in which you created it.

    • Drag the workbin from the Object Browser to the Workflow Viewer.

  10. Note: You can also add views to the workbin, if necessary. See Adding a View Object.

General Tab

Script Name

(Read-only) Displays the name that you assigned in the Object Browser.

Description

(Optional) Enter a description of the workbin.

Owner

Select the type of owner for this workbin: Agent, Agent Group, Place, or Place Group.

Note: If you change the type of workbin owner in the Workbin object's Properties dialog box in the Interaction Design window, you must also change it in the Routing Design window, in the strategy that contains the Workbin routing object. Otherwise, no message is generated in the IRD Details tab, or in the Log tab of the Interaction Design window, when you perform an integrity check.

Enabled

Select to specify that the workbin is ready to accept interactions. This check box is selected by default.

Note: You can also enable and disable a Workbin object in Configuration Manager. Locate the Workbin object in the Configuration/Resources/Scripts folder. On the General tab, select or clear the State Enabled check box to enable or disable (respectively) the workbin.

Order Tab

For information about the Order tab of this dialog box, see Order Tab.

Used In Tab

If this workbin is used by other Business Processes, the Used In tab of the Workbin object's Properties dialog box displays this information.

Queue Tab

Use this tab to choose which queue to use. You can choose a private queue (invisible to the user) or a general-use queue.

Linking a workbin and a queue enables you to direct interactions from multiple workbins to a single queue, when you want to use the same set of criteria for pulling interactions from those workbins. Each workbin that should use that set of criteria can be linked to the queue, and then you can create a view for the queue that contains the desired criteria. This eliminates the need to configure separate views and submitters for each of the workbins.

after configuring the queue, place it in a Business Process and create a single view for it, with the specified escalation condition, and then draw a single submitter to an escalation strategy.

  • If you select the Use The Work Bin’s Private Queue radio button, a private queue is created (if none already exists) and linked to the workbin. When you select this radio button, the drop-down list box and the Locate button are disabled.

  • If you select the Use The Following Queue radio button, you must select an existing queue from the drop-down list. The list contains names of queues that belong to the same Business Process as the workbin. However, if you then move the selected queue to another Business Process, it remains linked to the workbin, and the queue is identified as <Business Process>::<queue name>.

Note: If the workbin was previously linked to a private queue, that private queue is deleted from Configuration Server the next time you save the Business Process that includes the workbin.

  • Click Locate to see the selected queue in the Business Process Workflow Viewer.


Designing Business Processes > Creating a Business Process

Adding a Strategy Object

There are two ways to add a Strategy object ( [image]) to a Business Process:

  • Use an existing Strategy object, representing a routing strategy that has already been configured in the Interaction Routing Designer (IRD) Routing Design window, and that is listed in the Independent Objects folder in the Object Browser.

  • Create/add a new routing strategy or strategy placeholder from the Object Browser, and then drag it into the Workflow Viewer.

Warning! When a strategy is part of a Business Process, you must always finish the strategy and each strategy branch with one of the following objects:

  • Queue Interaction

  • Stop Interaction

  • Route Interaction

  • Workbin

Using an Existing Routing Strategy

To add a preconfigured routing strategy to a Business Process:

  1. In the Object Browser, select the routing strategy.

  2. Drag it into the Workflow Viewer.

If the routing strategy specifies any queues, persons, or servers, the Business Process adds these objects, as well as connecting lines.

Note: You can view or edit the strategy in the Routing Design window by selecting the strategy in the Object Browser or Workflow Viewer of the Interaction Design window, and then selecting Edit/View Strategy from the Tools menu.

Connectors for New and Existing Interactions

The lines that connect objects are color-coded, to indicate whether the interaction that is passed from the object of origin to the target object is an existing interaction or a new one.

  • A red connector line means that a new interaction is created as processing moves from the object of origin to the target object.

  • A black connector line means that the same (existing) interaction is going to a target.

IRD automatically colors the connector lines; you cannot change the colors.

In addition, the lines that connect objects may be solid or dotted, to indicate whether the connection is manually placed or automatically placed.

  • A solid connector line is used when objects are manually placed. Solid lines connect objects that have been dragged and dropped into the Workflow Viewer from the Object Browser tree.

  • A dotted connector line is used when objects are automatically placed based on edits in a strategy (called a strategy-linked node). The connector line can be red if a new interaction is generated, or black if an existing interaction is going to a target.

Note: You cannot delete a connector that has been automatically placed, or delete the object to which it connects. Instead, you must edit the object that generated the automatically-placed connector so that it no longer contains that particular strategy-linked node. In the figure above, to remove the Stop interaction node from Send ABC and its connector, you must first edit the Send ABC strategy.

For more information about configuring the IRD Multimedia objects that generate new and existing interactions, see the object descriptions in the Universal Routing 7.6 Reference Manual.

Adding a New Routing Strategy or Strategy Placeholder

To create/add a Strategy object or placeholder from the Object Browser:

  1. Create a new strategy by doing one of the following:

    • Under any Business Process object (either new or pre-existing), right-click the Strategies folder, and then select New Strategy from the shortcut menu.

    • From the Business Process menu, select New Strategy.

The New dialog box opens.

  2. Enter a name and an optional description, then click OK.

The Routing Design window opens, displaying an Entry object; the strategy name appears in the title bar.

Note: Until you save this strategy, it will not appear on the List pane in the IRD main window, nor will it appear in the Object Browser.

  3. Do one of the following:

    • Define the strategy, and then save it.

    • Save the strategy as a strategy placeholder. Then, go back and define the strategy at a later time, by right-clicking the Strategy object, and then selecting Edit/View Strategy from the shortcut menu.

  4. Drag the strategy from the Object Browser into the Workflow Viewer.

  5. In the Workflow Viewer, double-click the new Strategy object. The Strategy Properties dialog box opens.

The General tab displays the strategy name, and the location in which it is stored. If this strategy is later used by other Business Processes, the Used In tab of the Strategy Properties dialog box displays this information. If the strategy is loaded, the Strategy Loading tab displays the switch and Virtual Routing Point (VRP), on which it is loaded.

  6. If you want to specify the maximum number of interactions that Universal Routing Server (URS) and Interaction Server can send to the strategy, click the Limitations tab. You can enter a positive number up to 50000. Note that this number must not contain any comma or decimal point separators.

    • To specify a default maximum, enter a number in the Default text box.

    • To enter limits for a specific URS and Interaction Server, click Add, and then use the drop-down lists to select the URS and Interaction Server. Then, in the Limit column, enter the maximum number of submitted interactions from the specified servers. This limit overrides the default value.

  7. Click the Close button (X) in the upper-right corner to save your changes and close the dialog box.

Strategy-Linked Nodes

After you create the routing strategy, and then re-open the Business Process that uses it, additional nodes (strategy-linked nodes) appear in the workflow.


Designing Business Processes > Creating a Business Process

Adding a Submitter Object

After you define a Queue object, queue-processing rules in the form of a View object, and a Strategy object, you connect these objects by drawing a line. This creates a Submitter object (the connector line itself), which represents interactions being pulled from the queue and pushed (submitted) to a routing strategy.

To create a Submitter:

  1. In the Workflow Viewer, click the small globe that represents the View object, but do not release the mouse button. The cursor becomes a pointing hand.

  2. Continue to hold down the mouse button while drawing a line from the View object to the Strategy object.

  3. Release the mouse button.

  4. Save the Business Process, as it exists so far, by selecting Save from the File menu (or by clicking the Save button on the toolbar).


Designing Business Processes > Creating a Business Process

What's Next?

After you create the initial inbound Queue, View, Strategy, and Submitter objects, continue to create these objects for each branch of the Business Process.

Then create the remaining Business Processes that you require to complete the interaction flow in your environment.

When all of the Business Processes are complete:

  1. Verify the Business Processes, including the connections between them, if you are using Business Processes linked into a sequence to handle complex interaction flows. (See Testing Business Processes.)

  2. Use the Business Processes.

Keep in mind the following:

  • While you are creating Queue objects, do not forget about the different View objects that you may need.

  • After you create a Business Process and its associated objects, be sure to save it; otherwise, your work will be lost.

  • Working from multiple locations could present a problem if change notifications are disabled because of network downtime or other reasons.

  • Genesys recommends that you do not edit Interaction Design objects from Configuration Manager. If you do, please note that Interaction Design does not automatically reset values that have been modified in Configuration Manager for Queue, View, or Workbin objects. You must refresh the Interaction Design window (select Refresh from the File menu, or press F5) to see the object updates.


Designing Business Processes > Using Business Processes

Using Business Processes: Overview

Before you put a Business Process into use, configure it and test it extensively. Use the guidelines and procedures in the following topics:

  • Finishing a Business Process

  • Activating and Deactivating Strategies

  • Enabling Queues to Accept Interactions

  • Enabling Workbins to Accept Interactions

  • Using the Find Command

  • Testing Business Processes

  • Exporting and Importing Business Processes


Designing Business Processes > Using Business Processes

Finishing a Business Process

After designing and creating a Business Process, confirm that it meets the following requirements:

  • There is one inbound queue for each Media Server (for example, E-mail Server Java).

  • There is one outbound Media Server queue.

  • There is one inbound chat queue for each chat server.

  • There is a collaboration queue.

  • The corporate e-mail server has the correct inbound e-mail address.

  • At least one View object has been created for each queue.

  • A Default Queue and a Draft Queue have been configured for the Agent Desktop.


Designing Business Processes > Using Business Processes

Activating and Deactivating Strategies

In order to use (activate) a strategy, you must first load it on a Routing Point. In the case of a non-voice routing strategy, the Routing Point is a Virtual Routing Point, and you use the Strategy Activation Wizard to load the strategy.

For information about deactivating and unloading strategies, see Deactivating and Unloading Strategies, below.

To activate routing strategies that are associated with the Strategy objects used in a Business Process:

  1. Use one of the following methods to open the Strategy Activation Wizard:

  • In either the Object Browser or the Workflow Viewer, right-click the Strategy object, and then select Activate Strategy from the shortcut menu.

  • For a currently open Business Process, highlight the name in the Object Browser, and then select Activate Strategy (ies) from the Tools menu. With this method, you can activate multiple strategies at once.

The Strategy Activation Wizard opens.

    • If a connection does not exist between the switch and the Interaction Server in Configuration Manager, the wizard displays a warning.

    • If the connection does exist, the wizard prompts you to select an Interaction Server.

  2. Select an Interaction Server that will submit interactions to the routing strategy, then click Next. You are prompted to select a Universal Routing Server (URS).

    Note: If a connection does not exist between URS and the Interaction Server in Configuration Manager, the wizard displays a warning.

  3. Select a URS, then click Activate. The wizard indicates that the strategy is marked for activation, and it displays the result of activation.

  4. Click Close. In both the Workflow Viewer and the Object Browser, the icons for activated strategies contain a green arrow in the upper-right corner ( [image]).

Note: After you activate a strategy, the Activate Strategy command is still available for that strategy, because you can activate it for another URS.

Deactivating and Unloading Strategies

Note: It is possible to manually unload strategies in the Interaction Routing Designer (IRD) Monitoring view. However, using the Deactivate Strategies dialog box within the Interaction Design window is the preferred method, because it gives you more options.

Before you can open a strategy for editing or viewing with the Edit/View Strategy command, you must either deactivate or unload it.

To deactivate/unload a strategy:

  1. Open the Business Process that is associated with the strategy, by right-clicking it, and then selecting Open the Process from the shortcut menu.

  2. Use one of the following methods to open the Strategy Activation Wizard:

    • In the Object Browser or Workflow Viewer, right-click the Strategy object, and then select Deactivate Strategy from the shortcut menu.

    • In the Object Browser, highlight the Business Process name, and then select Deactivate Strategy(ies) from the Tools menu. With this method, you can deactivate multiple strategies at once.

The Deactivate <strategy_name> Strategies dialog box opens. Depending on the method that you use to open it, this dialog box lists either one or all of the strategies in the Business Process that you can deactivate.

The dialog box contains a Deactivate button and an Unload button.

  • Deactivate deletes the Virtual Routing Point, in addition to deactivating the strategy in the Business Process.

  • Unload does not delete the Virtual Routing Point; it only makes the strategy inactive in the Business Process. As a performance consideration in a large environment, Unload could save time later when you need to activate multiple strategies onto the existing Routing Points.

  3. If multiple strategies are listed, select the strategies that you want to deactivate or unload.

  4. Click the button for the desired action.

Warning! IRD does not display a confirmation prompt. After you click the desired button, the dialog box closes, and IRD performs the action.


Designing Business Processes > Using Business Processes

Enabling Queues to Accept Interactions

To enable Queue objects in a Business Process:

  1. In the Workflow Viewer, double-click the Queue object. The Queue Properties dialog box opens.

  2. Select the Enabled check box, if it is not already selected.

By default, this check box is selected for a new Queue object.

You can also enable the Queue object from Configuration Manager.

To close the dialog box and save your changes:

  • Click the Close button (X) in the upper-right corner of the dialog box.


Designing Business Processes > Using Business Processes

Enabling Workbins to Accept Interactions

To enable Workbin objects in a Business Process:

  1. In the Workflow Viewer, double-click the Workbin object. The Workbin Properties dialog box opens.

  2. Select the Enabled check box, if it is not already selected.

By default, this check box is selected for a new Workbin object.

You can also enable the Workbin object from Configuration Manager.

To close the dialog box and save your changes:

  • Click the Close button (X) in the upper-right corner of the dialog box.


Designing Business Processes > Using Business Processes

Using the Find Command

  1. From the Edit menu, select Find. The Find dialog box opens.

The following table describes the options in the Find dialog box.

Find What | Enter the text that you want to search for.
Match Case | Select to apply case sensitivity to the search.
Substring Search | Select to search for the object with a name that contains the text entered in the Find What text box.
Namespace Relative Names | Select to search for the object based on its decorative name (the name as it appears in the Interaction Design window), instead of by its internal name (the name of its configuration object as it appears in Configuration Manager).
Configuration Object Names | Select to search for the object based on its internal name (the name of its configuration object as it appears in Configuration Manager).
Workflow Elements | Select one or more types of workflow elements that you want to search for: strategies, queues, views, or workbins.

  2. Enter the search text in the Find What text box, and specify the search parameters.

  3. Click OK. The search is performed, and the results appear on the Search Results tab of the Log Viewer.

  4. Double-click each item in the list to highlight the object in the Object Browser. You can also press F4 or Shift+F4 to navigate from one item to the next.


Designing Business Processes > Using Business Processes

Testing Business Processes

The following are some tests that you can perform on a Business Process or a series of linked Business Processes:

  • Set up an e-mail client, and send e-mails to the corporate account.

  • Launch the Agent Desktop application, and verify that it receives the e-mails.

  • Launch the Supervisor Desktop application, and watch the e-mails progress through the e-mail queues.

  • Initiate an outbound e-mail from the Agent Desktop; then, go to the Supervisor Desktop and watch the e-mail progress through the e-mail queues.


Compiling, checking, and Debugging

Compiling, checking, and Debugging: Overview

Interaction Routing Designer has three processes that enable you to test the validity and usability of strategies:

  • Check Integrity locates invalid references to objects that have been deleted, moved, or renamed and are therefore no longer accessible.

  • Compile checks for invalid structure, such as the omission of a required connector.

  • Debugging enables you to walk step-by-step through a strategy so that you can locate syntax errors and logic problems.


Compiling, checking, and Debugging

Compiling a Strategy

The Compile command generates a compiled version of the strategy. When you compile a strategy, Interaction Routing Designer (IRD) automatically checks its structure. If any of the following problems are encountered, a warning message appears.

  • More than one Entry object

  • The input port of an object is not connected to another object

  • Required fields in an object's properties dialog box are empty

  • The output port of an object is connected to the input port

Note: IRD does not automatically save a strategy when you compile it. In order for the strategy to appear in the Strategies list, you must save it. You can save a strategy even if it does not compile without errors.

To compile a strategy:

  1. From the Routing Design window, click Compile or select Compile from the Tools menu, or press the F7 function key.

  2. Check the status bar at the bottom of the main window for progress.

    If the strategy cannot compile, IRD displays an error message. The object with the error is highlighted in red. Double-click the object to check for and correct errors.

  3. After successfully compiling the strategy, you can load it.

Notes:

  • Two temporary files, a .str and a .ooo file, are generated every time a strategy is compiled. The .str file is different from the .rbn file created when you save a strategy. The .str file is stored in the importstr directory where IRD is installed.

  • To compile a strategy, you must have read/write permission for the importstr directory.

  • The .str file is deleted immediately after you click OK in the compilation results message dialog box.

  • When you click OK in an object's properties dialog box, IRD sets all object properties to a value. In the case of an empty field, IRD sets this value to zero (0). IRD detects whether or not all required fields were filled in after you click OK. If, after you click OK, IRD detects that one or more required fields are empty, strategy compilation generates an error. (A compilation error does not occur if you click OK and one or more non-required fields are empty.) When you open an object's properties dialog box, do not enter values in any fields, then click Cancel, these actions also generate a compilation error. In this case, IRD assumes that one or more required fields were left empty.

See also:

Saving a Strategy

Configuring Object Properties

Checklist for a Valid Strategy


Checking Invalid References: Overview

Compiling, checking, and Debugging

Checking for Invalid References

An invalid reference is an object used in a strategy that is not present in Configuration Server.

  • IRD can automatically check a strategy for invalid references.

  • You can use the Check Integrity feature to obtain more detailed information about the invalid references.

IRD identifies any objects that contain invalid references by highlighting those objects with a red border. The errors for objects with invalid references are listed in the Errors in Strategy Output pane.

Warning! A strategy can be loaded even if it contains invalid references. You must resolve all invalid references in objects before loading a strategy.

In the Strategies list, IRD marks any strategy that contains an invalid reference with a red X ( [image]).


Compiling, checking, and Debugging

Checking References Automatically

When you are running IRD in Check Integrity mode, it automatically checks for invalid references. An invalid reference is an object used in a strategy that is not present in Configuration Server. Invalid references can refer to targets, skills, subroutines, routing rules, business rules, attributes, and interaction data.

  • IRD has two modes of operation: Normal and Check Integrity. You can toggle from one mode to the other by selecting the mode you want from the View menu. IRD automatically checks references only when you are in Check Integrity mode.

Note: When you are in Check Integrity mode, you cannot edit a strategy that has been loaded on a route point. To edit a loaded strategy, switch to Normal mode.

  • Highlight a strategy containing an invalid reference in the Strategies list to have IRD display the name of the invalid reference in the Details Output pane. If a strategy contains an invalid reference, the Strategy List view in IRD displays a red X over the strategy icon ( [image]).

  • To find the exact location of the invalid references, use the Check Integrity feature.


Compiling, checking, and Debugging

Checking References Using Check Integrity

You can locate invalid object references within a saved or compiled strategy using the Check Integrity tool.

Notes:

  • When a call should be routed to a Resource under a different Tenant using the Switch-to-Strategy routing object, the Check Integrity function always returns an error.

  • When Check Integrity mode is on, you cannot open or edit a loaded strategy.

  • Before checking strategy integrity, save your changes.

If you do not save your changes before using the Check Integrity tool, this error message appears: "Check Integrity Operation aborted."

  • If the Check Integrity tool is not available select View > Check Integrity to activate the tool. When the Check Integrity command is activated, all strategies and objects are automatically checked. While IRD performs the check, you cannot perform any other operation. The Progress Bar indicates the progress of the integrity checking.

  • Use the Compile command to check for strategy syntax errors. Use the Debugger to check for strategy logic problems.

  • Turn off Check Integrity when updating permissions applied to a large number of objects. If Check Integrity is turned on, it could take a long time to update permissions; for example, from No Access to Full Control.

To use the Check Integrity tool:

  1. Open a strategy.

  2. If you made any changes to the strategy since it was last saved or compiled, save the strategy again.

  3. Click Check Integrity ( [image]) in the toolbar.

    Each object containing an invalid reference is highlighted with a red border in the Routing Design window, and the invalid references are explained in the Errors in Strategy output pane below the Routing Design workspace.

  4. Double-click a red-outlined object to open its properties dialog box.

  5. Make corrections to the object as required.

    The red outline disappears when you close the properties dialog box for the corrected object.

Note: Use the Search or the Search and replace capabilities to search for all occurrences of an invalid reference.

See also: Checklist for a Valid Strategy


Compiling, checking, and Debugging

Checklist for a Valid Strategy

The following checklist of rules should be used for creating a complete, functional, and valid strategy.

  • There should be only one Entry object in the strategy.

  • The Entry object should always be connected to another object. If it is not connected, the rest of the strategy cannot be used, and all interactions are routed to the default destination.

  • Every object should have its input port connected to some other object, except for the Entry object which has no input port.

  • Properties must be defined for every object that has a properties dialog box.

  • You can only connect postrouting objects, such as Attach or Database Wizard, after each routing object. It does not make sense to have one routing object after another. For a list of objects that cannot be used in postrouting, see Routing Phase.

Note: You are not required to use another object after a routing object.

  • Every branch of a strategy should end with a routing object that specifies a target, including default routing.

Note: If an interaction is directed to an output port that is not connected to another object, the interaction is routed to the default destination.

  • It is good practice&emdash;but not mandatory&emdash;to connect the green output port of every Routing object to the Exit object. The green output port of other objects can be connected to the Default object.


Compiling, checking, and Debugging > Debugging

debugging: Overview

Debugging enables you to check a strategy for logic errors that prevent routing from occurring the way you intended.

Integrity checking and compiling enable you to locate other types of errors in strategies. Before loading a strategy in a testing environment, go through the validation checklist to make sure you have a workable strategy.

To use the debugger, see:

  • Debugging Strategies

  • Using the Debug Buttons

  • Example of a Debug Session


Compiling, checking, and Debugging > Debugging

Debugging Strategies

IRD contains a strategy Debugger. This tool enables you to manually execute a loaded strategy object-by-object, locating and resolving syntax errors and logic problems. Using the debug buttons, that become enabled when a debugging session opens, you can walk through a strategy and its subroutines to locate points at which the strategy is not handling interactions as you had intended.

In order to run the Strategy Debugger, you must be running v. 7.x of the following Genesys software components: Universal Routing Server, Configuration Server, and Message Server.

  • If IRD opens a 6.x strategy, you can debug it.

  • Before running the Debugger, close all open strategies. If you do not close all strategies before debugging, you will receive an error message instructing you to close all edited strategies before the debug process.

Running the Debugger

Warning! Do not use the Debugger in your production environment. To do so will cause interactions generated by the Debugger to appear on reports.

To start a debug session in your test environment:

  1. Load the strategy.

  2. Make sure that Universal Routing Server, Configuration Server, and Message Server are running (DB Server does not need to be running). The lights in the tabs at the bottom of the window (Connections, Configuration, and Monitoring) must be green for the Debug menu selection to be available.

  3. Right-click the strategy in the Loading list and select Debug from the context menu.

  4. In the Debug dialog box's Call properties tab, enter values for the various parameters. For example, enter a Caller Entered Digits (CEDs) to send the interaction along a route you want to test. If predefined values exist for any parameters, they appear in a drop-down list that opens when you click in the appropriate row in the Value column.

  5. Click the User Data tab in the Debug dialog box.

  6. If applicable, enter any customer information used by the strategy. This can be data input by the customer or data from a database lookup.

  • For each piece of customer information, click Add Item ( [image]) and add the data.

  • If you make a mistake, delete the item by clicking Delete Item ( [image]).

  7. When you have completed the Debug dialog box, click OK. The strategy appears in the Routing Design window with the strategy name at the top. The debug buttons are enabled. The Entry object is outlined in red.

  8. Use the debug buttons to step into and over objects during the debug session.

Notes:

  • The Step Out Of button is intended only for subroutine debugging. If you click it in the main strategy, you exit the debug session.

  • You can view the content of any object by double-clicking it, but you cannot edit the object in the Debugger with one exception. If an object uses a variable, you can edit the variable content. For example, if the routing strategy uses the Assign object, which assigns a value to a variable, you can edit the value of the variable.

  9. If the debugger needs information input in order to execute an object, a dialog box opens. You must enter any requested Input/Output values. Using the Error tab, you can set the debugger to emulate failure scenarios.

For example, if the current object is a routing target Selection object, you are prompted to specify whether the target was selected inside the object. If yes, you are prompted for the target name.

Note: When debugging a Database object, the complete Select statement appears in the Input/Output tab, including the requested database, tables, and fields. If you wish to change the Select statement, you must do so outside of the Debugger.

  10. Click the Errors tab to have debugger imitate failure scenarios so you can see how the strategy will work when placed in your actual production environment. For example, if the Selection object cannot find a ready target, an error occurs. You can select any error that might happen to an actual interaction. Click the Emulate function error check box to select the type of error.

  11. Click OK in the strategy debugging dialog box to close it and have the debugger execute the object according to your settings.

  12. When prompted to end your debug session, click OK in the message box that appears. You can also manually terminate the session using the Stop Debug button.


Compiling, checking, and Debugging > Debugging

Using the Debug Buttons

The debug buttons become enabled during a debug session. After you load a strategy, select Debug from the context menu, and complete the Debug properties dialog box.

Step Into

Used if the current object is a Call Subroutine object as a way to suspend debugging of the current strategy and start debugging the subroutine.

Step Out Of

Used when a subroutine is debugged as a way to finish debugging the subroutine and return to the calling strategy. Using this button in the main strategy exits debug mode

Step Over

Used to execute the current object and go to the next one.

Stop Debug

Terminates the debug session.


Compiling, checking, and Debugging > Debugging

Example Debug Session

At the start of the debug session, the Entry object is highlighted in red.

  • Click the Step over button to execute the next object in the strategy.

Note: Use the Step into button only if the current object is a Call Subroutine object. Step into suspends debugging of the current strategy and starts debugging the subroutine.

For example, if you are debugging the strategy shown below, you would perform the following steps:

  1. Enter a valid CED of 2 in the Call Property tab, which opens when you start the debug session.

  2. From the Entry object, click the Step over button to move to the Segmentation object.

  3. Click the Step over button again to move to the next object. Because your Segmentation object is using the value of the CED to segment, you proceed to the Selection object associated with that CED. In this case, your CED of 2 means that you speak English and Russian rather than English and Latvian.

  4. Click the Step over button again. A dialog box with the strategy name at the top opens requesting values.

  5. Enter requested values. In this case, the required value is the target to which the interaction should be sent.

  6. If you wish to emulate errors, complete the Errors tab, then click OK.

The error target Selection object is highlighted.

  7. Click the Step over button again. A message box appears indicating normal completion of the debug session.

  8. Click OK in the message box to close the debug session.


Loading, Scheduling, and monitoring Strategies

Loading, Scheduling, and Monitoring Strategies: Overview

A strategy is not active until it has been loaded on a routing point or group of routing points.

  • For voice routing strategies, loading is done in IRD Loading View (one routing point) or Group Loading view (group of routing points).

  • For non-voice routing strategies, loading is done with the Strategy Activation Wizard in the Interaction Design window, which automatically creates virtual routing points. For more information, see Activating Strategies or the Universal Routing Business Process User's Guide.

The same strategy can be loaded on multiple routing points. However, only one strategy can be loaded on each routing point.

Notes:

  • For DNs with the event_arrive option configured, IRD supports loading voice routing strategies to the following DN types only: Routing Point, Virtual Routing Point, Service Number, Voice Treatment Port, and Routing Queue.

  • Genesys recommends that you do not load a strategy to, or release one from, a very large number of Service Numbers/Routing Points (500 or more) at once; otherwise, IRD might occasionally stop responding and then start running again.

Loading Strategies When Using Load Distribution Server

If IRD detects that the specified Universal Routing Server (URS) is connected to T-Server through Load Distribution Server (LDS), it locates every instance of URS that has the same LDS in the Connection tab of its Configuration Layer Application object. IRD then loads the strategy on every associated URS.

Releasing the strategy is performed in the same way.

If you are not using LDS, the strategy is loaded on a single instance of URS.

Note: This functionality is implemented only for loading on a single routing point. It is not supported for Group Loading.

Scheduling Strategy Loading

You can use scheduling to have a strategy automatically loaded on a route point at a specified time. For example, you might want to have a new strategy take effect at midnight before a holiday weekend. By scheduling, you avoid having to manually load the new schedule at midnight.

See Scheduling Strategy Loading for detailed information on scheduling.

Monitoring Strategies

Monitoring provides you with a real-time look at how interactions are being routed. You can monitor:

  • All interactions that come through a particular route point.

  • All interactions routed by a particular strategy. In this case, the monitoring view includes interactions on all routing points on which the strategy is loaded.

See Monitoring Strategies for detailed information on monitoring.


Loading, Scheduling, and monitoring Strategies

Loading on One Routing Point

To load a voice routing strategy on one routing point:

  1. From the Shortcut bar in the IRD main window, click the Monitoring bar, then click Loading.

    The Loading List view displays, showing all the Universal Routing Servers (URSs) in Configuration Manager.

  2. Click the applicable URS, and expand it to see a list of switches.

  3. Click a switch, and expand it to see a list of all possible routing points.

    Note:     Disabled routing points do not appear in the list of possible routing points. These routing points reappear when they are enabled.

  4. Select the route point or route points you want to use for the strategy. Hold down the Control key to select multiple routing points.

  5. Load the strategy using one of these three methods: Select Load Strategy from the Main window Tools menu; press CTRL+L; or right-click a URS or a route point and select Load Strategy.

  6. Select the strategy you want to load, then click OK.

    Click the Routing Design shortcut bar then click Strategies to open the Strategies list. Check the Output pane in the Strategy List view for information or errors about the loading status of the strategy.

Notes:

  • If you are loading a new strategy over an existing strategy on the same routing point, the older strategy is automatically released. URS continues to process any current interactions using the older strategy until all interactions using this strategy are routed. Then the older strategy is deleted from memory.

  • If you are using Load Distribution Server (LDS), IRD loads the strategy on every URS that has the same LDS in the Connections tab of its Configuration Layer Application object.

You can also:

  • Schedule strategy loading

  • Monitor a strategy.


Loading, Scheduling, and monitoring Strategies

Loading on a Group of Routing Points

To load a strategy on a group of routing points:

  1. From the Shortcut bar in the IRD main window, click the Monitoring bar, then click Group Loading.

    The Group Loading List view opens, showing all the groups of routing points.

    Note:     For information on creating DN Groups of routing points, see Framework 7.6 Configuration Manager Help.

  2. From the drop-down menu on the left, select the Tenant. If you are in a single-tenant environment, you have only the one tenant listed.

  3. Select the primary Universal Routing Server from the drop-down list.

  4. Select the group, or switch within the group, on which you want to load the strategy.

  5. Load the strategy using one of these three methods: Select Load Strategy from the Main window Tools menu; press CTRL+L; or right-click the group, or switch within the group, and select Load Strategy.

Notes:

  • If a group contains disabled route points, they do not affect the loading of the strategy on other routing points in the group.

  • If another strategy is loaded on that group of routing points, it is automatically released when you load another strategy. Genesys recommends that you load one strategy onto another without releasing the first because in this way you avoid having interactions default routed during the changeover.

  6. Select the strategy you want to load, then click OK.

    Check the Output pane Details tab in the Strategies List view for information or errors on the loading status of the strategy.

Note:

  • If you are loading a new strategy over an existing strategy on a group of routing points, the older strategy is automatically released. URS continues to process any current interactions using the older strategy until all interactions using this strategy are routed. Then the older strategy is deleted from memory.

You can also:

  • Schedule strategy loading

  • Monitor a strategy.


Loading, Scheduling, and monitoring Strategies

Releasing a Strategy

You do not need to release a strategy from one routing point or a group of routing points before you can load another strategy. However, you must release a strategy if you want to view or edit it, unless you create a copy first.

Warning! Releasing a currently loaded strategy is not recommended while interactions are remaining in the queue. Any interaction received during the time interval between releasing the strategy and loading the new strategy will be routed to the default destination. If you want to load a different strategy to a routing point, Genesys recommends that you load the new strategy without releasing the existing one.

To release a strategy from one route point:

  1. From the Shortcut bar in the main window, click the Monitoring bar, then click Loading.

    The Loading List view opens, showing all the Universal Routing Servers (URSs) in Configuration Manager.

  2. Select a URS and expand the list to see the route points for the URS.

  3. Identify the route point for the strategy you want to release. Hold down the Control key to select multiple route points.

  4. Release a strategy using one of these three methods: select Release Strategy from the Main window's Tools menu; press CTRL+R; or right-click the route point and select Release.

To release a strategy from a group of route points:

  1. From the Shortcut bar in the main window, click the Monitoring bar, then click Group Loading.

    The Group Loading List view displays, showing the DN groups in Configuration Manager.

  2. Select the group, or switch within the group, for the strategy you want to release.

  3. Release a strategy using one of these three methods: select Release Strategy from the Main window's Tools menu; press CTRL+R; or right-click the group or switch and select Release.


Scheduling Stategy Loading Overview

Loading, Scheduling, and monitoring Strategies > Scheduling Strategy Loading

Scheduling Strategy Loading: Overview

A schedule instructs Universal Routing Server (URS) when to automatically load or release a specific strategy, including the switch and DNs to use.

Schedules are stored in Configuration Manager as Script objects of type Schedule.

Note: In order for scheduling to work, URS must be connected to Configuration Server. You create and load schedules in IRD.

  • Creating a Schedule

  • The Schedule Item Dialog Box

  • Time Formats for Scheduling

  • Loading a Schedule


Loading, Scheduling, and monitoring Strategies > Scheduling Strategy Loading

Creating schedules

A schedule instructs Universal Routing Server (URS) when and where to automatically load or release specified strategies. You can specify times for loading and releasing schedules using seconds, minutes, hours, dates, months, years, and days. Schedules are stored in Configuration Manager as Script objects of type Schedule.

Warning! Releasing a currently loaded strategy is not recommended while interactions are remaining in the queue. Any interaction received during the time interval between releasing the strategy and loading the new strategy will be routed to the default destination. If you want to load a different strategy to a routing point, Genesys recommends that you load the new strategy without releasing the existing one.

To create a new schedule:

  1. Click Schedules from the Routing Design shortcut bar or select Schedules from the View menu.

  2. From the File menu, select New; or right-click any folder or subfolder on the List pane; or right-click a column header on the List pane. The Schedules dialog box opens.

  3. Enter a name and a description (optional) for the new schedule. A description is recommended to distinguish the schedule from other schedules with similar names.

  4. In the Schedule section of the dialog box , click Add Item [image] .

  5. Complete the Schedule Item dialog box.

  6. When you have completed the Schedule Item dialog box, click OK. Schedule instructions appear in the Schedule items pane.


Schedule Item Dialog Box

Loading, Scheduling, and monitoring Strategies > Scheduling Strategy Loading

The Schedule Item Dialog Box

After you start creating a new schedule, the Schedule Item dialog box opens. Use this dialog box to specify when the schedule should be loaded (or released) on which route points or DNs.

Warning! Schedules are not checked for integrity or compilation errors. If you use an invalid schedule to load a strategy, IRD shows the schedule is loaded, but the following message is written to the URS log file:

  • <Schedule_name> cannot be loaded for <tenant_name>. Reason: incorrect schedule source

To complete the Schedule Item dialog box:

  1. Open the Schedule Item dialog box. The top section, used to enter the time at which the schedule is to be loaded or released is shown below.

  2. Enter the appropriate time values in each text box. You can enter values that specify complex loading schedules, such as having the schedule loaded and then released several time during the course of a single time period. See the Time Formats for Scheduling topic for instructions on how to enter these values.

  3. Select whether to Release or Attach (load) the strategy controlled by the schedule you are creating, as shown in the following figure.

If you select Attach (which means load), a Strategy drop-down list appears. If you are releasing a strategy, you do not need to specify which one you are releasing.

  4. Click the Strategy down arrow and select the strategy for which you are creating a schedule.

  5. Click Add Item [image]. The Routing Points dialog box opens, showing the DNs tab.

  6. Select a Switch. Once you select a Switch, its associated routing points appear in the DN numbers list.

  7. Select the routing points on which to load, or from which to release, the selected strategy. Hold down the Shift key to select multiple routing points.

  8. Click OK. The Routing Points pane of the Schedule Item dialog box now shows the routing points you selected.

  9. Click OK. The Schedules dialog box appears with your new scheduling instructions listed in the Schedule Items list.

See also: Loading a Schedule


Loading, Scheduling, and monitoring Strategies > Scheduling Strategy Loading

Time Formats for Scheduling

The time settings in the Schedule Item dialog box instruct IRD when to load or release a strategy. When entering time settings, you have the option of entering values for all time units or only one time unit.

If you specify only a day or day of the week, the schedule loads at 12:00 am on the specified day. In the case of Day of the Week, it loads at 12:00 am on the next occurrence of the specified weekday. If you specify only a month, the schedule loads at 12:00 am on the first day of that month.

  • For example, assume you enter 2006 in the Year field and do not enter values any other fields. URS loads the strategy at 12:00 am on January 1 of 2006. If you also enter 1 in the Min field, URS loads the strategy at 12:01 am on January 1 of 2006.

Note: An asterisk in a field = 0, which is the default.

To enter time values in the Schedule Item dialog box:

  1. Enter a number from 0–59 in the Sec (seconds) text box.

  2. Enter a number from 0-59 in the Min (minutes) text box.

  3. Enter a number from 0-23 in the Hour text box.

  2. Enter a number from 1–31 in the Day field.

  3. Enter a number from 1–12 in the Month field.

  4. Enter a year or year range in the Year field. Example: 2006–2007 indicates 2006 through 2007.

  5. Enter a number from 0–6 in the Day of week field (0 means Sunday).

Note: The schedule file time format is:

<seconds> | <minutes> | <hour> | <day> | <month> | <year> | <day_of_week> |

where each line of the schedule file indicates a certain action (including when a strategy should be attached (loaded) on or released from a routing point). The "|" symbol is a delimiter of the time fields.

For example, you can create one schedule to have URS load a strategy that is effective when the office is closed (6 PM - 8 am M-F) and load a work-day strategy for regular business hours (8 am - 6 PM M-F). The schedule is configured with two schedule items. They have these time parameters:

0 | 0 | 18 | * | * | * | 1-5 | (to load the office-closed strategy)

0 | 0 | 8 | * | * | * | 1-5 | (to load the work-day strategy)

Each schedule item attaches (loads) a different strategy. Every business day the URS on which you loaded this schedule loads the work-day strategy at 8 am and then loads the office-closed strategy at 6 PM. Over the weekend, the office-closed strategy continues to apply, because the work-day strategy does not replace it until Monday at 8 am.


Loading, Scheduling, and monitoring Strategies > Scheduling Strategy Loading

Loading a Schedule

After creating a schedule, you must load it on a Universal Server (URS).

  • Before loading a schedule, verify that you have the appropriate security permissions configured in Configuration Manager to enable you to load a schedule.

  1. From the Shortcut bar in the IRD main window, click the Monitoring bar, then click Loading.

  2. The Loading List view opens, showing all the Universal Routing Servers (URSs) in Configuration Manager.

  3. Right-click the URS that handles the routing points on which the schedule is to be loaded or from which it is to be released.

  4. Select Load Schedule or Release Schedule.

Note: Each URS can have only one schedule loaded on it.


Monitoring Strategies Overview

Loading, Scheduling, and monitoring Strategies > monitoring Strategies

Monitoring Strategies: Overview

Monitoring provides you with a real-time view of how interactions are being routed. You can monitor interactions at the URS level, at the routing point level, or at the strategy/subroutine level using the Trace commands. You can also view interaction counts and percentages for each object in a strategy.

Note: A strategy must be loaded before you can monitor it.

Real-time monitoring is based on notifications that IRD gets from Message Server, which receives the data from URS. This prevents monitoring from adding to—and slowing down—the processing load that URS handles. Therefore, Message Server must be running and connected to URS and IRD before you can monitor strategies.

If you have primary and backup Universal Routing Servers, their status is indicated in Loading List view by their icon color (blue indicates active; red indicates stand-by; and gray indicates URS is not running or the connection chain between URS, Message Server, and IRD is broken).

To monitor interactions, see:

  • Monitoring View: URS and Routing Points

  • Monitoring a Strategy

  • Monitoring a Strategy on One Routing Point


Loading, Scheduling, and monitoring Strategies > monitoring Strategies

monitoring View: URS and routing points

To monitor a Universal Routing Server (URS) and its routing points in Loading List view:

  1. From the Shortcut bar in the IRD main window, click the Monitoring bar, then click Loading. The Loading List view opens, showing all the URSs configured in Configuration Manager.

    Note:     You cannot use the Group Loading view to monitor interaction flow. You must use the Loading List view.

  2. Select a URS [image] .

  3. The Loading List displays total interaction counts for all routing points in this URS in the following columns: Entered, Routed, Abandoned, and In Process.

  4. A URS may contain one or more switches. Expand the URS to view all switches.

  5. Select a Switch [image] and expand it to see a list of all routing points.

    Note:     Disabled routing points do not appear in the list of possible routing points. These routing points reappear when they are enabled.

  6. For every Routing Point [image] , you can view the interaction count in the Entered, Routed, Abandoned, and In Process columns.

Notes:

An X in the Trace column does not affect the numbers shown in the Entered, Routed, Abandoned, and In Process columns. The Trace column only indicates whether tracing is on for the purpose of bringing up a Trace View window, which shows interaction counts and percentages for a single routing point or for a strategy.

URS starts calculating the numbers in the Entered, Routed, Abandoned, and In Process columns when it first starts up in Primary mode. Disabling/enabling a routing point, or stopping and then restarting URS, resets the numbers.

  7. Select the Monitoring tab in the Output pane to see status, details, and action for the selected URS.


Loading, Scheduling, and monitoring Strategies > monitoring Strategies

Monitoring a strategy

You can monitor counts for all interactions that are being routed by a particular strategy. This includes interactions on all routing points on which the strategy is loaded. To monitor a strategy, use the Trace commands to turn on tracing and open the Trace View window.

Note: A strategy must be loaded on the routing point before you can monitor it.

IRD displays the number and percentage of interactions that arrive at each object in the strategy. These numbers include all interactions that may be sent from other strategies, such as when using the Switch-to-Strategy object.

  • For example, Strategy A is loaded on 5 routing points. Strategy B loaded on 3 other routing points. Strategy B includes a Switch-to-Strategy object that sends interactions to Strategy A. In this case, the Trace View window for Strategy A shows interactions from all 8 Routing Points.

To open the Trace View window:

  1. From the Shortcut bar in the IRD main window, click the Routing Design bar, then click Strategies, or select Strategies from the View menu.

  2. In the Strategies List, right-click a strategy and select Trace On from the menu. An X appears in the Trace column. (Tracing must be on in order to select the Trace View command.)

  3. Right-click the strategy again and select Trace View from the menu. The strategy opens in the Trace View window.

Note: URS starts counting the number and percentage of interactions shown in the Trace View window from the moment you select Trace On, not from when you open the Trace View window. Or it counts from the moment you load the strategy on a route point if you selected Trace On before loading the strategy.

To clear and restart numbers in the Trace View window:

    • Select Trace Off to reset the numbers in the Trace View window to zero and tell URS to stop counting interactions.

    • Select Trace On (after numbers are cleared with Trace Off) to tell URS to start counting again. The number of interactions then starts from zero.

See also:

Monitoring View: URS and Routing Points

Monitoring a Strategy on One Routing Point


Monitoring One Routing Point

Loading, Scheduling, and monitoring Strategies > monitoring Strategies

Monitoring a strategy on One Routing Point

You can monitor interaction counts and percentages on a single routing point for the individual objects within the strategy loaded on that routing point. Interactions routed by the strategy that go through other routing points are not counted when you monitor a single routing point.

  • Monitor a routing point from the Loading List view by using the Trace commands to turn on tracing and open the Trace View window.

Note: A strategy must be loaded on the routing point before you can monitor it.

To open a routing point for monitoring:

  1. From the Shortcut bar in the IRD main window, click the Monitoring bar, then click Loading. The Loading List view appears, showing all the Universal Routing Servers (URSs) that are configured in Configuration Manager.

    Note:     You cannot use the Group Loading List view to monitor interaction flow. You must use the Loading List view.

  2. Select a URS [image] and expand it to see its switches and then select a switch [image] and expand it to see its routing points.

    Note:     Disabled routing points do not appear in the list of available routing points. These routing points reappear when they are enabled.

  3. Right-click a routing point and select Trace On from the menu. An X appears in the Trace column. (Tracing must be on in order to select the Trace View command.)

  4. Right-click the routing point again and select Trace View from the menu. The strategy loaded on the routing point appears in the Trace View window.

Notes:

IRD begins to count interactions from the moment you select Trace On for the routing point or from the moment a strategy is loaded on the routing point if this routing point already had Trace On selected.

IRD counts only interactions from this routing point. The numbers and percentages do not include:

  • Interactions routed by the same strategy but located on different routing points.

  • Interactions on this routing point, but controlled by a different strategy than the one loaded on this route point. This can occur if an interaction arrives as a result of a Switch-to-Strategy object in another strategy.

To clear and restart numbers in the Trace View window:

  • Select Trace Off to reset the numbers in the Trace View window to zero and tell URS to stop counting interactions.

  • Select Trace On (after numbers are cleared with Trace Off) to tell URS to start counting again. The number of interactions starts from zero.

See also:

Monitoring View: URS and Routing Points

Monitoring a Strategy


Editing and Managing Strategies

Editing And Managing Strategies: Overview

Once you have created a strategy, you can

  • Edit the strategy, edit text in dialog boxes, or edit the strategy description.

  • Create a copy.

  • Back up the strategy or restore a previous version.

  • Preview or print the strategy.

  • Change the strategy storage location.

  • Modify subroutine input/output parameters.

  • Establish access control for the strategy.

  • Load and release the strategy.

  • Monitor the strategy.

  • Rename the strategy using save as.

  • Search for objects used in the strategy.

See also: Debugging


Editing and Managing Strategies

Editing a Strategy

Warning! IRD allows a strategy loaded on a route point to be edited if the Check Integrity feature is off (that is, you have selected Normal mode from the View menu). However, to avoid the potential for invalid routing, Genesys recommends you first create a copy of the strategy, edit and test the copy, and then move it into your production environment.

To edit a strategy:

  1. If you want to save the current version, back it up now.

  2. If the current version is loaded to a route point, create a copy of the strategy, and then open the copy.

  3. Open the strategy in the Routing Design window.

  4. Make changes to the strategy as needed.

  5. Save the strategy.

  6. Load the edited strategy on top of the existing strategy on the current route point.

    Warning!     Do not release the existing strategy. If you release an existing strategy, all interactions are routed to the default destination. When you load one strategy on top of another, URS uses the original strategy to route the interactions that started processing before the new strategy was loaded. After the new strategy is loaded, URS routes newly submitted interactions to the new strategy.

Notes:

  • Universal Routing Server (URS) starts to use an updated strategy for routing interactions as soon as the strategy is updated.

  • When updating strategies, URS keeps all versions of the same strategy in memory and active simultaneously. This enables URS to continue processing any current interactions using the older version and prevents the routing of these interactions to the default destination. After all interactions using the older version of a strategy are routed, the older version is deleted from memory.

  • See the Details tab (on the Output pane, below the List pane on the main window) for information about when the strategy was created and updated and whether it is loaded on a routing point.

See also:

Editing Text in Properties Dialog Boxes

Configuring the Busy Tab for Routing Rules

Checklist for a Valid Strategy

Strategies List

Output Pane


Editing Text in Dialog Boxes

Editing and Managing Strategies

Editing Text in Properties Dialog Boxes

When working in the properties dialog boxes, right-click from any text box to access a text editing menu. Text editing menus have the following commands:

Undo | Cancels the last text editing operation
Cut | Removes the selected text and moves it to the clipboard
Copy | Makes a copy of the selected text and moves it to the clipboard
Paste | Moves a copy of the text from the clipboard to the text box where you cursor is located
Delete | Deletes the selected text in the text box
Select All | Selects all text within the text box


Editing and Managing Strategies

Copying an Object

If you want to copy an object (strategy, subroutine, routing rule, business rule, attribute, or interaction data), use the Create Copy command.

This function is especially useful if you want to edit a strategy that is loaded to a route point and you do not want to release it, or if you want to create a new strategy based on the existing one.

Note: You cannot copy objects using Edit menu commands.

To copy an object:

  1. Select the object from the List pane.

  2. Right-click on the object and select Create Copy from the shortcut menu. The Copy dialog box opens.

  3. In the Copy dialog box, keep the default "Copy Of" name or rename the object.

  4. Click the ... button next to the RBN File Path text box to change the storage location.

  5. Click the Config. Layer Location tab to see where the strategy is stored in the Configuration Layer. To change this location:

    1. Click in the Tree text box.

    2. Select the desired location from the tree view that appears.

  8. Click OK. The newly created copy appears on the object list pane.

You can now edit the copy without affecting the original object.


Preview-Print a Strategy

Editing and Managing Strategies

Previewing/Printing a Strategy

To preview a strategy before printing it:

  1. Open the strategy in the Routing Design window.

  2. From the File menu, click Print Preview.

  3. Use the Zoom buttons to adjust the view.

  4. If you want to print, click Print from the toolbar.

To print a strategy:

  1. Open the strategy.

    Note: If you have already configured Page Setup, you can skip Steps 2 and 3.

  2. From the File menu, click Page Setup.

Notes:

  • Selecting and saving options from the Size drop-down list that require significant changes to the layout in the Routing Design window (such as a very large zoom) may negatively impact IRD performance when you open and close the strategy.

  • Page boundaries that you set when configuring Page Setup are stored in the strategy .rbn file. As a result, you may receive a Save changes message when closing a strategy after previewing or printing it, even if you made no changes to the strategy.

  3. Choose the options you want, then click OK.

  4. From the File menu, choose Print.

  5. Select the page numbers and the number of copies you want to print, then click OK.

Note: If the option, Show Description of Objects on Graphic is selected in the Routing Design Options dialog box, object labels also print.


Editing and Managing Strategies

Changing Strategy Storage Location

After you create a strategy or subroutine and save it, you can later change the save location:

  1. Open the strategy or subroutine in the Routing Design window.

  2. From the File menu in the Routing Design window, select Save As.

In the resulting Save As dialog box, you can:

  • Save to a different Scripts folder (or subfolder) in the Configuration Layer.

  • Save the .rbn file to a different network path or to the database (if the IRD Application object contains a Data Access Point (DAP) in its Connections list).

  • If you wish to change from a network drive to the database, select the save to database check box. This deactivates the RBN File Path text box.

  • If you wish to change from the database to a network drive, clear the save to database check box, and then enter or browse for a network path in the RBN File Path text box.

  • To store on both a network drive and in the database, use the Save As function to save the strategy under another name in a different location.

Warning! A strategy or subroutine (.rbn file) should not be shared by multiple Configuration Servers. This occurs if you import a strategy or subroutine from the same storage location used by one Configuration Server into another Configuration Server. If you make changes, the script object for the strategy or subroutine changes in both Configuration Servers. To prevent changes to both script objects, copy the .rbn file to another location and import that strategy or subroutine into the second Configuration Server.


Editing and Managing Strategies

Editing a Subroutine

You can configure an unlimited number of subroutine input and output parameters.

To modify the list of input/output parameters for a subroutine open in the Routing Design window:

  1. From the File menu, select Describe. A dialog box opens where you can change the description.

  2. Change the description if desired then click Next. The Input parameters dialog box appears. It enables you to add, delete, or modify input parameters.

  3. To add a new input parameter, click the Add Item ( [image]) button. To delete a parameter, select the parameter and click the Delete ( [image] ) button.

  4. When you are finished, click Next. The Output parameters dialog box appears. It enables you to add, delete, or modify output parameters

  5. To add a new output parameter, click the Add Item ( [image]) button. To delete a parameter, select the parameter and click the Delete ( [image] ) button.

  6. When you are finished, click Finish.

When URS executes a subroutine, it checks that the number of parameters passed to (and expected from) a subroutine corresponds to the number of parameters that the subroutine expects to receive and return. If the numbers do not correspond, URS returns an error.


Editing and Managing Strategies

Renaming a Strategy or Subroutine

To change the name of a strategy or subroutine, use the Save As function.

Note: You cannot rename other objects using menu commands. To rename them, double-click the object on the List pane and then change the name in the properties dialog box.

To rename a strategy or subroutine:

  1. Open it in the Routing Design window.

  2. Select Save As from the File menu. This opens the Save As dialog box.

  3. Change the Strategy Name field.

  4. Click OK.

Note: In IRD 6.5.x, renaming was performed using the Rename command. In IRD 6.5.1 and 7.x, the Rename command is no longer supported. It has been replaced by the Save As command.


Editing and Managing Strategies

Deleting an Object

To delete an object in Interaction Routing Designer, select the object and press Delete on the keyboard.

Note: Objects cannot be deleted using menu commands. An .rbn file cannot be deleted after you delete the strategy.


Editing and Managing Strategies > Searching within Strategies

Searching Within Strategies: Overview

You can search for text strings or find and replace routing rules within a strategy. You have two tools for performing these actions:

  • Search [image] .

Select the Selection check box to limit the search to specified objects.

  • Find and replace [image] .

Note: You can only search in one strategy at a time. Within the strategy, you can limit the search to specified objects.


Editing and Managing Strategies > Searching within Strategies

Searching for Text Strings

This tool enables you to search for text strings used in a strategy, in its objects, rules, functions, and so on.

To search for a text string:

  1. Open the strategy from the Strategies List pane.

  2. In Routing Design window, click Search ( [image] ) on the tool bar.

    The Find dialog box appears.

  3. Type the name of the object into the Find what field.

    Warning!     This feature is case sensitive. You must enter the name or text string exactly as it appears in the strategy.

  4. If you only want to search for an exact match, select the Match whole word only option.

  5. Click Find now.

    The Find in Strategy tab of the Output pane appears below the Routing Design window's workspace and lists the occurrences of the text string.

  6. Double-click the Debug line on the Output pane.

    The object containing the search item is outlined in red in the strategy.

    Note:     You can move through the list of string occurrences using the Arrow keys on your keypad or the F3 function key. The object containing the text string is outlined in red as you move through the list.

  7. Double-click the red-outlined object to open its properties dialog box and locate the desired text string.

    Note:     The outline disappears when you close the properties dialog box.


Editing and Managing Strategies > Searching within Strategies

Searching For and Replacing Routing Rules

You can search for and replace a routing rule of one type with another routing rule of the same type.

  1. Open the strategy from the Strategies List pane.

  2. Click Find and replace ( [image] ) on the Routing Design window toolbar.

The Find and Replace dialog box appears.

  3. Select the rule from the Routing rule drop-down list.

  4. Select the replacement rule from the Replace with drop-down list.

  5. Click Find next to find the next occurrence of the routing rule and Replace to replace it. The object that contains the rule is outlined in red.

Click Replace all only if you want to replace all occurrences of the routing rule. If Replace all is used, IRD provides the number of times the rule was replaced.


Sharing Strategies

Editing and Managing Strategies > Sharing Strategies

Sharing Strategies: Overview

Sharing a strategy with people on a different network and/or using a different Configuration Database is a three-step process.

  1. Export all strategy components in the original environment to a strategy-moving file. This can be in .zcf (archive), .xml (open), or .kvl (text) format.

See Components of a Strategy for the objects that are—and are not—included in the strategy-moving file.

Note: If you use the .xml or .kvl format, only the strategy file itself is exported. To export the strategy with all associated objects, you must use the .zcf format.

  2. Import the strategy components in the destination environment by unpacking the strategy-moving file to the new location.

  3. In the destination environment, create all objects required by the strategy and its subroutines that are created in applications other than IRD. For example, you may need to create Field, Format, Table Access, Person, Queue, and various other objects in the new environment.

Note: If you need technical support, please contact the support staff before proceeding.

Warning! A strategy or subroutine (.rbn file) should not be shared by multiple Configuration Servers. This occurs if you import a strategy or subroutine from the same storage location used by one Configuration Server into another Configuration Server. If you make changes, the script object for the strategy or subroutine changes in both Configuration Servers. To prevent changes to both script objects, copy the .rbn file to another location and import that strategy or subroutine into the second Configuration Server.


Editing and Managing Strategies > Sharing Strategies

Sharing Within a Network

Warning! You cannot simply copy and paste the .rbn file when sharing a strategy on the same network. This is because strategies are stored in two parts, and each part is in a different location:

  • The script portion of the strategy is stored in the Configuration Database.

  • The graphical portion (.rbn file) of the strategy is stored in the path specified in the strategy section of the Configuration Manager Annex tab.

To share a strategy with people on the same network but at different workstations:

  1. Save and compile the .rbn file (graphical portion of the strategy) in a network directory that is accessible to all users involved. If any Switch-to-strategy routing rules are used, save and compile the .rbn files of those strategies in the same network directory.

Note: To display the Annex tab in the Properties dialog box for any object in Configuration Manager, you must select View > Options > Show annex tab from the Configuration Manager menu.

  2. Specify the same access path for all of the workstations that require access to this network directory.

  3. Provide these users with access to all configuration objects used in the strategy, using one of the following methods:

  • Supply the same UserID and password to these users for accessing the same Configuration Server. This is the simplest solution, but should only be used when security is not an issue.

  • Assign a unique UserID and password to each user for accessing the same Configuration Server and the same tenant. Set up different permission levels for viewing or modifying objects depending on the user.

  • Note: To edit strategies, you must have Write access to the network directory.

Warning! A strategy (.rbn file) should not be shared by multiple Configuration Servers. When two or more Configuration Servers are involved, avoid using the same location for strategy storage. If you change a strategy, IRD will update the strategy's Script object by using the Configuration Server to which it is currently connected.

See also:

  • Components of a Strategy


Editing and Managing Strategies > Sharing Strategies

Sharing Strategies in the Database

Just as you can share strategies stored on a network drive, you can also share strategies saved in the Configuration Database.

To save a strategy in the database:

  1. Open the strategy in the Routing Design window.

  2. Select Save or Save As from the File menu.

  3. Complete the fields in the Save or Save As dialog box that appears.

  4. Select the save to database check box. The database used is the Configuration Database. The table name is ird_strategies.

Note: In order to enable the save to database check box, a Database Access Point must appear in the Connections tab of the IRD Application in Configuration Manager.

  5. Click OK in the Save or Save As dialog box.

Note: When two or more users access the same strategy in the database, no warning message appears. Only the last user's changes are saved.


Editing and Managing Strategies > Sharing Strategies

Creating Transaction Objects When Sharing

If you are manually sharing to a different environment (that is, if you are moving raw .rbn files instead of performing an automatic export/import by using a .zcf file), you must manually create Transaction objects in the new environment.

Transactions objects are all objects created in IRD that are used in the strategy or subroutine that you are sharing—routing rules, interaction data, attributes, business rules, custom statistics, and so on.

For instructions on how to create new Transaction objects, see:

  • Creating Reusable Objects and Data —To create Transaction objects by using IRD.

  • Creating Objects When Importing a Strategy —To create Transaction objects in Configuration Manager.


Exporting and Importing

Exporting and Importing: Overview

IRD enables you to export and import:

  • Strategies and subroutines complete with all objects. For this you can use either the Export/Import Shortcut bar or the Export to File and Import from File commands on the File menu in the IRD main window.

  • Strategies and subroutines with only selected objects. For this, you must use the Export/Import Shortcut bar.

  • Objects used in strategies, such as routing rules, business rules, attributes, interaction data, statistics, and macros. For this, you must use the Export/Import Shortcut bar.

  • Strategy-building object that appear in the Routing Design window. For details, see Placing Objects.

  • Business processes.

  • Variables.

IRD provides two ways of sharing strategies and subroutines:

  • Starting in release 7.6, you can use the Export/Import Shortcut bar, which enables you to select strategies, subroutines, or various objects used in strategies, such as routing rules and statistics. If you use this method, you can select any of the following export/import formats: .rbn, .zcf,. xml, or .kvl (text).

  • The export/import functionality from pre-7.6 releases continues to be available, with the addition of .xml and .kvl (text) as supported export/import formats (as well as .zcf). Use the Export to File and Import from File commands on the File menu in the IRD main window, which enable you to export and import entire strategies. If you use this method, you cannot select specific objects, such as statistics or routing rules, for export or import.

Note: If you use the .xml or .kvl format, only the strategy file itself is exported. To export the strategy with all associated objects, you must use the .zcf format.


Export and Import Strategy Objects Overview

Exporting and Importing > Exporting and Importing Strategies and Objects

Exporting and Importing Strategies and Objects: Overview

The Export/Import Shortcut bar in the IRD main window enables you to export and import:

  • Strategies and subroutines, either complete with all their objects, or with a selected set of objects.

  • Objects used in strategies, such as routing rules, business rules, attributes, interaction data, statistics, list objects, and macros.

Note: See Alternative Methods for additional export/import options.

You can export and import strategies and subroutines in a number of formats:

  • .rbn (native)

  • .zcf (archive)

  • .xml (open)

  • .kvl (text)

Note: Objects can be exported and imported only in .kvlt (text) format.

Editing Object Properties During Import

  • You can edit the properties for strategies or subroutines that have been exported in .xml or .kvl format, and for objects that have been exported in .kvlt format.

Exporting and Importing Variables

  • You can now move variables from one strategy or subroutine to another by exporting and importing them.

Alternative Methods of Exporting and Importing Strategies and Subroutines

  • The Export/Import Shortcut bar is new in IRD 7.6. The pre-7.6 export/import functionality is still available. It has been expanded to support .xml (open) and .kvl (text) formats, as well as .zcf format. For more information about the pre-7.6 method of performing exports and imports, see Exporting and Importing Entire Strategies.

Note: The pre-7.6 functionality can be used only to export and import entire strategies or subroutines along with all their objects. To export or import objects alone, or to export and import strategies and subroutines with only some of their objects, you must use the Export/Import Shortcut bar.

  • You can export and import strategy objects from the Routing Design window. For details, see the Exporting and Importing Objects section of the Placing Objects topic.


Exporting Strategy Objects

Exporting and Importing > Exporting and Importing Strategies and Objects

Exporting Strategies and Objects

To export a strategy, subroutine, or other objects, you must:

  1. Select the objects.

  2. Specify the export format(s).

  3. Perform the export.

Note: The Solution export view does not automatically display updates made from outside your instance of IRD (for example, changes to configuration objects, or the switching on or off of the Check Integrity function). To update the view, right-click anywhere on the List pane, and then select Refresh.

The steps below explain the export process in detail:

  1. Click the Solution export icon on the Export/Import Shortcut bar.

The Solution export list appears. It contains all of your strategies, subroutines, routing rules, interaction data, attributes, statistics, and so on.

  2. Select the row for the desired object.

  3. Within that row, highlight the cell in the column that controls the appropriate action, and then either double-click the selected cell, Shift-click it, or press Enter. IRD marks the column with an x.

  • To add a single object of any type, use the Add column.

  • To add a strategy or subroutine, and all of the objects that are included in it, use both the Add and the Add all used columns. In addition to the x's in the Add and Add all used cells for the selected strategy or subroutine, each of the objects used in the selected strategy or subroutine contain a Y in the Mark used column, showing that it will be included in the export.

  • To remove included objects from the export after selecting Add all used, mark the cell with an N for no. To do this, either double-click the cell in the Mark used column for that object, or Shift-click the cell, or select the cell and then press Enter.

Note: To remove the N and include an object for export, toggle back to Y for yes by performing the same action you used to mark the cell with an N. That is, double-click the cell in the Mark used column for that object, or Shift-click the cell, or select the cell and then press Enter.

  4. When you have selected the objects for export, specify the export format. To do so, highlight the row for the object, and then do one of the following:

  • Right-click in the row, and then select Select format from the shortcut menu to open a drop-down list of format types.

  • Double-click the row Select format cell in the row, and then select the export format from the drop-down list that appears.

Notes:

  • Only strategies and subroutines offer multiple export format types. Objects used in strategies and subroutines (routing rules, attributes, macros, and so on) are exported only in text (.kvlt) format.

  • Selecting the Add function for a strategy and then choosing the .zcf export format results in the same export functionality as was previously available by using the Export to File and Import from File commands on the File menu in the IRD main window. That is, the strategy and all the objects it uses are exported.

  5. To perform the export, right-click anywhere on the Solution export list pane, and then select Export from the shortcut menu.

The Select folder for export dialog box opens. By default, it specifies an export folder, called ExportResult that is located in the IRD working directory. Each time you perform an export, IRD then creates a subfolder that is named according to the time of the export.

  6. Click Select the accept the default folder and location, or browse to a different folder then click Select.

Note: You must export to an empty folder. This prevents the export files from becoming accidentally mixed in with other files. If you export a file with the same name as a previously-exported file to the same location, the older file is overwritten.

IRD performs the export. When it is finished, a dialog box asks whether you want to see the export log.

  7. Click Yes to see the export log. When you are done viewing the log, click Close in the Result dialog box, which displays the log text.

Note: If you want to see the log again later, right-click in the Solution export view, and then select View export log from the shortcut menu.

When you return to the Solution export view, the Result column shows, for each exported object, whether the export was successful.

  8. When you return to the Solution export view after an export, the entire window is inactive (grayed out). To reactivate the Solution export view, right-click anywhere on the List pane, and then select Clear results or Clear all.

  • Select Clear results to retain your export selections when the Solution export view becomes active again.

  • Select Clear all to remove all export selections and reactivate the Solution export view.

Note: You can leave the Solution export view and use other IRD functionality without reactivating the Solution export view. However, if you return to the Solution export view, the window is still inactive, and you must clear it. (Refreshing the Solution export view, or closing IRD and restarting it, also clears the Solution export view.


Importing Strategy Objects

Exporting and Importing > Exporting and Importing Strategies and Objects

Importing Strategies and Objects

To import a strategy, subroutine, or other objects, you must:

  1. Load a set of the available objects into the Solution import List pane. (There must already be exported objects before you can load them.)

  2. Select the objects to be imported.

  3. Specify the locations to which new objects should be saved.

  4. Perform the import.

The steps below explain the import process in detail:

  1. Click the Solution import icon on the Export/Import Shortcut bar.

The Solution import list appears. The first time you open this view, it is empty.

  2. To display exported strategies and any other objects, right-click the empty List pane and then select Load data.

The Select folder dialog box opens.

  3. Browse to the location of the files that you want to import, then click Select. All files within the folder that you select are displayed (with the exception of the export log file).

Note: Although the selected files appear on the Solution import List pane, they are not yet imported. If you close IRD without performing an import, the Solution import List pane is automatically cleared, and it will be empty the next time you open IRD.

  4. Review your selections to make sure that you are importing the correct objects.

  • Objects that are already present in the Configuration Database have an x in the Already exists column. Note that the Already exists information is not automatically updated if someone else makes a change to a configuration object outside IRD. To update the view, reload the data.

  • Objects to be imported have an x in the Add column. To remove them from the list of objects to be imported, delete the x by double-clicking the cell for that object in the Add column. Alternatively, right-click the Add cell, and then select Add the object to import list. This command toggles the selection off and on.

  5. In the Set config folder column and (for strategies and subroutines only) the Set file path column, review the default locations for the objects to be imported.

  • You cannot change the location of an object that already exists.

  • For new objects, you can change the location in the Location for <object_name> dialog box. To open the dialog box, double-click the appropriate cell, or right-click the cell, and then select Set config folder and file path.

  6. (Optional) You can edit the properties of objects that were exported in .kvl or .kvlt (text) format, so that the imported copies of the objects have the updated properties.

Note: Editing changes the properties of only the import copy of the object. It does not change the properties of the object in the export folder.

  7. To perform the import, right-click anywhere on the List pane, and then select Import.

IRD performs the import. When it is finished, a dialog box asks whether you want to see the import log.

  8. Click Yes to see the import log. When you are done viewing the log, click Close in the Result dialog box, which displays the log text.

Note: If you want to see the log again later, right-click in the Solution import view, and then select View import log from the shortcut menu.

When you return to the Solution import view, the Result column shows, for each imported object, whether the import was successful.

  9. When you return to the Solution import view after an import, the entire window is inactive (grayed out). To reactivate the Solution import view, right-click anywhere on the List pane, and then select Clear results or Clear all.

  • Select Clear results to retain your export selections when the Solution import view becomes active again.

  • Select Clear all to clear the entire content of the Solution import view. To perform another import, right-click and then select Load data (as described in Step 2, above).

Note: You can leave the Solution import view and use other IRD functionality without reactivating the Solution import view. However, if you return to the Solution import view, the window is still inactive, and you must clear it. (Closing IRD and restarting it also clears the Solution import view.)


Editing Export/Import Object Properties

Exporting and Importing > Exporting and Importing Strategies and Objects

Editing Properties of Export/Import Objects

You can edit strategies, subroutines, or configuration objects after an export or during an import.

Notes:

  • Although you can edit almost any properties of a strategy, subroutine, or configuration object, Genesys recommends that you limit changes to the names of configuration objects, and/or any function or expression strings that they contain.

  • There are certain properties that you cannot edit, such as an object's database ID (DBID), tenant DBID, object type, and so on. Although you can enter new values for these properties, IRD disregards your changes.

Editing Exported Objects

After exporting, you can edit:

  • Strategies or subroutines that have been exported in .xml format, using any third-party XML editor.

  • Strategies, subroutines, or configuration objects that have been exported in .kvl or .kvlt (text) format, using any text editor.

Note: If you export in .kvl or .kvlt format, you can also edit from within IRD before importing.

Editing While Importing

During the import process, you may want to change some properties of the objects that you are importing. For example, some queue names may need to be updated to correspond to queue names in the import location.

You can edit the properties only of objects that were exported in .kvl or .kvlt (text) format. The Edit properties command is inactivated if the selected object is not in .kvl or .kvlt format.

Notes:

  • Editing changes the properties of only the import copy of the object. It does not change the properties of the object in the export folder.

  • You can also edit the properties of objects after they are imported.

To edit an object:

  1. Highlight the object row, and then right-click.

  2. Select Edit properties from the shortcut menu.

The Properties dialog box opens, displaying the object properties in text format.

  3. Make the desired changes.

The Find and Replace buttons provide standard functionality for locating text strings and replacing them with an alternative.

  4. Click Update to save your edits, or click Cancel to exit without making changes.

You can now continue with your import.


Export and Import Entire Strategies Overview

Exporting and Importing > Exporting and Importing Entire Strategies

Exporting and Importing Entire Strategies: Overview

After creating a strategy in Interaction Routing Designer (IRD), you may want to share it with other people for testing, debugging, or development purposes. These people may work on the same network, different networks, or configuration environments. To share a strategy, you must provide them with the strategy components.

  • To export and import entire strategies, use the Export to File and Import from File commands on the File menu in the IRD main window. This method is described in this section of the Help file.

Note: You can also export a strategy or subroutine by right-clicking it on the Strategies or Subroutines list pane, and then selecting Export to file from the shortcut menu.

  • To export or import strategies or subroutines with only some of the associated objects, or to export and import only objects (such as routing rules, business rules, interaction data, statistics, or macros), use the Export/Import Shortcut bar.

You share strategies and subroutines differently, depending on the computer environment of the people who you want to share the strategy with:

  • For people on the same network and sharing the same Configuration Database, sharing strategies only requires providing the people with access permissions to all strategy components.

  • For people on a different network or using another Configuration Database, the components can be automatically packaged for export and then imported and unpackaged in the new location.

Note: You can also export and import variables in order to copy them from one strategy to another.

See also:

  • E stablishing Access Control

  • Sharing to a Different Network or Configuration Environment


Exporting and Importing > Exporting and Importing Entire Strategies

Exporting a Strategy

IRD provides an automated way to package all strategy-related objects that it creates into a strategy-moving file for export to a different environment. The strategy-moving file can be in .zcf (archive), .xml (open), or .kvl (text) format. The name of the strategy-moving file always matches the name of the strategy that you are moving, with the addition of the appropriate filename extension.

Notes:

  • Only objects that IRD creates are included in the strategy-moving file. These objects include the strategy, subroutines, business rules, routing rules, attributes, interaction data, statistics, list objects, and macros.

  • The strategy-moving file does not include Format, Field, and Table Access objects, or other objects, such as Agents and Queues, that are created in other applications. To prepare for the export, fill out a worksheet that lists all the objects to be created, and the settings to be used when configuring them.

  • For a list of items in a strategy, including items that IRD does not create, see Components of a Strategy.

  • If you use the .xml or .kvl format, only the strategy file itself is exported. To export the strategy with all associated objects, you must use the .zcf format.

To automatically package a strategy for export:

  1. In the Strategies List, select the name of the strategy that you want to export.

  2. Select Export To File from the File menu or press CTRL+E.

The Export of strategy <strategy name> dialog box opens.

  3. Navigate to the folder in which you want to place the strategy-moving file.

Note: If a file with the same name as the new strategy-moving file already exists in the selected folder, the existing file is overwritten.

  4. From the Files of type drop-down list, select the file format.

  5. Click Select.

The Interaction Routing Designer message box opens, reporting on the completion of the export.

  6. Click OK to continue.

Note: If you selected the .zcf format, IRD creates an export.log file, which contains a detailed description of the objects that were either successfully or unsuccessfully exported during the export operation. This file is located in the IRD working directory.

Warning! IRD overwrites the contents of the export.log file with every new export operation. If you do not want to overwrite the export.log file, move it to another location.


Importing a Strategy

IRD provides an automated way to import all strategy-related objects from the strategy-moving file into a destination environment. The strategy-moving file can be in .zcf (archive), .xml (open), or .kvl (text) format. IRD temporarily stores the imported strategy in the importstr subdirectory in the current strategy storage location.

When unpackaging the objects of the imported strategy from the strategy-moving file into the destination environment, IRD reads and recreates the following: business rules, routing rules, attributes, interaction data, statistics used in a strategy or one of its subroutines, .rbn files for the strategy and all subroutines used in it, Script objects for the strategy, and Script objects for subroutines called by the strategy.

  • When you import a strategy, you must recreate any non-IRD objects that it requires, but that were not created in IRD, such as Configuration objects. These include Field, Format, and Table Access objects.

Note: You cannot successfully import a strategy if a strategy with the same name is loaded on a Routing Point.

Warning! To import a strategy, you need access permission for the objects being unpackaged, and permission to create and/or update existing strategy objects.

To import a strategy:

  1. Open the Strategies List in the destination environment.

  2. Select Import From File from the File menu or press CTRL+I.

The Import of strategy dialog box opens.

  3. Navigate to the folder containing the strategy-moving file that you want to import into the current environment.

If the file that you want to import is in a format other than .zcf, select the format type from the Files of type drop-down list. The available formats are .zcf, .xml., .rbn, and .kvl.

  4. Click Open.

    The Import to dialog box opens.

  5. Change the Storage Location and the Config. Layer Location settings, if necessary, then click OK.

IRD performs the import. During this process, it opens and attempts to compile the imported strategy, reporting any error that it finds while doing so.

Notes:

  • If any objects in the imported strategy have the same names as objects already in the location to which you are importing, a dialog box asks you to confirm whether to overwrite the existing objects. This is an all-or-nothing choice. To overwrite selectively, you must use the Solution import.

  • If the import is unsuccessful, check your access permissions for the objects, and your access level to create and/or update existing strategy objects. Then, import the strategy again.

  • The import is canceled if at least one .rbn file with the same name already exists in the current strategy storage location, and you are not importing a strategy or subroutine that references this .rbn file. In such as case, IRD considers that the .rbn file is probably referenced by some strategy from another environment. Importing is canceled to prevent potential damage to the other environment.

  • If you are importing a strategy in .zcf format, after the operation is complete, IRD generates an import.log file. The import.log file contains a detailed description of the objects that were either successfully or unsuccessfully imported during the import operation. This file is located in the IRD working directory.

Warning! IRD overwrites the contents of the import.log file with every new import. If you do not want to overwrite the import.log file, move it to another location before performing another import.

See also:

  • Access Permission Rules

  • Creating Objects when Importing a Strategy


Exporting and Importing > Exporting and Importing Entire Strategies

Creating Objects When Importing a Strategy

When you import a strategy, you must recreate any objects that it requires, but that were not created in IRD, such as Configuration objects that are created in Configuration Manager. For example, you must create Fields, Formats, Table Access, Persons, Queues, and so on.

  • For information about how to create Configuration objects, see Framework 7.6 Configuration Manager Help.

To create the new objects:

  1. Create a worksheet that lists the exact name of each object that needs to be created in the new environment.

  2. In the original environment, open each Configuration object, and export its Options and Annex tab settings to .cfg files. Note all other pertinent settings in the worksheet.

  3. In the destination environment, create the new objects. Use the names and settings for the objects as you recorded them in the worksheet. Import the settings from the .cfg files into the Options and Annex tabs of Configuration objects.

Note: Object names must be exactly the same in both environments; otherwise IRD indicates that it cannot find the objects.

  4. Open the strategy and check its integrity to make sure that you have created all required objects.


Exporting and Importing > Exporting and Importing Entire Strategies

Access Permission Rules

When performing exporting and importing operations between configuration environments, Interaction Routing Designer (IRD) verifies information against access permission rules.

For information on access control, see Establishing Access Control.

IRD imports a strategy in accordance with the following cancellation and warning rules:

Cancellation Rules

When IRD cancels the process of importing a strategy, it displays a cancellation message and makes no changes to the new environment.

  • For strategy and subroutine objects, the cancellation occurs in the following situations:

  • The user does not have permission to create these objects.

  • Some of the objects already exist in the new environment, and the user does not have permission (access rights) to change at least one of these objects.

  • At least one .rbn file already exists in the current strategy storage location, and the current user does not have access rights to the strategy or subroutine that references this .rbn file.

  • At least one of these objects already exists in the current environment, and the object is open in IRD.

  • For business rules, routing rules, attributes, interaction data, and statistic objects, the cancellation occurs in the following situations:

  • The strategy being imported contains one or more of these objects, and the user does not have permission to create one or more of them.

  • Some of the objects already exist in the new environment, and the user does not have permission (access rights) to change at least one of these objects.

Warning Rules

If some of the objects being imported already exist and the user has permission to change all of them, a warning message box appears. The user has the option of cancelling the operation, in which case no changes will be made to the environment, or confirming the operation, in which case the existing objects that share the same name as the objects being imported are overwritten.

As mentioned above, if the user does not have permission, the operation is cancelled.

  • For strategy and subroutine objects, a warning message displays regardless of whether or not any of the imported objects exist in the corresponding .rbn file in the new strategy storage location. The warning message includes a list of objects that will be overwritten if the user confirms the operation. If the user confirms the operation, a successful completion message appears when the operation is finished.

  • If an existing .rbn file with the same name as one of the .rbn files being imported is not stored in the strategy storage location, IRD does not overwrite it.

  • For business rules, routing rules, attributes, interaction data, and statistic objects, a warning message appears and includes a list of objects that will be overwritten if the user confirms the operation. If the user confirms the operation, a successful completion message appears when the operation is finished.

If none of these rules apply, IRD imports the strategy and provides a successful-completion message.

See also:

  • The description of the Access column in the Strategies List topic.

  • Establishing Access Control

  • Exporting a Strategy

  • Importing a Strategy


Exporting and Importing Business Processes

Exporting and Importing > Exporting and Importing Business Processes

Exporting and Importing Business Processes: Overview

Having the ability to export and import Business Processes means that you can:

  • Store the information contained in a Business Process—for the purpose of creating a backup copy, for example. The information includes comments attached to object groups or placed as unattached labels in a Business Process.

  • Easily move Business Processes from your Test environment to your Production environment.

  • Share or consult on workflow design with a co-worker.

  • Automatically create all of the required Configuration Layer objects during the export process, and write them to a Configuration Database during the import process.

Interaction Routing Designer (IRD) enables you to export and import multiple Business Processes at one time. It is likely that you will use this feature at some point, because it is common for one Business Process to depend on processing that occurs in another Business Process, or to use objects that originate outside of itself.

Exporting and Importing Screening Rules and Standard Responses

Starting with release 7.6, IRD handles screening rules and standard responses in a new way. In the past, IRD used the names of objects in Configuration Server to identify screening rules/standard responses. Now IRD uses the display names to identify them.

This change affects export and import of screening rules/standard responses. Formerly, a screening rule/standard response with a single database identifier might exist in two environments, with a different display name in each. If the screening rule/standard response was then exported from one of the environments into the other, the display name from the source environment overwrote the display name in the destination environment. From the perspective of an IRD user, suddenly the familiar screening rule/standard response was gone.

Now that only the display name is used to identify screening rules/standard responses, this point of confusion is eliminated. When a screening rule/standard response with a different display name is imported into an environment, it appears as a separate item.

Note: For this reason, screening rule and standard response display names must be unique.

Warning! The use of display names to identify these objects is contrary to basic rules used by Configuration Server, which allows multiple objects to have the same display names. The uniqueness is required by, and enforced by Multimedia and IRD. To minimize the risk of accidentally overwriting screening rules/standard responses, do not change the display names of existing screening rules/standard responses, especially by doing so directly in Configuration Manager.

Automatic Decisions

The IRD import utility automatically makes/logs the following decisions:

  • When a submitter that is being imported conflicts with either an existing submitter or a Script object of a different type, the imported submitter is assigned a new name.

  • When an association between a view and strategy already exists (that is, there is a submitter that connects the view and the strategy), IRD does not import the submitter.

  • When a parent object is not imported (for example, a queue with a View child object, or a view with a Submitter child object), the child object is also not imported.


Exporting and Importing > Exporting and Importing Business Processes

Exporting Business Processes

Follow the steps below to export a Business Process. If the Business Process is already open, start at Step 4.

  1. In the IRD main window, click Interaction Design.

  2. Click Business Processes. The existing Business Processes are listed for selection.

  3. Double-click any Business Process to open the Interaction Design window.

  4. From the File menu, select Export. The Export dialog box appears.

  5. Select the Business Processes that you want to export.

    • To select individual Business Processes, hold down the Ctrl key while you click them.

    • To select a range of Business Processes, hold down the Shift key, then click the first and the last Business Processes in the range.

Note: Media servers are not included in IRD’s export/import process.

  6. (Optional) In the Short Comments text box, enter any comments.

  7. Click Browse. The Choose File Name dialog box appears

  8. Browse to or create the folder that will hold the exported Business Process, if it is not already selected.

  9. In the File name text box, enter the file name for the exported Business Process.

  10. Click Save. The Export dialog box is updated to reflect your entries.

Note: IRD uses a .wie file name extension when it imports and exports Business Processes.

  11. Click OK. The following message briefly appears: Configuration Exporting.

After a successful export, the following message appears: Done.


Exporting and Importing > Exporting and Importing Business Processes

Importing Business Processes

Follow the steps below to import a Business Process. If the Business Process is already open, Start with Step 5.

  1. In the IRD main window, click Interaction Design.

  2. Click Business Processes. The existing Business Processes are listed for selection.

  3. Double-click a Business Process to open the Interaction Design window.

  4. From the File menu, select Import. The Configuration Import Wizard Choose File page appears.

  5. Next to the File text box, click Browse. The Open dialog box appears.

  6. Locate the *.wie file you want to import, and double-click it. The Open dialog box closes. IRD inserts the selected directory path and file name into the File text box in the Configuration Import Wizard.

  7. Under Where to put strategy RBN files, do one of the following:

    • Click Browse, and then locate the folder that will hold the graphical portion of strategies in the Business Process (strategy *.rbn files, which consume more space than the script portion of strategies).

    • Select the Into Database check box (if it is enabled), to save *.rbn files in a database.

Notes:

  • In order for the Into Database checkbox to be enabled, a Database Access Point must appear in the Connections tab of the IRD Application in Configuration Manager.

  • The database used is the Configuration Server database. The table name is ird_strategies.

  • If security is a consideration, you may want to store the .rbn files in a database. For example, if you are a Service Provider, you might not want your subscribers to have access to your corporate drives. In this case, saving to the database in the recommended method.

  8. If you want to save the details of the import operation to a log file, click Browse next to the Log text box (unless the log file is already selected), and then locate or create the log file.

  9. Click Next. The Configuration Wizard Confirm Importing page appears.

  10. If you are satisfied with your entries, click Import; otherwise, click Back to return to the Configuration Import Wizard Choose File page, and repeat Steps 5-9.

After you click Import, the Configuration Import dialog box appears. A progress bar shows the progress of the import.

  11. Do one of the following:

  • To update your configuration settings immediately after the update, click Refresh.

  • Click Close; then at any time, you can update your configuration settings by selecting Refresh from the File menu.

  12. Respond to any messages that appear.

Note: If you encounter any problems during the import, see Troubleshooting Business Process Imports.


Exporting and Importing > Exporting and Importing Business Processes

Troubleshooting Business Process Imports

If an import request encounters problems, IRD opens a dialog box that lists the problems and possible workarounds. You can:

  • Select the workaround for each problem.

  • Cancel the import operation.

Note: Selecting a particular workaround may trigger another problem. For example, if a strategy already exists, choosing to overwrite the strategy may cause a problem if the .rbn file that is associated with the strategy already exists in the specified location. In such cases, IRD opens another dialog box.

If you click Cancel Import, the Configuration Import Wizard Configuration import page appears.

Problem types and workarounds are listed below.

Problem: The Object to Be Imported Already Exists in the Configuration Database

Applicable to objects of the same type (queues, views, strategies, and so on). IRD offers the following workarounds:

  • Do not import the object

  • Overwrite existing object

Exceptions: For Business Processes, the only allowed workaround is merging. Since a Business Process object keeps a list of the objects that belong to it, merging combines those objects with the objects that belong to the Business Process that is being imported.

Problem: The Name of an Object Being Imported Conflicts with an Existing Object

Applicable to objects of different types (Business Process, queue, view, strategy, and workbin) that are of the same Configuration Manger object type (Script). For example, a conflict is created when you attempt to import a queue Script object that has the same name as an existing strategy Script object. IRD offers the following workaround:

  • Do not import the object

Exceptions: If the Business Process being imported conflicts with an existing object (a Script object of a different type), IRD considers the problem to be severe, and it always aborts the import operation.

Problem: The .rbn File of an Imported Strategy Already Exists in the Specified Location

Applicable to strategies. IRD offers the following workarounds:

  • Put the file into alternative location. The alternative location is an automatically created subfolder in the location that you specified as in the Configuration Import Wizard.

  • Overwrite the existing file.

Exceptions: None.

Problem: A Screening Rule/Standard Response with the Same Display Name Already Exists

The resolution depends on whether the display names are associated with the same screening rule/standard response or with a different one. Starting with release 7.6, IRD handles screening rules and standard responses in a new way. In the past, IRD used the names of objects in Configuration Server to identify screening rules/standard responses. Now IRD uses the display names to identify them. Therefore, an existing screening rule/standard response could:

  1. Have the same display names and content.

  2. Have the same content but different display names.

  3. Have the same display names but different content.

In case 1, you must decide whether to overwrite one version of the screening rule/standard response with the other.

In case 2, you will end up with two screening rules/standard responses with the same content but different names. For consistency, you could delete one, but this is not necessary.

In case 3, you can either overwrite the content in the destination environment, or choose not to import the screening rule/standard response until you have changed the name of one of the screening rules/standard responses.

Note: Genesys recommends that you not change screening rule/standard response names in Configuration Manager. Change the names in Knowledge Manager instead. Also, change screening rule and standard response names only when this is necessary to prevent overwriting.


Sample Strategies

Sample Strategies: Overview

The following five voice routing strategy samples describe four contact center scenarios and the corresponding strategies. Each scenario is more complex than the previous one and demonstrates different ways to use IRD objects.

Also see Universal Routing Strategy Samples, which contains both voice and multimedia strategy samples.

  • Sample A: DNIS, Load Balancing, Percentage Allocation, Default Route

  • Sample B: Day of Week, Time, Routing Rules, IVR

  • Sample C: Date, Day of Week, Time, JumpToStrategy

  • Sample D: CED, Variables, Attached Data, Skill-based Routing, Generic Segmentation

  • Sample E: Attributes, Business Rules, Database Lookup

Before you begin, familiarize yourself with the IRD interface. If you are not sure how to perform a task in one of the samples, see Preparation and Planning or search the Index.


Sample A

Sample Strategies > Sample A

Sample A: Overview

DNIS, Load Balancing, Percentage, Default Route

In this scenario, your customers reach your company through two 800 numbers: one for placing orders and one for requesting services. You have two queues for sales calls and two Agent groups for customer service.

In this strategy you will do the following:

  • Segment the calls based on the number dialed (DNIS object).

  • Route the calls to Agents in different locations and groups using load balancing and percentage allocation.

On the following figure, click each object to see what it does and how to create it. Use the navigation links on top of each page to return to this page and figure.


Sample Strategies > Sample A

Sample A: Route Based on DNIS

In this scenario, customers call 1-888-436-3797 for sales and 1-888-369-5555 for customer service.

  1. Open a new strategy from the Strategies List by choosing New from the Main window's File menu.

  2. Place the DNIS segmentation object [image] in the strategy and open its properties dialog box.

  3. Click Add Item [image] to create two segments.

    Note: If you make a mistake, you can delete an item by clicking Delete Item [image] .

  4. In the DNIS column, enter an 800 number for each segment.

    In this case, segment one is 1-888-436-3797 and segment two is 1-888-369-5555.

  5. Close the properties dialog box.

    The two output ports on the DNIS object represent the two segments.

    Note: Later you will connect these output ports to other objects that process the interaction if the DNIS number matches the criteria.

  6. Connect the Entry object to the DNIS object.

Note: If the DNIS of an incoming interaction does not match one of the two you defined, the interaction flows to the red output port, which represents the default condition. Because you did not attach an object to this port, the interaction goes to the default destination. You can connect the Default object to this port to achieve the same result.


Sample Strategies > Sample A

Sample A: Load Balancing

In this scenario, there is a queue for sales (8001) at the San Francisco and Boston locations. For sales calls, balance the call load between the Agents at these two locations.

  1. Place the Load balancing object [image] to the right of the DNIS object in the Routing Design window workspace.

  2. Open the properties dialog box for the object, select a Load Balancing routing rule, then click OK.

    For the rule to be available for you to select, you must create it ahead of time. Or click New Rule to create one on the spot. See Creating a Routing Rule for more information.

  3. Draw a connector from the first output port (DNIS='18884363797' for sales) on the DNIS object to the input port on the Load balancing object.

    Note: To identify which segment is which, press the Shift key and hover your cursor over the output port until it description appears.

  4. Place a comment near the Load balancing object and label it Sales. For more information, see Inserting Comments.


Sample Strategies > Sample A

Sample A: Percentage Allocation

You have two teams of Agents to handle customer service. For customer service calls, allocate 40 percent of the calls to CS_Team1 and 60 percent of the calls to CS_Team2.

  1. Place the Percentage allocation object [image] to the right of the DNIS object in the Routing Design window workspace.

  2. Open the properties dialog box for the object, select a Percentage routing rule, then click OK.

For the rule to be available for you to select, you must create it ahead of time. Or click New Rule to create one on the spot. See Creating a Routing Rule for more information.

  3. When you have finished, draw a connector to the Percentage allocation object from the second output port (DNIS='18883695555' for customer service) on the DNIS object.

  4. Place a comment near the Percentage allocation object and label it Customer Service. For more information, see Inserting Comments.


Sample B

Sample Strategies > Sample B

Sample B: Overview

Day of Week, Time, Routing Rules, IVR

Your service agreement with the sales department has been changed. You have now agreed that during business hours (M-F, 9:00 AM - 5:00 PM), 70 percent of sales calls will be answered in 20 seconds.

In this scenario you will do the following:

  • Route calls according to the day of the week.

  • Route calls according to the time of the day.

  • Specify the service level for answering calls.

  • Set up an IVR treatment to handle calls received when the office is closed.

On the following figure, click each object to see what it does and how to create it. Use the navigation links on top of each page to return to this page and figure.


Sample Strategies > Sample B

Sample B: Day of Week

Create a segment for each day of the week.

  1. Open a new strategy from the Strategies List by selecting New from the Main window's File menu.

  2. Place the Day of Week object [image] in the strategy. The Day of Week object is located in the Segmentation toolbar.

  3. Open the properties dialog box for the Day of Week object and click Add Item [image] repeatedly to create seven segments.

  4. Use the drop-down lists in the dialog box to assign one day to each segment (Monday through Sunday).

Segment | Day
1 | Monday
2 | Tuesday
3 | Wednesday
4 | Thursday
5 | Friday
6 | Saturday
7 | Sunday

  5. Draw a connector from the Entry object to the Day of Week object.

You can now connect each of the output ports to other objects to further process the interaction. For example, you can connect the five ports for Monday through Friday to an object that will be applied to interactions arriving on a weekday.

Note: To identify each segment, press the Shift key and hover your cursor over the output port until the description appears.


Sample Strategies > Sample B

Sample B: Time of Day

Create one segment for business hours and one for after hours:

  1. Place the Time segmentation object [image] in the strategy. The Time segmentation object is located in the Segmentation toolbar.

  2. Open the properties dialog box for the object and create a segment for business hours.

Segment | From | Up Until
1 | 9:00 AM | 5:00 PM

Notes:

Rather than creating segments for nonbusiness hours, use the red port for nonbusiness hours. If you want to create segments for nonbusiness hours, you need to create one segment for the morning and one for the evening because a segment cannot cross midnight.

In the Time Segmentation object, the value of the Up Until parameter is excluded from the time interval. For example, if you segment interactions with a From time of 9:00:00 AM and an Up Until time of 5:00:00 PM, URS includes interactions arriving between 9:00:00 AM and 4:59:59 PM.

  3. Click OK.

  4. Draw a connector to this object from each weekday output port on the Day of Week object.

    You should have five segments connecting to the input port of the Time segmentation object.

Note: Later you will connect Segment 1 to the Service level object and the red output port to the IVR for after hours.


Sample Strategies > Sample B

Sample B: Service Level

  1. Place the Service level object [image] in the strategy.

  2. Open the properties dialog box for the object and select a Service level routing rule from the list (70_20 SL). This rule distributes 70 percent of interactions in 20 seconds. Then click OK.

    For the rule to be available for you to select, you must create it ahead of time. Or click New Rule to create one on the spot. See Creating a Routing Rule and Sample E: Service Level Routing Rules for more information about how to create the 70_20 SL rule.

  3. Draw a connector from the 9:00 AM to 5:00 PM segment of the Time segmentation object to the Service level object.


Sample B: IVR

Sample Strategies > Sample B

Sample B: IVR Treatment

During nonbusiness hours, all calls are directed to an IVR that announces that the office is closed.

  1. Place the IVR object [image] in the strategy.

  2. Open the properties dialog box for the object and select Compatible Mode to have URS explicitly send calls to IVR ports.

  3. Select the script that announces the office is closed. In the target field, click the arrow to specify the type (typically a Queue or Group of Places), name, and location of the target. In the Duration field type a positive integer that is greater than or equal to the length of the script.

    In this example, the Closed script on the IVR queue is played for 20 seconds.

SCRIPT | Closed
TARGET | IVRQueue@.Q
DURATION | 20

    Note: If the IVR is configured to return the call to the route point, specify a value of 0 (zero) for Duration.

    See the Universal Routing 7.6 Reference Manual for more information about the IVR object.

  4. Draw connectors from the Saturday and Sunday segments in the Day of Week object to the IVR object. Draw a connector from the red port in the Time segmentation object to the IVR object.

    You should have three segments connecting to the input port of the IVR object.


Sample C

Sample Strategies > Sample C

Sample C: Overview

Date, Day of Week, Time, JumpToStrategy

To create a schedule-based strategy to handle the scheduling needs of your business, you can use Segmentation objects. When building the strategy, plan the flow of the interaction based on scheduling information. Use the Date, Day of Week, and Time objects to segment the interaction flow. Specify the dates, days of the week, and time of day according to the schedule that you want to use for your business.

In your schedule-based strategy, you can use a JumpToStrategy function in a Function object to start a strategy as part of your plan to segment the interaction flow according to the scheduling needs of your business.

In this strategy, you will route interactions:

  • According to the date.

  • To another strategy using the JumpToStrategy function in the Function object.

  • According to the day of week.

  • According to the time of day.

On the following figure, click each object to see what it does and how to create it. Use the navigation links on the top of each page to return to this page and figure.


Sample Strategies > Sample C

Sample C: Date

To specify the beginning and ending dates during which the strategy is effective, use the Date object:

  1. Open a new strategy from the Strategies List by choosing New from the Main window's File menu.

  2. From the Segmentation toolbar, place the Date object [image] in the strategy. Open the Date segmentation properties dialog box.

  3. In the Date From text box, enter the beginning date. In the Up to date text box, enter the last date.

Note: The value of the Up To Date parameter is excluded from the time interval. For example, if you segment interactions with a Date From of 12/21/07 and an Up to date of 03/21/08, URS includes interactions arriving between 12:00:00 AM on 12/21/07 and 11:59:59 PM on 03/20/08.

In this scenario, the Date From is 12/21/07 and the Up to date is 03/21/08.

Segment | Date From | Up to date
1 | 12/21/07 | 03/21/08

  4. Click OK to close the properties dialog box.

The output port on the Date object represents the segment.

Note: You will connect the output port to another object that processes the interaction if the interaction arrives between the dates specified.

  5. Connect the Entry object to the Date object.

Note: If an incoming interaction does not arrive in the specified date interval (the from and up to dates that you specified) the interaction flows to the red output port, which you will connect to a Function object.


Sample C: JumpToStrategy-Spring, Summer, Fall

Sample Strategies > Sample C

Sample C: Jump To Strategy—Spring, Summer, Fall

Use the JumpToStrategy function in the Function object to route interactions that arrive before 12/21/07 and after 3/21/08.

The JumpToStrategy function enables you to jump from one strategy to another already-created strategy. In this sample, you will create strategies that function as placeholders in order to use this function.

  1. Create the following three strategy stubs, each of which contains only an Entry object: Spr_Sum_Fall, Prem_VQ, and Close_Center.

    You will connect to the Spr_Sum_Fall strategy in Step 5. You will connect to Prem_VQ and Close_Center later in this sample.

  2. From the Miscellaneous toolbar, place the Function object [image] in the strategy. Open the Function properties dialog box.

  3. Select All Functions under Type and JumpToStrategy under Name in the Data pane.

  4. In the Parameter and Value pane, click in the Strategy Name row of the Value column then click the arrow button ( [image]) to open the Key dialog box.

  5. From the Type drop-down list in the Key dialog box, select Script and from the Value drop-down list select Spr_Sum_Fall. Then click OK to close the Key dialog box and return to the properties dialog box for the Function object.

  6. Click Add to create the expression.

    The right side of the expression should appear as JumpToStrategy['Spr_Sum_Fall'].

  7. If you want to verify that the expression is valid, click Verify.

    If you choose to verify and the expression is invalid, you will receive a message warning you of a syntax error and your expression highlights in red. Make sure you followed Steps 2 through 6 correctly.

  8. Click OK.

  9. Draw a connector from the red output port of the Date object to the Function object.


Sample C: Day of the Week

Sample Strategies > Sample C

Sample C: Day of Week

You will create two Day of Week objects. For the first, use the Advanced option of the Day of Week object to specify a From and To day of the week (Monday to Friday). Then use the Day of Week object without the Advanced option to configure a separate Day of Week object with a segment for Saturday and a segment for Sunday.

To configure the Monday to Friday Day of Week object:

  1. From the Segmentation toolbar, place the Day of Week object [image] in the strategy. Open the Day of week segmentation properties dialog box.

  2. Click the Advanced radio button. From and To columns appear in the Day of week segmentation properties dialog box.

Note: The Advanced function is separate from the Time Zone drop down list.

  3. In the From field, enter Monday. In the To field, enter Friday.

  4. Click OK.

To configure the Day of Week object with two segments: Saturday and Sunday:

  1. From the Segmentation toolbar, place another Day of Week object in the strategy. Open the Day of week segmentation properties dialog box.

  2. Click Add Item [image] once so that you have two segments.

  3. Use the drop-down lists in the Day of Week segmentation properties dialog box to choose Saturday for the first segment and Sunday for the second segment.

Segment | Day
1 | Saturday
2 | Sunday

  4. Click OK.

  5. Draw a connector from the red port of the Monday to Friday Day of Week object to the Saturday and Sunday Day of Week object.

Note: To identify the segment in the Saturday and Sunday Day of Week object, press the Shift key and hover your cursor over the output port until the description appears.


Sample Strategies > Sample C

Sample C: Time of Day

To create a Time of Day object with one segment for the From and To time, use the Time object:

  1. From the Segmentation toolbar, place the Time segmentation object [image] in the strategy. Open the Time segmentation properties dialog box.

  2. Click the From field and set the time to 9:00:00 AM.

  3. Click the To field and set the time to 5:00:00 PM.

  4. Click OK.

  5. Draw a connector from the Day of Week object that specifies Monday to Friday to the input port of the Time object.


Sample C: JumpToStrategy-Premium

Sample Strategies > Sample C

Sample C: Jump To Strategy—Premium

Use the JumpToStrategy function in the Function object to route interactions that arrive between 12/21/07 and 03/21/08, Monday to Friday, and between 9:00 AM and 5:00 PM.

  1. From the Miscellaneous toolbar, place the Function object [image] in the strategy. Open the Function properties dialog box.

  2. Select All Functions under Type and JumpToStrategy under Name in the Data pane.

  3. In the Parameter and Value pane, click in the Strategy Name row of the Value column then click the arrow button ( [image]) to open the Key dialog box.

  4. From the Type drop-down list in the Key dialog box, select Script and from the Value drop-down list select Prem_VQ. Then click OK to close the Key dialog box and return to the properties dialog box for the Function object.

  5. Click Add to create the expression.

    The right side of the expression should appear as JumpToStrategy['Prem_VQ'].

  6. If you want to verify that the expression is valid, click Verify.

    If you choose to verify and the expression is invalid, you will receive a message warning you of a syntax error and your expression highlights in red. Make sure you followed Steps 2 through 5 correctly.

  7. Click OK.

  8. Draw a connector from the green output port of the Time object to the Function object.


Sample C: JumpToStrategy-Close Center

Sample Strategies > Sample C

Sample C: Jump To Strategy—Close Center

Use the JumpToStrategy function in the Function object to route interactions that arrive between 12/21/07 and 03/21/08 on Saturday or Sunday.

  1. From the Miscellaneous toolbar, place the Function object [image] in the strategy. Open the Function properties dialog box.

  2. Select All Functions under Type and JumpToStrategy under Name in the Data pane.

  3. In the Parameter and Value pane, click in the Strategy Name row of the Value column then click the arrow button ( [image]) to open the Key dialog box.

  4. From the Type drop-down list in the Key dialog box, select Script and from the Value drop-down list select Close_Center. Then click OK to close the Key dialog box and return to the properties dialog box for the Function object.

  5. Click Add to create the expression.

    The right side of the expression should appear as JumpToStrategy['Close_Center'].

  6. If you want to verify that the expression is valid, click Verify.

    If you choose to verify and the expression is invalid, you will receive a message warning you of a syntax error and your expression highlights in red. Make sure you followed Steps 2 through 5 correctly.

  7. Click OK.

  8. Draw connectors from the two output ports of the Saturday and Sunday Day of Week objects to the Close Center Function object.

  9. Draw a connector from the red output port of the Time object to the Close Center Function object.


Sample D

Sample Strategies > Sample D

Sample D: Overview

CED, Variables, Attached Data, Skill-Based Routing, Generic Segmentation

To improve your customer service, you need to route incoming calls based on Caller-Entered Digits (CED). In this example, the customer presses 3 for billing and 4 for investment.

In this strategy you will do the following:

  • Create a variable.

  • Assign a CED to a variable.

  • Attach the service selection (billing or investment) to the call as Interaction Data for screen pops and reporting.

  • Segment the calls based on the service selection (CED).

  • Send the billing calls (selection = 3) to the billing group based on the Agent who has been available the longest by using a Statistics object.

  • Select Agents for receiving investment calls who have a high level (>7) of bond skills, a high level (>7) of stock skills, and a medium level (>5) of English skills.

On the following figure, click each object to see what it does and how to create it. Use the navigation links on top of each page to return to this page figure.


Sample Strategies > Sample D

Sample D: Create a Variable

Create the variable ser_selection_var:

  1. Open a new strategy from the Strategies List by choosing New from the Main window's File menu.

  2. Click Variables on the Routing Design window toolbar ( [image] ). The Variable list dialog box opens.

  3. Click Add Item [image] to create a new entry.

  4. In the Variable field, type ser_selection_var.

  5. From the Type drop-down list, select INTEGER.

  6. From the Scope drop-down list, select LOCAL.

  7. Click OK.

For more information, see Creating Variables.


Sample Strategies > sample d

Sample D: Assign

Assign CED to a variable:

  1. Place the Assign object [image] in the strategy and open the properties dialog box.

  2. From the Expression drop-down list in the dialog box, select the ser_selection_var variable.

  3. Select CallInfo from the Type column, and then choose CED from the Name column.

  4. Click Add to create the expression.

    The right side of the expression should be CED[ ].

  5. If you want to verify that the expression is valid, click Verify.

    If you choose to verify and the expression is invalid, you will receive a message warning you of a syntax error and your expression is highlighted in red. Make sure you followed the procedure correctly.

  6. Click OK.

  7. Draw a connector from the Entry object to the Assign object.


Sample Strategies > sample d

Sample D: Configure Interaction Data

Create the interaction data for use in this sample:

  1. From the Shortcut bar, click Interaction Data, or select Interaction Data from the View menu.

    The Interaction Data list appears. Existing interaction data appears on the List pane.

  2. From the File menu, select New.

  3. In the Properties dialog box, complete the following:

Name | Type | Values
ser_select_key | INTEGER | 3, 4

  4. Click OK.

The new interaction data appears on the List pane.

See also: Configuring Interaction Data


Sample D: Attach

Sample Strategies > sample d

Sample D: Attach Function

Before attaching the customer's service selection to the call, you must create interaction data to be used as a key.

Attach the service selection to the call:

  1. Place a Function object [image] in the strategy and open the properties dialog box.

  2. From the Name column in the dialog box, select the Attach function.

  3. In the Parameters section, click in the Value field for Key parameter then click on the arrow button ( [image] ) to display the Key dialog box.

  4. From the Type drop-down list in the Key dialog box, select Interaction Data and from the Value drop-down list select ser_select_key. Then click OK to close the Key dialog box and return to the properties dialog box for the Function object.

  5. In the Parameters section, select the ser_selection_var value from the drop-down list in the Value field for the Value parameter.

  6. Click Add to create the expression.

    The right side of the expression should appear as Attach['ser_select_key',ser_selection_var].

  7. If you want to verify that the expression is valid, click Verify.

    If you choose to verify and the expression is invalid, you will receive a message warning you of a syntax error and your expression is highlighted in red. Make sure you followed Steps 2 through 6 correctly.

  8. Click OK.

  9. Draw a connector from the Assign object to the Function object.


Sample Strategies > Sample D

Sample D: CED Segmentation

Segment the interactions according to CED:

  1. Place a Generic segmentation object [image] in the strategy.

  2. Open the properties dialog box for the object and click Add Item [image] to create two segments.

Note: If you make a mistake, you can delete an item by clicking Delete Item [image] .

  3. For the first segment, click the down arrow ( [image]) in the Expression column to open the Expression Builder.

  • From the Type column, select CallInfo.

  • From the Name column, select CED.

  • From the Operator column, select the equal sign.

  • In the Value column, type the value that corresponds to the service selection for the first segment. In this example it would be 3, to represent billing.

  4. Click Add to create the expression, then click Verify if you want to verify that the expression is valid.

  5. Click OK.

  6. Repeat Steps 3 through 6 for the next segment, except enter a value of 4 in the Value column to represent investment.

  7. Click OK to close the Generic segmentation properties dialog box.

  8. Draw a connector from the Function object to the Generic Segmentation object.

Note: Later, you will connect the Billing segment to the Statistics object and the Investment segment to the Selection object.


Sample Strategies > sample d

Sample D: Statistics

Send the billing calls (selection = 3) to the billing group based on the Agent who has been available the longest.

  1. Place a Statistics object [image] in the strategy and open the properties dialog box.

  2. Select the LAAinBilling rule from the list in the dialog box and click OK.

    For the rule to be available for you to select, you must create it ahead of time. Or click New Rule to create one on the spot. The rule used here selects the longest available target in the billing Agent group. This rule uses the maximum value for the statistic StatTimeInReadyState. See Creating a Routing Rule for more information.

  3. Draw a connector from the CED = 3 segment of the Generic segmentation object to the Statistics object.

    Note: To identify each segment, press the Shift key and hover your cursor over the output port until the description appears.


Sample Strategies > Sample D

Sample D: Selection

Use the Selection object to route calls based on any one of the many available criteria. In this example, the Selection object is used to route interactions to a target based on skill and skill level. You will send investment calls to Agents with a high level (>7) of bond skills, a high level (>7) of stock skills, and a medium level (>5) of English skill. The calls will go to the Agent who has been ready the longest.

  1. Place the Selection object [image] in the strategy.

  2. In the Selection properties dialog box, click the Target Selection tab and select Max and StatTimeInReadyState.

  3. In the Target box, click Add Item [image] .

  4. In the Type column, select Skill.

  5. In the Name column, click the down arrow to open the Skill Expression properties dialog box.

  6. Select the following:

Type | Skill
Name | Bond
Operator | >
Value | 7

  7. Click Add to add the first part of the expression, then click AND.

  8. Repeat Steps 6 and 7 two more times, except specify Stock>7 & English>5.

    The final expression should look like this:

    Bond > 7 & Stock > 7 & English > 5

  9. If you want to verify that the expression is valid, click Verify.

  10. Click OK.

  11. Draw a connector from the CED = 4 segment of the Generic segmentation object to the Selection object.


Sample E

Sample Strategies > Sample E

Sample E: Overview

Attributes, Business Rules, and Database Lookup

In this scenario, you do the following:

  • Retrieve the service selection and account number of the customer by using an IVR.

  • Do a Database lookup to gather more information.

  • Segment customers according to their profile, and distribute the interactions according to Service Level and Statistics.

On the following figure, click each object to see what it does and how to create it. Use the navigation links on top of each page to return to this page and figure.

This strategy requires that you create interaction data, attributes, and business rules.


Sample Strategies > Sample E

Sample E: Configure Interaction Data

Configure the following interaction data for use in this sample. See Configuring Interaction Data for instructions.

Name | Type | Values
acct_num_key | INTEGER | [Leave this field empty.]
lang_key | INTEGER | 1, 2
serv_select_key | INTEGER | 3, 4
Tier | STRING | bronze, silver, platinum


Sample E: Business Rules and Attributes

Sample Strategies > Sample E

Sample E: Create Attributes & Business Rules

This sample requires attributes and business rules.

Creating Attributes

You must create the following attributes before you can create the business rules that are used in this sample. These attributes use the Interaction Data you created for this sample. See Configuring Attributes for instructions.

Name | Value | Expression
Language | English | UData['lang_key'] = '1'
 | Spanish | UData['lang_key'] = '2'
Service | Investment | UData['serv_select_key'] = '3'
 | Billing | UData['serv_select_key'] = '4'
Tier | Platinum | UData['Tier'] = 'platinum'
 | Silver | UData['Tier'] = 'silver'
 | Bronze | UData['Tier'] = 'bronze'

Creating Business Rules

You must create the following business rules before you can use them in the Business Segmentation object for this example. These business rules are based on the attributes you just created. See Creating a Business Rule for instructions.

Business Rule | Attribute Name | Value
billing_english | Service | Billing
 | Language | English
billing_spanish | Service | Billing
 | Language | Spanish
investment_platinum | Service | Investment
 | Tier | Platinum
 | Language | English
investment_silver | Service | Investment
 | Tier | Silver
 | Language | English
investment_bronze | Service | Investment
 | Tier | Bronze
 | Language | English
investment | Service | Investment


Sample Strategies > Sample E

Sample E: Create a Variable

Create the variable acct_num_var:

  1. Open a new strategy from the Strategies List by choosing New from the Main window's File menu.

  2. Click Variables on the toolbar ( [image] ). The Variable list dialog box opens.

  3. Click Add Item [image] to create a new entry.

  4. In the Variable field, enter acct_num_var.

  5. From the Type drop-down list, select INTEGER.

  6. From the Scope drop-down list, select LOCAL.

  7. Click OK.

For more information, see Creating Variables.


Sample E: IVR Object

Sample Strategies > Sample E

Sample E: IVR Treatment

In this part of the strategy you will:

  • Retrieve the customer's service selection and account number from the IVR using a GetCustInfo script.

  • Assume that the IVR is going to attach the value of service selection to serv_select_key and the value of the account number to acct_num_key.

  • Retrieve customer selection on their language choice (1 for English, 2 for Spanish) from the GetCustInfo IVR script. The language choice is attached to lang_key.

To create the IVR object:

  1. Place the IVR object [image] in the strategy.

  2. Open the properties dialog box for the object and select Compatible Mode to have URS explicitly send calls to IVR ports.

  3. Select the value for the Script parameter that collects information from the customer. In the Value field for the Target parameter, click the arrow to specify the type (typically a Queue or Group of Places), name, and location of the target. In the Value field for the Duration parameter type a positive integer that is greater than or equal to the length of the script.

In this example the GetCustInfo script on the IVR queue is played for 120 seconds.

SCRIPT | GetCustInfo
TARGET | IVRqueue@.Q
DURATION | 120

Note: If the IVR is configured to return the call to the route point, specify a value of 0 (zero) for Duration. See the Universal Routing 7.6 Reference Manual for more information about the IVR object.

  4. Draw a connector from the Entry object to the IVR object.


Sample Strategies > Sample E

Sample E: Assign

Because the account number entered by the customer is used for a database lookup, its value must be assigned to a variable. Assigning the value of interaction data to a variable enables the Database Wizard object to recognize the data. In this example, the value of acct_num_key is assigned to acct_num_var.

  1. Place the Assign object [image] in the strategy.

  2. Open the properties dialog box for the object and in the Expression field for the left side select the account number variable from the drop-down list. In this case, acct_num_var is used.

    Note: If the variable has not been created in advance, you can create one from here. For more information, see Creating Variables.

  3. Select Interaction Data from the Type column in the Data section, and then choose the key from the Name column that the IVR assigned to the customer's account number. In this case, acct_num_key is used.

  4. Click Add to create the expression.

  5. If you want to verify that the expression is valid, click Verify.

    If you choose to verify and the expression is invalid, you will receive a message warning you of a syntax error and your expression highlights in red. Make sure you followed Step 3 correctly.

  6. Click OK.

  7. Draw a connector from the IVR object to the Assign object.


SampleE: Database Lookup

Sample Strategies > Sample E

Sample E: Database Lookup

In this part of the strategy, you will perform a database lookup, gather additional customer profile information from the customer's table (customer_db) using the AcctNum as the key to the table, and retrieve the value from the Tier column.

Note: To perform an SQL query, or database lookup, the database tables and fields must be accurately defined as objects in Configuration Manager. These objects&emdash;not the actual database tables and fields&emdash;are used to create the SQL query. The Database Wizard object shows only the fields that are defined as Configuration objects, so you will not necessarily be able to choose from all the fields in the tables.

  1. Place the Database Wizard object [image] in the strategy, and open the Database Wizard.

  2. Select the Database Server radio button.

  3. Select a DB Access Point and a DB server, select the Select radio button, then click Next.

  4. Specify the table that contains customer information. In this case, the table is called Customer.

    Using the buttons between the Select field and Fields Selected text boxes, add the fields that contain the customer's account number and tier to the Fields Selected list, then click Next.

  5. Using the Expression Builder, create a Where expression that specifies what records you want to retrieve, based on the account number entered by the customer. In this example, the expression will search for the record with the account number that matches the current interaction.

  • In the First Operand box, select the table and field to search. In this example, the table is Customers, and the field is AcctNum.

  • Select a relation symbol. In this example, an exact match is required, so use the equal sign (=).

  • In the Second Operand box, select variable and then choose the variable that was assigned to the customer's account number in the previous step.

  • Click Add to create the expression.

  • If you want to verify that the expression is valid, click Verify.

    If you choose to verify and the expression is invalid, you will receive a message warning you of a syntax error and your expression is highlighted in red.

  6. Click Next.

  7. Click Next again to skip the Sort Order step. Because there should be only one return value, there is no need to sort.

  8. In the Using output values window, select Attach key-value pair(s) by assigning interaction data key to members of output values separated by a user-defined separator, then click Next.

  9. Select comma, and then select account_num_key in the Interaction data key field.

  10. Click Finish, and then draw a connector from the Assign object to the Database Wizard object.


Sample Strategies > Sample E

Sample E: Business Segmentation

The Business segmentation object is a container for one or more business rules. Each green output port represents a different segment, or business rule.

In this example, there are three customer attributes to consider: service selection, language, and tier. Use business segmentation in the strategy so that you can later report based on the segmentation.

For investment service, segment the customers to maximize overall service. Customers are segmented into three groups, Platinum, Silver, and Bronze, based on the value of their investment portfolio. These three groups are defined by the attribute Tier. Billing customers are also segmented by their language.

  1. If you have not already done so, create business rules that identify the following segments of callers:

  • billing_english: requests billing service (serv_select_key=3), speaks English (lang_key=1)

  • billing_spanish: requests billing service (serv_select_key=3), speaks Spanish (lang_key=2)

  • investment_platinum: requests investment (serv_select_key=4), speaks English (lang_key=1), is a platinum customer. If the customer is not platinum, the next level (silver) is checked.

  • investment_silver: requests investment (serv_select_key=4), speaks English (lang_key=1), is a silver customer

  • investment_bronze: requests investment (serv_select_key=4), speaks English (lang_key=1), is a bronze customer

  • investment: this segment catches all investment customers that did not fall into the platinum, silver, or bronze segments or did not select English as their language.

  2. Place a Business segmentation object [image] in the strategy and open the properties dialog box.

  3. Click Add Item [image] repeatedly until there are six segments.

  4. For the first segment, select a business rule from the drop-down list. The list is sorted alphabetically.

  5. Continue selecting a business rule for each segment as follows:

Segment | Business Rule
1 | billing_english
2 | billing_spanish
3 | investment_platinum
4 | investment_silver
5 | investment_bronze
6 | investment

  6. Click OK to close the Business segmentation properties dialog box.

  7. Draw a connector from the Database wizard object to the Business Segmentation object.

Note: Later you will connect the six output ports to other objects that will process the interaction if the customer attributes match the criteria for that output port.


Sample Strategies > Sample E

Sample E: Service Level

In this part of the strategy, you will create three Service Level routing objects, one each for Platinum, Silver, and Bronze customers. Set the criteria for each tier's service level using Service Level routing rules. You will have a 90_10 service level for Platinum customers, 70_20 for Silver customers, and 60_30 for Bronze customers. Set the timeout to 40 seconds in each case.

The skills required for the Agents in each case are a high level (>7) for bond, high level (>7) for stock, and a medium level (>5) for English. However, it is of Critical importance that Agents serving Platinum customers have high investment skills, High importance for Silver customers, and Medium importance for Bronze customers.

  1. Define Service Level routing rules for 90_10, 70_20, and 60_30. There is an easy way to create the three similar routing rules.

  2. Place a Service Level object [image] in the strategy, and select a Service Level routing rule (90_10 SL) .

  3. Repeat Step 2 twice more, until you have three objects, one for 90_10, one for 70_20, and one for 60_30.

  4. Connect the first investment segment (investment_platinum) in the Business segmentation object to the first Service Level object (90_10 SL).

  5. Connect the second investment segment (investment_silver) in the Business segmentation object to the second Service Level object (70_20 SL).

  6. Connect the third investment segment (investment_bronze) in the Business segmentation object to the third Service Level object (60_30 SL).


Sample Strategies > Sample E

Sample E: Service Level Routing Rules

The easiest way to define three similar routing rules is by creating one rule and then making copies of that rule.

To create the first Service level routing rule:

  1. From the Shortcut bar in the main window, select Routing Rules. You can also select Routing Rules from the View menu.

  2. From the File menu, click New.

  3. In the New dialog box, select Service Level, enter a name (such as 90_10 SL) and a description (optional), then click OK.

  4. In the Service Level Routing Rule properties dialog box, click the Service Level tab.

  5. In the Service Factor box, select the Distribute check box, and then adjust the percent of interactions and the number of seconds. In this example, percent is 90 and seconds is 10.

  6. In the Best fit box, click Add Item [image] .

  • For Skill, select English.

  • For the skill Level, select Medium. Medium means an Agent's skill level can range from 4-7.

  • Select the Importance of the skill as High. This means the Agents with the selected skill level (Medium English skills) will be considered first.

Repeat this step until you have specified all the targets among which you want to distribute interactions. The following table shows how the Routing rules should be configured in this example.

  7. Select the Busy tab in the Service level routing rule dialog box.

  8. Select a value in the Timeout box at the bottom of the dialog box.

    In this example, Timeout is set to 40 seconds for each rule. Timeout should not be less than the specified time in the service factor parameter.

  9. Click OK.

To create the other two routing rules:

  1. From the Routing Rules List view, right-click the rule you just created and choose Create copy.

  2. Double-click the copy to display the properties. Type a new name for the rule, and then select the Service Level tab.

    Note: Since the timeout will remain at 40 seconds for each rule, there is no need to change anything in the Busy tab.

  3. Change the service factor and best fit for the new rule, then click OK.

In this example, the three Service level routing rules are configured as follows:

Name | Service Factor | Skill | Level | Importance
90_10 SL | 90% in 10 sec. | English | Medium | High
 |  | Bond | High | Critical
 |  | Stock | High | Critical
70_20 SL | 70% in 20 sec. | English | Medium | High
 |  | Bond | High | High
 |  | Stock | High | High
60_30 SL | 60% in 30 sec. | English | Medium | Medium
 |  | Bond | High | Medium
 |  | Stock | High | Medium

See also: Creating a Routing Rule


Sample Strategies > Sample E

Sample E: Statistics

In this part of the strategy you will create three Statistics objects that will:

  • Route customers from the billing_spanish segment to the Agent in the BillingExpertSpan Agent group who has been available longest.

  • Route customer from the billing_english segment to the Agent in the Billing Agent group who has been available longest.

  • Route customers from the last investment segment (all other investment customers) to the Agent in the investment group who has been available longest.

To create the Statistics objects:

  1. Place a Statistics object [image] in the strategy.

  2. Select the LongestAvailAgentEng from the Routing Rule list or click New Rule if the rule has not been created. See Creating a Routing Rule for more information.

  3. Click OK.

  4. Repeat Steps 1 through 3 two more times, selecting LongestAvailAgentSpan and LongestAvailInvestment.

  5. Create the following connections:

From: | To:
billing_english segment (Business segmentation object) | Statistics object with LongestAvailAgentEng routing rule
billing_spanish segment (Business segmentation object) | Statistics object with LongestAvailAgentSpan routing rule
investment segment (Business segmentation object) | Statistics object with LongestAvailInvestment routing rule